<?php
namespace App\Exports;
use App\user;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class CompanyCollectionExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
  
	  protected $collection;

	  
	  function __construct($collection)
	  {
        $this->collection = $collection;
       }
	   
	  public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elite.jpeg'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	 public function view(): View
    {
		
       $result = DB::table('tbl_company_collection_header')
		         ->leftjoin('tbl_customer','tbl_company_collection_header.customer_id','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','tbl_company_collection_header.warehouse_id','=','tbl_warehouse.id')
		        
		         ->leftjoin('tbl_customer_type','tbl_company_collection_header.distributor_type','=','tbl_customer_type.id')
		         ->leftjoin('tbl_currency_type','tbl_company_collection_header.currency','=','tbl_currency_type.id')
		  
                  ->select('tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_company_collection_header.collection_number','tbl_customer_type.customer_type_name','tbl_customer_type.customer_type_code','tbl_currency_type.currency_notation','tbl_company_collection_header.created_at','tbl_company_collection_header.collection_type')
				  ->where('tbl_company_collection_header.id','=',$this->collection)
				 ->get();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_collection_details as c')
			->select('c.invoice_no','c.outstanding_dr','c.outstanding_cr','c.paid_amt','c.credit_amt')
	    ->where('c.header_id','=',$this->collection)
	   ->get()
	   ->all();
	  // dd($get_data_details);
	 return view('export.company_collection_export', 
		                  ['header' => $result],
		                  ['details' => $get_data_details]
						  
		            );
  
  }
  }
