<?php
namespace App\Exports;
use App\Models\WarehouseModel; 
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel;
use App\Models\CustomerModel;
use App\Models\OutletStockTransferModel;
use App\Models\ReasonModel;
use App\Models\MaterialCategoryModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use PDF;

class OutletStockTransferExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $outlet_stock_transfer;
	 
    /**
    * @return \Illuminate\Support\Collection
    */
	 function __construct($outlet_stock_transfer) {
        $this->outlet_stock_transfer = $outlet_stock_transfer;
       }
	   
	 public function drawings()
      {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
      }
	
	public function startCell(): string
    {
        return 'A9'; 
    }
	
	 public function registerEvents(): array
       {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:D5');
                   
                $event->sheet->getStyle('A6:H6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
				
				$event->sheet->getStyle('A10:H10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
	         }
          ];
       } 
	   
	      
         public function view(): View
          {
		
		   $get_data =DB::table('tbl_outlet_stock_transfer_header')
		
		->leftJoin('tbl_warehouse as outlet', 'tbl_outlet_stock_transfer_header.outlet_id', '=', 'outlet.id')
		->leftJoin('tbl_customer', 'tbl_outlet_stock_transfer_header.distibutor', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_outlet_stock_transfer_header.from_warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_reason', 'tbl_outlet_stock_transfer_header.reason_name', '=', 'tbl_reason.id')
		->leftJoin('tbl_reason_type', 'tbl_outlet_stock_transfer_header.reason_type', '=', 'tbl_reason_type.id')
		           
		->select('tbl_outlet_stock_transfer_header.*','outlet.warehouse_name as outlet_name','outlet.warehouse_code as outlet_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_reason.reason_code','tbl_reason.reason_name as r_name','tbl_reason_type.reasion_type','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code')
		 ->where('tbl_outlet_stock_transfer_header.id','=',$this->outlet_stock_transfer)
		   ->get()->all();
		  
		 $get_data_details =DB::table('tbl_outlet_stock_transfer_details')

		  ->leftJoin('tbl_material_master', 'tbl_outlet_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
		   
  
		  ->select('tbl_outlet_stock_transfer_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation') 
		  ->where('tbl_outlet_stock_transfer_details.id','=',$this->outlet_stock_transfer)
		   ->get()->all();
		  // dd($get_data_details);
        return view('export.outlet_stock_transfer_export', 
		                  ['header' => $get_data],
		                  ['details' => $get_data_details]
						  
		            );
           } 
	
		  
           
    /**
    * @return \Illuminate\Support\Collection
    */
      
        
}

