<?php
namespace App\Exports;
use App\Models\SupplierModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class PurchaseGoodReceiptNoteExportPdf implements FromView,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $good_receipt_note;
	 
    /**
    * @return \Illuminate\Support\Collection
    */
	 function __construct($good_receipt_note) {
        $this->good_receipt_note = $good_receipt_note;
       }
	    
	
	public function startCell(): string
    {
        return 'A9'; 
    }
	
	 public function registerEvents(): array
       {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:D5');
                   
                $event->sheet->getStyle('A6:H6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
				
				$event->sheet->getStyle('A10:H10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
	         }
          ];
       } 
	   
    public function view(): View
     { 
		$get_data_header = DB::table('tbl_good_receipt_note_header')
		   ->leftJoin('tbl_supplier', 'tbl_good_receipt_note_header.supplier_id', '=', 'tbl_supplier.id')
		   ->select('tbl_supplier.supplier_code','tbl_supplier.supplier_name','tbl_good_receipt_note_header.tin_no','tbl_good_receipt_note_header.delivery_date','tbl_good_receipt_note_header.remark','tbl_good_receipt_note_header.total_grn_value','tbl_good_receipt_note_header.grn_code')
		   ->where('tbl_good_receipt_note_header.id','=',$this->good_receipt_note)
		   ->get()->all();
   
         $get_data_details =DB::table('tbl_good_receipt_note_details')
		  ->leftJoin('tbl_material_master', 'tbl_good_receipt_note_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_good_receipt_note_details.uom', '=', 'tbl_unit_of_measurement.id')
          ->select('tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation','tbl_good_receipt_note_details.quantity','tbl_good_receipt_note_details.unite_price','tbl_good_receipt_note_details.vat','tbl_good_receipt_note_details.net_amount','tbl_good_receipt_note_details.total','tbl_good_receipt_note_details.discount')
		  ->where('tbl_good_receipt_note_details.header_id', '=', $this->good_receipt_note)->get()->all();
		  
        return view('export.pdf.good_receipt_note_pdf', ['header' => $get_data_header], ['details' => $get_data_details] );
      }  
	
  }
