<?php
namespace App\Exports;  
use App\Models\SupplierModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use PDF;

class PurchaseVendorPaymentExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $vendor_payment; 
		/**
		* @return \Illuminate\Support\Collection
		*/
	 function __construct($vendor_payment) {
        $this->vendor_payment = $vendor_payment;
       }
	   
   public function drawings()
     {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png')); 
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1'); 
		
        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A9'; 
    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:D5');
                   
                $event->sheet->getStyle('A6:H6')->applyFromArray ([ 
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
				
				$event->sheet->getStyle('A10:H10')->applyFromArray ([ 
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ] 
				]); 
	 }
        ];
    }
	  
    public function view(): View 
    { 
		$get_data_header = DB::table('vendor_payment_header')
		   ->leftJoin('tbl_supplier', 'vendor_payment_header.supplier_id', '=', 'tbl_supplier.id') 
		   
		   ->select('tbl_supplier.supplier_code','tbl_supplier.supplier_name','vendor_payment_header.collection_type','vendor_payment_header.vendor_payment_code')
		   ->where('vendor_payment_header.id','=',$this->vendor_payment)
		   ->get()->all();

         $get_data_details =DB::table('vendor_payment_details')
          ->select('vendor_payment_details.invoice_number','vendor_payment_details.total_outstanding','vendor_payment_details.outstanding_amt','vendor_payment_details.paid_amount')
		  ->where('vendor_payment_details.header_id', '=', $this->vendor_payment)->get()->all();
		  
        return view('export.purchase_vendor_payment_export', ['header' => $get_data_header], ['details' => $get_data_details] );
    } 
	 
 }
 