<?php

namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing; 
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
 
class RouteCollectionExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents  
  {
	 
	   protected $id;

        function __construct(int $id){
		
          $this->id = $id;
		
	        }
			
			   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	      
         public function view(): View
          {
		
		    $result = DB::table('tbl_route_collection_header')->select
		(
		'tbl_route_collection_header.*',					
		'tbl_route.route_code',
		'tbl_route.route_name',
		'tbl_customer.customer_code',
		'tbl_customer.customer_name',
		'tbl_warehouse.warehouse_code',
		'tbl_warehouse.warehouse_name',
        'tbl_trading_center.trading_name',
        'tbl_trading_center.trading_center_code',
      )
		
		 
		 ->leftJoin('tbl_route', 'tbl_route.id', '=', 'tbl_route_collection_header.route_id')
		 ->leftJoin('tbl_trading_center', 'tbl_trading_center.id', '=', 'tbl_route_collection_header.trading_center_id')
		 ->leftJoin('tbl_customer', 'tbl_customer.id', '=', 'tbl_route_collection_header.customer_id')
		 ->leftJoin('tbl_warehouse', 'tbl_warehouse.id', '=', 'tbl_route_collection_header.warehouse_id')
		 ->leftJoin('tbl_route_collection_details', 'tbl_route_collection_details.header_id', '=', 'tbl_route_collection_header.id')
		 ->where('tbl_route_collection_header.id', '=',$this->id)->get()->first();
		
		 
		 
		 $get_data=DB::table('tbl_route_collection_details')
		 ->select('tbl_route_collection_details.*')
		->where('tbl_route_collection_details.header_id', '=',$this->id)->get()->all();
		 
		  
        return view('export.route_collection_export', 
		                  ['header' => $result],
		                  ['details' => $get_data]
						  
		            );
           } 
	
		  
           
    /**
    * @return \Illuminate\Support\Collection
    */
      
        
}
