<?php
namespace App\Exports;
use App\Models\RouteExchangeModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class RouteExchangeExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $id;
	  
    /**
    * @return \Illuminate\Support\Collection
    */
	 function __construct($id) {
        $this->id = $id;
       }
	   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1'); 
        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:I6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
 
				$event->sheet->getStyle('A10:G10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                              ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                                        ],           
                              ]
				 
				    
				]);
				 
            
	 }
        ];
    }



    public function view(): View
    { 
			 $get_data = DB::select("SELECT riheader.*,
				customer.customer_name,salesman.salesman_name,warehouse.warehouse_name,route.route_name
				FROM tbl_route_exchange_header as riheader
				LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
				LEFT JOIN tbl_route as route on riheader.route_id=route.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
				WHERE riheader.id=".$this->id."
				 ");
			  
              $get_return_details =DB::select("SELECT riheader.*,
				material.material_name,uom.unit_notation,reason_type.reasion_type
				FROM tbl_route_exchange_return_details as riheader
				LEFT JOIN tbl_material_master as material on riheader.material_id=material.id
				LEFT JOIN tbl_unit_of_measurement as uom on riheader.uom_id=uom.id
				LEFT JOIN tbl_reason_type as reason_type on riheader.return_reason_id=reason_type.id
				WHERE riheader.header_id=".$this->id."
				 ");
                
        return view('export.route_exchange_export',  
		                  ['header' => $get_data],
		                  ['details' => $get_return_details] 
		            );
    } 
	
 }
