<?php
namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
 use PDF;
use Illuminate\Support\Facades\DB;
class SalesReportExport implements FromCollection,WithHeadings,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents 
   {
	protected $report_with;
	protected $region;
	protected $subregion;
	protected $warehouse;
	protected $fromdate;
	protected $todate;
	public $agent_name     = array();
	
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	public function startCell(): string
    {
        return 'A6';

    }
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				 
            
	 }
        ];
    } 
	
    function __construct($report_with,$region,$subregion,$warehouse,$fromdate,$todate) {
        $this->report_with = $report_with;
         $this->region = $region;
		  $this->subregion = $subregion;
          $this->warehouse = $warehouse;
          $this->fromdate = $fromdate;
         $this->todate = $todate;
		$agent_id     = array(); 
			 
    }
	public function headings():array{
		 
	if($this->warehouse!='s')
	 {
		$agent_name     = array(); 
		$agent_id     = array();
	    $final_data  = array();
		if($this->warehouse!=0)
		{
		   $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		  ->where('tbl_warehouse.warehouse_type','=',1)
		  ->where('tbl_warehouse.status','=','active')
	      ->where('tbl_warehouse.id','=',$this->warehouse)->get();
	    foreach($get_data1 as $key=> $warehous)
		{
		  $agent_name[] = $warehous->warehouse_name;
		  $agent_id[]=$warehous->id;
		}
										
	  }
	 else  
	 {
	   
	   $get_data1 = DB::table('tbl_warehouse')
	   ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
	   ->where('tbl_warehouse.warehouse_type','=',1)
	   ->where('tbl_warehouse.status','=','active')
	   ->get();
	   foreach($get_data1 as $key=> $warehous)
	 	{
		 $agent_name[] = $warehous->warehouse_name;
		 $agent_id[]=$warehous->id;
		}
	   }
	 }/* END WAREHOUSE */
	else if($this->subregion!='s')
	  {
		 $agent_name     = array(); 
		 $agent_id     = array(); 
		 $final_data  = array();
		if($this->subregion!=0)
		{
		   $agent_name     = array(); 
		   $agent_id     = array(); 
		   $get_data1 = DB::table('tbl_sub_region')
		   ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
		   ->where('tbl_sub_region.id','=',$this->subregion)					
			->get();
			foreach($get_data1 as $key=> $sub_region)
			  {
				$agent_name[] = $sub_region->sub_region_name;
				$agent_id[]=$sub_region->id;
			  }
		}
		else  
	    {
		   $get_data1 = DB::table('tbl_sub_region')
			->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->get();
			foreach($get_data1 as $key=> $sub_region)
			  {
				    $agent_name[] = $sub_region->sub_region_name;
					$agent_id[]=$sub_region->id;
				 }
	     }	
	   }
	   else
	   {
		     $agent_name     = array(); 
			 $agent_id     = array(); 
			 $final_data         = array();
			if($this->region!=0)
		    {
			  $get_data1 = DB::table('tbl_region')
			  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			  ->where('tbl_region.id','=',$this->region)->get()->all();
			 foreach($get_data1 as $key=> $region)
			  {
				 $agent_name[] = $region->region_name;
				 $agent_id[]=$region->id;
		      }
			}
			else  
			 {
			    $get_data1 = DB::table('tbl_region')
			    ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
				->get()->all();
			  foreach($get_data1 as $key=> $region)
			   {
				 $agent_name[$region->id] = $region->region_name;
				 $agent_id[]=$region->id;
			   }
			 }
	   }
	   
		 return $agent_name;
		
	}
    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection()
	{	
		

		$get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->get()->all();		  
        return collect($get_data1);
    }
	
 }
