<?php

namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing; 
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
 
class StockTransferExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents  
  {
	 
	     protected $id;
       
        function __construct(int $id){
		
          $this->id = $id;
		  
	        }
			  
			   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(100);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	  public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:B5'); 
                   
              $event->sheet->getStyle('A6:E6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					    'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],            
                    ]  
				 
				    
				]);   
				
			  $event->sheet->getStyle('A10:E10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					   'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				   
				    
				]);  
				 
            
	 }
        ];
    }  
	
	      
         public function view(): View
          {
		
		   $get_data =DB::table('tbl_company_stock_transfer_header')
            ->leftJoin('tbl_warehouse', 'tbl_company_stock_transfer_header.from_warehouse', '=', 'tbl_warehouse.id')
		    ->leftJoin('tbl_warehouse as t_warehouse', 'tbl_company_stock_transfer_header.transfer_warehouse', '=', 't_warehouse.id')
		    ->leftJoin('tbl_reason', 'tbl_company_stock_transfer_header.transfer_reason', '=', 'tbl_reason.id')
		    ->select('tbl_company_stock_transfer_header.*','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','t_warehouse.warehouse_name as t_warehouse_name','t_warehouse.warehouse_code as t_warehouse_code','tbl_reason.reason_code','tbl_reason.reason_name')->where('tbl_company_stock_transfer_header.id', '=',$this->id)->get()->first();
		  
		  $get_data_details =DB::table('tbl_company_stock_transfer_details')
            ->leftJoin('tbl_material_master', 'tbl_company_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
	       ->leftJoin('tbl_unit_of_measurement', 'tbl_company_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
	       ->select('tbl_company_stock_transfer_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_company_stock_transfer_details.header_id', '=', $this->id)->get()->all();
		  
        return view('export.stock_transfer_export', 
		                  ['header' => $get_data],
		                  ['details' => $get_data_details]
						  
		            );
           } 
	
		  
           
    /**
    * @return \Illuminate\Support\Collection
    */
      
        
}
