<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\AssetTrackingModel;
use App\Models\RegionTypeModel;
use App\Models\RouteModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerCategoryModel;
use App\Models\CustomerModel; 
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;
use Session;


class AssetTrackingController extends Controller
 {
   public function add()
    {
		$result = DB::table('tbl_asset_tracking')
		 ->select('tbl_asset_tracking.*')->get()->sortByDesc('id')->first();
	 
		if($result=='')
	      {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->asset_tracking_code;
		  }
	    else
		 {
			 $getcode = $result->asset_code; 
			 $last_code = ++$getcode;
		 }
		
	  $get_data=AssetTrackingModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
	     
	  return view('Merchandising.asset_tracking',compact('region','sub_region','route','get_data','last_code','customer'));  
	} 
	
   public function get_subregion($id, $subregion_id)
	{ 
	  $get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $id)->where('status', '=', 'active'); 
	  ?>
		  <option value=""></option>
		  <?php foreach($get_data as $subregion_name) { ?>		
		  <option value="<?php echo $subregion_name->id ?>" <?php if($subregion_name->id == $subregion_id) { echo "selected"; } ?> ><?php echo $subregion_name->sub_region_code." - ".$subregion_name->sub_region_name ?></option>	
	  <?php }
    }
	
   public function get_customer($id, $customer_id)
	{ 
	   //$get_data=CustomerModel::all()->sortByDesc('id')->where('customer_type', '=', '3')->where('customer_category_id', '=', $id);
	   $get_data=DB::table('tbl_customer')     
		   ->select('tbl_customer.*')
		   ->where('customer_type', '=', '3')
		   ->where('status', '=', 'active')
		   ->where('route_id', '=', $id)
		   ->get();
	     
	    
	    foreach($get_data as $customer_name) 
	     { 
		  ?>
				<option value=""></option>
			<option value="<?php echo $customer_name->id ?>" <?php if($customer_name->id == $customer_id) { echo "selected"; } ?> ><?php echo $customer_name->customer_code." - ".$customer_name->customer_name ?></option>	
		
		   <?php   
		  }
     }
	
    public function save(Request $request)
	 {   
	 //dd($request);
		   $data=new AssetTrackingModel;
		   $asset_image=$request->file('image');
		   
		   if($asset_image)
			 {  
			   $filenameWithExt = $request->file('image')->getClientOriginalName();
			   // Get just filename
			   $filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);            
			   // Get just ext
			   $extension = $request->file('image')->getClientOriginalExtension();
			   //Filename to store
			   $fileNameToStore = $filename.'_'.time().'.'.$extension;                       
			   // Upload Image
			   $path = $request->file('image')->storeAs('public/planogram', $fileNameToStore);
			  }
			elseif($request->updated_id !='' && $asset_image == '')
			  {
				$old_path = AssetTrackingModel::find($request->updated_id);
				$path= $old_path->image;
			 
			  }   
			else 
			  {
			    $path = '';
			  }		   				
		    //$data=new PlanogramModel;
		    $customer = array();
			
		    if($request->updated_id)
		      { 	
			    	
	   
				 $data = AssetTrackingModel::find($request->updated_id);  
				 
				 $data->asset_code=$request->asset_code;
				 $data->asset_name=$request->asset_name;
				 $data->asset_type=$request->asset_type;
				 $data->asset_barcode=$request->asset_barcode;
				 $data->serial_no=$request->serial_no;
				 $data->longitude=$request->longitude;
				 $data->latitude=$request->	latitude;
				 $data->valid_from=$request->valid_from;
				 $data->valid_to=$request->valid_to;
				 $data->region=$request->region;
				 $data->sub_region=$request->sub_region;
				 $data->route=$request->route;
				 $data->customer=$request->customer;
				 $data->image=$path;
				 $data->updated_user= Session::get('user_id');
				 $data->status=$request->status;
				 $data->save();

				 return redirect(route('asset_tracking_list'))->with('successMessage','Asset Updated Successfully');
			   }
		     else 
			   {
		         
				 $data->asset_code    =$request->asset_code;
				 $data->asset_name    =$request->asset_name;
				 $data->asset_type    =$request->asset_type;
				 $data->asset_barcode =$request->asset_barcode;
				 $data->serial_no     =$request->serial_no;
				 $data->longitude     =$request->longitude;
				 $data->latitude      =$request->latitude;
				 $data->valid_from    =$request->valid_from;
				 $data->valid_to      =$request->valid_to;
				 $data->region        =$request->region;
				 $data->sub_region    =$request->sub_region;
				 $data->route         =$request->route;
				 $data->customer      =$request->customer;
				 $data->image         =$path;
				 $data->created_user  =Session::get('user_id');
				 $data->status        =$request->status;
				 $data->save();
					  
				 return redirect(route('asset_tracking_list'))->with('successMessage','Asset Added Successfully');
			   } 
	 }
	
	public function list()
	 {
	      $get_data = DB::table('tbl_asset_tracking')
			  ->leftJoin('tbl_region', 'tbl_asset_tracking.region', '=', 'tbl_region.id')
			  ->leftJoin('tbl_sub_region', 'tbl_asset_tracking.sub_region', '=', 'tbl_sub_region.id')
			 
			  ->select('tbl_asset_tracking.*', 'tbl_region.region_name','tbl_sub_region.sub_region_name')->orderBy('id', 'DESC')->get();
		  //dd($get_data);   
	      return view('Merchandising.asset_tracking_list',compact('get_data'));
      }
	 
	 public function edit($id)
      {
		  $get_data1=AssetTrackingModel::find($id);
		  $last_code = $get_data1->asset_code;
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$sub_region=SubRegionTypeModel::all()->sortByDesc('id')->where('region', '=', $id)->where('status', '=', 'active');
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   	$get_data = DB::table('tbl_asset_tracking')
		    ->leftJoin('tbl_customer', 'tbl_asset_tracking.customer', '=', 'tbl_customer.id')
			->select('tbl_asset_tracking.*', 'tbl_customer.customer_code','tbl_customer.customer_name')
			->where('tbl_asset_tracking.id', '=', $id)
			->first();
		//dd($get_data);
		return view('Merchandising.asset_tracking',compact('get_data1','region','sub_region','route','get_data','last_code'));
      }

     public function view($id)
	  {    
		
		 $get_data = DB::table('tbl_asset_tracking')
		     ->leftJoin('tbl_region', 'tbl_asset_tracking.region', '=', 'tbl_region.id')
		     ->leftJoin('tbl_sub_region', 'tbl_asset_tracking.sub_region', '=', 'tbl_sub_region.id')
		     
		     ->leftJoin('tbl_route', 'tbl_asset_tracking.route', '=', 'tbl_route.id')
		     ->leftJoin('tbl_customer', 'tbl_asset_tracking.customer', '=', 'tbl_customer.id')
		     ->select('tbl_asset_tracking.*', 'tbl_region.region_name','tbl_sub_region.sub_region_name','tbl_region.region_code','tbl_sub_region.sub_region_code','tbl_route.route_code','tbl_route.route_name','customer_code','customer_name')
		     ->where('tbl_asset_tracking.id', '=', $id)
             ->first();
		 //dd($get_data); 
		 $customer=CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active'); 
		
		 return view('Merchandising.asset_tracking_view',compact('get_data','customer'));
	  }	
	
 }  
