<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CurrencyTypeModel;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use App\Exports\CompanyCreditExport;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use App\Models\CustomerTypeModel;
use App\Models\CompanyOutstandingModel;
use App\Models\CompanyCreditNoteModel;
use App\Models\ReasonTypeModel;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Session;

class CompanyCreditNoteController extends Controller
 {
   public function list(Request $request)
	{
		 //dd($request);
		$current_date=date("Y-m-d");

		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }
  
		if($request->fromdate!='')
	      {
		    $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
	      }
 
	 
		if($request->customer!='')
		  {
			$where .= "AND customer.id = '".$request->customer."'";
		  }
			
		if($request->warehouse!='')
		  {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		  }
		  
		 $distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active');
		//$get_data = CurrencyTypeModel::all()->sortByDesc('id');

		$get_data = DB::select("SELECT riheader.*, 
		customer.customer_code,customer.customer_name,
		delivery_no.company_delivery_number,
		warehouse.warehouse_code,warehouse.warehouse_name,
		
		currency.currency_notation
		
		FROM tbl_company_credit_note_header as riheader
		
		LEFT JOIN tbl_customer as customer on riheader.customer=customer.id
		LEFT JOIN tbl_company_delivery_header as delivery_no on riheader.company_credit_delivery_number=delivery_no.id

		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse=warehouse.id
		LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
		WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC");
		
	
			
		return view('Company_Transaction.company_credit_note_list',compact('get_data','distibutor'));
	
	 }
	
	public function add()
     {   
		 $user_id=Session::get('user_id');	  
		 $result = DB::table('tbl_company_credit_note_header')
		 ->select('tbl_company_credit_note_header.*')->get()->sortByDesc('id')->first();
	 
		 if($result=='')
		   {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->company_credit_note_number;
		   }
		 else
		   {
			 $getcode = $result->company_credit_note_number; 
			 $last_code = ++$getcode;
		   }

			$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')				
			->get()->all();
			
			$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
  
			$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
 
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
			//dd($login_user);
 
		    return view('Company_Transaction.company_credit_note',compact('last_code','material_master','material_category','material','login_user'));
		

      }
		  
	 public function get_delivery_number_details2($id,$return)
      {
			$order_name =DB::table('tbl_company_delivery_header')
			->leftJoin('tbl_customer', 'tbl_company_delivery_header.customer', '=', 'tbl_customer.id')
			->select('tbl_company_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_company_delivery_header.order_type', '=',$return)->where('tbl_company_delivery_header.is_invoice', '=', '0')->get()->all();
						   
		    $get_data =DB::table('tbl_company_delivery_header')		
		   ->select('tbl_company_delivery_header.*')->where('tbl_company_delivery_header.id', '=',$id)-> get()->first();
		   
		   $get_order_number =DB::table('tbl_company_order_header')
             ->select('tbl_company_order_header.company_order_number')->where('tbl_company_order_header.id', '=',$get_data->order_number)->get()->first();
		 
		    $get_data_details =DB::table('tbl_company_delivery_detail')
		    ->leftJoin('tbl_material_master', 'tbl_company_delivery_detail.material_id', '=', 'tbl_material_master.id')
		    ->leftJoin('tbl_unit_of_measurement', 'tbl_company_delivery_detail.uom', '=', 'tbl_unit_of_measurement.id')
			 ->leftJoin('tbl_reason_type', 'tbl_company_delivery_detail.resion', '=', 'tbl_reason_type.id')
  
		    ->select('tbl_company_delivery_detail.*','tbl_material_master.material_name','tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.uom_code','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type')->where('tbl_company_delivery_detail.header_id', '=', $id)->get()->all();
		    //dd($get_data_details);
		
		    $user_id=Session::get('user_id');
		
		    $login_user = DB::table('tbl_user')
		    ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		    ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		    ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		    ->where('tbl_user.id', '=', $user_id)
		    ->get()->first(); 
		  
		    $user_id=Session::get('user_id');
  
		    $user_id=Session::get('user_id');
  
		    $result = DB::table('tbl_company_credit_note_header')
		    ->select('tbl_company_credit_note_header.*')->get()->sortByDesc('id')->first();
		 
		    if($result=='')
		      {
			    $getcode = ManageCodeModel::where('id', 1)->first();
			    $last_code = $getcode->company_credit_note_number;
		      }
		    else
		      {
			    $getcode = $result->company_credit_note_number; 
			    $last_code = ++$getcode;
		      }

				$material_master = DB::table('tbl_material_master')
				->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
				
				->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')
			
				->get()->all();
				
			   $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=',  'active');
			  
			    /*$user_login =UserModel::all()->sortByDesc('id')->where('id','=',$user_id)->where('status', '=', 'active');
			  
			    echo $user_login->company_id;
			    exit;
			    */
			
			   //dd($get_data_details->return_type);
	
			  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
			  $reason =ReasonTypeModel::all()->sortByDesc('id')->where('return_type', '=',$get_data_details[0]->return_type );
		
			  $login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();
			
		    return view('Company_Transaction.company_credit_note',compact('last_code','material_master','material_category','material','login_user','get_data','get_data_details','order_name','reason','get_order_number'));
	  }
	 
	 public function get_delivery_number2($id)
	  {		 
		$get_data1 =DB::table('tbl_company_delivery_header')
		->leftJoin('tbl_customer', 'tbl_company_delivery_header.customer', '=', 'tbl_customer.id')
		->select('tbl_company_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_company_delivery_header.order_type', '=',$id)->where('tbl_company_delivery_header.is_credit', '=', '0')->get()->all();

		?>
		<option  value="">     </option>
		<?php
		foreach($get_data1 as $order_name)
		  {
			?>
			<option value="<?php echo $order_name->id ?>"  ><?php echo $order_name->company_delivery_number .' ( '. $order_name->customer_code.' - '. $order_name->customer_name ?> )</option>	
			<?php		
		  }
	
	  }
	  
	 public function save(Request $request)
	{ 
	   $get_cust =DB::table('tbl_company_delivery_header')		        
		->select('tbl_company_delivery_header.customer','tbl_company_delivery_header.warehouse','tbl_company_delivery_header.delivery_date','tbl_company_delivery_header.distribution_type','tbl_company_delivery_header.tin_no')->where('tbl_company_delivery_header.id', '=',$request->   delivery_number)->where('tbl_company_delivery_header.is_credit', '=', '0')->get()->first();
		
	    $current = Carbon::now();
	    $user_id=Session::get('user_id');
	
		$login_user = DB::table('tbl_user')
	     ->join('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
	     ->join('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
	     ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
	     ->where('tbl_user.id', '=', $user_id)
	     ->get()->first();
	  
	      //add flag in delevery
	     DB::table('tbl_company_delivery_header')
	     ->where('id', $request->delivery_number)
	     ->update(['is_credit' => '1']);
	 
		 //getting credit days of customer
		  $customer_creditdays = DB::table('tbl_customer')
		 ->select('tbl_customer.credit_days')->where('tbl_customer.id', '=', $get_cust->customer)->get()->first();
	 
	     // dd($customer_creditdays);
	  
		  //adding credit days with current date
		  $current_date=date("Y-m-d");  
		  $date=date_create($current_date);
		  date_add($date,date_interval_create_from_date_string(" ".$customer_creditdays->credit_days." days"));
	     $due_date= date_format($date,"Y-m-d");
	
	
	      $data3=array
			(
			 'company_credit_note_number'      =>  $request->company_credit_note_number,
			 'currency'            =>  $login_user->currency_id,
			 'company_credit_delivery_number'        =>$request->delivery_number,
			 'delevary_date'          =>  $get_cust->delivery_date,
			 'customer'             =>  $get_cust->customer,
			 'warehouse'          =>  $get_cust->warehouse,
			  'distribution_type'   =>  $get_cust->distribution_type,
			 'tin_no'          =>  $get_cust->tin_no,
			 
			 'order_type'          =>  $request->order_typehidden,
			 'total_gross'         =>  $request->gross_amount_totali,
			 'net_total_amount'    =>  $request->net_amount_totali,
			 'total_Excise'        =>  $request->excise_amount_totali,
			 'total_vat'           =>  $request->vat_amount_totali,
			 
			  'total_discount'      =>$request->vat_amount_totali,
			  'total_delivery_value' =>  $request->invoice_amount_totali,
			  'created_at'         => $current,
			  'created_user'         => $user_id,
		     );
		
			//outstanding		
		    $header_id =DB::table('tbl_company_credit_note_header')->insertGetId($data3);		 
			$data=new CompanyOutstandingModel;
			$data->customer=$get_cust->customer;
			$data->warehouse=$get_cust->warehouse;
			$data->invoice_id=$header_id;
			$data->invoice_number=$request->company_credit_note_number;
			$data->invoice_total=$request->invoice_amount_totali;
			$data->invoice_paid=$request->invoice_amount_totali;;
			$data->invoce_outstandig=0;
			$data->due_date=$due_date;
			$data->delivery_type='is_credit_note';
			$data->credit_amount=$request->invoice_amount_totali;
			$data->save();
	 
		 foreach($request['material_name1'] as $key => $n)
		   {
			 if($request->quantity1[$key ]!='')
		       {
			   
				 $data2=array(
				 'material_id' => $request->material_name1[$key ],
				 'header_id'     => $header_id,
				 'uom'           => $request->uom[$key ],
				 'unite_price'   => $request->price1[$key ],
				 'gross_total'   => $request->gross1[$key ],
				 'vat'           => 0,
				 'excise'        => 0,
				 'total'         => $request->total1[$key ],
				 'net_amount'    => 0,
				 'quantity'      => $request->quantity1[$key ],
				 'return_type'   => $request->return_type[$key ],
				 'base_qty'      => $request->packing_size[$key ],
				 'resion'        => $request->resion[$key ],
				 'created_at'    => $current,
				 );
				 DB::table('tbl_company_credit_note_details')->insert($data2);
			   } 
		    }
		    return redirect(route('company_credit_note_list'))->with('successMessage',$request->company_credit_note_number.' '.'Credit Note Save Successfully');
	   }
  
	  public function view($id)
	   {   	
		$user_id=Session::get('user_id');
		$get_data =DB::table('tbl_company_credit_note_header')				
		->leftJoin('tbl_customer', 'tbl_company_credit_note_header.customer', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_company_credit_note_header.warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_customer_type', 'tbl_company_credit_note_header.distribution_type', '=', 'tbl_customer_type.id')
		//->join('tbl_warehouse', 'tbl_company_order_header.warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_currency_type', 'tbl_company_credit_note_header.currency', '=', 'tbl_currency_type.id')
		->select('tbl_company_credit_note_header.*','tbl_customer.customer_name','tbl_customer.customer_code',
		'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_customer_type.customer_type_name','tbl_customer_type.customer_type_code','tbl_currency_type.currency_notation')->where('tbl_company_credit_note_header.id', '=',$id)->get()->first();
			 
		$get_data_details =DB::table('tbl_company_credit_note_details')	  
		  ->leftJoin('tbl_material_master', 'tbl_company_credit_note_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_company_credit_note_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_company_credit_note_details.resion', '=', 'tbl_reason_type.id') 
  
		  ->select('tbl_company_credit_note_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type')->where('tbl_company_credit_note_details.header_id', '=', $id)->get()->all();
		   
		$login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();			  
 
		$reason =ReasonTypeModel::all()->sortByDesc('id')->where('return_type', '=',$get_data_details[0]->return_type );
  
	   return view('Company_Transaction.company_credit_note_view',compact('get_data','get_data_details','login_user','reason'));
	
     }
    public function get_warehousename_filter_credit_note($id,$warehouse_url)
     {
	   $material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=',1);
	
       ?>
		 <option  value="">     </option>
	   <?php
	   foreach($material as $material_name)
		 {
			?>
			<option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
			<?php		
		 }
		 //return response()->json($get_data);

      }
	  public function credit_report_exportpdf($year,$month)
	 { 	
		return Excel::download(new MaterialPerformanceExport($year,$month), 'company_credit_note.pdf');		  
	 }
	 
	 public function company_credit_export($id) 
    {
        return Excel::download(new CompanyCreditExport($id), 'company_credit.xlsx');
    }
	public function company_credit_export_pdf($id)
	 {
		 $user_id=Session::get('user_id');
		$get_data = DB::table('tbl_company_credit_note_header as cc')
		         ->leftjoin('tbl_customer','cc.customer','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','cc.warehouse','=','tbl_warehouse.id')
		         ->leftjoin('tbl_currency_type','cc.currency','=','tbl_currency_type.id')
		         ->leftjoin('tbl_company_delivery_header','cc.company_credit_delivery_number','=','tbl_company_delivery_header.id')
				 ->select('tbl_customer.*','tbl_company_delivery_header.company_delivery_number','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_currency_type.currency_notation','cc.company_credit_note_number',
				 
				 'cc.delevary_date','cc.total_delivery_value',
				 'cc.total_gross','cc.total_Excise',
				 'cc.total_vat','cc.net_total_amount',
				 'cc.total_discount','cc.total_delivery_value',
				 )
		  
                 
				  ->where('cc.id','=',$id)
				 ->get()->first();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_credit_note_details')	  
		  ->leftJoin('tbl_material_master','tbl_company_credit_note_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_company_credit_note_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_company_credit_note_details.resion', '=', 'tbl_reason_type.id') 
         ->select('tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type','tbl_reason_type.return_type','tbl_company_credit_note_details.quantity','tbl_company_credit_note_details.unite_price','tbl_company_credit_note_details.total')
		 
	    ->where('tbl_company_credit_note_details.header_id','=',$id)
	   ->get()
	   ->all();
	   
		$pdf=PDF::loadView('export.pdf.company_credit_note_pdf',compact('get_data','get_data_details'));
		  
		  return $pdf->download('company_credit_note.pdf');
	
	    //return response()->json($get_data);
	 }
 }
