<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\SalesReportExport;

class CompanyCustomerStatementReportController extends Controller
{
	public function list()
	{	
	
		//$get_data = SupplierTypeModel::all()->sortByDesc('id');
		 $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		  foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id; 
		 
	     }
     
         $regId=implode(",",$all_region);
		 
		 $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
		return view('Report.company_customer_statement_report_list',compact('region','material','regId'));  
	}
		
   public function get_subregion_data($region)
	{
	  $data = explode(',',$region);
		

		$sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		
		if(count($sub_region)>0){
			foreach($sub_region as $subreg){
				
				$all_subregion[] = $subreg->id;
			}
			$subregId=implode(",",$all_subregion);
		}else{

			$subregId = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($sub_region) > 0){ ?>
			<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php } 
		foreach($sub_region as $sub_region_name)
		  {
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		    <?php  	   	
		  }
	 }
	 public function get_warehouse_data($sub_region)
	 {
		
		$data = explode(',',$sub_region);
		$warehouse =WarehouseModel::all()->sortByDesc('id')->whereIn('sub_region',$data)->where('status', '=', 'active')->where('warehouse_type', '=', '1');
		
		if(count($warehouse)>0){
			foreach($warehouse as $subreg){
				
				$all_warehaouse[] = $subreg->id;
			}
			$allwarehaouse=implode(",",$all_warehaouse);
		}else{

			$allwarehaouse = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($warehouse) > 0){ ?>
			<option  value="0" data-value="<?php echo $allwarehaouse ?>">Select All</option>
		<?php } 
		foreach($warehouse as $warehouse_name)
		  {
			?>
			  <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
		   <?php  	 	   	
		  }
	 }
	 
  public function get_sales_report($region,$subregion,$warehouse,$fromdate,$todate)
	 {
     if($warehouse!='s')
	 {
		
	 $final_data  = array();
	  $data1 = explode(',',$warehouse);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		   ->where('tbl_warehouse.warehouse_type','=',1)
		   ->where('tbl_warehouse.status','=','active')
		   ->whereIn('tbl_warehouse.id',$data1)->get(); 
		 foreach($get_data1 as $key=> $warehous)
		  {
		   $agent_name[$warehous->id] = $warehous->warehouse_name;
		   $agent_id[]=$warehous->id;
		  }
	     
		$get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total,cust.customer_code as cust_code ,cust.customer_name,cust.id,warehouse1.id as warehous_id FROM `tbl_company_outstanding` as outt
		LEFT JOIN tbl_customer as cust on outt.customer=cust.id
		LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
	    WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND warehouse1.id in (".implode(',',$agent_id).") group by cust.id,warehous_id");
		$count=count($get_sales_material_wise);
		
	    foreach($get_sales_material_wise as $row) 
		 {
		  $final_data['item'][$row->id]  = $row->cust_code.' - '.$row->customer_name;
		  $final_data['sales'][$row->warehous_id][$row->id]  = $row->total;
		 }	
		 
	  $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
	  <thead class='bg-secondary text-white'> 	
	  <tr style='height: 56px;background-color: #3f6ad8;color: white;'>
	  <th style='width:60px;' class='text-justify font-weight-bold  text-center'>Customer </th>";
	   $i=2;
	 foreach($agent_name as $warehouse)
	  {
	   $i++;
	   $html .="<th style='width:40px;' class='font-weight-bold  text-center'>".$warehouse."</th>";
	  }
	  $html .="<th style='width:60px;' class='font-weight-bold  text-center'>Total  Outstanding</th>
	  </tr>";
	  $count=count($get_sales_material_wise);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan=".$i." style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		$html .="</thead><tbody>";
		$total_alter_sales = array();
		$total_base_sales  = array();
		foreach($final_data['item'] as $item_id => $item_name) 
		  {
		   $html .="<tr>
		   <td class='font-weight-bold  text-left'>".$item_name."</td>";
			$alter_item_sales = 0;
			$base_item_sales  = 0;
			foreach($agent_id as $name) 
			 {
			   if (!isset($total_alter_sales[$name])) {
				$total_alter_sales[$name] = 0;}
				$alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
				$alter_item_sales  +=$alter_item_count;
				$total_alter_sales[$name]+= $alter_item_count;
				$model  = $alter_item_count > 0  ? "modal" : "";
				$data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				$class= $alter_item_count > 0  ? "material_wise_warehouse_sales_modal" : "";
				 
                 $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2) ."</td>";
			}
			
			 
			$html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
		}
      $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
			 <th class='font-weight-bold  text-left'>Total Outstanding</th>";
			 $total_item_alter_sales = 0;
			 $total_item_base_sales  = 0;
			 foreach($agent_id as $name) 
			  {
				  
			  $item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
			  $total_item_alter_sales += $item_total_alter_sales;
			  $model  = $item_total_alter_sales > 0  ? "modal" : "";
			  $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			  $class= $item_total_alter_sales > 0  ? "warehouse_modal" : "";
			  $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
	        }
			
			$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th></tr>
			</tfoot> </tbody>";
	  }
   $html .="</table>";
   $return['html'] = $html;
   echo json_encode($return);die;
  }/* warehouse with amount */

 else if($subregion!='s')
	 {
		$final_data = array();
			$data1 = explode(',',$subregion);
			  $agent_name     = array(); 
			  $agent_id     = array(); 
			  $get_data1 = DB::table('tbl_sub_region')
			  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			  ->where('tbl_sub_region.status','=','active')
			  ->whereIn('tbl_sub_region.id',$data1)->get();
			  foreach($get_data1 as $key=> $sub_region)
				{
				 $agent_name[$sub_region->id] = $sub_region->sub_region_name;
				 $agent_id[]=$sub_region->id;
				}
		  
				$get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total,cust.customer_code as cust_code ,cust.customer_name,cust.id,subregion.id as sub_region_id FROM `tbl_company_outstanding` as outt
		        LEFT JOIN tbl_customer as cust on outt.customer=cust.id
		        LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
		        LEFT JOIN tbl_sub_region as subregion on warehouse1.sub_region=subregion.id
	            WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND subregion.id in (".implode(',',$agent_id).") group by cust.id,sub_region_id");
		      $count=count($get_sales_material_wise);
		  
	        foreach($get_sales_material_wise as $row) 
		    {
		      $final_data['item'][$row->id]  =$row->cust_code.' - '.$row->customer_name;
		      $final_data['sales'][$row->sub_region_id][$row->id]  = $row->total;
		    }			
			$html ="<table  id='example' class='table table-hover table-striped table-bordered'><thead class='bg-secondary text-white'> 	
			<tr style='height: 56px;background-color: #3f6ad8; color: white;'>
			<th style='width: 60px;' class='font-weight-bold  text-center'>Customer </th>";
				 $i=2;
				foreach($agent_name as $subregion)
					{$i++;
					  $html .="<th style='width: 40px;' class='font-weight-bold  text-center'>".$subregion."</th>";
					}
					$html .="<th style='width: 60px;' class='font-weight-bold  text-center'>Total  Outstanding</th></tr>";
					
                    $count=count($get_sales_material_wise);	
					if($count<1)
					{
					 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
                    }
					else
					{
					  $html .="</thead><tbody>";
					  $total_alter_sales = array();
					  $total_base_sales  = array();
					 foreach($final_data['item'] as $item_id => $item_name) {
						$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					    $alter_item_sales = 0;
						$base_item_sales  = 0;
						foreach($agent_id as $name) {
						  if (!isset($total_alter_sales[$name])) {
                                $total_alter_sales[$name] = 0;}
								$alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
								$alter_item_sales +=$alter_item_count;
								$total_alter_sales[$name]+= $alter_item_count;
								$model  = $alter_item_count > 0  ? "modal" : "";
				                $data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				                $class= $alter_item_count > 0  ? "material_wise_subregion_sales_modal" : "";
				            $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
                            }
						$html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
					}
					 $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'><th class='font-weight-bold  text-left'>Total Outstanding </th>";
					$total_item_alter_sales = 0;
					$total_item_base_sales  = 0;
					foreach($agent_id as $name)
						{
						 $item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
						 $total_item_alter_sales += $item_total_alter_sales;
						 $model  = $item_total_alter_sales > 0  ? "modal" : "";
			             $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			             $class= $item_total_alter_sales > 0  ? "sub_region_modal" : "";
			             $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
						}
						$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th></tr>
								</tfoot></tbody>";
					 }
					$html .="<tfoot></tfoot></table>";
					$return['html'] = $html;
                echo json_encode($return);die;
		}/* END SUBREGION SALES REPORT */
  
else  if($region!='s')
		 {
	
		$final_data         = array();
		$data1 = explode(',',$region);
		 $agent_name     = array(); 
		 $agent_id     = array(); 
		 $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->where('tbl_region.status','=','active')
		->whereIn('tbl_region.id',$data1)->get()->all();
		 foreach($get_data1 as $key=> $region)
		  {
		   $agent_name[$region->id] = $region->region_name;
		   $agent_id[]=$region->id;
		  }
		 
		 $get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total,cust.customer_code as cust_code ,cust.customer_name,cust.id,region.id as region_id FROM `tbl_company_outstanding` as outt
		 LEFT JOIN tbl_customer as cust on outt.customer=cust.id
		 LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
		 LEFT JOIN tbl_region as region on warehouse1.region=region.id
	     WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND region.id in (".implode(',',$agent_id).") group by cust.id,region_id");
		 $count=count($get_sales_material_wise);
		 
		  foreach($get_sales_material_wise as $row) 
		   {
			$final_data['item'][$row->id]  = $row->cust_code.' - '.$row->customer_name;
			$final_data['sales'][$row->region_id][$row->id]  = $row->total;
		   }		
			$html ="<table  id='example' class='table table-hover table-striped table-bordered'>
					<thead class='bg-secondary text-white'> 	
					<tr style='height: 56px;background-color: #3f6ad8;color: white;'>
					<th style='width: 60px;' class='font-weight-bold  text-left'>Customer </th>";
				    $i=2;
			foreach($agent_name as $region)
				{
				  $i++;
				 $html .="<th style='width: 40px;' class='font-weight-bold  text-right'>".$region."</th>";
				}
				$html .="<th  style='width: 60px;' class='font-weight-bold  text-right'>Total Outstanding</th></tr>";
				 $count=count($get_sales_material_wise);	
				if($count<1)
					{
					 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
                    				  
					}
					else
					{
					 $html .="</thead><tbody>";
					  $total_alter_sales = array();
					  $total_base_sales  = array();
					  foreach($final_data['item'] as $item_id => $item_name) {
					  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					  $alter_item_sales = 0;
					  $base_item_sales  = 0;
					 foreach($agent_id as $name) {
					   if (!isset($total_alter_sales[$name])) {
                              $total_alter_sales[$name] = 0;}
						   $alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
						   $alter_item_sales +=$alter_item_count;
						   $total_alter_sales[$name]+= $alter_item_count;
						   $model  = $alter_item_count > 0  ? "modal" : "";
				           $data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				           $class= $alter_item_count > 0  ? "material_wise_region_sales_modal" : "";
				        $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
					}
                     $html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
				}
				$html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
				<th class='font-weight-bold  text-left'>Total Outstanding </th>";
				  $total_item_alter_sales = 0;
				  $total_item_base_sales  = 0;
				  
				   foreach($agent_id as $name)
					{
						$item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
						$total_item_alter_sales += $item_total_alter_sales;
						$model  = $item_total_alter_sales > 0  ? "modal" : "";
			            $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			            $class= $item_total_alter_sales > 0  ? "region_modal" : "";
			            $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
						}
					$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th>
                             </tr></tfoot> </tbody>"; 
					} 
					
					$html .="</table>";
					$return['html'] = $html;
                    echo json_encode($return);die;
				
			} /* END REGION SALES REPORT */ 
		
    } /* END GETTING REPORT */   

	public function get_return_sales_report_pop($fromdate, $todate, $region)
	 {
	  $agent_name     = array(); 
	  $agent_id     = array();
      $final_data = array();			 
	    $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->where('tbl_region.id','=',$region)					
		->get()->all();
		$titlename =$get_data1[0]->region_code.' - '.$get_data1[0]->region_name;
			
		$get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total, customer.customer_name,customer.customer_code as cust_code,customer.id,region_name.id as region_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
		
		LEFT JOIN tbl_customer as customer on outt.customer=customer.id
		LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
		LEFT JOIN tbl_region as region_name on warehouse1.region=region_name.id
		WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND region_name.id=".$region." 
		group by customer.id,region_id,DATE(outt.created_at)
        ORDER BY DATE(outt.created_at) DESC");
		
		foreach($get_sales_material_wise as $row) 
		  {
			$final_data['item'][$row->id]  =$row->cust_code.' - '.$row->customer_name;
			$final_data['sales'][$row->created_date][$row->id]  = $row->total;
		  } 
		   $first_date     = date($fromdate);
		   $last_date      = date($todate);
		 
		   $date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		 $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		  <thead class='bg-secondary text-white'> 
           <tr><th style='height: 56px;background-color: #3f6ad8;color: white;' colspan=".$colspan." class='text-left'>".$titlename."</th>
		   </tr><tr style='height: 56px;background-color: #3f6ad8;color: white;'><th style='width: 60px;' class='font-weight-bold  text-center'>Customer </th>";
			while($first_date <= $last_date) 
			{
			    $html .="<th style='width: 40px;' class='font-weight-bold  text-center'>".date('d M y', strtotime($first_date))."</th>";
				$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
            }
		   $html .="<th style='width: 60px;' class='font-weight-bold  text-center'>Total  Outstanding</th>
					</tr></thead><tbody>";
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name)  
 				{
				  $total_item_alter   = 0;
				  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
				  $first_date = date($fromdate);
				  $alter_item_sales  = 0;
				  $base_item_sales   = 0;
				  
				  while($first_date <= $last_date)
					{
					  if(!isset($total_alter_sales[$first_date])) 
						{
                          $total_alter_sales[$first_date] = 0;
                        } 
						$alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
						$total_item_alter   += $alter_date_sale; 
						$total_alter_sales[$first_date] += $alter_date_sale;
						
                      $html .="<td class='font-weight-bold  text-right'>".number_format($alter_date_sale,2)."</td>";
					  $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
					}
					$html .="<th class='font-weight-bold  text-right'>".$total_item_alter."</th>
						</tr>";
				}
				$html .="<tbody><tfoot><tr><th class='font-weight-bold  text-left'>Total Sales</th>";
						$first_date     = date($fromdate);
						$total_sales_alter    = 0;
						$total_sales_base     = 0;
						while($first_date <= $last_date)  
						{
						   $total_sales_alter += $total_alter_sales[$first_date];
								$html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>";
						        $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
						}
                        $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2)."</th> 
                    </tr><tfoot></table>";	
		 $return['html'] = $html;
         echo json_encode($return);die;

	}/* END REGION AMOUNT MODAL POPUP */			
	
   //modal for subregion
   public function get_subregionreturn_sales_report_pop($fromdate, $todate, $subregion)
	{
	    $agent_name     = array(); 
		$agent_id     = array();
		$final_data = array();			 
		$get_data1 = DB::table('tbl_sub_region')
		->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
		->where('tbl_sub_region.id','=',$subregion)					
		->get()->all();
		$titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
		
		$get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total, customer.customer_name,customer.customer_code as cust_code,customer.id,subregion.id as sub_region_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
		
		LEFT JOIN tbl_customer as customer on outt.customer=customer.id
		LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
		LEFT JOIN tbl_sub_region as subregion on warehouse1.sub_region=subregion.id
		WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND subregion.id=".$subregion." 
		group by customer.id,sub_region_id,DATE(outt.created_at)
        ORDER BY DATE(outt.created_at) DESC");
			
		foreach($get_sales_material_wise as $row) 
		  {
			$final_data['item'][$row->id]  = $row->cust_code.' - '.$row->customer_name;
			$final_data['sales'][$row->created_date][$row->id]  = $row->total;
	      }
		  
		 $first_date     = date($fromdate);
		 $last_date      = date($todate);
		 $date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		$html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 60px;' class='font-weight-bold  text-center'>Customer </th>";
		while($first_date <= $last_date) 
			{
			    $html .="<th class='font-weight-bold  text-center' style='width: 40px;'>".date('d M y', strtotime($first_date))."</th>";
				$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
            }
		$html .="<th style='width:60px; class='font-weight-bold  text-center'>Total  Outstanding</th></tr></thead>
				 <tbody>";
			$total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			{
			$total_item_alter   = 0;
							
			$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
			 $first_date = date($fromdate);
			 $alter_item_sales = 0;
			 $base_item_sales  = 0;
			 
			  while($first_date <= $last_date) 
				{
				  if(!isset($total_alter_sales[$first_date])) 
					{
                      $total_alter_sales[$first_date] = 0;
                    }
				  $alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
				  $total_item_alter   += $alter_date_sale; 
				  $total_alter_sales[$first_date] += $alter_date_sale;
                 $html .="<td class='font-weight-bold  text-right'>".number_format($alter_date_sale,2)."</td>";
				 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
									     
              }
			  $html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter,2)."</th>
						</tr>";
		   }
		$html .=" <tbody><tfoot><tr>
                 <th class='font-weight-bold  text-left'>Total Outstanding</th>";
				$first_date     = date($fromdate);
				$total_sales_alter    = 0;
				$total_sales_base     = 0;
				while($first_date <= $last_date) 
				{ 
					$total_sales_alter += $total_alter_sales[$first_date];
					 $html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>
						       ";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
				}
                         
                     $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2) ."</th></tr><tfoot>
			        </table>";	
         $return['html'] = $html;
         echo json_encode($return);die;					
	}/* END SUB REGION AMOUNT MODEL POPUP */ 	
		
       //modal for warehouse
   public function get_warehousereturn_sales_report_pop($fromdate, $todate, $warehous)
	{	
	 $agent_name     = array(); 
	 $agent_id     = array();
	 $final_data = array();			 
	$get_data1 = DB::table('tbl_warehouse')
    ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
    ->where('tbl_warehouse.warehouse_type','=',1)	
	->where('tbl_warehouse.id','=',$warehous)					
	 ->get()->all();
	$titlename =$get_data1[0]->warehouse_code.' - '. $get_data1[0]->warehouse_name;
	
	$get_sales_material_wise = DB::select("SELECT sum(outt.invoce_outstandig) as total, customer.customer_name,customer.customer_code as cust_code,customer.id,warehouse1.id as warehouse_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
		
		LEFT JOIN tbl_customer as customer on outt.customer=customer.id
		LEFT JOIN tbl_warehouse as warehouse1 on outt.warehouse=warehouse1.id
		
		WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND warehouse1.id=".$warehous." 
		group by customer.id,warehouse_id,DATE(outt.created_at)
        ORDER BY DATE(outt.created_at) DESC");
								
	foreach($get_sales_material_wise as $row) 
	  {
		$final_data['item'][$row->id]  = $row->cust_code.' - '.$row->customer_name;
		$final_data['sales'][$row->created_date][$row->id]  = $row->total;
	  } 
		
	  $first_date     = date($fromdate);
	  $last_date      = date($todate);
	      $date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		$html ="<table  id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 60px;' class='font-weight-bold  text-center'>Customer</th>";
		
		while($first_date <= $last_date)
		{
         $html .=" <th class='font-weight-bold  text-center' style='width: 40px;'>".date('d M y', strtotime($first_date))."</th>";
		 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
         }
		$html .="<th style='width: 40px;' class='font-weight-bold  text-center'>Total Outstanding</th>
			</tr></thead> <tbody>";
			$total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			{
			     $total_item_alter   = 0;
						
				 $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					
				$first_date = date($fromdate);
				$alter_item_sales = 0;
				$base_item_sales  = 0;
		      while($first_date <= $last_date) 
				 {
				  if (!isset($total_alter_sales[$first_date])) 
					{
                     $total_alter_sales[$first_date] = 0; }
					 $alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
					 $total_item_alter   += $alter_date_sale; 
					 $total_alter_sales[$first_date] += $alter_date_sale;
      
				    $html .=" <td class='font-weight-bold  text-right'>" .number_format($alter_date_sale,2)."</td>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
			     }
									
				$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter,2)."</th></tr>";
										
			}
			$html .="<tbody><tfoot><tr><th class='font-weight-bold  text-left'>Total Outstanding</th>";
						
				$first_date     = date($fromdate);
				$total_sales_alter    = 0;
				$total_sales_base     = 0;
			 while($first_date <= $last_date) 
				{
				  $total_sales_alter += $total_alter_sales[$first_date];
						
					$html .="<th class='font-weight-bold  text-right'>". number_format($total_alter_sales[$first_date],2)."</th>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
				}
             $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2)."</th>
                    </tr><tfoot></table>";
          $return['html'] = $html;
         echo json_encode($return);die;						
		
	 }/* END WAREHOUSE AMOUNT MODEL POPUP */
	
public function get_company_materialwise_quntity_sales_report_pop($fromdate, $todate, $warehous,$customer,$slug)
	 {
		$agent_name     = array(); 
	    $agent_id     = array();
        $final_data = array();
	   
	   if($slug=='warehouse')
		  { 
			 $get_data1 = DB::table('tbl_warehouse')
			 ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
			 ->where('tbl_warehouse.warehouse_type','=',1)					
			 ->where('tbl_warehouse.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->warehouse_name.' - '.$get_data1[0]->warehouse_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(outt.invoce_outstandig) as invoce_outstandig,
			 customer.customer_name,customer.id,customer.customer_code as cust_code,warehouse_name.id as warehouse_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
			 LEFT JOIN tbl_customer as customer on outt.customer=customer.id
			 LEFT JOIN tbl_warehouse as warehouse_name on outt.warehouse=warehouse_name.id
			 WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND warehouse_name.id=".$warehous." AND customer.id=".$customer."
			 group by customer.id,warehouse_id,DATE(outt.created_at)
			 ORDER BY DATE(outt.created_at) DESC");
			 
			 
		  }
         else if($slug=='sub_region')
	      {
			  
			 $get_data1 = DB::table('tbl_sub_region')
			 ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->where('tbl_sub_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(outt.invoce_outstandig) as invoce_outstandig,
			 customer.customer_name,customer.id,customer.customer_code as cust_code,subregion.id as subregion_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
			 LEFT JOIN tbl_customer as customer on outt.customer=customer.id
			 LEFT JOIN tbl_warehouse as warehouse_name on outt.warehouse=warehouse_name.id
			 LEFT JOIN tbl_sub_region as subregion on warehouse_name.sub_region=subregion.id
			 WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND subregion.id=".$warehous." AND customer.id=".$customer."
			 group by customer.id,subregion_id,DATE(outt.created_at)
			 ORDER BY DATE(outt.created_at) DESC");
			 
		 }
         else
		 {

			 $get_data1 = DB::table('tbl_region')
			 ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			->where('tbl_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->region_code.' - '.$get_data1[0]->region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(outt.invoce_outstandig) as invoce_outstandig,
			 customer.customer_name,customer.id,customer.customer_code as cust_code,region.id as region_id,DATE(outt.created_at) as created_date FROM `tbl_company_outstanding` as outt
			 LEFT JOIN tbl_customer as customer on outt.customer=customer.id
			 LEFT JOIN tbl_warehouse as warehouse_name on outt.warehouse=warehouse_name.id
			 LEFT JOIN tbl_region as region on warehouse_name.region=region.id
			 WHERE date(outt.created_at) >= '".$fromdate."' AND  date(outt.created_at) <= '".$todate."' AND region.id=".$warehous." AND customer.id=".$customer."
			 group by customer.id,region_id,DATE(outt.created_at)
			 ORDER BY DATE(outt.created_at) DESC");
			
		 }
	   
			foreach($get_sales_material_wise as $row) {
                $temp_date = date('Y-m-d', strtotime($row->created_date));
                $item_name = $row->cust_code.' - '.$row->customer_name;
                $final_data_base[$temp_date]  = $row->invoce_outstandig;
            } 
		$html = "<table style='width: 100%;' id='example' class='table table-hover       table-striped table-bordered'>
		
		  <thead class='text-white'> 
            <tr style='background-color: #3f6ad8;'>
             <th colspan='2' class='text-center'> ".ucfirst($item_name)." </th>
           </tr>
           <tr style='background-color: #3f6ad8;'>
            <th> Date </th>
            <th>Total Item Sales</th>
           </tr>
           </thead>
           <tbody>";
            $current_date   = date('Y-m-d');
            $first_date     = date($fromdate);
            $last_date      = date($todate);
			$base_item_sales  = 0;
			while($first_date <= $last_date) {
                $date_sale_base  = isset($final_data_base[$first_date]) ? $final_data_base[$first_date] : 0;
				$base_item_sales +=$date_sale_base;
				if($date_sale_base!=0)
				{
                $html .= "
                           <tr>
                                <td>".date('d M y', strtotime($first_date))."</td>
                                <td>".number_format($date_sale_base,2)."</td>
                            <tr>
                        ";
				}

                $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));        
            }
			$html .= "
                           <tr>
                               <th class='text-center'>Total</th>
                               <th colspan='2'>".number_format($base_item_sales,2)."</th>
                            <tr>";
		   $html .= "
                    </tbody>
                </table>";
		    $return['html'] = $html;
           echo json_encode($return);die;
	  }/* END MATERIAL WISE SALES REPORT POPUP */	    
}
