<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CompanyExpensesModel;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\ExpenseTypeModel;
use App\Models\RouteModel;
use App\Models\CustomerModel;
use App\Models\WarehouseModel;
use App\Models\CustomerTypeModel;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class CompanyExpensesController extends Controller
 {
   public function list(Request $request)
	{ 
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
	  
	  if($request->fromdate!='')
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
			
	  if($request->customer!='')
		{
		 $warehouses=array();
		  $get_warehouse_id = DB::select("SELECT id from tbl_warehouse where distributor =".$request->customer."");			
		  
		  foreach($get_warehouse_id as $key=> $warehouse_id)
		    {
			  $warehouses[]=$warehouse_id->id;
		    }
				
		  $where .= "AND warehouse.id in (".implode(',',$warehouses).")";
		}
		
	  if($request->warehouse!='')
		{
		  $where .= "AND warehouse.id = '".$request->warehouse."'";
		}
	 
			$distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active');
	
			$get_data = DB::select("SELECT riheader.*, 
			expense.expense_code,expense.expense_name,
			warehouse.warehouse_code,warehouse.warehouse_name,currency.currency_notation
			
			FROM tbl_company_expenses as riheader
			
			LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
		
 
		return view('Company_Transaction.company_expenses_list',compact('get_data','distibutor'));
	
	}

   public function add()
	{
	  $result =CompanyExpensesModel::get()->sortByDesc('id')->first();
	  if($result=='')
		{
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->company_expense_no;
		}
	  else
		{
			 $getcode = $result->expense_no; 
			 $last_code = ++$getcode;
		}
		
		  $warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);		
			$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('expense_category', '=', 1)->where('status', '=', 'active');;
			//->where('expense_category', '=', 'company_expense');
	
			return view('Company_Transaction.company_expenses',compact('last_code','warehouse','expense_type'));
		
     }
	
    public function edit($id)
	 {
		$warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
		
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$get_data = DB::table('tbl_company_expenses')				
		->leftJoin('tbl_warehouse', 'tbl_company_expenses.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_expense_type', 'tbl_company_expenses.expense_type', '=', 'tbl_expense_type.id')
		
		->select('tbl_company_expenses.*', 'tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_expense_type.expense_code','tbl_expense_type.expense_name')				
		->where('tbl_company_expenses.id', '=', $id)				
		->first();			
		$last_code = $get_data->expense_no;

	    return view('Company_Transaction.company_expenses',compact('get_data','warehouse','expense_type','last_code'));
	
	 }
	
	public function view($id)
	 {
		$warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$get_data = DB::table('tbl_company_expenses')				
		->leftJoin('tbl_warehouse', 'tbl_company_expenses.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_expense_type', 'tbl_company_expenses.expense_type', '=', 'tbl_expense_type.id')
		
		->select('tbl_company_expenses.*', 'tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_expense_type.expense_code','tbl_expense_type.expense_name')				
		->where('tbl_company_expenses.id', '=', $id)				
		->first();			
		 

		return view('Company_Transaction.company_expenses_view',compact('get_data'));
		
	}
	
   public function save(Request $request)
	{
			
		$data=new CompanyExpensesModel;		 
		$user_id=Session::get('user_id');        		
		$login_user = DB::table('tbl_user')
		->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		->where('tbl_user.id', '=', $user_id)
		->get()->first();		 
 
	   if($request->updated_id)
		 { 
			$data = CompanyExpensesModel::find($request->updated_id);			
			$data->expense_no=$request->expense_no;
			$data->warehouse_id=$request->warehouse_id;
			$data->expense_type=$request->expense_type;
			$data->expense_date=$request->expense_date;
			$data->expense_amount=$request->expense_amt;
			$data->comment=$request->comment;   
			$data->created_user=$user_id;   
							
			$data->save();
		   
		   return redirect(route('company_expenses_list'))->with('successMessage',$request->expense_no.' '.'Expenses Updated Successfully');
	
		 } 
	   else
		 {           
			$data->currency = $login_user->currency_id;
			$data->expense_no=$request->expense_no;
			$data->warehouse_id=$request->warehouse_id;
			$data->expense_type=$request->expense_type;
			$data->expense_date=$request->expense_date;
			$data->expense_amount=$request->expense_amt;
			$data->comment=$request->comment;
			$data->created_user=$user_id;  
			$data->save();
			  return redirect(route('company_expenses_list'))->with('successMessage',$request->expense_no.' '.'Expenses Save Successfully');
		
		 }   
	 }
		 
	public function get_warehousename_filter_expense($id,$warehouse_url)
     {
		
		$material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=',1);
	
		?>
		<option  value="">     </option>
		<?php
	    foreach($material as $material_name)
		  {
			?>
			<option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
			<?php		
		  }
						//return response()->json($get_data);
		
	 }
	 
 }
