<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\ExpenseTypeModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\CompanyExpensesReportExport;

class CompanyExpensesReportController extends Controller
 {
   public function list()
	{		
	  //$get_data = SupplierTypeModel::all()->sortByDesc('id');
	   $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id; 
		 
	     }
		  $regId=implode(",",$all_region);
			
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')
		->where('status', '=', 'active')
		->where('expense_category', '=', 1);

	  return view('Report.company_expenses_report',compact('region','expense_type','regId'));  
	}
		
   public function get_company_expenses_subregion($region)
    {
		 $data = explode(',',$region);
		

		$sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		
		if(count($sub_region)>0)
		  {
			  foreach($sub_region as $subreg){
			  
		   $all_subregion[] = $subreg->id;
		  }
		  $subregId=implode(",",$all_subregion);
		  }
		else 	
		  {
		    $subregId = 0;
		  }	
   
			?>
			<option  value="">     </option>
			<?php if(count($sub_region) > 0){ ?>
			<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php } 
		foreach($sub_region as $sub_region_name)
		  {
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		    <?php  	   	
		  }
	 }
			
	public function get_company_expenses_warehouse($sub_region)
	 {
	    $data = explode(',',$sub_region);
		$warehouse =WarehouseModel::all()->sortByDesc('id')->whereIn('sub_region',$data)->where('status', '=', 'active')->where('warehouse_type', '=',1);
		
		if(count($warehouse)>0){
			foreach($warehouse as $subreg){
				
				$all_warehaouse[] = $subreg->id;
			}
			$allwarehaouse=implode(",",$all_warehaouse);
		}else{

			$allwarehaouse = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($warehouse) > 0){ ?>
			<option  value="0" data-value="<?php echo $allwarehaouse ?>">Select All</option>
		<?php } 
		foreach($warehouse as $warehouse_name)
		  {
			?>
			  <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
		   <?php  	 	   	
		  }
	  }
			
	public function get_company_expenses_report($region,$subregion,$warehouse,$expenses,$fromdate,$todate)
	 {
		 
		   $where="";
	     if($expenses!='s'){$where .= " AND riheader.expense_type='".$expenses."'"; }
          
	 if($warehouse!='s')
	 {
      $final_data  = array();
	   $data1 = explode(',',$warehouse);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		   ->where('tbl_warehouse.warehouse_type','=',1)
		   ->where('tbl_warehouse.status','=','active')
		   ->whereIn('tbl_warehouse.id',$data1)->get();
		     
		 foreach($get_data1 as $key=> $warehous)
		  {
		   $agent_name[$warehous->id] = $warehous->warehouse_name;
		   $agent_id[]=$warehous->id;
		   
		  }
	     
		$get_data = DB::select("SELECT 
		riheader.created_at, warehouse.warehouse_code,warehouse.warehouse_name,
		riheader.expense_no,currency.currency_notation,tbl_expense_type.expense_code,tbl_expense_type.expense_name,
		riheader.expense_amount FROM tbl_company_expenses as riheader
		LEFT JOIN tbl_expense_type on tbl_expense_type.id=tbl_expense_type.id
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
		WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' ".$where." AND riheader.warehouse_id  in (".implode(',',$agent_id).")");
		 $count=count($get_data); 
		  
		 
	    $count=count($get_data);	
	  if($count<1)
		{
		 $html ="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
			 
			 $total_base_sales  = array();  
		     
				 
		
		 
		    foreach($get_data as $key=>$data)
		  {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			$space=" ";
			$html .="<td class='font-weight-bold text-justify text-left'>".$row1."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->warehouse_code.' - '.ucfirst($data->warehouse_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->expense_no."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->expense_code.' - '.ucfirst($data->expense_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->currency_notation.'  '.$data->expense_amount."</td></tr>";
                   
		 }   
		
	    }
  
   $return['html'] = $html;
   echo json_encode($return);die;
}/* warehouse finished*/

  else if($subregion!='s')
	 {
		$final_data = array();
			$data1 = explode(',',$subregion);
			  $agent_name     = array(); 
			  $agent_id     = array(); 
			  $get_data1 = DB::table('tbl_sub_region')
			  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			  ->where('tbl_sub_region.status','=','active')
			  ->whereIn('tbl_sub_region.id',$data1)->get();
			  foreach($get_data1 as $key=> $sub_region)
				{
				 $agent_name[$sub_region->id] = $sub_region->sub_region_name;
				 $agent_id[]=$sub_region->id;
				}
			 
				$get_data = DB::select("SELECT 
				riheader.created_at, subregion.sub_region_code,subregion.sub_region_name,
			    riheader.expense_no,expense.expense_code,expense.expense_name,currency.currency_notation,
				riheader.expense_amount FROM tbl_company_expenses as riheader
				LEFT JOIN tbl_expense_type as expense on  expense.id=expense.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_sub_region as subregion on warehouse.sub_region=subregion.id
				LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
				WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' ".$where." AND subregion.id  in (".implode(',',$agent_id).")");
		$count=count($get_data);	
		
	  if($count<1)
		{
		 $html ="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
			$html ="";
		   foreach($get_data as $key=>$data)
		  {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			$space=" ";
			$html .="<td class='font-weight-bold text-justify text-left'>".$row1."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->sub_region_code.' - '.ucfirst($data->sub_region_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->expense_no."</td><td class='font-weight-bold text-justify text-left'>".$data->expense_code.' - '.ucfirst($data->expense_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->currency_notation.'  '.$data->expense_amount."</td></tr>";
                   
		  }
		
	    }
  
					
		 $return['html'] = $html;
        echo json_encode($return);die;
		}/* END SUBREGION SALES REPORT */
    
 else  if($region!='s')
	  {
	    $final_data         = array();
		$data1 = explode(',',$region);
		 $agent_name     = array(); 
		 $agent_id     = array(); 
		 $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->where('tbl_region.status','=','active')
		->whereIn('tbl_region.id',$data1)->get()->all();
		 foreach($get_data1 as $key=> $region)
		  {
		   $agent_name[$region->id] = $region->region_name;
		   $agent_id[]=$region->id;
		  }
		 
		 $get_data = DB::select("SELECT 
		riheader.created_at, region.region_code,region.region_name,
		riheader.expense_no,expense.expense_code,expense.expense_name,currency.currency_notation,
		riheader.expense_amount FROM tbl_company_expenses as riheader 
		LEFT JOIN tbl_expense_type as expense on  expense.id=expense.id
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		LEFT JOIN tbl_region as region on warehouse.region=region.id
		LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
		WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' ".$where." AND region.id  in (".implode(',',$agent_id).")");
		 
		$count=count($get_data);	
		 
	  if($count<1)
		{
		 $html ="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
			$html ="";
		   foreach($get_data as $key=>$data)
		  {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			
			$html .="<td class='font-weight-bold text-justify text-left'>".$row1."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->region_code.' - '.ucfirst($data->region_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->expense_no."</td><td class='font-weight-bold text-justify text-left'>".$data->expense_code.' - '.ucfirst($data->expense_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->currency_notation.'  '.$data->expense_amount."</td></tr>";
                   
		  }
		
	    }
  	
    }
	$return['html'] = $html;
   echo json_encode($return);die;
 }
	  
	public function get_company_expenses_reportxls(Request $request)
	 {
		
		$region=$request->region1;
		$subregion=$request->subregion1;
		$warehouse=$request->warehouse1;
		$expenses=$request->expenses1;
		$fromdate=$request->fromdate1;
		$todate=$request->todate1;
		 return Excel::download(new CompanyExpensesReportExport($region,$subregion,$warehouse,$expenses,$fromdate,$todate), 'customer_expenses_report.xlsx');

      }
 }
