<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CurrencyTypeModel;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use App\Exports\SalesInvoiceExport;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use App\Models\CustomerTypeModel;
use App\Models\CompanyOutstandingModel;
use App\Models\ReasonTypeModel;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Session;

class CompanyInvoiceController extends Controller
 {
   public function list(Request $request)
	{
		//dd($request);
		 $current_date=date("Y-m-d");

		 $where="";		
	   if(count($request->all()) < 1)
		 {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		 }
	  
	   if($request->fromdate!='')
		 {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		 }
		 
		if($request->customer!='')
		  {
			$where .= "AND customer.id = '".$request->customer."'";
		  }
					
		if($request->warehouse!='')
		  {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		  }
		
			$distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active');
			//$get_data = CurrencyTypeModel::all()->sortByDesc('id');
			$get_data = DB::select("SELECT riheader.*, 
			customer.customer_code,customer.customer_name,
			delivery_no.company_delivery_number,
			warehouse.warehouse_code,warehouse.warehouse_name,		
			currency.currency_notation		
			FROM tbl_company_invoice_header as riheader		
			LEFT JOIN tbl_customer as customer on riheader.customer=customer.id
			LEFT JOIN tbl_company_delivery_header as delivery_no on riheader.delivery_number=delivery_no.id	
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse=warehouse.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
	
			/*	$get_data = DB::table('tbl_route_invoice_header')
			->join('tbl_trading_center', 'tbl_route_invoice_header.trading_center_id', '=', 'tbl_trading_center.id')
			->join('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
			->join('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
			->join('tbl_warehouse', 'tbl_route_invoice_header.warehouse', '=', 'tbl_warehouse.id')
			->join('tbl_salesman', 'tbl_route_invoice_header.salesman', '=', 'tbl_salesman.id')
			
			->select('tbl_route_invoice_header.*', 'tbl_trading_center.trading_name','tbl_route.route_name','tbl_route.route_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code')
			->get()->all();
			// 	
			*/
			return view('Company_Transaction.invoice_list',compact('get_data','distibutor'));
		}
	
	   public function add()
		{   
	        $user_id=Session::get('user_id');	  
        	$result = DB::table('tbl_company_invoice_header')
             ->select('tbl_company_invoice_header.*')->get()->sortByDesc('id')->first();
			 
		    if($result=='')
		      {
			    $getcode = ManageCodeModel::where('id', 1)->first();
			    $last_code = $getcode->company_invoice_no;
	          }
		    else
		     {
			   $getcode = $result->company_invoice_number; 
			   $last_code = ++$getcode;
		     }

               $material_master = DB::table('tbl_material_master')
               ->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
            
               ->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')
		
               ->get()->all();
			
		       $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  
		       /*$user_login =UserModel::all()->sortByDesc('id')->where('id','=',$user_id)->where('status', '=', 'active');
		  
		       echo $user_login->company_id;
		       exit;
		       */		
               $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  
		       $login_user = DB::table('tbl_user')
               ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			   ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
               ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			   ->where('tbl_user.id', '=', $user_id)
		       ->get()->first();
			   //dd($login_user);
		 
    	      return view('Company_Transaction.invoice',compact('last_code','material_master','material_category','material','login_user'));
	 
       }
		
	  public function get_delivery_number_details($id,$return)
       {			
			$order_name =DB::table('tbl_company_delivery_header')
			->leftJoin('tbl_customer', 'tbl_company_delivery_header.customer', '=', 'tbl_customer.id')
			->select('tbl_company_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_company_delivery_header.order_type', '=',$return)->where('tbl_company_delivery_header.is_invoice', '=', '0')->get()->all();
						   
			$get_data =DB::table('tbl_company_delivery_header')
            ->select('tbl_company_delivery_header.*')->where('tbl_company_delivery_header.id', '=',$id)->get()->first();
			
			$get_order_number =DB::table('tbl_company_order_header')
             ->select('tbl_company_order_header.company_order_number')->where('tbl_company_order_header.id', '=',$get_data->order_number)->get()->first();
			
		  $get_data_details =DB::table('tbl_company_delivery_detail')
	           ->leftJoin('tbl_material_master', 'tbl_company_delivery_detail.material_id', '=', 'tbl_material_master.id')
		       ->leftJoin('tbl_unit_of_measurement', 'tbl_company_delivery_detail.uom', '=', 'tbl_unit_of_measurement.id')
	  
               ->select('tbl_company_delivery_detail.*','tbl_material_master.material_name','tbl_material_master.material_code as mate_code','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.uom_code','tbl_unit_of_measurement.unit_notation')->where('tbl_company_delivery_detail.header_id', '=', $id)->get()->all();
		 
			  $user_id=Session::get('user_id');
			
				$login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();
			  
			  
		
			  $user_id=Session::get('user_id');
  
			  $user_id=Session::get('user_id');
  
			  $result = DB::table('tbl_company_invoice_header')
			  ->select('tbl_company_invoice_header.*')->get()->sortByDesc('id')->first();
		 
				if($result=='')
			      {
				    $getcode = ManageCodeModel::where('id', 1)->first();
				    $last_code = $getcode->company_invoice_no;
			      }
			    else
				  {
					 $getcode = $result->company_invoice_number; 
					 $last_code = ++$getcode;
				  }

				$material_master = DB::table('tbl_material_master')
				->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
            
				->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')		
				->get()->all();
			
				$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		   
				$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
					$login_user = DB::table('tbl_user')
					->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
					->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
					->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
					->where('tbl_user.id', '=', $user_id)
					->get()->first();
					//dd($login_user);
		  
				return view('Company_Transaction.invoice',compact('last_code','material_master','material_category','material','login_user','get_data','get_data_details','order_name','get_order_number'));
	 		 
	  }
			
	 public function get_delivery_number($id)
      {
 
	     $get_data1 =DB::table('tbl_company_delivery_header')
		 ->leftJoin('tbl_customer', 'tbl_company_delivery_header.customer', '=', 'tbl_customer.id')
		 ->select('tbl_company_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_company_delivery_header.order_type', '=',$id)->where('tbl_company_delivery_header.is_invoice', '=', '0')->get()->all();

		 ?>
		 <option  value="">     </option>
		 <?php
		 foreach($get_data1 as $order_name)
	       {
			 ?>
			 <option value="<?php echo $order_name->id ?>"  ><?php echo $order_name->company_delivery_number .' ( '. $order_name->customer_code.' - '. $order_name->customer_name ?> )</option>	
			 <?php		
		   }
 
	  }
		  
	 public function save(Request $request)
	  {	
         
		 // getting details of delivery number;
		 $get_cust =DB::table('tbl_company_delivery_header')		        
		->select('tbl_company_delivery_header.customer','tbl_company_delivery_header.warehouse','tbl_company_delivery_header.delivery_date','tbl_company_delivery_header.distribution_type','tbl_company_delivery_header.tin_no')->where('tbl_company_delivery_header.id', '=',$request->order_number)->  where('tbl_company_delivery_header.is_invoice', '=', '0')->get()->first();
	
	   $current = Carbon::now();
	   $user_id=Session::get('user_id');
		
			$login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
  
		 //add flag in delevery
		  DB::table('tbl_company_delivery_header')
		   ->where('id', $request->order_number)
		   ->update(['is_invoice' => '1']); 
		 
		 //getting credit days of customer
		  $customer_creditdays = DB::table('tbl_customer')
		 ->select('tbl_customer.credit_days')->where('tbl_customer.id', '=', $get_cust->customer)->get()->first();

		  //adding credit days with current date
		  $current_date=date("Y-m-d");  
		  $date=date_create($current_date);
		  date_add($date,date_interval_create_from_date_string(" ".$customer_creditdays->credit_days." days"));
		  $due_date= date_format($date,"Y-m-d");


		 $data3=array(
					 'company_invoice_number'      =>  $request->company_invoice_number,
					 'currency'            =>  $login_user->currency_id,
					 'delivery_number'        =>$request->order_number,
					 
					 'delivery_date'          =>  $get_cust->delivery_date,
					 'customer'             =>  $get_cust->customer,
					 'warehouse'          =>  $get_cust->warehouse,
					  'distribution_type'   =>  $get_cust->distribution_type,
					 'tin_no'          =>  $get_cust->tin_no,
					 
					 'order_type'          =>  $request->order_typehidden,
					 'total_gross'         =>  $request->gross_amount_totali,
					 'net_total_amount'    =>  $request->net_amount_totali,
					 'total_Excise'        =>  $request->excise_amount_totali,
					 'total_vat'           =>  $request->vat_amount_totali,

					  'total_discount'      =>$request->vat_amount_totali,
					  'total_invoice_value' =>  $request->invoice_amount_totali,
					  'created_at'         => $current,
					  'created_user'         => $user_id,
		             );
						
					$header_id =DB::table('tbl_company_invoice_header')->insertGetId($data3);
					
					//add data in outstanding
					$data=new CompanyOutstandingModel;
					$data->customer=$get_cust->customer;
					$data->warehouse=$get_cust->warehouse;
					$data->invoice_id=$header_id;
					$data->invoice_number=$request->company_invoice_number;
					$data->invoice_total=$request->invoice_amount_totali;
					$data->invoice_paid=0;
					
					$data->invoce_outstandig=$request->invoice_amount_totali;
					$data->due_date=$due_date;
					$data->delivery_type='is_invoice';
					
					$data->save();
					 
			 foreach($request['material_name'] as $key => $n)
			   {
			     if($request->quantity[$key ]!='')
			       {
					  
				     $data2=array(
					 'material_id' => $request->material_name[$key ],
					 'header_id'           =>$header_id,
					 'uom'           => $request->uom[$key ],
					 'unite_price'   => $request->price[$key ],
					 'gross_total'   => $request->gross[$key ],
					 'vat'           => $request->vat[$key ],
					 'excise'        => $request->excise[$key ],
					 'total'         => $request->total[$key ],
					 'base_qty'      => $request->packing_size[$key ],
					 'net_amount'    => $request->net_amount[$key ],
					 'quantity'    => $request->quantity[$key ],
				
					 'created_at'    => $current,
					 );
				
					 DB::table('tbl_company_invoice_details')->insert($data2);
			       }
                }
		 
			  return redirect(route('company_invoice_list'))->with('successMessage',$request->company_invoice_number.' '.'Invoice Save Successfully');
      }
	  
	 public function view($id)
	  {   
			$user_id=Session::get('user_id');
			$get_data =DB::table('tbl_company_invoice_header')		
			->leftJoin('tbl_customer', 'tbl_company_invoice_header.customer', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_company_invoice_header.warehouse', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_customer_type', 'tbl_company_invoice_header.distribution_type', '=', 'tbl_customer_type.id')
			//->join('tbl_warehouse', 'tbl_company_order_header.warehouse', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_currency_type', 'tbl_company_invoice_header.currency', '=', 'tbl_currency_type.id')
			->select('tbl_company_invoice_header.*','tbl_customer.customer_name','tbl_customer.customer_code',
			'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_customer_type.customer_type_name','tbl_customer_type.customer_type_code','tbl_currency_type.currency_notation')->where('tbl_company_invoice_header.id', '=',$id)->get()->first();
		 
			$get_data_details =DB::table('tbl_company_invoice_details')

			  ->leftJoin('tbl_material_master', 'tbl_company_invoice_details.material_id', '=', 'tbl_material_master.id')
			  ->leftJoin('tbl_unit_of_measurement', 'tbl_company_invoice_details.uom', '=', 'tbl_unit_of_measurement.id')
	  
			  ->select('tbl_company_invoice_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mate_code','tbl_unit_of_measurement.unit_notation')->where('tbl_company_invoice_details.header_id', '=', $id)->get()->all();
		  
		  
			$login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();			  
	 
			return view('Company_Transaction.invoice_view',compact('get_data','get_data_details','login_user'));

	  }
		
     public function get_routename_filter_invoice($id,$warehouse_url)
      {
		$material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=',1);
	
		?>
		<option  value="">     </option>
		<?php
		foreach($material as $material_name)
		  {
				?>
				<option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
				<?php		
		  }
		 //return response()->json($get_data);
	
     }
	 
	 public function sales_invoice_export($id) 
    {
        return Excel::download(new SalesInvoiceExport($id), 'sales_invoice.xlsx');
    }
	public function sales_invoice_export_pdf($id)
	 {
		 
		 $user_id=Session::get('user_id');
		 
		$get_data = DB::table('tbl_company_invoice_header')
		         ->leftjoin('tbl_customer','tbl_company_invoice_header.customer','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','tbl_company_invoice_header.warehouse','=','tbl_warehouse.id')
		         ->leftjoin('tbl_currency_type','tbl_company_invoice_header.currency','=','tbl_currency_type.id')
		         ->leftjoin('tbl_company_delivery_header','tbl_company_invoice_header.delivery_number','=','tbl_company_delivery_header.id')
				 
		  
                 ->select('tbl_company_invoice_header.company_invoice_number','tbl_company_invoice_header.created_at','tbl_customer.*','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_company_invoice_header.total_invoice_value','tbl_company_delivery_header.company_delivery_number','tbl_currency_type.currency_notation',
				 
				 'tbl_company_invoice_header.total_gross',
				 'tbl_company_invoice_header.total_vat',
				 'tbl_company_invoice_header.total_excise',
				 'tbl_company_invoice_header.net_total_amount',
				 'tbl_company_invoice_header.total_discount',
				 
				 )
				  ->where('tbl_company_invoice_header.id','=',$id)
				 ->get()->first();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_invoice_details')

	   ->leftJoin('tbl_material_master', 'tbl_company_invoice_details.material_id', '=', 'tbl_material_master.id')
	   ->leftJoin('tbl_unit_of_measurement', 'tbl_company_invoice_details.uom', '=', 'tbl_unit_of_measurement.id')
       ->select('tbl_material_master.material_name', 'tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation','tbl_company_invoice_details.quantity','tbl_company_invoice_details.unite_price','tbl_company_invoice_details.discount','tbl_company_invoice_details.vat','tbl_company_invoice_details.excise','tbl_company_invoice_details.net_amount','tbl_company_invoice_details.gross_total')
	   
	    ->where('tbl_company_invoice_details.header_id','=',$id)
	   ->get()
	   ->all();
		 $pdf=PDF::loadView('export.pdf.comapny_sales_invoice_pdf',compact('get_data','get_data_details'));
		  
		  return $pdf->download('sales_invoice.pdf');
	
        
	    //return response()->json($get_data);
	 }
	
 }
