<?php

namespace App\Http\Controllers;  
use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel;
use App\Models\CustomerModel;
use App\Models\ClientModel;
use App\Models\ReasonModel;
use App\Models\MaterialCategoryModel;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Session;
use PDF;
use App\Exports\StockTransferExport; 
use Maatwebsite\Excel\Facades\Excel;
class CompanyStockTransferController extends Controller
 {	

  public function list(Request $request)
   {   
      
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
	    {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
	   
	  if($request->fromdate!='')
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
			
			
	  if($request->warehouse!='')
	    {
		  $where .= "AND warehouse.id = '".$request->warehouse."'";
	    }
		 
				$get_data = DB::select("SELECT riheader.*, 
				warehouse.warehouse_code,warehouse.warehouse_name,
				warehouse1.warehouse_code as transfer_w_code,warehouse1.warehouse_name as transfer_w_name,reason_code,reason_name					
				FROM tbl_company_stock_transfer_header as riheader
				LEFT JOIN tbl_warehouse as warehouse on riheader.from_warehouse=warehouse.id
				LEFT JOIN tbl_warehouse as warehouse1 on riheader.transfer_warehouse=warehouse1.id
				LEFT JOIN tbl_reason on riheader.transfer_reason=tbl_reason.id
				WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC ");
				
				$warehouse=WarehouseModel::get()->where('status', '=', 'active')->whereIn('warehouse_type', [0,1])->where('status', '=', 'active')->all();
			
			return view('Stock_Management.company_stock_transfer_list',compact('get_data','warehouse'));
	}
 
   public function add()
	{ 	
	   
	   $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $reason1 =ReasonModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   
		$get_data=WarehouseModel::get()->where('status', '=', 'active')->whereIn('warehouse_type', [0,1])->where('status', '=', 'active')->all();		
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
		
		return view('Stock_Management.company_stock_transfer',compact('get_data','material_category','material','reason1'));
	}
	
   public function view($view)
	{   

		//$user_id=Session::get('user_id');
		$get_data =DB::table('tbl_company_stock_transfer_header')

		->leftJoin('tbl_warehouse', 'tbl_company_stock_transfer_header.from_warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_warehouse as t_warehouse', 'tbl_company_stock_transfer_header.transfer_warehouse', '=', 't_warehouse.id')
		->leftJoin('tbl_reason', 'tbl_company_stock_transfer_header.transfer_reason', '=', 'tbl_reason.id')
		
		->select('tbl_company_stock_transfer_header.*',
		'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','t_warehouse.warehouse_name as t_warehouse_name','t_warehouse.warehouse_code as t_warehouse_code','tbl_reason.reason_code','tbl_reason.reason_name')->where('tbl_company_stock_transfer_header.id', '=',$view)->get()->first();
		 
		//dd($get_data);
		
		$get_data_details =DB::table('tbl_company_stock_transfer_details')

	    ->leftJoin('tbl_material_master', 'tbl_company_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
	    ->leftJoin('tbl_unit_of_measurement', 'tbl_company_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
	  

	    ->select('tbl_company_stock_transfer_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_company_stock_transfer_details.header_id', '=', $view)->get()->all();
	  
		   //dd($get_data_details);  
		
		return view('Stock_Management.company_stock_transfer_view',compact('get_data','get_data_details'));
	}
			
   public function warehouse_material_details($id)
	{ 	
		$get_data=WarehouseStockModel::get()->where('warehouse_id','=',$id)->all();
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
	
	}

   public function get_transfer_warehouse_list($id)
	{ 	
		$get_data=WarehouseModel::get()->where('id','!=',$id)->whereIn('warehouse_type', [0,1])->where('status', '=', 'active')->all();
		?>
		<option  value=""> </option>
		<?php
		
		foreach($get_data as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		
     }
	
	public function get_category_details($id)
	 { 	
		$get_data=WarehouseModel::get()->where('status', '=', 'active')->all();		
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();		
		$get_transfer_warehouse=WarehouseModel::get()->where('id','!=',$id)->all();   	
		return view('Company_Transaction.company_stock_transfer',compact('get_data','material_category','get_transfer_warehouse'));
		
	 }
		
	public function save(Request $request)
	 {
		
		$current = Carbon::now();
		$date = str_replace('/', '-', $request->adjust_date);
		$newDate = date("d-m-Y", strtotime($date));
			
		$data3=array
				    (
					
					  'from_warehouse'           =>     $request->warehouse_stock,
					  'transfer_warehouse'       =>     $request->transfer_warehouse,
					  'transfer_date'            =>     $request->transfer_date,
					  'reason_type'              =>     $request->reason_type,
			          'transfer_reason'          =>     $request->reason_is,
					  'remark'                   =>     $request->remark,
					  'status'                   =>     'transferred',
					  'created_at'               =>     $current,
			        );
		 $header_id =DB::table('tbl_company_stock_transfer_header')->insertGetId($data3); 
		 
		 if(count($request->material_name)>0)
		   {
				foreach($request['material_name'] as $key => $n)
				  {
				   if($request->quantity[$key ]!='')
				     {
					   $material_details= DB::table('tbl_material_master')
							->select('tbl_material_master.uom_id', 'tbl_material_master.material_category_id',  'tbl_material_master.material_types_id')
							->where('tbl_material_master.id','=',$request->material_name[$key ])
						    ->get()->first();
					   
							   
				   $data2=array(
								 'material_id'           => $request->material_name[$key ],
								 'header_id'             => $header_id,
								 'uom_id'                => $request->uomh[$key ],
								 'material_category_id'  => $material_details->material_category_id,
								 'stock_qty'             => $request->quantity[$key ],
								 
								 'balance_qty'           => $request->discount[$key ],
								 'created_at'            => $current,
							   );
							 
						 DB::table('tbl_company_stock_transfer_details')->insert($data2); 
						 
						 //storing data in warehouse_stock
							 $material_master = DB::table('tbl_warehouse_stock')
							  ->where('tbl_warehouse_stock.warehouse_id','=',$request->transfer_warehouse)
							  ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
							  ->get()->all();
							  
							  $count=count($material_master);
							  if($count>0)
							    {
								
								  // reducing from 1st warehouse
								  $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id', $request->warehouse_stock)
								  ->where('material_id','=',$request->material_name[$key]);
								  
								   $query->decrement('qty',$request->quantity[$key]*$request->packing_size[$key]);
								   
									// increamenting from 2nd warehouse
								   $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id', $request->transfer_warehouse)
								  ->where('material_id','=',$request->material_name[$key]);
								   $query->increment('qty',$request->quantity[$key]*$request->packing_size[$key]);
								}
							  else
							    {
								   // reducing from 1st warehouse
								   $query = DB::table('tbl_warehouse_stock')
								   ->where('warehouse_id', $request->warehouse_stock)
								   ->where('material_id','=',$request->material_name[$key]);
								   
								    $query->decrement('qty',$request->quantity[$key]*$request->packing_size[$key]);
								   //when stock does not exist
								  
									 $warehouse_details = DB::table('tbl_warehouse')
										->select('tbl_warehouse.region',  'tbl_warehouse.sub_region')
										->where('tbl_warehouse.id','=',$request->transfer_warehouse)
										->get()->first();
							
						   
							   $data4=array(
											 'region'                => $warehouse_details->region,
											 'subregion'             => $warehouse_details->sub_region,
											 'warehouse_id'          => $request->transfer_warehouse,
											 'material_category_id'  => $material_details->material_category,
											 'material_id'           => $request->material_name[$key],
											 'uom_id'                => $material_details->uom,
											 'qty'                   => $request->quantity[$key ]*$request->packing_size[$key],
											 'material_type'         => $material_details->material_types,
											 'created_at'            => $current,
											);	
						  			
						   DB::table('tbl_warehouse_stock')->insert($data4);
						   
						   
							   }
							 
					  } 
				 }
	  
			}
			
           				
					
					
			return redirect(route('company_stock_transfer_list'))->with('successMessage','Stock Transfered Successfully');
	 }
				
    public function get_material_price($id,$val,$uom,$reason_type)
	 {
	     
			$alt_unit_price = DB::select('SELECT qty as stock FROM `tbl_warehouse_stock` as ws WHERE ws.warehouse_id='.$id.' AND  `material_id` ='.$val.'');
			
			$s=0;
			$count=count($alt_unit_price);
					if($count > 0)
					echo $alt_unit_price[0]->stock;
					else
					echo $s;
		  
	 }
		
	public function get_material_detailsUom($id,$row)
	 {
			
		$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.unit_notation','tbl_unit_of_measurement.uom_code')
			->where('tbl_material_master.id','=',$id)
			->get()->all();
			
		$alt_uom = explode(",",$material_master[0]->alt_uom);
	   
		$key = array_search($material_master[0]->uom_id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material_master[0]->alt_packing_size);
			
		echo $material_master[0]->unit_notation.'-'.$material_master[0]->uom_id.'-'. $alt_alt_packing_size[$key];
				    
	 }
	  
	  public function get_reason($route)
	{ 
        
		  $data =ReasonModel::select('reason_name','id')->where('reason_type','=',$route)->where('status', '=', 'active')->get();
		$html = '';
      if(count($data) > 0) {
        foreach($data as $reason_name) {
			$html .='<option value=""></option>';
            $html .= '<option class="opt_v1" value="' . $reason_name->id . '">'. $reason_name->reason_name;
            $html .= "</option>";
        }
      return response()->json($html);//then sent this data to ajax success 
	}
		
	}
	
	public function company_stock_transfer_export($id){
		
		return Excel::download(new StockTransferExport($id),'stock_export.xlsx');
	}
	
	public function company_stock_transfer_pdf($id){
		
		$get_data =DB::table('tbl_company_stock_transfer_header')
           ->leftJoin('tbl_warehouse', 'tbl_company_stock_transfer_header.from_warehouse', '=', 'tbl_warehouse.id')
		   ->leftJoin('tbl_warehouse as t_warehouse', 'tbl_company_stock_transfer_header.transfer_warehouse', '=', 't_warehouse.id')
		   ->leftJoin('tbl_reason', 'tbl_company_stock_transfer_header.transfer_reason', '=', 'tbl_reason.id')
		   ->select('tbl_company_stock_transfer_header.*','tbl_warehouse.warehouse_name','tbl_warehouse.contact_no','tbl_warehouse.address','tbl_warehouse.warehouse_code','t_warehouse.warehouse_name as t_warehouse_name','t_warehouse.warehouse_code as t_warehouse_code','tbl_reason.reason_code','tbl_reason.reason_name')->where('tbl_company_stock_transfer_header.id', '=',$id)->get()->first();
		$get_data_details =DB::table('tbl_company_stock_transfer_details')
           ->leftJoin('tbl_material_master', 'tbl_company_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
	       ->leftJoin('tbl_unit_of_measurement', 'tbl_company_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
	       ->select('tbl_company_stock_transfer_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_company_stock_transfer_details.header_id', '=', $id)->get()->all();
		   
		$pdf=PDF::loadView('export.pdf.stock_transfer_pdf', compact('get_data','get_data_details'));
		return $pdf->download('stock_export.pdf');
	}
 }
