<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CompanyTypeModel;
use App\Models\ManageCodeModel;
use App\Exports\CompanyTypeExport;
use Maatwebsite\Excel\Facades\Excel;

use Session;

class CompanyTypeController extends Controller
 {
   public function list()
	{		
		$get_data = CompanyTypeModel::all()->sortByDesc('id');		
		return view('Parameters_Configuration.company_type_list',compact('get_data'));
	}
	
   public function add()
	{ 
	  $result =CompanyTypeModel::get()->sortByDesc('id')->first();
	  if($result=='')
		{
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->company_type_code;
		}
	  else
		{
			 $getcode = $result->company_type_code; 
			 $last_code = ++$getcode;
		} 
			return view('Parameters_Configuration.company_type',compact('last_code'));
	}	
	
   public function edit($id)
	{
		$get_data=CompanyTypeModel::find($id);
		$last_code = $get_data->company_type_code;
		
		return view('Parameters_Configuration.company_type',compact('get_data','last_code'));
	}
	
   public function save(Request $request)
		{
	
				$data=new CompanyTypeModel;				
				if($request->updated_id) 
			      {			 
					$data = CompanyTypeModel::find($request->updated_id);
					$data->company_type_code=$request->company_type_code;
					$data->company_type_name=$request->company_type_name;
					$data->updated_user= Session::get('user_id');
					$data->status=$request->status;
					$data->save();
					return redirect(route('company_type_list'))->with('successMessage','Company Type Updated Successfully');
		
		          }
			    else
			      {			
					$data->company_type_code=$request->company_type_code;
					$data->company_type_name=$request->company_type_name;
					$data->created_user= Session::get('user_id');
					$data->status=$request->status;
					$data->save();
					return redirect(route('company_type_list'))->with('successMessage','Company Type Added Successfully');
			
			     }	
    	 
	 }
	 
	 public function exportexcel()
	 
	{
		return Excel::download(new CompanyTypeExport,'companytypeexcel.xlsx');
		
	}
	
	 public function exportpdf()
	 
	{
		return Excel::download(new CompanyTypeExport,'companytypepdf.pdf');
		
	}
	
	 
 }
