<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CustomerCategoryModel;
use App\Models\TripCodeModel;
use App\Models\CustomerTypeModel;
use Session;
use App\Models\ManageCodeModel;
use Illuminate\Support\Facades\DB; 

class CustomerCategoryController extends Controller
 {
   public function list()
	{
		
		$get_data = DB::table('tbl_customer_category')
		->leftJoin('tbl_customer_type', 'tbl_customer_category.customer_type_id', '=', 'tbl_customer_type.id')
		
		->select('tbl_customer_category.*', 'tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name')
		->orderBy('id', 'DESC')
		->get()->all();
		
		return view('Parameters_Configuration.customer_category_list',compact('get_data'));
	}
		
   public function add()
	{ 
		 $result =CustomerCategoryModel::get()->sortByDesc('id')->first();
		 $customer_type=CustomerTypeModel::get()->where('status', '=', 'active');
		 //dd($customer_type);   
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->customer_category_code;
		  }
		else
		{
			 $getcode = $result->customer_category_code; 
			 $last_code = ++$getcode; 
		} 
		return view('Parameters_Configuration.customer_category',compact('last_code','customer_type'));
	}
		
   public function edit($id)
	{
		$get_data=CustomerCategoryModel::find($id);
		$last_code = $get_data->customer_category_code;
		$customer_type=CustomerTypeModel::get()->where('status', '=', 'active');
		
		return view('Parameters_Configuration.customer_category',compact('get_data','last_code','customer_type'));
	}
		
   public function save(Request $request)
	{

	  $data=new CustomerCategoryModel;				
	  if($request->updated_id)
        {
			
			$data = CustomerCategoryModel::find($request->updated_id);
			$data->customer_category_code=$request->customer_category_code;
			$data->customer_category_name=$request->customer_category_name;
			$data->customer_type_id=$request->customer_type;  
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('customer_category_list'))->with('successMessage','Customer Category Updated Successfully');

		 }
	   else
         {
			
			$data->customer_category_code=$request->customer_category_code;
			$data->customer_category_name=$request->customer_category_name;
			$data->customer_type_id=$request->customer_type;
			$data->created_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('customer_category_list'))->with('successMessage','Customer Category Added Successfully');
		
		 }	 
     }
	 
	 
	 
	 
	 
	 
	 
 }
