<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\DeviceAllotmentModel;
use App\Models\DeviceEnrollmentModel;
use App\Models\SalesmanModel;
use DB;

class DeviceAllotmentController extends Controller
{
    //
	   public function list()
    {  
	  
	$get_data=DB::table('tbl_device_allotment')
	->leftjoin('tbl_device_enrollment','tbl_device_allotment.device_name','=','tbl_device_enrollment.id')
	->leftjoin('tbl_salesman_type','tbl_device_allotment.user_type','=','tbl_salesman_type.id')
	->leftjoin('tbl_salesman','tbl_device_allotment.user_name','=','tbl_salesman.id')
	 
	->select(
	'tbl_device_allotment.*',
	'tbl_device_enrollment.device_code',
	'tbl_device_enrollment.device_name',
	'tbl_device_enrollment.imei_1',
	'tbl_salesman_type.salesman_type_code',
	'tbl_salesman_type.salesman_type_name',
	'tbl_salesman.salesman_code',
	'tbl_salesman.salesman_name') 
	->get()->all();
	//dd($get_data);
	 
		return view('Device_Management.device_allotment_list',compact('get_data'));
     }
	 
	 
	     public function add()
	 {    
	      $deviceName =  DB::table('tbl_device_enrollment')
	      ->select('tbl_device_enrollment.*')->where('is_alloted', '=', '0')
	      ->get()->all();
		  
		  $usertype =  DB::table('tbl_salesman_type')
	      ->select('tbl_salesman_type.*')->where('status', '=', 'active')
	      ->get()->all();
		  
		/*   */ 
	    //  dd($deviceName); 
		  return view('Device_Management.device_allotment',compact('deviceName','usertype'));
		   
     }
	 
	  public function get_username($usertypeid,$user_name)
	 { 
	 
		$username = SalesmanModel::all()->where('salesman_type_id','=' , $usertypeid)
		->where('status', '=', 'active');  
		    
		   ?>
		<option  value="">     </option>
		<?php
     	foreach($username as $get_data)
		  {
			?>
			<option <?php if($get_data->id==$user_name){ echo "selected"; } ?> value="<?php echo $get_data->id ?>"  ><?php echo $get_data->salesman_code." - ".$get_data->salesman_name ?></option>	     
			<?php		
		  } 
	}
		 
	     public function save(Request $request)
	 {    
	 	$data=new DeviceAllotmentModel;
		if($request->updated_id) 
			{
			$data = DeviceAllotmentModel::find($request->updated_id);		
	        $data->device_name=$request->device_name; 
			$data->user_type=$request->user_id;
			$data->user_name=$request->user_name; 
			$data->assign_date=$request->assign_date;  
			$data->validate_date=$request->validate_date;  
			$data->registered_line=$request->registered_line;
			$data->status=$request->status;
			$data->save(); 
			
			return redirect(route('device_allotment_list'))->with('successMessage','Device Updated Successfully'); 
			}
	 else
	 {
			$data->device_name=$request->device_name; 
			$data->user_type=$request->user_id;
			$data->user_name=$request->user_name; 
			$data->assign_date=$request->assign_date;  
			$data->validate_date=$request->validate_date;  
			$data->registered_line=$request->registered_line;
			$data->status=$request->status;
			$data->save(); 
			 
			 $sql = $data->save(); 
			 
			if($sql)
				{
				 DB::table('tbl_device_enrollment')->where('id', $request->device_name)
		             ->update(['is_alloted' => '1']);
				}
		return redirect(route('device_allotment_list'))->with('successMessage','Device Allotment Save Successfully');
		  
     }}
	 
	 public function view($id)
	 {
		 
	$get_data=DB::table('tbl_device_allotment')
	->leftjoin('tbl_device_enrollment','tbl_device_allotment.device_name','=','tbl_device_enrollment.id')
	->leftjoin('tbl_salesman_type','tbl_device_allotment.user_type','=','tbl_salesman_type.id')
	->leftjoin('tbl_salesman','tbl_device_allotment.user_name','=','tbl_salesman.id')
	 
	->select(
	'tbl_device_allotment.*',
	'tbl_device_enrollment.device_code',
	'tbl_device_enrollment.device_name',
	'tbl_device_enrollment.imei_1',
	'tbl_salesman_type.salesman_type_code',
	'tbl_salesman_type.salesman_type_name',
	'tbl_salesman.salesman_code',
	'tbl_salesman.salesman_name') 
	->first();
		  
		return view('Device_Management.device_allotment_view',compact('get_data'));
	 }
	 
	  public function edit($id)
	 {
	    $get_data = DeviceAllotmentModel::find($id);
		$deviceName =  DB::table('tbl_device_enrollment')
	      ->select('tbl_device_enrollment.*')->where('is_alloted', '=', '0')
	      ->get()->all();
		  
		  $usertype =  DB::table('tbl_salesman_type')
	      ->select('tbl_salesman_type.*')
	      ->get()->all();
		   
		return view('Device_Management.device_allotment',compact('get_data','deviceName','usertype'));
	 } 
}
