<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\DiscountModel;
use App\Models\CustomerCategoryModel;
use App\Models\CustomerTypeModel;
use App\Models\CustomerModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialCategoryModel;
use App\Models\RegionTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\MaterialDiscountModel;
use App\Models\CategoryDiscountModel;
use App\Models\BrandDiscountModel;
use App\Models\BrandTypeModel;
use App\Models\OutstandingDetailsModels;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class DiscountController extends Controller
 {
   public function list()
    {
	  //$get_data = DiscountModel::all()->sortByDesc('id');
	   $get_data = DB::table('tbl_discount')
			 ->select('tbl_discount.*')
			->orderBy('id', 'DESC')->get();
			 
	   return view('Master_Configuration.discount_list',compact('get_data'));
    }
	
   public function add()
	{
		$customer_type =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$distributor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 2);
		$customer_category =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$brand =BrandTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$region= RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material= MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		
		$result =DiscountModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
				$getcode = ManageCodeModel::where('id', 1)->first();
				$last_code = $getcode->discount_code;
			
		   }
		 else
		  {
			 $getcode = $result->discount_code; 
			 $last_code = ++$getcode;
		  }
			  return view('Master_Configuration.discount',compact('customer_type','customer_category','last_code','distributor','category','brand','region','material'));
     }
	 
	public function view($id)
	 {    
		
		     $get_data = DB::table('tbl_discount')
			->leftJoin('tbl_brand_type', 'tbl_discount.brand', '=', 'tbl_brand_type.id')
			->leftJoin('tbl_material_category', 'tbl_discount.cat_categories', '=', 'tbl_material_category.id')
			->select('tbl_discount.*', 'tbl_brand_type.brand_code','tbl_brand_type.brand_name','tbl_material_category.category_code','tbl_material_category.category_name')
			->where('tbl_discount.id', '=', $id)->get()
			->first();

            $get_details = DB::table('tbl_material_discount_details')
			->leftJoin('tbl_material_master', 'tbl_material_discount_details.material_id', '=', 'tbl_material_master.id')
			->select('tbl_material_discount_details.*', 'tbl_material_master.material_code','tbl_material_master.material_name')
			->where('tbl_material_discount_details.header_id', '=', $id)->get()
			->all();			
		/* 	dd($get_details); */
		    /* $get_details=MaterialDiscountModel::where('header_id',$id)->get()->all();  */
		 
		   return view('Master_Configuration.discount_view'  ,compact('get_data','get_details')  ); 
	 }
	
	public function edit($id)
	 {
		$get_data=DiscountModel::find($id);
		$get_details=MaterialDiscountModel::where('header_id',$id)->get()->all();
		$get_brand_details=BrandDiscountModel::where('header_id',$id)->get()->all();
		$get_category_details=CategoryDiscountModel::where('header_id',$id)->get()->all();
	   
		$customer_type =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$distributor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 2);
		$customer_category =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$brand =BrandTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$region= RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material= MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$last_code = $get_data->discount_code;
		
		//dd($get_data);
		return view('Master_Configuration.discount',compact('get_data','customer_type','customer_category','last_code','distributor','category','region','brand','material','get_details','get_brand_details','get_category_details'));   
	 }
	
	public function save(Request $request)
	 {
        
		$data=new DiscountModel;
		
		if($request->updated_id)
		  {
		   $data = DiscountModel::find($request->updated_id);

		   
			  $data->discount_code=$request->discount_code;
			  $data->discount_name=$request->discount_name;
			  $data->from_date=$request->from_date;
			  $data->to_date=$request->to_date;
			  $data->discount_on=$request->discount_on;
			  $data->status=$request->status;
			  $data->created_user= Session::get('user_id');
			  $data->company_id= Session::get('company_id');
			  
			 if($request->discount_on==1)
			  {				 
					
				  $data->cat_distribution=$request->cat_distribution;
					
					if($request->cat_distribution==2)
					{
						$data->cat_customer_segment=implode(",",$request->cat_customer_segment);
					    $data->cat_region=implode(",",$request->cat_region);
					}
					else{
                        $data->cat_customer_segment=null;
					    $data->cat_region=null;
					}
					$data->save();
					
					DB::table('tbl_category_discount_details')->where('header_id',$request->updated_id)->delete();
					
					 foreach($request['get_category'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'         => $data->id,
							'category_id'       => $request->get_category[$key ],
							'discount_type'     => $request->discount_type_cat[$key ],
							'lower_range'       => $request->lower_range_cat[$key ],
							'upper_range'       => $request->upper_range_cat[$key ],
							'discount_value'    => $request->discount_value_cat[$key ],
							
						   );
						  DB::table('tbl_category_discount_details')->insert($data2);
						 
					 }
					 
                    return redirect(route('discount_list'))->with('successMessage','Discount Updated Successfully');			
					
			  }	
			  else if($request->discount_on==2)
			   {
				    $data->brand=$request->brand_categories;
					$data->brand_lower_range=$request->brand_lower_range;
					$data->brand_upper_range=$request->brand_upper_range;
					$data->brand_discount_type=$request->brand_discount_type;
					$data->brand_discount_value=$request->brand_discount_value;
					$data->brand_distribution=$request->brand_distribution;
					
					if($request->brand_distribution==2)
					{
						$data->brand_customer_segment=implode(",",$request->brand_customer_segment);
					    $data->brand_region=implode(",",$request->brand_region);
						
					}
                    else{
                        $data->brand_customer_segment=null;
					    $data->brand_region=null;
					}
					$data->save();
					
					DB::table('tbl_brand_discount_details')->where('header_id',$request->updated_id)->delete();
					
					foreach($request['get_brand'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'       => $data->id,
							'brand_id'       => $request->get_brand[$key ],
							'discount_type'   => $request->discount_type_brand[$key ],
							'lower_range'     => $request->lower_range_brand[$key ],
							'upper_range'     => $request->upper_range_brand[$key ],
							'discount_value'  => $request->discount_value_brand[$key ],
							
						   );
						  DB::table('tbl_brand_discount_details')->insert($data2);
						 
					 }
                    return redirect(route('discount_list'))->with('successMessage','Discount Updated Successfully');			

                  					
			   }
			   else
			   {
				    $data->discount_code=$request->discount_code;
			        $data->discount_name=$request->discount_name;
			        $data->from_date=$request->from_date;
			        $data->to_date=$request->to_date;
			        $data->discount_on=$request->discount_on;
			        $data->status=$request->status;
			        $data->created_user= Session::get('user_id');
			        $data->company_id= Session::get('company_id');
                    $data->product_distribution=$request->product_distribution; 					
					
                    if($request->product_distribution==2)
					{
						$data->product_customer_segment=implode(",",$request->product_customer_segment);
					    $data->product_region=implode(",",$request->product_region);
						
					}
					else{
						$data->product_customer_segment=null;
					    $data->product_region=null;
					   }
					$data->save();
					
					DB::table('tbl_material_discount_details')->where('header_id',$request->updated_id)->delete();
					
					 foreach($request['material_name'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'       => $data->id,
							'material_id'       => $request->material_name[$key ],
							'discount_type'   => $request->discount_type[$key ],
							'lower_range'     => $request->lower_range[$key ],
							'upper_range'     => $request->upper_range[$key ],
							'discount_value'  => $request->discount_value[$key ],
							
						   );
						  DB::table('tbl_material_discount_details')->insert($data2);
						 
					 }
                    return redirect(route('discount_list'))->with('successMessage','Discount Updated Successfully');			  
			   } 
			
			$data->save(); 
			return redirect(route('discount_list'))->with('successMessage','Discount Updated Successfully');
	
		  }
		else
		  {
			  $data->discount_code=$request->discount_code;
			  $data->discount_name=$request->discount_name;
			  $data->from_date=$request->from_date;
			  $data->to_date=$request->to_date;
			  $data->discount_on=$request->discount_on;
			  $data->status=$request->status;
			  $data->created_user= Session::get('user_id');
			  $data->company_id= Session::get('company_id');
			  
			  
			 if($request->discount_on==1)
			  {				 
					
					$data->cat_distribution=$request->cat_distribution;
					
					if($request->cat_distribution==2)
					{
						$data->cat_customer_segment=implode(",",$request->cat_customer_segment);
					    $data->cat_region=implode(",",$request->cat_region);
						
					}
					
					$data->save();
					
					 foreach($request['get_category'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'         => $data->id,
							'category_id'       => $request->get_category[$key ],
							'discount_type'     => $request->discount_type_cat[$key ],
							'lower_range'       => $request->lower_range_cat[$key ],
							'upper_range'       => $request->upper_range_cat[$key ],
							'discount_value'    => $request->discount_value_cat[$key ],
							
						   );
						  DB::table('tbl_category_discount_details')->insert($data2);
						 
					 }
                    return redirect(route('discount_list'))->with('successMessage','Discount Added Successfully');
			  }	
			  else if($request->discount_on==2)
			   {
				    
					$data->brand_distribution=$request->brand_distribution;
					
					if($request->brand_distribution==2)
					{
						$data->brand_customer_segment=implode(",",$request->brand_customer_segment);
					    $data->brand_region=implode(",",$request->brand_region);
						
					}
                    $data->save();
					
					 foreach($request['get_brand'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'       => $data->id,
							'brand_id'       => $request->get_brand[$key ],
							'discount_type'   => $request->discount_type_brand[$key ],
							'lower_range'     => $request->lower_range_brand[$key ],
							'upper_range'     => $request->upper_range_brand[$key ],
							'discount_value'  => $request->discount_value_brand[$key ],
							
						   );
						  DB::table('tbl_brand_discount_details')->insert($data2);
						 
					 }
                    return redirect(route('discount_list'))->with('successMessage','Discount Added Successfully');
					
			   }
			   else
			   {
				    $data->discount_code=$request->discount_code;
			        $data->discount_name=$request->discount_name;
			        $data->from_date=$request->from_date;
			        $data->to_date=$request->to_date;
			        $data->discount_on=$request->discount_on;
			        $data->status=$request->status;
			        $data->created_user= Session::get('user_id');
			        $data->company_id= Session::get('company_id');
                    $data->product_distribution=$request->product_distribution; 					
					
                    if($request->product_distribution==2)
					{
						$data->product_customer_segment=implode(",",$request->product_customer_segment);
					    $data->product_region=implode(",",$request->product_region);
						
					}
					$data->save();
					
					 foreach($request['material_name'] as $key => $n)
					 {
					    $data2=array
						   (				 
							'header_id'       => $data->id,
							'material_id'       => $request->material_name[$key ],
							'discount_type'   => $request->discount_type[$key ],
							'lower_range'     => $request->lower_range[$key ],
							'upper_range'     => $request->upper_range[$key ],
							'discount_value'  => $request->discount_value[$key ],
							
						   );
						  DB::table('tbl_material_discount_details')->insert($data2);
						 
					 }
                    return redirect(route('discount_list'))->with('successMessage','Discount Added Successfully');					 
			   }   
			  /* $data->save();
			  return redirect(route('discount_list'))->with('successMessage','Discount Added Successfully'); */
		  }	
    		
    }
	
	public function get_discount_category()
	 {
		$result = DB::table('tbl_material_category')
		   ->select('tbl_material_category.*')
		   ->where('status', '=', 'active')
		   ->get()->all();
		
		?>
		<option  value="">     </option>
		<?php
		foreach($result as $matcat)
		  {
			?>
			<option value="<?php echo $matcat->id ?>" ><?php echo $matcat->category_name ?></option>	
			<?php		
		   }
		   
	 }
	
	public function get_discount_brand()
	 {
			
	    $result =BrandTypeModel::get()->where('status', '=', 'active')->all();
			
		?>
		<option  value="">     </option>
		<?php
		foreach($result as $brand)
		  {
			?>
			<option value="<?php echo $brand->id ?>" ><?php echo $brand->brand_name ?></option>	
			<?php		
		  }
	 }
	
	
}
 