<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\SalesmanTypeModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\OutstandingDetailsModels;
use App\Models\ReasonTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanUnloadModel;
use App\Models\ManageCodeModel;
use App\Models\TripCodeModel;
use App\Models\CheckinCheckoutModel;
use Session;
use Illuminate\Support\Facades\DB;    

class MasterApiController extends Controller
 {
	
    public function salesman_login($request, $password)
     {  
	     $get_data1 =array();
		 $get_data=DB::table('tbl_salesman')
		 ->leftJoin('tbl_route', 'tbl_salesman.route_id', '=', 'tbl_route.id')
		 ->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
		 ->leftJoin('tbl_salesman_type', 'tbl_salesman.salesman_type_id', '=', 'tbl_salesman_type.id')
		 ->leftJoin('tbl_customer', 'tbl_route.distibutor_id', '=', 'tbl_customer.id') 
		 ->leftJoin('tbl_vehicle', 'tbl_route.vehicle_id', '=', 'tbl_vehicle.id') 
	   	->leftJoin('tbl_company', 'tbl_salesman.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id') 
 
		 ->select('tbl_salesman.salesman_type_id',
		          'tbl_salesman_type.salesman_type_name',
		          'tbl_salesman_type.salesman_type_code',
				  'tbl_currency_type.id as currency_id',
				  'tbl_currency_type.currency_notation',
				  'tbl_company.vat',
				  'tbl_salesman.salesman_name',
				  'tbl_salesman.salesman_code',
				  'tbl_salesman.id as salesman_id',
				  'tbl_route.route_code',
				  'tbl_route.id as route_id',
				  'tbl_route.route_name',    
				  'tbl_route.route_description',    
				  'tbl_route.vehicle_id',
				  'tbl_vehicle.vehicle_number',
				  'tbl_warehouse.warehouse_name',
				  'tbl_warehouse.id as warehouse_id',
				  'tbl_warehouse.warehouse_code',
				  'tbl_warehouse.region as region_id',
				  'tbl_warehouse.sub_region as sub_region_id',
				  'tbl_route.distibutor_id',
				  'tbl_customer.customer_code as distibutor_code',
				  'tbl_customer.customer_name as distibutor_name',
		 	      'tbl_salesman.salesman_picture',
		 	      'tbl_salesman.customer_from',
				  'tbl_salesman.invoice_from',
		 	      'tbl_salesman.order_from',
				  'tbl_salesman.delivery_from',
		 	      'tbl_salesman.collection_from',
				  'tbl_salesman.return_order_from',
		 	      'tbl_salesman.exchange_from',
				  'tbl_salesman.load_from',
		        )

		 ->where('tbl_salesman.salesman_password', $password)
		 ->where('tbl_salesman.salesman_code', $request)
		 ->get()->first();
		 
	 if($get_data!='')
	  {  
		 /* CHECKING ROUTE INVOICE CODE */ 
		$result = DB::table('tbl_pending_customer')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_pending_customer.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->customer_code; 
		     $get_data->customer_from = ++$getcode;
		  }
       
      /* CHECKING ROUTE INVOICE CODE */	   
		$result = DB::table('tbl_route_invoice_header')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_invoice_header.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->invoice_number; 
		     $get_data->invoice_from = ++$getcode;
		  }
		  
		/* CHECKING SALESMAN LOAD CODE */	   
		$result = DB::table('tbl_route_salesmanload_header')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_salesmanload_header.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->load_number; 
		     $get_data->load_from = ++$getcode;
		  }
		  
		  /* CHECKING ROUTE COLLECTION CODE */	   
		$result = DB::table('tbl_route_credit_collection')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_credit_collection.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->collection_no; 
		     $get_data->collection_from = ++$getcode;
		  }
		  
		  /* CHECKING ROUTE RETURN CODE */	   
		  $result = DB::table('tbl_return_sales_header')
		            ->where('route_id','=',$get_data->route_id)
		            ->select('tbl_return_sales_header.*')
					->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->return_number; 
		     $get_data->return_order_from = ++$getcode;
		  }
		  
		  /* CHECKING TRIP CODE */	   
		 /*  $result = DB::table('tbl_trip_code')
		            ->select('tbl_trip_code.*')
					->get()->sortByDesc('id')->first();
	     if($result=='')
			   {
				 $getcode = ManageCodeModel::where('id', 1)->first();
				 $last_code = $getcode->trip_code;
			   }
			 else
			   {
				 $getcode = $result->trip_code; 
				 $last_code = ++$getcode;
			   } */
			$dateANDtime= date("Y-m-d h:i:s");
			
		  
		   /*  $data3=array( 
				          'trip_code'       =>  $last_code,
						  'salesman_id'     =>  $get_data->salesman_id,
						  'distributor_id'  =>  $get_data->distibutor_id,
						  'region_id'       =>  $get_data->region_id,
						  'subregion_id'    =>  $get_data->sub_region_id,
						  'route_id'        =>  $get_data->route_id,
						  'start_time'      =>  $dateANDtime,
						  'end_time'        =>  " ",
						);
				
			$header_id =DB::table('tbl_trip_code')->insertGetId($data3);
			
			$trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$header_id)->get(); */
			
			//INSERT SALESMAN CHECKIN DETAILS
			$data3=array(  'salesman_id'     =>  $get_data->salesman_id,
						  'distribution'    =>  $get_data->distibutor_id,
						  'region_id'       =>  $get_data->region_id,
						  'subregion_id'    =>  $get_data->sub_region_id,
						  'route_id'        =>  $get_data->route_id,
						  'checkin'         =>  $dateANDtime,
						  'checkout'        =>  null,
						 );
				
			DB::table('tbl_salesman_checkin_checkout')->insertGetId($data3);
			
		  $final_data= array();
		  
        
           $final_data['salesman_type_id']= $get_data->salesman_type_id;
           $final_data['salesman_type_name']=$get_data->salesman_type_name;
           $final_data['salesman_type_code']=$get_data->salesman_type_code;
           $final_data['currency_id']=$get_data->currency_id;
           $final_data['currency_notation']=$get_data->currency_notation;
           $final_data['vat']=$get_data->vat;
           $final_data['salesman_name']=$get_data->salesman_name;
           $final_data['salesman_code']=$get_data->salesman_code;
           $final_data['salesman_id']=$get_data->salesman_id;
           $final_data['route_code']=$get_data->route_code;
           $final_data['route_id']=$get_data->route_id;
           $final_data['route_name']=$get_data->route_name;
           $final_data['route_description']=$get_data->route_description;
           $final_data['vehicle_id']=$get_data->vehicle_id;
           $final_data['vehicle_number']=$get_data->vehicle_number;
           $final_data['warehouse_name']=$get_data->warehouse_name;
           $final_data['warehouse_id']=$get_data->warehouse_id;
           $final_data['warehouse_code']=$get_data->warehouse_code;
           $final_data['region_id']=$get_data->region_id;
           $final_data['sub_region_id']=$get_data->sub_region_id;
           $final_data['distibutor_id']=$get_data->distibutor_id;
           $final_data['distibutor_code']=$get_data->distibutor_code;
           $final_data['distibutor_name']=$get_data->distibutor_name;
           $final_data['salesman_picture']=$get_data->salesman_picture;
           $final_data['customer_from']=$get_data->customer_from;
           $final_data['invoice_from']=$get_data->invoice_from;
           $final_data['order_from']=$get_data->order_from;
           $final_data['delivery_from']=$get_data->delivery_from;
           $final_data['collection_from']=$get_data->collection_from;
           $final_data['return_order_from']=$get_data->return_order_from;
           $final_data['exchange_from']=$get_data->exchange_from;
           $final_data['load_from']=$get_data->load_from;
           /* $final_data['trip_id']=$trip_details[0]->trip_id;
           $final_data['trip_code']=$trip_details[0]->trip_code; */

       			 
			
		  return array('Result'=>$final_data, 'API_Status' => 1, 'Message' => "Salesman Login  Details");
	  }
		  
		 else{
              return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is wrong");
             } 
    }
	 
    public function customer_plan_details($customer_type, $route_id)
     {  
		 $today = Carbon::now()->format('Y-m-d'); 
		 $day = date("D");
		 $day1=lcfirst($day); 
		 $get_data1 =array();

		 $get_data=DB::table('tbl_route_visit_plan_details')
		 ->leftJoin('tbl_customer', 'tbl_route_visit_plan_details.customer_id', '=', 'tbl_customer.id')
		 ->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
	   	->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
	   	->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
	   	->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
	   	->leftJoin('tbl_trading_center', 'tbl_customer.trading_center_id', '=', 'tbl_trading_center.id')
	   	->leftJoin('tbl_payment_term', 'tbl_customer.payment_term', '=', 'tbl_payment_term.id')
	   	->leftJoin('tbl_country', 'tbl_customer.country_id', '=', 'tbl_country.id')
	   	->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id') 
	   	->leftJoin('tbl_route_visit_plan_header', 'tbl_route_visit_plan_details.header_id', '=', 'tbl_route_visit_plan_header.id') 
		
		 ->select('tbl_customer.id as customer_id',
		          'tbl_customer.customer_code',
		          'tbl_customer.customer_name',
		          'tbl_customer.customer_type as customer_type_id',
				  'tbl_customer_type.customer_type_name',
				  'tbl_customer_type.customer_type_code',
				  'tbl_customer.customer_category as customer_category_id',
				  'tbl_customer_category.customer_category_code',
				  'tbl_customer_category.customer_category_name',
				  'tbl_customer.tin_no',
				  'tbl_customer.email',
				  'tbl_customer.contact_no',
				  'tbl_customer.credit_days',
				  'tbl_customer.credit_limit',
				  'tbl_customer.region as region_id',
				  'tbl_region.region_code',
				  'tbl_region.region_name',
				  'tbl_customer.sub_region as sub_region_id',
				  'tbl_sub_region.sub_region_code',
				  'tbl_sub_region.sub_region_name',
				  'tbl_customer.route_id as route_id',
				  'tbl_route.route_code',
				  'tbl_route.route_name',
				  'tbl_customer.trading_center_id',
				  'tbl_trading_center.trading_center_code',
				  'tbl_trading_center.trading_name',
				  'tbl_customer.payment_term as payment_term_id',
				  'tbl_payment_term.payment_code',
				  'tbl_payment_term.payment_term',
				  'tbl_customer.address',
				  'tbl_customer.country_id as country_id',
				  'tbl_country.country_code',
				  'tbl_country.country_name',
				  'tbl_customer.city_id as city_id',
		 	      'tbl_city.city_code',
		 	      'tbl_city.city_name',
		 	      'tbl_customer.latitude',
		 	      'tbl_customer.longitude',
		 	      'tbl_customer.thresold_frequency'
		 	    )
				->where('tbl_route_visit_plan_header.valid_from','<=', $today)
				->where('tbl_route_visit_plan_header.valid_to','>=', $today)
				->where('tbl_route_visit_plan_header.route_id','=', $route_id)
				->where('tbl_customer.customer_type','=', $customer_type)
				->where('tbl_route_visit_plan_details.'.$day1.'','=', 1)
			 ->get()->all();
			 
		  if($get_data !='')
			{   
              return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Details");
            }
          else
		  {
            return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something Went Wrong");
          }
    } 

   public function customer_details($type_name, $route_id)
     { 
		$get_data = DB::table('tbl_customer')
		->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
		->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
		->leftJoin('tbl_trading_center', 'tbl_customer.trading_center_id', '=', 'tbl_trading_center.id')
		->leftJoin('tbl_payment_term', 'tbl_customer.payment_term', '=', 'tbl_payment_term.id')
		->leftJoin('tbl_country', 'tbl_customer.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id')
		->leftJoin('tbl_outstanding_details', 'tbl_customer.id', '=', 'tbl_outstanding_details.customer_id')
		

		 ->select('tbl_customer.id as customer_id',
		          'tbl_customer.customer_code',
		          'tbl_customer.customer_name',
		          'tbl_customer.customer_type as customer_type_id',
				  'tbl_customer_type.customer_type_name',
				  'tbl_customer_type.customer_type_code',
				  'tbl_customer.customer_category as customer_category_id',
				  'tbl_customer_category.customer_category_code',
				  'tbl_customer_category.customer_category_name',
				  'tbl_customer.tin_no',
				  'tbl_customer.email',
				  'tbl_customer.contact_no',
				  'tbl_customer.credit_days',
				  'tbl_customer.credit_limit',
				  'tbl_customer.region as region_id',
				  'tbl_region.region_code',
				  'tbl_region.region_name',
				  'tbl_customer.sub_region as sub_region_id',
				  'tbl_sub_region.sub_region_code',
				  'tbl_sub_region.sub_region_name',
				  'tbl_customer.route_id as route_id',
				  'tbl_route.route_code',
				  'tbl_route.route_name',
				  'tbl_customer.trading_center_id',
				  'tbl_trading_center.trading_center_code',
				  'tbl_trading_center.trading_name',
				  'tbl_customer.payment_term as payment_term_id',
				  'tbl_payment_term.payment_code',
				  'tbl_payment_term.payment_term',
				  'tbl_customer.address',
				  'tbl_customer.country_id as country_id',
				  'tbl_country.country_code',
				  'tbl_country.country_name',
				  'tbl_customer.city_id as city_id',
		 	      'tbl_city.city_code',
		 	      'tbl_city.city_name',
		 	      'tbl_customer.latitude',
		 	      'tbl_customer.longitude',
				   'tbl_outstanding_details.amount_outsatnding as amount_outstanding',
		 	      'tbl_customer.thresold_frequency'
				
		 	    )
				 
				->where('tbl_customer.route_id','=', $route_id)
				->where('tbl_customer.customer_type','=', $type_name)
			 ->get()->all(); 
		  
				if($get_data !='')
				  {   
				   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Details");
				   }
				 else 
				 { 
			      return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is wrong"); 
				 } 
	 }
	 
   public function material_details()
    {  
		$get_data=DB::table('tbl_material_master') 
		 ->leftJoin('tbl_material_category','tbl_material_master.material_category_id', '=', 'tbl_material_category.id')
		 ->leftJoin('tbl_type','tbl_type.id','=','tbl_material_master.material_types_id') 
		 ->leftJoin('tbl_unit_of_measurement','tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
		 
	     ->select('tbl_material_master.id as material_id',
		    'tbl_material_master.material_types_id',
			'tbl_type.type as material_type_name',
	     	'tbl_material_master.material_code',
	     	'tbl_material_master.material_name',
	     	'tbl_material_master.uom_id',
	     	'tbl_unit_of_measurement.uom_name as base_uom_name',
	     	'tbl_material_master.unit_price as base_price',
	     	'tbl_material_master.bar_code',
	     	'tbl_material_master.net_weight',
	     	'tbl_material_master.packing_size as base_packing_size',
	     	'tbl_material_master.shelf_life',
	     	'tbl_material_master.promotional_material',
	     	'tbl_material_master.vat',
	     	'tbl_material_master.material_category_id',
	     	'tbl_material_master.excise',
	     	'tbl_material_master.erp_material_code as erp_code',
	     	'tbl_material_master.alt_uom as alt_uom_id', 
	     	'tbl_material_master.alt_uom_name as alt_uom_name', 
	     	'tbl_material_master.alt_packing_size',
	     	'tbl_material_master.alt_unit_price',
	     	'tbl_unit_of_measurement.uom_code')

	      ->where('tbl_material_master.status','active')
		   ->get()->all();
			 
		   if($get_data !='') 
			{  
			 return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Material  Details"); 
			}
			else
			{
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Material Details Are Not Found"); 
			}   

	}
	
   public function materialcategory_details()
	{
	   $get_data=DB::table('tbl_material_category') 
		->select(
		'tbl_material_category.category_code',
		'tbl_material_category.id as category_id',
		'tbl_material_category.category_name')

		 ->where('tbl_material_category.status','active')
		 ->get()->all();  
		 
			if($get_data !='')
			  {   
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Material Category Details"); 
			  } 
			  else
			  {
			   return array('Result'=>[], 'API_Status' => 0, 'Message' => "Material Category Details Are Not Found"); 
			  }
    }
  
   public function load_request_list($route_id,$salesman_id)
    {  
	
	
		 $fields = array();
		 $return_data1 = array();
         $today = Carbon::now()->format('Y-m-d'); 
         $get_data=DB::table('tbl_route_salesmanload_header') 
	       ->select('tbl_route_salesmanload_header.id',
	     	'tbl_route_salesmanload_header.route_id',
	     	'tbl_route_salesmanload_header.salesman_id',
	     	'tbl_route_salesmanload_header.load_date',
	     	'tbl_route_salesmanload_header.load_number',
	     	'tbl_route_salesmanload_header.warehouse_id',
	     	'tbl_route_salesmanload_header.currency',
	     	'tbl_route_salesmanload_header.status',
	     	'tbl_route_salesmanload_header.total_load_value',
	     	)
			->where('tbl_route_salesmanload_header.route_id','=',$route_id)
			->where('tbl_route_salesmanload_header.salesman_id','=',$salesman_id) 
			->Where('tbl_route_salesmanload_header.status','!=','pending') 
			->whereBetween(DB::raw("(STR_TO_DATE(tbl_route_salesmanload_header.load_date,'%Y-%m-%d'))"),[$today,$today])
			->get(); 
		
	     if($get_data!='')
	       {		             
	        foreach($get_data as $key => $details)	
		    {
			if($get_data[$key]->status!='pending')
			{
			$return_data1[$key]['id']               = $get_data[$key]->id;
			$return_data1[$key]['route_id']         = $get_data[$key]->route_id;
			$return_data1[$key]['salesman_id']      = $get_data[$key]->salesman_id;
			$return_data1[$key]['load_date']        = $get_data[$key]->load_date;
			$return_data1[$key]['load_number']      = $get_data[$key]->load_number;
			$return_data1[$key]['warehouse_id']     = $get_data[$key]->warehouse_id;
			$return_data1[$key]['currency']         = $get_data[$key]->currency;
			$return_data1[$key]['status']           = $get_data[$key]->status;
			$return_data1[$key]['total_load_value'] = $get_data[$key]->total_load_value;
	
			$get_material_data=DB::table('tbl_route_salesmanload_details')
			->leftJoin('tbl_material_master','tbl_route_salesmanload_details.material_id', '=', 'tbl_material_master.id')
            ->leftJoin('tbl_unit_of_measurement','tbl_route_salesmanload_details.uom_id', '=', 'tbl_unit_of_measurement.id')
			->select('tbl_route_salesmanload_details.id',
	     	'tbl_route_salesmanload_details.header_id',
	     	'tbl_route_salesmanload_details.material_id',
	     	'tbl_route_salesmanload_details.uom_id',
	     	'tbl_route_salesmanload_details.quantity',
	     	'tbl_route_salesmanload_details.price',
	     	'tbl_route_salesmanload_details.total',
			'tbl_material_master.material_code',
	     	'tbl_material_master.material_name',
			'tbl_unit_of_measurement.unit_notation' 
			)
			->where('tbl_route_salesmanload_details.header_id','=',$get_data[$key]->id)
			->get(); 
			
		if($get_material_data!='')	
		  {
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				  $fields[$key1] = 
                  array( //this array must be created dynamic 
                      'material_id'      => $get_material_data[$key1]->material_id,
                      'material_name'    => $get_material_data[$key1]->material_name,
                      'material_code'    => $get_material_data[$key1]->material_code,
                      'uom_id'           => $get_material_data[$key1]->uom_id,
                      'uom_name'         => $get_material_data[$key1]->unit_notation,
                      'quantity'         => $get_material_data[$key1]->quantity,
					  'price'            => $get_material_data[$key1]->price,
                      'total'            => $get_material_data[$key1]->total,
					  
				      );
			     } 
		   
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array();
                 
	    }
			
			} 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Load Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
               }
   }
   
   public function route_visit_plan_details()
    {  
		 $fields = array();
		 $return_data1 = array();
         $today = Carbon::now()->format('Y-m-d'); 
         $get_data=DB::table('tbl_route_visit_plan_header') 
	       ->select('tbl_route_visit_plan_header.id',
	     	'tbl_route_visit_plan_header.for_visit_plan',
	     	'tbl_route_visit_plan_header.sales_area_id',
	     	'tbl_route_visit_plan_header.route_id',
	     	'tbl_route_visit_plan_header.valid_from',
	     	'tbl_route_visit_plan_header.valid_to',
	     	 )
			//->where('tbl_route_visit_plan_header.route_id','=',$route_id)
			//->whereBetween(DB::raw("(STR_TO_DATE(tbl_route_visit_plan_header.load_date,'%Y-%m-%d'))"),[$today,$today])
			->get(); 
		
	     if($get_data!='')
	       {		
	        foreach($get_data as $key => $details)	
		    {
			if($get_data[$key])
			{
			$return_data1[$key]['id']              = $get_data[$key]->id;
			$return_data1[$key]['for_visit_plan']  = $get_data[$key]->for_visit_plan;
			$return_data1[$key]['sales_area_id']   = $get_data[$key]->sales_area_id;
			$return_data1[$key]['route_id']        = $get_data[$key]->route_id;
			$return_data1[$key]['valid_from']      = $get_data[$key]->valid_from;
			$return_data1[$key]['valid_to']        = $get_data[$key]->valid_to;
			 
			$get_material_data=DB::table('tbl_route_visit_plan_details')
			->leftJoin('tbl_customer','tbl_route_visit_plan_details.customer_id', '=', 'tbl_customer.id') 
			->select('tbl_route_visit_plan_details.id',
	     	'tbl_route_visit_plan_details.header_id',
	     	'tbl_route_visit_plan_details.customer_id',
	     	'tbl_customer.customer_code',
	     	'tbl_customer.customer_name',
	     	'tbl_route_visit_plan_details.mon',
	     	'tbl_route_visit_plan_details.tue',
	     	'tbl_route_visit_plan_details.wed',
	     	'tbl_route_visit_plan_details.thu',
	     	'tbl_route_visit_plan_details.fri',
	     	'tbl_route_visit_plan_details.sat',
	     	'tbl_route_visit_plan_details.sun'
			)
			->where('tbl_route_visit_plan_details.header_id','=',$get_data[$key]->id)
			->get(); 
			
		if($get_material_data!='')	
		  {
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'customer_id' => $get_material_data[$key1]->customer_id, 
                      'customer_code' => $get_material_data[$key1]->customer_code,
					  'customer_name' => $get_material_data[$key1]->customer_name,
                      'mon' => $get_material_data[$key1]->mon,
                      'tue' => $get_material_data[$key1]->tue,
                      'wed' => $get_material_data[$key1]->wed,
					  'thu' => $get_material_data[$key1]->thu,
                      'fri' => $get_material_data[$key1]->fri,
                      'sat' => $get_material_data[$key1]->sat,
                      'sun' => $get_material_data[$key1]->sun,
					  
				      );
			     } 
		    }
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array(); 
		  } 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Visit Plan Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
               }
   }



 public function pricing_plan()
    {  
		 $fields = array();
		 $return_data1 = array();
        
         $get_data=DB::table('tbl_pricing_plan') 
	       ->select('tbl_pricing_plan.*')
			->get(); 
	
	     if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
			
			if($get_data[$key]->status='active')
			{
				
			$return_data1[$key]['id']                    = $get_data[$key]->id;
			$return_data1[$key]['company_id']            = $get_data[$key]->company_id;
			$return_data1[$key]['plan_name']             = $get_data[$key]->plan_name;
			$return_data1[$key]['price_applied_on']      = $get_data[$key]->price_applied_on;
			$return_data1[$key]['valid_to']              = $get_data[$key]->valid_to;
			$return_data1[$key]['valid_from']            = $get_data[$key]->valid_from;
			$return_data1[$key]['created_user']          = $get_data[$key]->created_user;
			$return_data1[$key]['updated_user']          = $get_data[$key]->updated_user;
			$return_data1[$key]['created_at']            = $get_data[$key]->created_at;
			$return_data1[$key]['customer_category_id '] = $get_data[$key]->customer_category_id;
			$return_data1[$key]['material_category_id']  = $get_data[$key]->material_category_id;
			$return_data1[$key]['route_id']              = $get_data[$key]->route_id;
			$return_data1[$key]['status']                = $get_data[$key]->status;
			$get_material_data=DB::table('tbl_new_price')
			 ->leftJoin('tbl_unit_of_measurement','tbl_new_price.uom_id', '=', 'tbl_unit_of_measurement.id')
			 ->leftJoin('tbl_material_master','tbl_new_price.material_id', '=', 'tbl_material_master.id')
			->select('tbl_new_price.*','tbl_unit_of_measurement.unit_notation','tbl_material_master.material_name')
			->where('tbl_new_price.header_id','=',$get_data[$key]->id)
			->get(); 
			
		if($get_material_data!='')
		
		  {
			  
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'material_id' => $get_material_data[$key1]->material_id,
                      'material_name' => $get_material_data[$key1]->material_name,
                      'new_price' => $get_material_data[$key1]->new_price,
                      'current_price' => $get_material_data[$key1]->current_price,
                      'uom_id' => $get_material_data[$key1]->uom_id,
                      'uom_name' => $get_material_data[$key1]->unit_notation,
                      'currency' => $get_material_data[$key1]->currency,
                      'material_category_id' => $get_material_data[$key1]->material_category_id,
					  'created_user' => $get_material_data[$key1]->created_user,
                      'total' => $get_material_data[$key1]->updated_user,
					  
				      );
			     } 
		    }
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array();
				
		  } 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Load Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
               }
   }
   
	 
   public function save_invoice(Request $request)	 
    { 
	  
	    $trading = DB::table('tbl_customer')
		 ->leftJoin('tbl_route_invoice_header','tbl_customer.id', '=', 'tbl_route_invoice_header.customer_name')
		 ->select('tbl_customer.trading_center_id','tbl_customer.customer_name')
		 ->where('tbl_customer.id', $request->customer_name) 
		 ->get()->all(); 
 
		   $newDate = date('Y-m-d');
		   $save_data=array(
			 'invoice_number'                   =>  $request->invoice_number,
			 'salesman_id'                      =>  $request->salesman,
			 'region_id'                        =>  $request->region,
			 'subregion_id'                     =>  $request->subregion,
			 'warehouse_id'                     =>  $request->warehouse,
			 'invoice_date'                     =>  $newDate,
			 'customer_name'                    =>  $request->customer_name,
			 'route_id'                         =>  $request->route_id, 
		     'trading_center_id'                =>  $request->trading_center_id,
			 'remark'                           =>  $request->remark,
			 'total_gross'                      =>  $request->total_gross,
			 'total_invoice_value'              =>  $request->total_invoice_value,
			 'currency_id'                      =>  $request->currency,
			 'total_vat'                        =>  $request->total_vat,
			 'total_discount'                   =>  $request->total_discount,
			 'net_total_amount'                 =>  $request->net_total_amount,
			 'trip_id'                          =>  $request->trip_id,
			  );
         
		   $header=DB::table('tbl_route_invoice_header')->insertGetId($save_data);  
		   
		   foreach($request['items'] as $key)
		   {  
		   
		   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_code']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
		   
		   
			 $data2=array(
			  'header_id'                     => $header, 
			 'material_code'                   =>   $key['material_code'],
			 'uom_id'                          =>   $key['uom_id'],
			 'quantity'                        =>   $key['quantity'],
			 'unite_price'                     =>   $key['unite_price'],
			 'vat'                             =>   $key['vat'],
			 'gross_total'                     =>   $key['gross_total'],
			 'discount'                        =>   $key['discount'],
			 'discount_id'                     =>   $key['discount_id'],
			 'base_qty'                        =>   $total,
			 'total'                           =>   $key['total'],
			 'net_amount'                      =>   $key['net_amount'],
			  );
			  
			    $stock = DB::table('tbl_route_warehouse_stock') 
							  ->where('tbl_route_warehouse_stock.warehouse_id','=',$request->warehouse)
							  ->where('tbl_route_warehouse_stock.item_id','=',$key['material_code'])
							  ->where('tbl_route_warehouse_stock.route_id','=',$request->route_id)
							  
							  ->get()->all();
							 
							  //dd($stock);
							  
							  $count=count($stock);
							  if($count>0)
								{
								  // reducing stock from warehouse
								  $query = DB::table('tbl_route_warehouse_stock')
								  ->where('warehouse_id',$request->warehouse)
								  ->where('route_id',$request->route_id)
								  ->where('item_id','=',$key['material_code']);
								  
								   $query->decrement('qty',$total);
								 
								}	
		   
			   $details= DB::table('tbl_route_invoice_details')->insert($data2); 
			}
		    
		   if($details)
		     { 
		       return array( 'API_Status' => 1, 'Message' => "Data Inserted"); 
			 } 
			else
			 { 
		       return array('API_Status' => 0, 'Message' => "Data Not Inserted"); 
		     } 
    } 
	
 
    public function save_saleman_load(Request $request)
     { 
		   $save_data=array(
				'route_id'            =>  $request->route_id,
			    'salesman_id'         =>  $request->salesman_id,
			    /* 'trip_id'             =>  $request->trip_id, */
				'load_date'           =>  $request->load_date,
			    'load_number'         =>  $request->load_number,
			    'warehouse_id'        =>  $request->warehouse_id,
				'currency'            =>  $request->currency,
				'status'              =>  $request->status,
				'total_load_value'    =>  $request->total_load_value,
			   );

		 $header_id =DB::table('tbl_route_salesmanload_header')->insertGetId($save_data); 
		 
		   foreach($request['Details'] as $key)
			{
			$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
			 //dd($total);
					$data2=array(
						'header_id'     => $header_id,
						'material_id'   => $key['material_id'],
						'uom_id'        => $key['uom'],
						'quantity'      => $key['quantity'],
						'price'         => $key['price'],
						'total'         => $key['total'],
						'base_qty'      => $total,
					  );
					
					$details= DB::table('tbl_route_salesmanload_details')->insert($data2);
			 }	
			 
		     if($details)
			  {

		          return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");

			  } else 			   
			    {

					return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");

				}
   }
  
   public function update_load_status(Request $request)
   { 
      
       $current = Carbon::now()->format('Y-m-d'); 
		if(!strcmp($request->status,"confirm"))
		 {
			 $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
				 
		   foreach($stock_reserve as $key => $n)
		    {
			       //storing data in warehouse_stock
					$material_master = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					->where('item_id','=',$stock_reserve[$key]->item_id)
					->get()->all();
					
					$count = count($material_master);
				
				if($count>0)
				  {
				   // INCREMENTING ROUTE WAREHOUSE STOCK
					$query = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					->where('item_id','=',$stock_reserve[$key]->item_id);
					
					$query->increment('qty',$stock_reserve[$key]->base_qty);
					
									   
				  }
				else
				{
					$data4=array(
					'warehouse_id'  => $stock_reserve[$key]->warehouse_id,
					'route_warehouse_id' => $stock_reserve[$key]->route_warehouse_id,
					'item_id'  => $stock_reserve[$key]->item_id,
					'uom_id'   => $stock_reserve[$key]->uom,
					'qty'   => $stock_reserve[$key]->base_qty,
					'route_id'  => $stock_reserve[$key]->route_id,
					'created_at'  => $current,
					);	
					
				 DB::table('tbl_route_warehouse_stock')->insert($data4); 
				}
		   }
		    
		   /* CHECKING TRIP CODE */	
         $dateANDtime= date("Y-m-d h:i:s"); 			
		 $result = DB::table('tbl_trip_code')
		            ->select('tbl_trip_code.*')
					->get()->sortByDesc('id')->first();
					
		 if($result=='')
			   {
				  $getcode = ManageCodeModel::where('id', 1)->first();
				  $last_code = $getcode->trip_code;
				 
				  $data3=array( 
				          'trip_code'       =>  $last_code,
						  'salesman_id'     =>  $request->salesman_id,
						  'distributor_id'  =>  $request->distributor_id,
						  'region_id'       =>  $request->region_id,
						  'subregion_id'    =>  $request->subregion_id,
						  'route_id'        =>  $request->route_id,
						  'start_time'      =>  $dateANDtime,
						  'end_time'        =>  null,
						);
				    $header_id =DB::table('tbl_trip_code')->insertGetId($data3);
			        $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$header_id)->get();
			   }
			 else
			   {
				  if($result->end_time!='')
				   {
					   $getcode = $result->trip_code; 
				       $last_code = ++$getcode; 
					   
					   $data3=array( 
				          'trip_code'       =>  $last_code,
						  'salesman_id'     =>  $request->salesman_id,
						  'distributor_id'  =>  $request->distributor_id,
						  'region_id'       =>  $request->region_id,
						  'subregion_id'    =>  $request->subregion_id,
						  'route_id'        =>  $request->route_id,
						  'start_time'      =>  $dateANDtime,
						  'end_time'        =>  null,
						);
				     $header_id =DB::table('tbl_trip_code')->insertGetId($data3);
			         $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$header_id)->get();
					 
				   }
				   else{
					     $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$result->id)->get(); 
				       }
				
				    
			   }
			    /* TRIP FUNCTIONALITY IS ENDED */	
			}
		else
		{
		  $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
					 
		   foreach($stock_reserve as $key => $n)
		   {	
			    $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				->where('material_id','=',$stock_reserve[$key]->item_id)
				->get()->all();
				
				$count=count($query);
			
			 if($count>0)
			  {
				  // incrementing main warehouse stock
			      $query = DB::table('tbl_warehouse_stock')
				  ->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				  ->where('material_id','=',$stock_reserve[$key]->item_id); 
				  $query->increment('qty',$stock_reserve[$key]->base_qty);
		      } 
		   } 
		}	 
	      
	       DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->delete();
					 
			$mediaFiles = $request->sign;
			$extension = $mediaFiles->getClientOriginalExtension(); 
			$media_ext = $mediaFiles->getClientOriginalName();
			$media_no_ext = pathinfo($media_ext, PATHINFO_FILENAME);
			$mFiles = 'singnature-' . time() . '.' . $extension;
			$mediaFiles->move(public_path().'/images/salesmanload_sign/', $mFiles); 
				//dd($mediaFiles); 
			 $data= DB::table('tbl_route_salesmanload_header')
			 ->where('id', $request->load_id)
			 ->update([
					 'status' => $request->status,
					 'trip_id' => $trip_details[0]->trip_id,
					 'sign' =>   $mFiles
				    ]);
					  
		   if($data) 
		     { 
		       return array('Result'=>$trip_details,'API_Status' => 1, 'Message' => "status updated "); 
		     } 
		     else 
		     {
			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Status Not updated"); 
		     } 
    }
	
	
	/*  public function update_unload_status(Request $request)
   { 
       $current = Carbon::now()->format('Y-m-d'); 
		if(!strcmp($request->status,"confirm"))
		 {
			$route_stock=DB::table('tbl_route_warehouse_stock')
			         ->where('route_wrehouse_id', $request->load_id)
			         ->get()->all();
				 
		   foreach($route_stock as $key => $n)
		    {
			       //storing data in warehouse_stock
					$material_master = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $route_stock[$key]->warehouse_id)
					->where('route_warehouse_id', $route_stock[$key]->route_warehouse_id)
					->where('item_id','=',$route_stock[$key]->item_id)
					->get()->all();
					
					$count = count($material_master);
				
				if($count>0)
				  {
				   // reducing from 1st warehouse
					$query = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $route_stock[$key]->warehouse_id)
					->where('route_warehouse_id', $route_stock[$key]->route_warehouse_id)
					->where('item_id','=',$route_stock[$key]->item_id);
					
					$query->increment('qty',$route_stock[$key]->qty);
									   
				  }
				else
				{
					$data4=array(
					'warehouse_id'  => $route_stock[$key]->warehouse_id,
					'route_warehouse_id' => $route_stock[$key]->route_warehouse_id,
					'item_id'  => $route_stock[$key]->item_id,
					'uom_id'   => $route_stock[$key]->uom,
					'qty'   => $route_stock[$key]->qty,
					'route_id'  => $route_stock[$key]->route_id,
					'created_at'  => $current,
					);	
					
				 DB::table('tbl_route_warehouse_stock')->insert($data4); 
				}
		   }
             
		}
		else
		{
		  $route_stock=DB::table('tbl_route_warehouse_stock')
			         ->where('route_warehouse_id', $request->load_id)
			         ->get()->all();
					 
		   foreach($route_stock as $key => $n)
		   {	
			    $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $route_stock[$key]->warehouse_id)
				->where('material_id','=',$route_stock[$key]->item_id)
				->get()->all();
				
				$count=count($query);
			
			 if($count>0)
			  {
				  // reducing from 1st warehouse
			      $query = DB::table('tbl_warehouse_stock')
				  ->where('warehouse_id', $route_stock[$key]->warehouse_id)
				  ->where('material_id','=',$route_stock[$key]->item_id); 
				  $query->increment('qty',$route_stock[$key]->qty);
		      } 
		   } 
		}	 
	   
	   DB::table('tbl_route_warehouse_stock')
			         ->where('route_warehouse_id', $request->load_id)
			         ->delete();
					 
			
			 $data= DB::table('tbl_route_salesmanload_header')
			 ->where('id', $request->load_id)
			 ->update([
					 'status' => $request->status,
					 
				 ]);
					  
		   if($data) 
		     { 
		       return array('Result'=>[], 'API_Status' => 1, 'Message' => "status updated "); 
		     } 
		     else 
		     {
			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Status Not updated"); 
		     } 
    } */
 
   public function save_company_order(Request $request)
    { 
		   $newDate = date("d-m-Y");
		   $save_data=array(
			 'company_order_number'             =>  $request->company_order_number,
			 'customer_id'                      =>  $request->customer_name,
			 'remark'                           =>  $request->remark,
			 'distribution_type_id'             =>  $request->distribution_type,
			 'currency_id'                      =>  $request->currency,
			 'order_type_id'                    =>  $request->order_type,
			 'tin_no'                           =>  $request->tin_no,
			 'is_deliver'                       =>  $request->is_deliver,
			 'warehouse_id'                     =>  $request->warehouse,
			 'total_excise'                     =>  $request->total_excise, 
			 'delevary_date'                    =>  $newDate,
			 'total_gross'                      =>  $request->total_gross,
			 'total_vat'                        =>  $request->total_vat,
			 'total_discount'                   =>  $request->total_discount,
			 'net_total_amount'                 =>  $request->net_total_amount,
			 'total_order_value'                =>  $request->total_order_value,
			 );

		   $header_id =DB::table('tbl_company_order_header')->insertGetId($save_data);
		 
		   foreach($request['Item'] as $key )
		   {
			 $data2=array(
			 'header_id'                       =>   $header_id,
			 'material_id'                     =>  $key['material_code'],
			 'uom_id'                          =>  $key['uom'],
			 'quantity'                        =>  $key['quantity'],
			 'unite_price'                     =>  $key['unite_price'],
			 'vat'                             =>  $key['vat'],
			 'gross_total'                     =>  $key['gross_total'],
			 'discount'                        =>  $key['discount'],
			 'discount_id'                     =>  $key['discount_id'],
			 'excise'                          =>  $key['excise'],
			 'return_type_id'                  =>  $key['return_type'],
			 'total'                           =>  $key['total'],
			 'net_amount'                      =>  $key['net_amount'],
			 'resion_id'                       =>  $key['resion'],
			  );
			  $details= DB::table('tbl_company_order_detail')->insert($data2);
		  
			}
			
		  if($details) 
		    { 
		      return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted"); 
			}
		  else 
		    {
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted"); 
		    } 
      }
  
   public function customer_plan_detail()
	{
		$today = Carbon::now()->format('Y-m-d'); 
		$get_data=DB::table('tbl_customer_visit_plan')
	    ->leftJoin('tbl_route', 'tbl_customer_visit_plan.route_id', '=', 'tbl_route.id') 
		
		 ->select('tbl_customer_visit_plan.route_id','tbl_customer_visit_plan.cust_id','tbl_customer_visit_plan.mon','tbl_customer_visit_plan.tue','tbl_customer_visit_plan.wed','tbl_customer_visit_plan.thu','tbl_customer_visit_plan.fri','tbl_customer_visit_plan.sat','tbl_customer_visit_plan.sun')
		->where('tbl_customer_visit_plan.mon',"1" AND 'tbl_customer_visit_plan.mon',"0") 
	      
		  ->whereBetween(DB::raw("(STR_TO_DATE(tbl_customer_visit_plan.valid_from,'%Y-%m-%d'))"),[$today,$today])->get(); 
			
			if($get_data !='')
			  {  
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Plan Details");
			  }
			 else
			  { 
			   return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is Wrong"); 
			  }

     }
		  
   public function expence_type_details() 
	{
	      $get_data=DB::table('tbl_expense_type')
		  ->leftJoin('tbl_expense_category', 'tbl_expense_type.id', '=', 'tbl_expense_category.id')
		  ->select('tbl_expense_type.id','tbl_expense_type.expense_code','tbl_expense_type.expense_name','tbl_expense_category.expense_category_code','tbl_expense_category.expense_category')
		  ->where('tbl_expense_type.status','=',"active")
		  ->where('tbl_expense_category.id','=','2') 
		  ->get();
		 
		  if($get_data !='')
		   {  
             return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Expense Details");
		   }
		  else 
	       {
    		 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Details Not Found");
           } 
     }
	 
	 public function expense_request(Request $request)
	 
		{
			$login_user = DB::table('tbl_user')
		->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
	
		->get()->first();
				 $ldate = date('Y-m-d H:i:s');
	
				$save_data=array(
				
				"expense_no"             =>$request->expense_no,
				"salesman_name"          =>$request->salesman_name,
				"expense_type"           =>$request->expense_type,
				"expense_date"           =>$request->expense_date,
				"expense_amount"         =>$request->expense_amount,
				"route_id"               =>$request->route_id,
				"warehouse_id"           =>$request->warehouse_id,
				"comment"                =>$request->comment,
				"currency"               =>$login_user->currency_id,
				"created_at"  	         =>$ldate,
				);
				$header=DB::table('tbl_route_expenses')
				
				->insertGetId($save_data);
				
		  if($header)
			{
				
				return array('API_Status' => 1, 'Message' => "Data Inserted");
			}
			else 
		    { 
			 return array( 'API_Status' => 0, 'Message' => "Data Not Inserted");
	
			} 
	}

	 
   public function reason_type_good_and_bad()
	 {  
		  $returntype = ReasonTypeModel::all(); 
		  $r= array();
		  $i=0;
		  foreach($returntype as $value)
		  {
			   
			  $r[$i]['id'] = $value->id; 
			  $r[$i]['reasion_type'] = $value->reasion_type;
			  $r[$i]['return_type'] = $value->return_type;
			 
			 if($value->return_type =='1')
			 {
				$r[$i]['return_type_name'] = "Good Return";
			 }
			 else 
			 {
				 $r[$i]['return_type_name'] = "Bad Return";
			 }			 
			 
			  $i++; 
		  }
			
			if(!empty($r)) 
			 { 
			  return array('Data'=>$r, 'Status' => '1', 'Message' => 'Records');
			 } 
			else
			 { 
			  return $r  =  array('Data'=>[], 'Status' => '0', 'Message' => 'No Records Found');
			 } 
    }
 
  public function save_pending_customer(Request $request) 
	{
				$cmp= DB::table('tbl_warehouse')
				->select('tbl_warehouse.company_id')
				->where('id', $request->warehouse) 
				->get()->all(); 
	
				$cmp_id=$cmp[0]->company_id;
				$newDate = date("d-m-Y");
	
				$save_data=array(
				"company_id"            =>$cmp_id,
				"customer_type"         =>$request->customer_type,
				"customer_category"     =>$request->customer_category,
				"customer_code"         =>$request->customer_code,
				"customer_name"         =>$request->customer_name,
				"tin_no"                =>$request->tin_no,
				"address" 			    =>$request->address,
				"city"  				=>$request->city,
				"country"  				=>$request->country,
				"email"  				=>$request->email,
				"contact_no"  			=>$request->contact_no,
				"payment_term"  		=>$request->payment_term,
				"credit_limit"  		=>$request->credit_limit,
				"credit_days"  			=>$request->credit_days,
				"region"  				=>$request->region,
				"sub_region"  			=>$request->sub_region,
				"warehouse"  			=>$request->warehouse,
				"route_id"  			=>$request->route_id,
				"trading_center_id" 	=>$request->trading_center_id,
				"thresold_frequency"  	=>$request->thresold_frequency,
				);
				$header=DB::table('tbl_pending_customer')
				
				->insertGetId($save_data);
				
		  if($header)
			{
				return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");
			}
			else 
		    { 
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
	
			} 
	}
 
   public function sales_return_save(Request $request) 
	{
		/* dd($request); */
		 $trading = DB::table('tbl_customer') 
		 ->leftJoin('tbl_return_sales_header','tbl_customer.id','=', 'tbl_return_sales_header.customer_id') 
		 ->select('tbl_customer.trading_center_id','tbl_customer.customer_name') 
		  ->where('tbl_customer.id', $request->customer_name) 
		  ->get()->all();  
		   //$trading_id=$trading[0]->trading_center_id;
			
		   $newDate = date("d-m-Y");
		   $save_data=array(
			 'return_number'                 =>  $request->return_number,
			 'salesman_id'                      =>  $request->salesman,
			 'trip_id'                      =>  $request->trip_id,
			 'region'                        =>  $request->region,
			 'subregion'                     =>  $request->subregion,
			 'warehouse_id'                     =>  $request->warehouse,
			 'invoice_date'                  =>  $newDate,
			 'customer_id'                 =>  $request->customer_name,
			 'route_id'                      =>  $request->route_id, 
			 'trading_center_id'             =>  $request->trading_center_id,
			 'remark'                        =>  $request->remark,
			 'total_gross'                   =>  $request->total_gross,
			 'total_invoice_value'           =>  $request->total_invoice_value,
			 'currency'                      =>  $request->currency,
			  );
 
		     $header_id =DB::table('tbl_return_sales_header')->insertGetId($save_data);
		  
		  
		   foreach($request['Item'] as $key)
		   {  
		   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
		   //dd( $total);
		   
			 $data2=array(
		     'header_id'                       =>  $header_id, 
			 'material_id'                     =>  $key['material_id'],
			 'uom'                             =>  $key['uom'],
			 'quantity'                        =>  $key['quantity'],
			 'return_type'                     =>  $key['return_type'],
			 'resion'                          =>  $key['resion'],
			 'unite_price'                     =>  $key['unite_price'],
			 'gross_total'                     =>  $key['gross_total'],
			 'total'                           =>  $key['total'],
			 'base_qty'                        =>  $total
			  );
			  
			   $stock = DB::table('tbl_route_warehouse_stock') 
			   ->where('tbl_route_warehouse_stock.warehouse_id','=',$request->warehouse)
			   ->where('tbl_route_warehouse_stock.item_id','=',$key['material_id'])
			   ->where('tbl_route_warehouse_stock.route_id','=',$request->route_id)
			   ->get()->all();
			   //dd($stock);
			   
				$count=count($stock);
					  if($count>0)
						{
						  // reducing stock from warehouse
						  if( $key['return_type']==1)
						  {
						  $query = DB::table('tbl_route_warehouse_stock')
						  ->where('warehouse_id',$request->warehouse)
						  ->where('route_id',$request->route_id)
						  ->where('item_id','=',$key['material_id']);
						  
						   $query->increment('qty',$total);
						  }
						  else
						  {
							$query = DB::table('tbl_route_warehouse_stock')
						  ->where('warehouse_id',$request->warehouse)
						  ->where('route_id',$request->route_id)
						  ->where('item_id','=',$key['material_id']);
						  
						   $query->increment('bad_qty',$total);
						  }
						}	
 			   $details= DB::table('tbl_return_sales_details')->insert($data2);
 		   
			}	
		   if($details)
		    {
			 return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted"); 
			}
			else
			{ 
		     return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
		    }  
	}
	  
   public function country_details() 
    {
		 $get_data=DB::table('tbl_country')
		 ->select('tbl_country.id','tbl_country.country_name')
		 ->where('tbl_country.status','=',"active")
		 ->get();
	
		 if($get_data !='') 
			{  
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Country Details");
			}
		  else 
			{
		 	 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Country Details Not Found");
			} 
	}  
     	
   public function city_details() 
    {
		 $get_data=DB::table('tbl_city')
		 ->leftJoin('tbl_country', 'tbl_city.country_id', '=', 'tbl_country.id')
		 ->select('tbl_city.id','tbl_city.city_name','tbl_city.country_id','tbl_country.country_name')
		 ->where('tbl_city.status','=',"active")
		 ->get();
	
		 if($get_data !='')
			{  
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "City Details");
			}
		  else 
		    {
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "City Details Not Found");
		    } 
	}
	  
   public function customer_category_detail() 
	 { 
		 $get_data=DB::table('tbl_customer_category') 
		 ->select('tbl_customer_category.id','tbl_customer_category.customer_category_name')
		 ->where('tbl_customer_category.status','=',"active")
		 ->get();
	
		 if($get_data !='')
			{  
			  return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Category Details");
			}
		  else 
		    {
			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Customer Category Details Not Found");
		    } 
	}
		   
   public function uom_details()
	 {
		$details= DB::table('tbl_unit_of_measurement') 
		->select('tbl_unit_of_measurement.id as alt_uom_id','tbl_unit_of_measurement.unit_notation as alt_uom_name')
		->get()->all();
		if($details !='')
		{
		  return array('result'=>$details, 'Status'=>1, 'Message'=>'Uom Details');
		}
	   else
		{
		  return array('Result'=>[],'Status'=>0, 'Message'=>'Uom Details Not');
			
		} 
	}
	 
   public function device_configuration_details()
	{
		$get_data=DB::table('tbl_device_configuration') 
		->select('tbl_device_configuration.id',
		'tbl_device_configuration.synchronize',
		'tbl_device_configuration.google_api_key',
		'tbl_device_configuration.gcm_notification',
		'tbl_device_configuration.printer_type',
		'tbl_device_configuration.geofence_radius',
		'tbl_device_configuration.pre_sale', 
		'tbl_device_configuration.disclaimer') 
		->get()->all();

		if($get_data !='')
		  {  
			return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Device Configuration Details"); 
		  }
		 else 
		 {
		  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Device Configuration Details Are Not Found"); 
		 }
	 } 
   
   public function trading_center_details($id)
	 {
		$get_data=DB::table('tbl_trading_center')
		->leftJoin('tbl_route','tbl_route.id','=','tbl_trading_center.route_id')
		->select('tbl_trading_center.id','tbl_trading_center.trading_center_code','tbl_trading_center.trading_name') 
		->where('tbl_route.id','=',$id)
		->get()->all();

		if($get_data) 
			{  
			 return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Trading Center Details"); 
		    } 
			else
		   { 
			return array('Result'=>[], 'API_Status' => 0, 'Message' => "Trading Center Details Are Not Found"); 
		   } 
	 }
     
 
   
   public function save_route_unload(Request $request)	 
    {
       //THIS IS FOR MAINTAIN TRIP FOR LOGOUT
       $log = TripCodeModel::where('id', $request->trip_id) 
                  ->first();

         if($log) {
           $log->end_time = date('Y-m-d H:i:s');
           $log->save();
        }		
	  
	   $route_warehouse=DB::table('tbl_warehouse')
	   ->where('warehouse_type','=',2)
	   ->where('status', '=', 'active')
	   ->where('route_warehouse','=', $request->warehouse_id)
       ->get()->all();
	   
	 
	  
		   $newDate = date("H:i:s"); 
		   $save_data=array(
			 'salesman_id'                      =>  $request->salesman_id,
			 'warehouse_id'                      =>  $request->warehouse_id,
			 'route_id'                         =>  $request->route_id,
			 'trip_id'                         =>  $request->trip_id,
			 'unload_time'                      =>  $newDate,
			 'unload_code'                      =>  $request->unload_code,
			 
			  );
         
		   $header=DB::table('tbl_route_unload_header')->insertGetId($save_data); 
		   
		   
		 
//dd($alt_alt_packing_size);
		 foreach($request['items'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             $total1= $alt_alt_packing_size[$key1]*$key['availble_quantity'];
		    
			 $data2=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'available_qty'                    =>   $key['availble_quantity'],
			 'base_qty'                         =>   $total,
			 'available_base_qty'               =>   $total1,
		     );
			
		     $material_master = DB::table('tbl_route_warehouse_stock')
			->where('warehouse_id',  $request->warehouse_id)
			->where('route_warehouse_id', $route_warehouse[0]->id)
			->where('item_id','=',$key['material_id'])
			->get()->all();
			
			 $count = count($material_master);
			 if($count>0)
              {
			  // reducing from 1st warehouse
				 $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $request->warehouse_id)
				->where('material_id','=',$key['material_id']);
				 $query->increment('qty',$key['availble_quantity']);
				}	
					
			     $details= DB::table('tbl_route_unload_details')->insert($data2); 
		  }
		  
		foreach($request['stock_variance'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             
		    
			 $data3=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'base_qty'                         =>   $total,
			 );
			
		     DB::table('tbl_stock_variance')->insert($data3); 
		  }
		foreach($request['return_stock'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             
		    
			 $data4=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'return_type'                      =>   $key['return_type'],
			 'return_reason'                    =>   $key['return_reason'],
			 'base_qty'                         =>   $total,
			 );
			 
			$material_master = DB::table('tbl_route_warehouse_stock')
			->where('warehouse_id',  $request->warehouse_id)
			->where('route_warehouse_id', $route_warehouse[0]->id)
			->where('item_id','=',$key['material_id'])
			->get()->all();
			
			 $count = count($material_master);
			 if($count>0)
              {
			  // reducing from 1st warehouse
				 $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $request->warehouse_id)
				->where('material_id','=',$key['material_id']);
				 $query->increment('return_stock',$total);
			  }
		    $details= DB::table('tbl_unload_return_stock')->insert($data4); 
		  }
		     DB::table('tbl_route_warehouse_stock')
					->where('route_id','=', $request->route_id)
					->delete();
		    if($details)
		     { 
		       return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			 } 
			 else
			 { 
		       return array( 'API_Status' => 0, 'Message' => "Data Not Inserted"); 
		     } 
    } 
	
 //Merchandising
 
        public function shelf_display_details($route_id)
		{
			 $get_data=DB::select('SELECT t2.id,
			 t1.id,
			 t1.name,
			 t1.valid_from,
			 t1.valid_to,
			 t1.height,
			 t1.width,
			 t1.depth,
			 t1.capacity,
			 t3.region_name,
			 t4.sub_region_name,
			 t1.customer
			 FROM tbl_shelf_display as t1
			 LEFT JOIN tbl_customer as t2 ON find_in_set(t2.id, t1.customer)
			 LEFT JOIN tbl_region as t3 ON find_in_set(t3.id, t1.region)
			 LEFT JOIN tbl_sub_region as t4 ON find_in_set(t4.id, t1.sub_region)
			 where t2.route_id='.$route_id.' AND  t1.status="active"
			 GROUP by t1.id');
			// dd($get_data);
  
		  if($get_data!='')
		  {
			  return array('Result'=>$get_data, 'Status'=>1, 'Message'=>"Data Found");
		  }
		  else
		  {
				return array('Result'=>$get_data, 'Status'=>0, 'Message'=>"Data Not Found");
		  }
				
		   }

   
     public function planogram_details($route_id)
		{
			 $get_data=DB::select('SELECT t2.id,
			 t1.id,
			 t1.planogram_name,
			 t3.name as shelf_dispaly_name,
			 t1.valid_from,
			 t1.valid_to,
			 t4.region_name,
			 t5.sub_region_name,
			 t1.planogram_image1,
			 t1.planogram_image2,
			 t1.customer
			 FROM tbl_planogram as t1
			 LEFT JOIN tbl_customer as t2 ON find_in_set(t2.id, t1.customer)
			 LEFT JOIN tbl_shelf_display as t3 ON find_in_set(t3.id, t1.shelf_display_name)
			 LEFT JOIN tbl_region as t4 ON find_in_set(t4.id, t1.region)
			 LEFT JOIN tbl_sub_region as t5 ON find_in_set(t5.id, t1.sub_region)
			 where t2.route_id='.$route_id.' AND  t1.status="active"
			 GROUP by t1.id');
			// dd($get_data);
  
		  if($get_data!='')
		  {
			  return array('Result'=>$get_data, 'Status'=>1, 'Message'=>"Data Found");
		  }
		  else
		  {
				return array('Result'=>$get_data, 'Status'=>0, 'Message'=>"Data Not Found");
		  }
				
		   }
   
   
   
   public function asset_tracking_details($route_id)
   {
	$get_data=DB::table('tbl_asset_tracking as t1')
    ->select(
             't1.id',			 
             't1.asset_code',			 
             't1.asset_name',			 
             't1.asset_type',			 
             't1.asset_barcode',			 
             't1.serial_no',			 
             't1.image',			 
             't1.longitude',			 
             't1.latitude',			 
             't1.valid_from',			 
             't1.valid_to',			 
             't3.region_name',			 
             't4.sub_region_name',			 
             't1.route',			 
             't1.customer',
			 )
			 ->leftjoin('tbl_customer as t2','t2.id','=','t1.customer')
			 ->leftjoin('tbl_region as t3','t3.id','=','t1.region')
			 ->leftjoin('tbl_sub_region as t4','t4.id','=','t1.sub_region')
			 ->leftjoin('tbl_route as t5','t5.id','=','t1.route')
			 ->where('t1.route',$route_id)
			 ->where('t1.status','=',"active")
			 ->get();
			 
			 if($get_data !='')
			 {
				 return array('Rresult'=>$get_data, 'Status'=>1, 'Message'=>"Data Found");
			 }
			 else
			 {
				 return array('Result'=>[], 'Status'=>0, 'Message'=>"Data Not Found");
			 }
	
	
   }
   
   public function save_route_order(Request $request)
   {
	    $trading = DB::table('tbl_customer') 
		 ->leftJoin('tbl_return_sales_header','tbl_customer.id','=', 'tbl_return_sales_header.customer_name') 
		 ->select('tbl_customer.trading_center_id','tbl_customer.customer_name') 
		  ->where('tbl_customer.id', $request->customer_name) 
		  ->get()->all(); 
	   $ldate = date('Y-m-d H:i:s');
	   $save_data= array(
	   'order_number'       =>$request->order_number,
	   'salesman_id'        =>$request->salesman_id,
	   'trip_id'            =>$request->trip_id,
	   'warehouse_id'       =>$request->warehouse_id,
	   'order_date'         =>$request->order_date,
	   'customer_id'        =>$request->customer_id,
	   'route_id'           =>$request->route_id,
	   'region_id'          =>$request->region_id,
	   'subregion_id'       =>$request->subregion_id,
	   'trading_center_id'  =>$request->trading_center_id,
	   'remark'             =>$request->remark,
	   'currency_id'        =>$request->currency_id,
	   'total_gross'        =>$request->total_gross,
	   'total_vat'          =>$request->total_vat,
	   'net_total_amount'   =>$request->net_total_amount,
	   'total_discount'     =>$request->total_discount,
	   'total_invoice_value'=>$request->total_invioce_value,
	   'created_at'         =>$ldate,
	   'is_deliver'         =>$request->is_deliver,
	     );
 
		   $header_id =DB::table('tbl_route_order_header')->insertGetId($save_data);
		   
		 foreach($request['Item'] as $key)
		   {
			   
			    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
			   
			   $save_data2=array(
			   'material_id'          =>$key['material_id'],
			   'uom_id'               =>$key['uom_id'],
			   'quantity'             =>$key['quantity'],
			   'base_qty'             =>$total,
			   'header_id'            =>$header_id,
			   'unite_price'          =>$key['unite_price'],
			   'gross_total'          =>$key['gross_total'],
			   'vat'                  =>$key['vat'],
			   'net_amount'           =>$key['net_amount'],
			   'discount'             =>$key['discount'],
			   'discount_id'          =>$key['discount_id'],
			   'total'                =>$key['total'],
			   'created_at'           =>$ldate,
			   );
			   $details= DB::table('tbl_route_order_details')->insert($save_data2);
		  
			}	
		   if($details)
		    {
			 return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			}
			else
			{ 
		     return array('API_Status' => 0, 'Message' => "Data Not Inserted");
		    }  
	}
			   
   public function delivery_details()
  {
	  $fields = array();
		 $return_data1 = array();
        
	  $get_data=DB::table('tbl_route_delivery_header as rd')
	            ->select(
				          'rd.id',
						  'rd.route_delivery_number',
						  'rd.salesman_id',
						  'rd.warehouse_id',
						  'rd.order_date',
						  'rd.customer_id',
						  'rd.route_id',
						  'rd.region_id',
						  'rd.subregion_id',
						  'rd.trading_center_id',
						  'rd.currency_id',
						  'rd.total_gross',
						  'rd.total_vat',
						  'rd.net_total_amount',
						  'rd.total_discount',
						  'rd.total_order_value',
						  'rd.order_type',
						  'rd.order_number',
	              
				        )
						
				->get(); 
		 if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
			
			if($get_data[$key]->status='active')
			{
				
			$return_data1[$key]['id']                               = $get_data[$key]->id;
			$return_data1[$key]['route_delivery_number']            = $get_data[$key]->route_delivery_number;
			$return_data1[$key]['salesman_id']                      = $get_data[$key]->salesman_id;
			$return_data1[$key]['warehouse_id']                     = $get_data[$key]->warehouse_id;
			$return_data1[$key]['order_date']                       = $get_data[$key]->order_date;
			$return_data1[$key]['customer_id']                      = $get_data[$key]->customer_id;
			$return_data1[$key]['route_id']                         = $get_data[$key]->route_id;
			$return_data1[$key]['region_id']                        = $get_data[$key]->region_id;
			$return_data1[$key]['subregion_id']                     = $get_data[$key]->subregion_id;
			$return_data1[$key]['trading_center_id ']               = $get_data[$key]->trading_center_id;
			$return_data1[$key]['currency_id']                      = $get_data[$key]->currency_id;
			$return_data1[$key]['total_gross']                      = $get_data[$key]->total_gross;
			$return_data1[$key]['total_vat']                        = $get_data[$key]->total_vat;
			$return_data1[$key]['net_total_amount']                 = $get_data[$key]->net_total_amount;
			$return_data1[$key]['total_discount']                   = $get_data[$key]->total_discount;
			$return_data1[$key]['total_order_value']                = $get_data[$key]->total_order_value;
			$return_data1[$key]['order_type']                       = $get_data[$key]->order_type;
			$return_data1[$key]['order_number']                     = $get_data[$key]->order_number;
			
			$get_material_data=DB::table('tbl_route_delivery_details')
			 
			->get(); 
			
		if($get_material_data!='')
		
		  {
			  
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] =        
                  array( //this array must be created dynamic 
                      'material_id'     => $get_material_data[$key1]->material_id,
                      'uom_id'          => $get_material_data[$key1]->uom_id,
                      'quantity'        => $get_material_data[$key1]->quantity,
                      'header_id'       => $get_material_data[$key1]->header_id,
                      'unite_price'     => $get_material_data[$key1]->unite_price,
                      'gross_total'     => $get_material_data[$key1]->gross_total,
                      'vat'             => $get_material_data[$key1]->vat,
                      'net_amount'      => $get_material_data[$key1]->net_amount,
                      'discount'        => $get_material_data[$key1]->discount,
                      'discount_id'     => $get_material_data[$key1]->discount_id,
                      'total'           => $get_material_data[$key1]->total,
                      'base_qty'        => $get_material_data[$key1]->base_qty,
					  
				      );
			     } 
		    }
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array();
				
		  } 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Delivery Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Delivery Details NOt Found");
               }
   }
   
   public function save_route_exchange(Request $request)
   {
	 $details2="";   
	   $ldate = date('Y-m-d H:i:s');
	   $save_data= array(
	   'exchange_number'        =>$request->exchange_number,
	   'exchange_date'          =>$request->exchange_date,
	   'exchange_amount'        =>$request->exchange_amount,
	   'customer_id'            =>$request->customer_id,
	   'salesman_id'            =>$request->salesman_id,
	   'warehouse_id'           =>$request->warehouse_id,
	   'route_id'               =>$request->route_id,
	   'invoice_code'           =>$request->invoice_code,
	   'return_code'            =>$request->return_code,
	   'amount'                 =>$request->amount,
	   'trip_id'                =>$request->trip_id,
	   'created_at'             =>$ldate,
	     );
 
		   $header_id =DB::table('tbl_route_exchange_header')->insertGetId($save_data); 
		   
		 foreach($request['Invoice'] as $key)
		   {
			   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);
			 if($material){   
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
			
			   $save_data2=array(
			   'material_id'          =>$key['material_id'],
			   'uom_id'               =>$key['uom_id'],
			   'quantity'             =>$key['quantity'],
			   'base_qty'             =>$total,
			   'amount'               =>$key['amount'],
			   'header_id'            =>$header_id,
			   'total_amount'         =>$key['total_amount'],
			   'created_at'           =>$ldate,
			   );
			  $details1= DB::table('tbl_route_exchange_invoice_details')->insert($save_data2);  
		     }	
		   }	
		   
		 foreach($request['Return'] as $key)
		   {
			   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);
		   if($material){
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
			   
			 
			   $save_data3=array(
			   'material_id'              =>$key['material_id'],
			   'uom_id'                   =>$key['uom_id'],
			   'quantity'                 =>$key['quantity'],
			   'base_qty'                 =>$total,
			   'amount'                   =>$key['amount'],
			   'header_id'                =>$header_id, 
			   'total_amount'             =>$key['total_amount'],
			   'return_type_id'           =>$key['return_type_id'],
			   'return_reason_id'         =>$key['return_reason_id'],
			   'created_at'               =>$ldate,
			   );
			    $details2= DB::table('tbl_route_exchange_return_details')->insert($save_data3);
		      }
			}	
			
		   if($details2)
		    {
			 return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			}
			else
			{ 
		     return array('API_Status' => 0, 'Message' => "Data Not Inserted");
		    } 
       }
     
	 
	 public function route_exchange_details()
   {
	        $fields = array();
		 $return_data1 = array();
        
	  $get_data=DB::table('tbl_route_exchange_header as rd')
	            ->leftJoin('tbl_customer','rd.customer_id','=','tbl_customer.id') 
	            ->leftJoin('tbl_salesman','rd.salesman_id','=','tbl_salesman.id') 
	            ->leftJoin('tbl_warehouse','rd.warehouse_id','=','tbl_warehouse.id') 
	            ->leftJoin('tbl_route','rd.route_id','=','tbl_route.id') 
	            ->select(
				          'rd.id',
						  'rd.exchange_number',
						  'rd.exchange_date',
						  'rd.exchange_amount',
						  'rd.customer_id',
						  'tbl_customer.customer_name',
						  'rd.salesman_id',
						  'tbl_salesman.salesman_name',
						  'rd.warehouse_id',
						  'tbl_warehouse.warehouse_name',
						  'rd.route_id',
						  'rd.invoice_code',
						  'rd.return_code',
						  'rd.amount',
						)
				->get(); 
				
		 if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
				
			$return_data1[$key]['id']                               = $get_data[$key]->id;
			$return_data1[$key]['exchange_number']                  = $get_data[$key]->exchange_number;
			$return_data1[$key]['exchange_date']                    = $get_data[$key]->exchange_date;
			$return_data1[$key]['exchange_amount']                  = $get_data[$key]->exchange_amount;
			$return_data1[$key]['customer']                         = $get_data[$key]->customer_name;
			$return_data1[$key]['customer_id']                      = $get_data[$key]->customer_id;
			$return_data1[$key]['salesman']                         = $get_data[$key]->salesman_name;
			$return_data1[$key]['salesman_id']                      = $get_data[$key]->salesman_id;
			$return_data1[$key]['warehouse']                        = $get_data[$key]->warehouse_name;
			$return_data1[$key]['warehouse_id']                     = $get_data[$key]->warehouse_id;
			$return_data1[$key]['route_id']                         = $get_data[$key]->route_id;
			$return_data1[$key]['invoice_code']                     = $get_data[$key]->invoice_code;
			$return_data1[$key]['return_code']                      = $get_data[$key]->return_code;
			$return_data1[$key]['amount']                           = $get_data[$key]->amount;
			
			
		$get_material_data=DB::table('tbl_route_exchange_invoice_details as exchange_invoice')
		                   ->leftJoin('tbl_material_master','exchange_invoice.material_id','=','tbl_material_master.id') 
	                       ->leftJoin('tbl_unit_of_measurement','exchange_invoice.uom_id','=','tbl_unit_of_measurement.id') 
		                   ->get(); 
			
		if($get_material_data!='')
		  {
		    foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'material_id'       => $get_material_data[$key1]->material_id,
                      'material'          => $get_material_data[$key1]->material_name,
                      'uom_id'            => $get_material_data[$key1]->uom_id,
                      'uom'               => $get_material_data[$key1]->unit_notation,
                      'quantity'          => $get_material_data[$key1]->quantity,
                      'header_id'         => $get_material_data[$key1]->header_id,
                      'amount'            => $get_material_data[$key1]->amount,
                      'total_amount'      => $get_material_data[$key1]->total_amount,
                      );
			    	
		  }
		  }
			
			$material_data=DB::table('tbl_route_exchange_return_details as exchange_return')
		                   ->leftJoin('tbl_material_master','exchange_return.material_id','=','tbl_material_master.id') 
	                       ->leftJoin('tbl_unit_of_measurement','exchange_return.uom_id','=','tbl_unit_of_measurement.id') 
	                       ->leftJoin('tbl_reason_type','exchange_return.return_reason_id','=','tbl_reason_type.id') 
	                       ->get(); 
			
	  if($material_data!='')
		  {
		    foreach($material_data as $key2 => $load_details1)	
		      {
				
				$fields2[$key2] = 
                  array( //this array must be created dynamic 
                      'material_id'       => $material_data[$key2]->material_id,
                      'material'          => $material_data[$key2]->material_name,
                      'uom_id'            => $material_data[$key2]->uom_id,
                      'uom'               => $material_data[$key2]->unit_notation,
                      'quantity'          => $material_data[$key2]->quantity,
                      'header_id'         => $material_data[$key2]->header_id,
                      'amount'            => $material_data[$key2]->amount,
                      'total_amount'      => $material_data[$key2]->total_amount,
                      'return_type_id'    => $material_data[$key2]->return_type_id,
                      'return_reason_id'  => $material_data[$key2]->return_reason_id,
                      'reasion_type'      => $material_data[$key2]->reasion_type,
                      );
			     } 
		    }
			
			$return_data1[$key]['return'] = $fields2;
			$return_data1[$key]['invoice'] = $fields;
			
		   $fields=array();
		   
			
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1, 'API_Status' => 1, 'Message' => "Route Exchange Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => " Details NOt Found");
               }
   }
	 
   
   public function save_outstanding(Request $request)
   {
	  $ldate=date('Y-m-d H:i:s');
		   $save_data=array(
		   'salesman_id'           =>$request->salesman_id,
		   'trip_id'               =>$request->trip_id,
		   'customer_id'           =>$request->customer_id,
		   'region'                =>$request->region,
		   'subregion'             =>$request->subregion,
		   'warehouse_id'          =>$request->warehouse_id,
		   'route_id'              =>$request->route_id,
		   'amount_paid'           =>$request->amount_paid,
		   'amount_outsatnding'    =>$request->amount_outsatnding,
		   'total_invoice_amount'  =>$request->total_invoice_amount,
		   'due_date'              =>$request->due_date,
		   'created_at'            =>$ldate
		   );
	 
		$details=DB::table('tbl_outstanding_details')->insertGetId($save_data);
		if($details !='')
		{
			return array('API_status'=>1, 'Message'=>'Data Inserted');
		}
		else
		{
			return array('Result'=>[],'API_status'=>0, 'Message'=>'Data Not Inserted');
		}
   }  
   public function route_collection_save(Request $request)
    {   
		 $current = Carbon::now(); 
		 $newDate = date("d-m-Y");
		  
		   
		 $save_data=array(
						 
						 'route_id'            =>  $request->route_id,
						 'trip_id'            =>  $request->trip_id,
						 'customer_id'         =>  $request->customer_id,
						 'trading_center_id'   =>  $request->trading_center_id,
						 'warehouse_id'        =>  $request->warehouse_id,
						 'collection_type'     =>  $request->collection_type,
						 'collection_number'   =>  $request->collection_number, 
						 'cheque_number'       =>  $request->cheque_no, 
						 'cheque_date'         =>  $request->cheque_date,
						 'bank_name'           =>  $request->bank_name,
						 'account_number'      =>  $request->account_no,
						 'branch_name'         =>  $request->branch_name,
						 'created_at'          =>  $current,
						);

		   $header_id =DB::table('tbl_route_collection_header')->insertGetId($save_data);
		   
		   foreach($request['Item'] as $key => $n)
		    {
		        
		    $data=OutstandingDetailsModels::find($request['Item'][$key]['out_id']);
			if($data)
			{ 
		      if($request['Item'][$key]['paid_amount']!=0)
			    {
					 $total_outstanding_amount =DB::table('tbl_outstanding_details')
					  ->where('tbl_outstanding_details.id','=',$request['Item'][$key]['out_id'])
					  ->get();
				  if(count($total_outstanding_amount)>0){
		             $total_outstanding= $total_outstanding_amount[0]->total_invoice_amount;	
				   }
				   
				   
				     $data->increment('amount_paid',$request['Item'][$key]['paid_amount']);
				     $data->decrement('amount_outsatnding',$request['Item'][$key]['paid_amount']);
				     $data->save();
					
				     $s= $data->amount_outsatnding;
		               
		            
		   
					 $data2=array
						        (
								 'header_id'             =>   $header_id,
								 'invoice_id'            =>   $request['Item'][$key]['invoice_id'],
								 'invoice_no'            =>   $request['Item'][$key]['invoice_number'],
								 'outstanding_amt'       =>   $s,
								 'total_outstanding'     =>   $total_outstanding,
								 'paid_amt'              =>   $request['Item'][$key]['paid_amount'],
								 'created_at'            =>   $current,
								);
						
				     if($s < 1)
					    {
					 OutstandingDetailsModels::find($request['Item'][$key]['out_id'])->delete(); 
						   
					    }
				  	
				}
					//dd($data2);
			      $details= DB::table('tbl_route_collection_details')->insert($data2); 
			 }
			}	
		   if($details)
		    {

		        return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");

			} else {

		            return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");

		           } 

    }  

//Route collection Details	 
	 public function route_collection_list()
	 {
		   $fields = array();
		 $return_data1 = array();
	
	  $get_data=DB::table('tbl_route_collection_header as rd')
	            ->select(
				          'rd.id',
						  'rd.collection_number',
						  'rd.warehouse_id',
						  'rd.customer_id',
						  'rd.route_id',
						  'rd.trading_center_id',
						  'rd.collection_type',
						  'rd.cheque_number',
						  'rd.bank_name',
						  'rd.account_number',
						  'rd.branch_name',
	              
				        )
						
				->get(); 
		 if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
			
				
			$return_data1[$key]['id']                               = $details->id;
			$return_data1[$key]['collection_number']            = $details->collection_number;
			$return_data1[$key]['warehouse_id']                     = $details->warehouse_id;
			$return_data1[$key]['customer_id']                      = $details->customer_id;
			$return_data1[$key]['route_id']                         = $details->route_id;
			$return_data1[$key]['trading_center_id ']               = $details->trading_center_id;
			$return_data1[$key]['collection_type']                      = $details->collection_type;
			$return_data1[$key]['cheque_number']                      = $details->cheque_number;
			$return_data1[$key]['bank_name']                        = $details->bank_name;
			$return_data1[$key]['account_number']                 = $details->account_number;
			$return_data1[$key]['branch_name']                   = $details->branch_name;
			
			
	
			$get_material_data=DB::table('tbl_route_collection_details')
			->where('header_id','=',$details->id)
			->get(); 
			
		if($get_material_data!='')
		
		  {
			  
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'header_id'                => $get_material_data[$key1]->header_id,
                      'invoice_no'               => $get_material_data[$key1]->invoice_no,
                      'invoice_id'               => $get_material_data[$key1]->invoice_id,
                      'outstanding_amt'          => $get_material_data[$key1]->outstanding_amt,
                      'paid_amt'                 => $get_material_data[$key1]->paid_amt,
                      'total_outstanding'        => $get_material_data[$key1]->total_outstanding,
					  
				      );
			     } 
				 $return_data1[$key]['details'] = $fields;
		    $fields=array();
		    }
			                                                                                                                                                                
		  } 
	    }
	  	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Collection Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Collection Details NOt Found");
               }
   } 
	 
   
    public function route_outstanding_details($route_id)
	 {
		   $fields = array();
		 $return_data1 = array();
	
	  $get_data=DB::table('tbl_outstanding_details as rd')
	 
	            ->select(DB::raw("SUM(rd.amount_outsatnding) as total_amount_outsatnding"),
						  'rd.customer_id',
						  'rd.route_id',
						  
				         )
					->where('rd.route_id',$route_id)
					->groupBy('rd.customer_id')
					
				    ->get();
					
		 if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
			$return_data1[$key]['customer_id']                      = $details->customer_id;
			$return_data1[$key]['route_id']                         = $details->route_id;
			$return_data1[$key]['total_amount_outsatnding']                         = $details->total_amount_outsatnding;
				
	   
			
			$customer_outstanding=DB::table('tbl_outstanding_details')
			->where('customer_id','=',$details->customer_id)
			->get();
		    if($customer_outstanding!='')
		
		  {
			  
		  	foreach($customer_outstanding as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'outstanding_id'           => $customer_outstanding[$key1]->id,
                      'salesman_id'              => $customer_outstanding[$key1]->salesman_id,
                      'customer_id'              => $customer_outstanding[$key1]->customer_id,
                      'warehouse_id'             => $customer_outstanding[$key1]->warehouse_id,
                      'route_id'                 => $customer_outstanding[$key1]->route_id,
                      'invoice_id'               => $customer_outstanding[$key1]->invoice_id,
                      'remaining_outstanding'    => $customer_outstanding[$key1]->amount_outsatnding,
                      'total_paid_amount'        => $customer_outstanding[$key1]->amount_paid,
                      'total_outstanding'        => $customer_outstanding[$key1]->total_invoice_amount,
					  
				      );
			     } 
			
			
			     $return_data1[$key]['get_outstanding_customer_wise'] = $fields;
		    $fields=array();
			
		    }
			                                                                                                                                                                
		  } 
	    
	  	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Collection Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Collection Details NOt Found");
               }
   } 
	 
   
	 }
	
	public function customer_outstanding_save(Request $request)
	{
		
		 $current = Carbon::now(); 
		 $newDate = date("d-m-Y");
		  
		 
		  
		  if($request->collection_type==1)
		  {
				
				 $save_data= array(
				  
			    "route_id"                  =>$request->route_id,
				"warehouse_id"              =>$request->warehouse_id,
				'collection_number'         =>$request->collection_number, 
				"customer_id"               =>$request->customer_id,
				"trading_center_id"         =>$request->trading_center_id,
				"collection_type"           =>$request->collection_type,
				"trip_id"           =>$request->trip_id,
				"created_at"                =>$current,
				);
				
		  }
		  else if($request->collection_type===2)
		  {
			   $save_data= array(
				"route_id"                  =>$request->route_id,
				"warehouse_id"              =>$request->warehouse_id,
				'collection_number'         =>$request->collection_number, 
				"customer_id"               =>$request->customer_id,
				"trading_center_id"         =>$request->trading_center_id,
				"collection_type"           =>$request->collection_type,
				"cheque_number"             =>$request->cheque_no,
				"cheque_date"               =>$request->cheque_date,
				"trip_id"                   =>$request->trip_id,
				"created_at"                =>$current,
		
			  );
		  }
		  else
		  {
			 $save_data= array(
			    "route_id"                  =>$request->route_id,
				"warehouse_id"              =>$request->warehouse_id,
				'collection_number'         =>$request->collection_number, 
				"customer_id"               =>$request->customer_id,
				"trading_center_id"         =>$request->trading_center_id,
				"collection_type"           =>$request->collection_type,
		 		"bank_name"                 =>$request->bank_name,
		        "account_number"            =>$request->account_no,
		        "branch_name"               =>$request->branch_name,
				"trip_id"                   =>$request->trip_id,
				"created_at"                =>$current, 
			  
		
		  		);
		  }
		   $header_id =DB::table('tbl_route_collection_header')->InsertgetId($save_data);
		$paid_amt=$request->paid_amount;
		
		$get_customer=DB::table('tbl_outstanding_details')
		
		->select('tbl_outstanding_details.id','tbl_outstanding_details.total_invoice_amount','tbl_outstanding_details.customer_id','tbl_outstanding_details.amount_outsatnding','tbl_outstanding_details.invoice_id','tbl_outstanding_details.amount_paid')
		->where('tbl_outstanding_details.customer_id',$request->customer_id)
		->get();
		
      
		  
		  
	   
		   foreach($get_customer as $key => $outstanding)
		    {
		       if($paid_amt !=0)
			   {
				   if($paid_amt==$outstanding->amount_outsatnding)
				   {
					   OutstandingDetailsModels::find($outstanding->id)->delete();
					   
					   $data2=array
						    (
								 'header_id'             =>   $header_id,
								 'outstanding_amt'       =>   0,
								 'total_outstanding'     =>   $outstanding->total_invoice_amount,
								 'paid_amt'              =>   $paid_amt,
								 "created_at"            =>   $current,
							 );
					    $details=DB::table('tbl_route_collection_details')->Insert($data2);
					   
					    $paid_amt=0; 
					   
				   }
				   
	  else if($paid_amt>$outstanding->amount_outsatnding)
				  
				  {
					  $paid_amt=$paid_amt-$outstanding->amount_outsatnding;
					  OutstandingDetailsModels::find($outstanding->id)->delete();
					    $data2=array
						    (
								 'header_id'             =>   $header_id,
								 'outstanding_amt'       =>   0,
								 'total_outstanding'     =>   $outstanding->total_invoice_amount,
								 'paid_amt'              =>   $outstanding->amount_outsatnding,
								);
					    $details=DB::table('tbl_route_collection_details')->Insert($data2);
					  
					  
				  }
		  else
		         {
					     $credit=$outstanding->amount_outsatnding-$paid_amt;
						 
						  $data=OutstandingDetailsModels::find($outstanding->id);
				          $data->amount_outsatnding = $credit;
						  $data->amount_paid =$paid_amt;
				          $data->save();
						  
						  $data2=array
						    (
								 'header_id'             =>   $header_id,
								 'outstanding_amt'       =>   $data->amount_outsatnding,
								 'total_outstanding'     =>   $outstanding->total_invoice_amount,
								 'paid_amt'              =>   $paid_amt,
								);
			 $details=DB::table('tbl_route_collection_details')->Insert($data2);
			 $paid_amt=$paid_amt-$credit;
				      }
				   
			   }
				   
			if($details !='')
			{
			return array('API_Status'=>1,'Message'=>'Data Inserted');	
			}
			else
			{
				return array('API_Status'=>0,'Message'=>'Data Not Inserted');
			}

			
        }
			 
 }
 
       public function asset_save(Request $request)
    {
	   $current = Carbon::now();
	   $image_impload=array(); 
	   $image1=$request->file('image1');
	   $image2=$request->file('image2');
	   $image3=$request->file('image3');
	   $image4=$request->file('image4');
	   
	   if($image1!='')
	     {  
	       $filenameWithExt1 = $request->file('image1')->getClientOriginalName();
		
            // Get just filename
            $filename1 = pathinfo($filenameWithExt1, PATHINFO_FILENAME);            
                       
            // Get just ext
            $extension1 = $request->file('image1')->getClientOriginalExtension();
     
            //Filename to store
            $fileNameToStore1 = $filename1.'_'.time().'.'.$extension1;   
             
          
             // Upload Image
            $image_impload[0]=$path1 = $request->file('image1')->storeAs('public/salesman', $fileNameToStore1);
            
		 }
		 
     if($image2!='')
	      {  
	       $filenameWithExt2 = $request->file('image2')->getClientOriginalName();
		 
            // Get just filename 
            $filename2 = pathinfo($filenameWithExt2, PATHINFO_FILENAME);            
                 
            // Get just ext 
            $extension2 = $request->file('image2')->getClientOriginalExtension();
        
            //Filename to store 
            $fileNameToStore2 = $filename2.'_'.time().'.'.$extension2;   
              
          
            // Upload Image 
            $image_impload[1]=$path2 = $request->file('image2')->storeAs('public/salesman', $fileNameToStore2);
           
	     }
		 
	 if($image3!='')
	     {  
	       $filenameWithExt3 = $request->file('image3')->getClientOriginalName();
		  
            // Get just filename 
            $filename3 = pathinfo($filenameWithExt3, PATHINFO_FILENAME);            
                       
            // Get just ext 
            $extension3 = $request->file('image3')->getClientOriginalExtension();
          
            //Filename to store 
            $fileNameToStore3 = $filename3.'_'.time().'.'.$extension3;   
        
            // Upload Image 
            $image_impload[2]=$path3 = $request->file('image3')->storeAs('public/salesman', $fileNameToStore3);

          }
		  
	  if($image4!='')
	       {  
		   $filenameWithExt4 = $request->file('image4')->getClientOriginalName();
            // Get just filename
                     
            $filename4 = pathinfo($filenameWithExt4, PATHINFO_FILENAME);            
             // Get just ext
          
            $extension4 = $request->file('image4')->getClientOriginalExtension();
            //Filename to store  
            $fileNameToStore4 = $filename4.'_'.time().'.'.$extension4;   
          
             // Upload Image 
             $image_impload[3] =$path4 = $request->file('image4')->storeAs('public/salesman', $fileNameToStore4);
		  }
		
		$image_path=implode(",", $image_impload); 
		  $save_data=array(
		         'fdate'                =>  $request->fdate,
				 'route_id'            =>  $request->route_id,
				 'customer'            =>  $request->customer,
				 'salesman'            =>  $request->salesman,
				 'asset_name'          =>  $request->asset_name,
				 'latitude'            =>  $request->latitude,
				 'longitude'           =>  $request->longitude,
				 'reason_id'           =>  $request->reason_id,
				 'images'              =>  $image_path,
				 'created_at'          =>  $current,
			     );
				
			 $header_id =DB::table('tbl_asset_post')->insertGetId($save_data);
			 
			 if($header_id) {

            return array('Result'=>[], 'API_Status' => 1, 'Message' => "data inserted");

           }  else {

            return array('Result'=>[], 'API_Status' => 0, 'Message' => "data not saved");

                }
			 
  }
 
   
       public function planogram_save(Request $request)
    {
	   $current = Carbon::now();
	  
	   $path1="";
	   $path2="";
	   $before_image=$request->file('before_image');
	   $after_image=$request->file('after_image');
	
	   
	   if($before_image!='')
	     {  
	       $filenameWithExt1 = $request->file('before_image')->getClientOriginalName();
		
            // Get just filename
            $filename1 = pathinfo($filenameWithExt1, PATHINFO_FILENAME);            
                       
            // Get just ext
            $extension1 = $request->file('before_image')->getClientOriginalExtension();
     
            //Filename to store
            $fileNameToStore1 = $filename1.'_'.time().'.'.$extension1;   
             
          
             // Upload Image
            $path1 = $request->file('before_image')->storeAs('public/salesman', $fileNameToStore1);
            
		 }
		 
     if($after_image!='')
	      {  
	       $filenameWithExt2 = $request->file('after_image')->getClientOriginalName();
		 
            // Get just filename 
            $filename2 = pathinfo($filenameWithExt2, PATHINFO_FILENAME);            
                 
            // Get just ext 
            $extension2 = $request->file('after_image')->getClientOriginalExtension();
        
            //Filename to store 
            $fileNameToStore2 = $filename2.'_'.time().'.'.$extension2;   
              
          
            // Upload Image 
            $path2 = $request->file('after_image')->storeAs('public/salesman', $fileNameToStore2);
           
	     }
		 
	
		  $save_data=array(
		         'fdate'                   =>  $request->fdate,
		         'route_id'                =>  $request->route_id,
				 'customer'                =>  $request->customer,
				 'salesman'                =>  $request->salesman,
				 'planogram_name'          =>  $request->planogram_name,
				 'latitude'                =>  $request->latitude,
				 'longitude'               =>  $request->longitude,
				 'shelf_display'           =>  $request->shelf_display,
				 'before_image'            =>  $path1,
				 'after_image'            =>   $path2,
				 'comment'                 =>  $request->comment,
				 'created_at'              =>  $current,
			     );
				
			 $header_id =DB::table('tbl_planogram_post')->insertGetId($save_data);
			 
			 if($header_id) {

            return array('Result'=>[], 'API_Status' => 1, 'Message' => "data inserted");

           }  else {

            return array('Result'=>[], 'API_Status' => 0, 'Message' => "data not saved");

                }
			 
  }
 
    public function complaint_save(Request $request)
      {
		  $image_impload=array(); 
	      $images=$request->file('images');
	  
	    if($images!='')
	     {  
	       $filenameWithExt1 = $request->file('images')->getClientOriginalName();
		
            // Get just filename
            $filename1 = pathinfo($filenameWithExt1, PATHINFO_FILENAME);            
                       
            // Get just ext
            $extension1 = $request->file('images')->getClientOriginalExtension();
     
            //Filename to store
            $fileNameToStore1 = $filename1.'_'.time().'.'.$extension1;   
             
          
             // Upload Image
            $image_impload[0]=$path1 = $request->file('images')->storeAs('public/salesman', $fileNameToStore1);
            
		 }
		  
	      $current = Carbon::now();
		  $image_path=implode(",", $image_impload);
	 	  $save_data=array(
		         'ticket_id'                   =>  $request->ticket_id,
		         'department_id'               =>  $request->department_id,
				 'complaint_type'              =>  $request->complaint_type,
				 'note'                        =>  $request->note,
				 'route_id'                    =>  $request->route_id,
				 'salesman_id'                 =>  $request->salesman_id,
				 'warehouse_id'                =>  $request->warehouse_id,
				 'date_time'                   =>  $request->date_time,
				 'resolution'                  =>  $request->resolution,
				 'responsible_person'          =>  $request->responsible_person,
				 'images'                      =>  $image_path,
				 'flag'                        =>  $request->flag,
				 'is_assign'                   =>  $request->is_assign,
				 'status'                      =>  $request->status,
				 'priority'                    =>  $request->priority,
				 'old_priority'                =>  $request->old_priority,
				 'created_at'                  =>  $current,
			     );
				
			 $header_id =DB::table('tbl_merchandising_complaint')->insertGetId($save_data);
			 
			 if($header_id) {

            return array('Result'=>[], 'API_Status' => 1, 'Message' => "data inserted");

           }  else {

            return array('Result'=>[], 'API_Status' => 0, 'Message' => "data not saved");

                }
			 
       }
     
	  public function survey_save(Request $request)
      {
		  $current = Carbon::now();
		 
	 	  $save_data=array(
		         'survey_name'             =>  $request->survey_name,
		         'from_date'               =>  $request->from_date,
				 'to_date'                 =>  $request->to_date,
				 'status'                  =>  $request->status,
				 'created_at'              =>  $current,
			     );
				
			 $get_data =DB::table('tbl_surveys')->insertGetId($save_data);
			 
			 if($get_data) {

            return array('API_Status' => 1, 'Message' => "data inserted");

           }  else {

            return array('API_Status' => 0, 'Message' => "data not saved");

                }
			 
  } 
  public function survey_details()
  {
	 $fields = array();
	 $return_data1 = array();

	$get_data=DB::table('tbl_surveys as rd')
		   ->select('rd.id',
					'rd.survey_name',
					'rd.from_date',
					'rd.to_date',
				   )
		   ->where('rd.status','=','active')
		   ->get();

			
	 if($get_data!='')
	   {	

		foreach($get_data as $key => $details)	
		{
		$return_data1[$key]['id']                      = $details->id;
		$return_data1[$key]['survey_name']             = $details->survey_name;
		$return_data1[$key]['from_date']               = $details->from_date;
		$return_data1[$key]['to_date']                 = $details->to_date;
			

		
		$question_details=DB::table('tbl_questions')
		
	    ->where('tbl_questions.survey_id','=',$details->id)
		->get();
		if($question_details!='')

	  {
		  
		foreach($question_details as $key1 => $load_details1)	
		  {
			if($question_details[$key1]->question_type=='selectbox')
			{
			  $fields[$key1] = 
			  array( //this array must be created dynamic 
			  'id'                        => $question_details[$key1]->id,
			  'question'                  => $question_details[$key1]->question,
			  'question_type'             => $question_details[$key1]->question_type,
			  'question_type_select_based'=> $question_details[$key1]->question_type_select_based,
			  'survey_id'                 => $question_details[$key1]->survey_id,
			  'question_delete'           => $question_details[$key1]->question_delete,
			  
			  );
			
			}
            else
			{
				$fields[$key1] = 
				  array( //this array must be created dynamic 
				  'id'                        => $question_details[$key1]->id,
				  'question'                  => $question_details[$key1]->question,
				  'question_type'             => $question_details[$key1]->question_type,
				  'survey_id'                 => $question_details[$key1]->survey_id,
				  'question_delete'           => $question_details[$key1]->question_delete,
				  );
			}
	   } 
            $return_data1[$key]['questions'] = $fields;
		    $fields=array();
	  }
	  } 
	    if($get_data !='')
		   {  
			return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Collection Details");
		   }
		   else
		   {
			return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Collection Details NOt Found");
		   }
       } 
	 
   
	 }
	  
  public function save_competitor(Request $request)
     { 
	 $path1="";
	$images=$request->file('complaint_images');
	    
	     if($images!='')
	      {  
	       $filenameWithExt1 = $request->file('complaint_images')->getClientOriginalName();
		
            // Get just filename
            $filename1 = pathinfo($filenameWithExt1, PATHINFO_FILENAME);            
                       
            // Get just ext
            $extension1 = $request->file('complaint_images')->getClientOriginalExtension();
     
            //Filename to store
            $fileNameToStore1 = $filename1.'_'.time().'.'.$extension1;   
            $path1 = $request->file('complaint_images')->storeAs('public/salesman', $fileNameToStore1);
            
		 }
	 
			 
			$current = Carbon::now();
		   $save_data=array(
				'route_id'               =>  $request->route_id,
			    'salesman_id'            =>  $request->salesman_id,
				'company_name'           =>  $request->company_name,
			    'brand'                  =>  $request->brand,
			    'item_name'      		 =>  $request->item_name,
				'price'            		 =>  $request->price,
				'promotions'             =>  $request->promotions,
				'notes'            		 =>  $request->notes,
				'complaint_images'       =>  $path1,
				'distributer_name'       =>  $request->distributer_name,
				 'created_at'            =>  $current,
			    );

		   $insert =DB::table('tbl_competitor')->insertGetId($save_data);
		  
		     if($insert)
			  {
				return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");

			  } else 			   
			    {
				return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");

				}
	}
	
public function survey_answer_save(Request $request)
    {   
		 $current = Carbon::now(); 
		 $newDate = date("d-m-Y");
		  
		   
		 $save_data=array(
						 
						 'survey_id'           =>  $request->survey_id,
						 'customer_id'         =>  $request->customer_id,
						 'salesman_id'         =>  $request->salesman_id,
						 'route_id'            =>  $request->route_id,
						 'phone_no'            =>  $request->phone_no,
						 'created_at'          =>  $current,
						);

		   $header_id =DB::table('tbl_survey_answer_header')->insertGetId($save_data);
		   
		   foreach($request['answer1'] as $key )
		    {
                 $data2=array
							(
							 'header_id'          =>   $header_id,
							 'question_id'        => $key['question_id'],
							 'answer'             =>  $key['answer'],
							 'created_at'         =>   $current,
							);
					
			
			
			   $details= DB::table('tbl_survey_answer_details')->insert($data2);
		}
		   if($details)
		    {
				return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");
            } 
			else 
			{
			    return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
             } 
      }   

	 public function save_promotion_post(Request $request)
     { 
			$image_impload=array(); 
	       $images=$request->file('images');
	    
	     if($images!='')
	      {  
	       $filenameWithExt1 = $request->file('images')->getClientOriginalName();
		
            // Get just filename
            $filename1 = pathinfo($filenameWithExt1, PATHINFO_FILENAME);            
                       
            // Get just ext
            $extension1 = $request->file('images')->getClientOriginalExtension();
     
            //Filename to store
            $fileNameToStore1 = $filename1.'_'.time().'.'.$extension1;   
             
          
             // Upload Image
            $image_impload[0]=$path9 = $request->file('images')->storeAs('public/salesman', $fileNameToStore1);
            
		 }
	 
			$current = Carbon::now();
			 $image_path=implode(",", $image_impload);
			// dd($image_impload);
		   $save_data=array(
				'date'                  =>  $request->date,
				'free_material'         =>  $request->free_material,
				'invoice'               =>  $request->invoice,
			    'salesman'              =>  $request->salesman,
				'customer'              =>  $request->customer,
			    'phone'                 =>  $request->phone,
			    'amount_spend'      	=>  $request->amount_spend,
				'remark'                =>  $request->remark,
				'images'                =>  $image_path,
				'created_at'            =>  $current,
			    );

		   $insert =DB::table('tbl_promotional_post')->insertGetId($save_data);
		  
		     if($insert)
			  {
				return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");

			  } else 			   
			    {
				return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");

				}
	}
				/* {
				"free_material":"1",
				"invoice":"PP0001",
				"salesman":"1",
				"customer":"2",
				"phone":"95588805",
				"amount_spend":"500",
				"remark":"Testing",
				"date":"2021-11-22",
				"images":"application.png" 
				} */


public function checkin_checkout($salesman_id){
		    
		   $log = CheckinCheckoutModel::where('salesman_id', $salesman_id) 
                  ->first();
        
         if($log) {
           $log->checkout = date('Y-m-d H:i:s');
           $log->save();
        }
		   
		 Session::flush();
		if($log!='')
			{   
              return array('API_Status' => 1, 'Message' => "log out");
            }
          else
		  {
            return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something Went Wrong");
          }
	 	 
	  
	   }

 }