<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\SalesmanTypeModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\ReasonTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanUnloadModel;
use Illuminate\Support\Facades\DB;    

class MasterApisController extends Controller
 { 
   public function salesman_login($request, $password)
    {  
		 $get_data1 =array();
		 $get_data=DB::table('tbl_salesman')
		 ->leftJoin('tbl_route', 'tbl_salesman.route_id', '=', 'tbl_route.id')
		 ->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
		 ->leftJoin('tbl_salesman_type', 'tbl_salesman.salesman_type_id', '=', 'tbl_salesman_type.id')
		 ->leftJoin('tbl_customer', 'tbl_route.distibutor_id', '=', 'tbl_customer.id') 
		 ->leftJoin('tbl_vehicle', 'tbl_route.vehicle_id', '=', 'tbl_vehicle.id') 
	   	->leftJoin('tbl_company', 'tbl_salesman.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id') 
 
		 ->select('tbl_salesman.salesman_type_id',
		          'tbl_salesman_type.salesman_type_name',
		          'tbl_salesman_type.salesman_type_code',
				  'tbl_currency_type.id as currency_id',
				  'tbl_currency_type.currency_notation',
				  'tbl_company.vat',
				  'tbl_salesman.salesman_name',
				  'tbl_salesman.salesman_code',
				  'tbl_salesman.id as salesman_id',
				  'tbl_route.route_code',
				  'tbl_route.id as route_id',
				  'tbl_route.route_name',    
				  'tbl_route.vehicle_id',
				  'tbl_vehicle.vehicle_number',
				  'tbl_warehouse.warehouse_name',
				  'tbl_warehouse.id as warehouse_id',
				  'tbl_warehouse.warehouse_code',
				  'tbl_route.distibutor_id',
				  'tbl_customer.customer_code as distibutor_code',
				  'tbl_customer.customer_name as distibutor_name',
		 	      'tbl_salesman.salesman_picture',
		 	      'tbl_salesman.customer_from',
				  'tbl_salesman.invoice_from',
		 	      'tbl_salesman.order_from',
				  'tbl_salesman.delivery_from',
		 	      'tbl_salesman.collection_from',
				  'tbl_salesman.return_order_from',
		 	      'tbl_salesman.exchange_from',
				  'tbl_salesman.load_from',
		        )

		 ->where('tbl_salesman.salesman_password', $password)
		 ->where('tbl_salesman.salesman_code', $request)
		 ->get()->first();
		 
	 if($get_data!='')
	  {  
		 /* CHECKING ROUTE INVOICE CODE */ 
		$result = DB::table('tbl_pending_customer')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_pending_customer.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->customer_code; 
		     $get_data->customer_from = ++$getcode;
		  }
       
      /* CHECKING ROUTE INVOICE CODE */	   
		$result = DB::table('tbl_route_invoice_header')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_invoice_header.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->invoice_number; 
		     $get_data->invoice_from = ++$getcode;
		  }
		  
		/* CHECKING SALESMAN LOAD CODE */	   
		$result = DB::table('tbl_route_salesmanload_header')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_salesmanload_header.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->load_number; 
		     $get_data->load_from = ++$getcode;
		  }
		  
		  /* CHECKING ROUTE COLLECTION CODE */	   
		$result = DB::table('tbl_route_credit_collection')->where('route_id','=',$get_data->route_id)
		 ->select('tbl_route_credit_collection.*')->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->collection_no; 
		     $get_data->collection_from = ++$getcode;
		  }
		  
		  /* CHECKING ROUTE RETURN CODE */	   
		  $result = DB::table('tbl_return_sales_header')
		            ->where('route_id','=',$get_data->route_id)
		            ->select('tbl_return_sales_header.*')
					->get()->sortByDesc('id')->first();
	     if($result!='')
		  {
			 $getcode = $result->return_number; 
		     $get_data->return_order_from = ++$getcode;
		  }
		  
		  return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Salesman Login  Details");
	  }
		  
		 else{
              return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is wrong");
             } 
    }
   public function customer_details($type_name, $route_id)
    { 
		 $get_data = DB::table('tbl_customer')
		 ->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
		 ->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
	   	 ->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
	   	 ->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
	   	 ->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
	   	 ->leftJoin('tbl_trading_center', 'tbl_customer.trading_center_id', '=', 'tbl_trading_center.id')
	   	 ->leftJoin('tbl_payment_term', 'tbl_customer.payment_term', '=', 'tbl_payment_term.id')
	   	 ->leftJoin('tbl_country', 'tbl_customer.country_id', '=', 'tbl_country.id')
	   	 ->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id')

		 ->select('tbl_customer.id as customer_id',
		          'tbl_customer.customer_code',
		          'tbl_customer.customer_name',
		          'tbl_customer.customer_type as customer_type_id',
				  'tbl_customer_type.customer_type_name',
				  'tbl_customer_type.customer_type_code',
				  'tbl_customer.customer_category as customer_category_id',
				  'tbl_customer_category.customer_category_code',
				  'tbl_customer_category.customer_category_name',
				  'tbl_customer.tin_no',
				  'tbl_customer.email',
				  'tbl_customer.contact_no',
				  'tbl_customer.credit_days',
				  'tbl_customer.credit_limit',
				  'tbl_customer.region as region_id',
				  'tbl_region.region_code',
				  'tbl_region.region_name',
				  'tbl_customer.sub_region as sub_region_id',
				  'tbl_sub_region.sub_region_code',
				  'tbl_sub_region.sub_region_name',
				  'tbl_customer.route_id as route_id',
				  'tbl_route.route_code',
				  'tbl_route.route_name',
				  'tbl_customer.trading_center_id',
				  'tbl_trading_center.trading_center_code',
				  'tbl_trading_center.trading_name',
				  'tbl_customer.payment_term as payment_term_id',
				  'tbl_payment_term.payment_code',
				  'tbl_payment_term.payment_term',
				  'tbl_customer.address',
				  'tbl_customer.country_id as country_id',
				  'tbl_country.country_code',
				  'tbl_country.country_name',
				  'tbl_customer.city_id as city_id',
		 	      'tbl_city.city_code',
		 	      'tbl_city.city_name',
		 	      'tbl_customer.latitude',
		 	      'tbl_customer.longitude',
		 	      'tbl_customer.thresold_frequency'
		 	    )
				 
				->where('tbl_customer.route_id','=', $route_id)
				->where('tbl_customer.customer_type','=', $type_name)
			 ->get()->all(); 
		  
				if($get_data !='')
				  {   
				   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Details");
				   }
				 else 
				 { 
			      return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is wrong"); 
				 } 
	 }
	 
   public function material_details()
    {  
		$get_data=DB::table('tbl_material_master') 
		 ->leftJoin('tbl_material_category','tbl_material_master.material_category_id', '=', 'tbl_material_category.id')
		 ->leftJoin('tbl_type','tbl_type.id','=','tbl_material_master.material_types_id') 
		 ->leftJoin('tbl_unit_of_measurement','tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
		 
	     ->select('tbl_material_master.id as material_id',
		    'tbl_material_master.material_types_id',
			'tbl_type.type as material_type_name',
	     	'tbl_material_master.material_code',
	     	'tbl_material_master.material_name',
	     	'tbl_material_master.uom_id',
	     	'tbl_unit_of_measurement.uom_name as base_uom_name',
	     	'tbl_material_master.unit_price as base_price',
	     	'tbl_material_master.bar_code',
	     	'tbl_material_master.net_weight',
	     	'tbl_material_master.packing_size as base_packing_size',
	     	'tbl_material_master.shelf_life',
	     	'tbl_material_master.promotional_material',
	     	'tbl_material_master.vat',
	     	'tbl_material_master.material_category_id',
	     	'tbl_material_master.excise',
	     	'tbl_material_master.erp_material_code as erp_code',
	     	'tbl_material_master.alt_uom as alt_uom_id', 
	     	'tbl_material_master.alt_packing_size',
	     	'tbl_material_master.alt_unit_price',
	     	'tbl_unit_of_measurement.uom_code')

	      ->where('tbl_material_master.status','active')
		   ->get()->all();
			 
		   if($get_data !='') 
			{  
			 return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Material  Details"); 
			}
			else
			{
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Material Details Are Not Found"); 
			}   

	}

 public function pricing_plan()
    {  
		 $fields = array();
		 $return_data1 = array();
        
         $get_data=DB::table('tbl_pricing_plan') 
	       ->select('tbl_pricing_plan.*')
			->get(); 
	
	     if($get_data!='')
	       {	
	   
	        foreach($get_data as $key => $details)	
		    {
			
			if($get_data[$key]->status='active')
			{
				
			$return_data1[$key]['id']                    = $get_data[$key]->id;
			$return_data1[$key]['company_id']            = $get_data[$key]->company_id;
			$return_data1[$key]['plan_name']             = $get_data[$key]->plan_name;
			$return_data1[$key]['price_applied_on']      = $get_data[$key]->price_applied_on;
			$return_data1[$key]['valid_to']              = $get_data[$key]->valid_to;
			$return_data1[$key]['valid_from']            = $get_data[$key]->valid_from;
			$return_data1[$key]['created_user']          = $get_data[$key]->created_user;
			$return_data1[$key]['updated_user']          = $get_data[$key]->updated_user;
			$return_data1[$key]['created_at']            = $get_data[$key]->created_at;
			$return_data1[$key]['customer_category_id '] = $get_data[$key]->customer_category_id;
			$return_data1[$key]['material_category_id']  = $get_data[$key]->material_category_id;
			$return_data1[$key]['route_id']              = $get_data[$key]->route_id;
			$return_data1[$key]['status']                = $get_data[$key]->status;
			$get_material_data=DB::table('tbl_new_price')
			 ->leftJoin('tbl_unit_of_measurement','tbl_new_price.uom_id', '=', 'tbl_unit_of_measurement.id')
			 ->leftJoin('tbl_material_master','tbl_new_price.material_id', '=', 'tbl_material_master.id')
			->select('tbl_new_price.*','tbl_unit_of_measurement.unit_notation','tbl_material_master.material_name')
			->where('tbl_new_price.header_id','=',$get_data[$key]->id)
			->get(); 
			
	   if($get_material_data!='')
		
		  {
			  
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'material_id' => $get_material_data[$key1]->material_id,
                      'material_name' => $get_material_data[$key1]->material_name,
                      'new_price' => $get_material_data[$key1]->new_price,
                      'current_price' => $get_material_data[$key1]->current_price,
                      'uom_id' => $get_material_data[$key1]->uom_id,
                      'uom_name' => $get_material_data[$key1]->unit_notation,
                      'currency' => $get_material_data[$key1]->currency,
                      'material_category_id' => $get_material_data[$key1]->material_category_id,
					  'created_user' => $get_material_data[$key1]->created_user,
                      'total' => $get_material_data[$key1]->updated_user,
					  
				      );
			     } 
		    }
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array();
				
		  } 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Load Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
               }
   }
  public function trading_center_details($id)
   {
		$get_data=DB::table('tbl_trading_center')
		->leftJoin('tbl_route','tbl_route.id','=','tbl_trading_center.route_id')
		->select('tbl_trading_center.id','tbl_trading_center.trading_center_code','tbl_trading_center.trading_name') 
		->where('tbl_route.id','=',$id)
		->get()->all();

		if($get_data) 
			{  
			 return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Trading Center Details"); 
		    } 
			else
		   { 
			return array('Result'=>[], 'API_Status' => 0, 'Message' => "Trading Center Details Are Not Found"); 
		   } 
   }
   public function customer_plan_details($customer_type, $route_id)
     {  
		 $today = Carbon::now()->format('Y-m-d'); 
		 $day = date("D");
		 $day1=lcfirst($day); 
		 $get_data1 =array();

		 $get_data=DB::table('tbl_route_visit_plan_details')
		 ->leftJoin('tbl_customer', 'tbl_route_visit_plan_details.customer_id', '=', 'tbl_customer.id')
		 ->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
	   	->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
	   	->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
	   	->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
	   	->leftJoin('tbl_trading_center', 'tbl_customer.trading_center_id', '=', 'tbl_trading_center.id')
	   	->leftJoin('tbl_payment_term', 'tbl_customer.payment_term', '=', 'tbl_payment_term.id')
	   	->leftJoin('tbl_country', 'tbl_customer.country_id', '=', 'tbl_country.id')
	   	->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id') 
	   	->leftJoin('tbl_route_visit_plan_header', 'tbl_route_visit_plan_details.header_id', '=', 'tbl_route_visit_plan_header.id') 
		
		 ->select('tbl_customer.id as customer_id',
		          'tbl_customer.customer_code',
		          'tbl_customer.customer_name',
		          'tbl_customer.customer_type as customer_type_id',
				  'tbl_customer_type.customer_type_name',
				  'tbl_customer_type.customer_type_code',
				  'tbl_customer.customer_category as customer_category_id',
				  'tbl_customer_category.customer_category_code',
				  'tbl_customer_category.customer_category_name',
				  'tbl_customer.tin_no',
				  'tbl_customer.email',
				  'tbl_customer.contact_no',
				  'tbl_customer.credit_days',
				  'tbl_customer.credit_limit',
				  'tbl_customer.region as region_id',
				  'tbl_region.region_code',
				  'tbl_region.region_name',
				  'tbl_customer.sub_region as sub_region_id',
				  'tbl_sub_region.sub_region_code',
				  'tbl_sub_region.sub_region_name',
				  'tbl_customer.route_id as route_id',
				  'tbl_route.route_code',
				  'tbl_route.route_name',
				  'tbl_customer.trading_center_id',
				  'tbl_trading_center.trading_center_code',
				  'tbl_trading_center.trading_name',
				  'tbl_customer.payment_term as payment_term_id',
				  'tbl_payment_term.payment_code',
				  'tbl_payment_term.payment_term',
				  'tbl_customer.address',
				  'tbl_customer.country_id as country_id',
				  'tbl_country.country_code',
				  'tbl_country.country_name',
				  'tbl_customer.city_id as city_id',
		 	      'tbl_city.city_code',
		 	      'tbl_city.city_name',
		 	      'tbl_customer.latitude',
		 	      'tbl_customer.longitude',
		 	      'tbl_customer.thresold_frequency'
		 	    )
				->where('tbl_route_visit_plan_header.valid_from','<=', $today)
				->where('tbl_route_visit_plan_header.valid_to','>=', $today)
				->where('tbl_route_visit_plan_header.route_id','=', $route_id)
				->where('tbl_customer.customer_type','=', $customer_type)
				->where('tbl_route_visit_plan_details.'.$day1.'','=', 1)
			 ->get()->all();
			 
		  if($get_data !='')
			{   
              return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Details");
            }
          else
		  {
            return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something Went Wrong");
          }
    }
   public function customer_plan_detail()
	{
		$today = Carbon::now()->format('Y-m-d'); 
		$get_data=DB::table('tbl_customer_visit_plan')
	    ->leftJoin('tbl_route', 'tbl_customer_visit_plan.route_id', '=', 'tbl_route.id') 
		
		 ->select('tbl_customer_visit_plan.route_id','tbl_customer_visit_plan.cust_id','tbl_customer_visit_plan.mon','tbl_customer_visit_plan.tue','tbl_customer_visit_plan.wed','tbl_customer_visit_plan.thu','tbl_customer_visit_plan.fri','tbl_customer_visit_plan.sat','tbl_customer_visit_plan.sun')
		->where('tbl_customer_visit_plan.mon',"1" AND 'tbl_customer_visit_plan.mon',"0") 
	      
		  ->whereBetween(DB::raw("(STR_TO_DATE(tbl_customer_visit_plan.valid_from,'%Y-%m-%d'))"),[$today,$today])->get(); 
			
		if($get_data !='')
		  {  
		   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Plan Details");
		  }
		 else
		  { 
		   return array('Result'=>[], 'API_Status' => 0, 'Message' => "Username or Password is Wrong"); 
		  }
     }	
	public function route_visit_plan_details()
     {  
		 $fields = array();
		 $return_data1 = array();
         $today = Carbon::now()->format('Y-m-d'); 
         $get_data=DB::table('tbl_route_visit_plan_header') 
	       ->select('tbl_route_visit_plan_header.id',
	     	'tbl_route_visit_plan_header.for_visit_plan',
	     	'tbl_route_visit_plan_header.sales_area_id',
	     	'tbl_route_visit_plan_header.route_id',
	     	'tbl_route_visit_plan_header.valid_from',
	     	'tbl_route_visit_plan_header.valid_to',
	     	 )
			//->where('tbl_route_visit_plan_header.route_id','=',$route_id)
			//->whereBetween(DB::raw("(STR_TO_DATE(tbl_route_visit_plan_header.load_date,'%Y-%m-%d'))"),[$today,$today])
			->get(); 
		
	     if($get_data!='')
	       {		
	        foreach($get_data as $key => $details)	
		    {
			if($get_data[$key])
			{
			$return_data1[$key]['id']              = $get_data[$key]->id;
			$return_data1[$key]['for_visit_plan']  = $get_data[$key]->for_visit_plan;
			$return_data1[$key]['sales_area_id']   = $get_data[$key]->sales_area_id;
			$return_data1[$key]['route_id']        = $get_data[$key]->route_id;
			$return_data1[$key]['valid_from']      = $get_data[$key]->valid_from;
			$return_data1[$key]['valid_to']        = $get_data[$key]->valid_to;
			 
			$get_material_data=DB::table('tbl_route_visit_plan_details')
			->leftJoin('tbl_customer','tbl_route_visit_plan_details.customer_id', '=', 'tbl_customer.id') 
			->select('tbl_route_visit_plan_details.id',
	     	'tbl_route_visit_plan_details.header_id',
	     	'tbl_route_visit_plan_details.customer_id',
	     	'tbl_customer.customer_code',
	     	'tbl_customer.customer_name',
	     	'tbl_route_visit_plan_details.mon',
	     	'tbl_route_visit_plan_details.tue',
	     	'tbl_route_visit_plan_details.wed',
	     	'tbl_route_visit_plan_details.thu',
	     	'tbl_route_visit_plan_details.fri',
	     	'tbl_route_visit_plan_details.sat',
	     	'tbl_route_visit_plan_details.sun'
			)
			->where('tbl_route_visit_plan_details.header_id','=',$get_data[$key]->id)
			->get(); 
			
		if($get_material_data!='')	
		  {
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'customer_id' => $get_material_data[$key1]->customer_id, 
                      'customer_code' => $get_material_data[$key1]->customer_code,
					  'customer_name' => $get_material_data[$key1]->customer_name,
                      'mon' => $get_material_data[$key1]->mon,
                      'tue' => $get_material_data[$key1]->tue,
                      'wed' => $get_material_data[$key1]->wed,
					  'thu' => $get_material_data[$key1]->thu,
                      'fri' => $get_material_data[$key1]->fri,
                      'sat' => $get_material_data[$key1]->sat,
                      'sun' => $get_material_data[$key1]->sun,
					  
				      );
			     } 
		    }
			
			$return_data1[$key]['material'] = $fields;
		    $fields=array(); 
		  } 
	    }
	  }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Visit Plan Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
               }
   }
   public function device_configuration_details()
	{
		$get_data=DB::table('tbl_device_configuration') 
		->select('tbl_device_configuration.id',
		'tbl_device_configuration.synchronize',
		'tbl_device_configuration.google_api_key',
		'tbl_device_configuration.gcm_notification',
		'tbl_device_configuration.printer_type',
		'tbl_device_configuration.geofence_radius',
		'tbl_device_configuration.pre_sale', 
		'tbl_device_configuration.disclaimer') 
		->get()->all();

		if($get_data !='')
		  {  
			return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Device Configuration Details"); 
		  }
		 else 
		 {
		  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Device Configuration Details Are Not Found"); 
		 }
	 }
    public function save_company_order(Request $request)
     { 
		   $newDate = date("d-m-Y");
		   $save_data=array(
			 'company_order_number'             =>  $request->company_order_number,
			 'customer_id'                      =>  $request->customer_name,
			 'remark'                           =>  $request->remark,
			 'distribution_type_id'             =>  $request->distribution_type,
			 'currency_id'                      =>  $request->currency,
			 'order_type_id'                    =>  $request->order_type,
			 'tin_no'                           =>  $request->tin_no,
			 'is_deliver'                       =>  $request->is_deliver,
			 'warehouse_id'                     =>  $request->warehouse,
			 'total_excise'                     =>  $request->total_excise, 
			 'delevary_date'                    =>  $newDate,
			 'total_gross'                      =>  $request->total_gross,
			 'total_vat'                        =>  $request->total_vat,
			 'total_discount'                   =>  $request->total_discount,
			 'net_total_amount'                 =>  $request->net_total_amount,
			 'total_order_value'                =>  $request->total_order_value,
			 );

		   $header_id =DB::table('tbl_company_order_header')->insertGetId($save_data);
		 
		   foreach($request['Item'] as $key )
		   {
			 $data2=array(
			 'header_id'                       =>   $header_id,
			 'material_id'                     =>  $key['material_code'],
			 'uom_id'                          =>  $key['uom'],
			 'quantity'                        =>  $key['quantity'],
			 'unite_price'                     =>  $key['unite_price'],
			 'vat'                             =>  $key['vat'],
			 'gross_total'                     =>  $key['gross_total'],
			 'discount'                        =>  $key['discount'],
			 'discount_id'                     =>  $key['discount_id'],
			 'excise'                          =>  $key['excise'],
			 'return_type_id'                  =>  $key['return_type'],
			 'total'                           =>  $key['total'],
			 'net_amount'                      =>  $key['net_amount'],
			 'resion_id'                       =>  $key['resion'],
			  );
			  $details= DB::table('tbl_company_order_detail')->insert($data2);
		  
			}
			
		  if($details) 
		    { 
		      return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted"); 
			}
		  else 
		    {
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted"); 
		    } 
      }	 
}
			 
