<?php
namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\MaterialMasterModel;
use App\Models\MaterialCategoryModel;
use App\Models\MaterialCategoryNewModel;
use App\Models\BrandTypeModel;
use App\Models\TypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\ClientModel;
use App\Models\ManageCodeModel;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class MaterialMasterController extends Controller
 {
  public function list()
   {
	  $get_data = DB::table('tbl_material_master')
	  ->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
	  ->leftJoin('tbl_type', 'tbl_material_master.material_types_id', '=','tbl_type.id') 
	  ->leftJoin('tbl_brand_type', 'tbl_material_master.brand', '=','tbl_brand_type.id') 

			
	  ->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_code','tbl_unit_of_measurement.uom_name', 'tbl_type.type', 'tbl_type.type_code', 'tbl_brand_type.brand_code', 'tbl_brand_type.brand_name')
	  ->orderBy('id', 'DESC')->get();
		
	  return view('Master_Configuration.material_master_list',compact('get_data'));
    }
	
   public function view($id)
	{    
				  
		$uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		//$get_data=MaterialMasterModel::find($id);
		$get_data = DB::table('tbl_material_master')
		->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
		->leftJoin('tbl_material_category', 'tbl_material_master.material_category_id', '=', 'tbl_material_category.id')
		->leftJoin('tbl_material_category_new', 'tbl_material_master.material_category_new_id', '=', 'tbl_material_category_new.id')
		->leftJoin('tbl_type', 'tbl_material_master.material_types_id', '=', 'tbl_type.id')
		->leftJoin('tbl_brand_type', 'tbl_material_master.brand', '=','tbl_brand_type.id') 

		->select('tbl_material_master.*','tbl_unit_of_measurement.uom_code', 'tbl_unit_of_measurement.uom_name','tbl_material_category.category_code','tbl_material_category.category_name','tbl_material_category_new.category_codes','tbl_material_category_new.category_names','tbl_type.type', 'tbl_brand_type.brand_code', 'tbl_brand_type.brand_name')
		->where('tbl_material_master.id',$id)   
		->first();
		//dd($get_data);

		 $res = DB::table('tbl_client')->select('tbl_client.max_uom')->first();
		
		return view('Master_Configuration.material_master_view',compact('get_data','res','uom'));
	}
	
   public function add()
	{ 
	    
	    //$result =MaterialMasterModel::get()->sortByDesc('id')->first();
	    $result = DB::table('tbl_material_master')
		  ->select('tbl_material_master.*')->get()->sortByDesc('id')->first();	
			 
		
		//$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('uom_type','=',1);
		$alt_uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_types_id =TypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_type_codes =TypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_category_new =MaterialCategoryNewModel::all()->sortByDesc('id')->where('status', '=', 'active');
	

		$res = DB::table('tbl_client')->select('tbl_client.max_uom')->first();		
		// dd($res);
		return view('Master_Configuration.material_master',compact('material','uom','material_types_id','material_type_codes','res','material_category_new','alt_uom'));
    }
	
   public function edit($id)
	{
		$get_data=MaterialMasterModel::find($id);
		$material =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('uom_type','=',1);
		$alt_uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$get_uom1 =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_types_id =TypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_type_codes =TypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_category_new =MaterialCategoryNewModel::all()->sortByDesc('id')->where('status', '=', 'active');
		//$last_code = $get_data->material_code;

		$res = DB::table('tbl_client')->select('tbl_client.max_uom')->first();

		return view('Master_Configuration.material_master',compact('get_data','material','uom','res','get_uom1','material_types_id','material_type_codes','material_category_new','alt_uom'));
		//dd($get_data);
    }
		
   public function save(Request $request)
	{	
		
		$alt_uom    = array();
		$alt_packing_size    = array();
		$alt_unit_price    = array();
		$data=new MaterialMasterModel;
	  
	    $material_images=$request->file('material_image');	   
		   if($material_images)
			 {  
	  
				$filenameWithExt = $request->file('material_image')->getClientOriginalName();
				// Get just filename
				$filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);            
				// Get just ext
				$extension = $request->file('material_image')->getClientOriginalExtension();
				//Filename to store
				$fileNameToStore = $filename.'_'.time().'.'.$extension;                       
				// Upload Image
				$path = $request->file('material_image')->    storeAs('public/material', $fileNameToStore);
			 }
		   elseif($request->updated_id !='' && $material_images == '')
			 {
				$old_path = MaterialMasterModel::find($request->updated_id);
				$path= $old_path->material_image;
			  }
		  else
			{
				$path = '';
			}		   
		
		  if($request->updated_id)
			{
		
			  foreach($request['alt_uom'] as $key => $n)
				{ 
					$alt_uom[$key] = $request->alt_uom[$key ];
					$alt_packing_size[$key] = $request->alt_packing_size[$key ];
					$alt_unit_price[$key]   =$request->alt_unit_price[$key ];

				}

			  $alt_uoms= implode(",",$alt_uom);
			  $alt_uoms_trim=rtrim($alt_uoms,',');

			  $alt_prices= implode(",",$alt_unit_price);
			  $alt_price_trim=rtrim($alt_prices,',');
			
			 $data = MaterialMasterModel::find($request->updated_id);		
			 $data->material_types_id=$request->material_types_id;
			 $data->material_code=$request->material_type_codes;
			 $data->material_name=$request->material_name;
			 $data->material_category_new_id=$request->material_category_new;
			 $data->uom_id=$request->uom;
			 $data->unit_price=$request->unit_price;
			 $data->material_category_id=$request->material_category;
			 $data->brand=$request->brand;
			 $data->excise=$request->excise_amt;
			 $data->vat=$request->vat;
			 $data->bar_code=$request->bar_code;
			 $data->material_image=$path;
			 $data->net_weight=$request->net_weight;
			 $data->packing_size=$request->packing_size;
			 $data->shelf_life=$request->shelf_life;
			 $data->promotional_material=$request->promotional_material;
			 $data->erp_material_code=$request->erp_material_code;
			 $data->updated_user= Session::get('user_id');
			 $data->company_id= Session::get('company_id');
			 $data->status=$request->status;
			
			 $data->alt_uom=$alt_uoms_trim;
			 $data->alt_packing_size=implode(",",$alt_packing_size);
			 $data->alt_unit_price=$alt_price_trim;
			
			 //dd($alt_packing_size);
			 $data->save();
				
			return redirect(route('material_master_list'))->with('successMessage','Material master updated successfully');
		
	      } 
		else 
		  {
		
		   foreach($request['alt_uom'] as $key => $n)
			 { 
				$alt_uom[$key] = $request->alt_uom[$key ];
				$alt_packing_size[$key] = $request->alt_packing_size[$key ];
				$alt_unit_price[$key]   =$request->alt_unit_price[$key ];
				
			 }
			
			    $alt_uoms= implode(",",$alt_uom);
				$alt_uoms_trim=rtrim($alt_uoms,',');
				$alt_prices= implode(",",$alt_unit_price);
				$alt_price_trim=rtrim($alt_prices,',');	

				
				$data->material_types_id=$request->material_types_id;
				$data->material_code=$request->material_type_codes;
				$data->material_name=$request->material_name;
				$data->material_category_new_id=$request->material_category_new;
				$data->uom_id=$request->uom;
				$data->unit_price=$request->unit_price;
				$data->material_category_id=$request->material_category;
				$data->brand=$request->brand;
				$data->excise=$request->excise_amt;
				$data->vat=$request->vat;
				$data->bar_code=$request->bar_code;
				$data->material_image=$path;
				$data->net_weight=$request->net_weight;
				$data->packing_size=$request->packing_size;
				$data->shelf_life=$request->shelf_life;
				$data->promotional_material=$request->promotional_material;
				$data->erp_material_code=$request->erp_material_code;
				$data->created_user= Session::get('user_id');
				$data->company_id= Session::get('company_id');
				$data->status=$request->status;					
				$data->alt_uom=$alt_uoms_trim;
				$data->alt_packing_size=implode(",",$alt_packing_size);
				
				$data->alt_unit_price=$alt_price_trim;					
				$data->save();  
				
				return redirect(route('material_master_list'))->with('successMessage','Material master added successfully');
		
		  }	   	
     } 
	
	public function getUom()
	 {

		// Fetch Employees by Departmentid
		/*$empData['data'] = Employees::orderby("name","asc")
				->select('id','name')
				->where('department',$departmentid)
				->get();*/
				
	    $uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   // $alt_uom =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		//dd($uom);
	    return response()->json($uom);

     }
		
    public function get_material_code($id)
	 {
			
		$result =MaterialMasterModel::get()->where('material_types_id','=',$id)->sortByDesc('material_types_id')->first();
	    if($result=='') 
		  {
		  
			$getcode = TypeModel::where('id', $id)->first();
			$last_code = $getcode->material_code;
				
		  }
	    else{
			 $getcode = MaterialMasterModel::get()->where('material_types_id','=',$id)->last();
			 $last_code = ++$getcode->material_code;
			}

        echo $last_code;
			 
	 }
	   
	public function get_material_cat($id,$edit)
	 {
		$result = DB::table('tbl_material_category')
		   ->select('tbl_material_category.*')
		   ->where('material_type_id','=',$id)->get()->all();
		
		?>
		<option  value="">     </option>
		<?php
		foreach($result as $matcat)
		  {
			?>
			<option value="<?php echo $matcat->id ?>" <?php if($matcat->id == $edit) { echo "selected"; } ?> ><?php echo $matcat->category_code." - ".$matcat->category_name ?></option>	
			<?php		
		   }
		   
	 }
	
	public function get_material_brand($id,$edit)
	 {
			
	    $result =BrandTypeModel::get()->where('material_type','=',$id)->where('status', '=', 'active')->all();
			
		?>
		<option  value="">     </option>
		<?php
		foreach($result as $brand)
		  {
			?>
			<option value="<?php echo $brand->id ?>" <?php if($brand->id == $edit) { echo "selected"; } ?> ><?php echo $brand->brand_code." - ".$brand->brand_name ?></option>	
			<?php		
		  }
	 } 
	   
	   
		
 }