<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\OutletExpenseModel ;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\ExpenseTypeModel;
use App\Models\RouteModel;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class OutletExpenseController extends Controller
 {
   public function list(Request $request)
	{ 	
	  $current_date=date("Y-m-d");
 
	  $where="";		
	  if(count($request->all()) < 1)
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
	  
	  if($request->fromdate!='')
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
		 
	  if($request->warehouse!='')
		{
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		}
 
			$warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 3);
	
			$get_data = DB::select("SELECT riheader.*, 
			expense.expense_code,expense.expense_name,
			warehouse.warehouse_code,warehouse.warehouse_name,currency.currency_notation
			
			FROM tbl_outlet_expenses as riheader
			
			LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
			WHERE riheader.id IS NOT NULL ".$where."  ORDER BY id DESC");	
			//dd($get_data);	
			return view('Outlet_Transaction.outlet_expenses_list',compact('get_data','warehouse'));		
	}
		
   public function add()
	{
		
		$result =OutletExpenseModel::get()->sortByDesc('id')->first();
		if($result=='')
		{
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->outlet_expense_number;
		}
	  else
		{
			$getcode = $result->expense_no; 
			$last_code = ++$getcode;
		}
		$warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 3);
		
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('expense_category', '=', 3)->where('status', '=', 'active');

		return view('Outlet_Transaction.outlet_expenses',compact('last_code','warehouse','expense_type'));

    }
		
   public function edit($id)
	{
		$warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$get_data = DB::table('tbl_outlet_expenses')
	
		->leftJoin('tbl_warehouse', 'tbl_outlet_expenses.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_expense_type', 'tbl_outlet_expenses.expense_type', '=', 'tbl_expense_type.id')
		
		->select('tbl_outlet_expenses.*', 'tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_expense_type.expense_code','tbl_expense_type.expense_name')
		
		->where('tbl_outlet_expenses.id', '=', $id)
		
		->first();
	
		$last_code = $get_data->expense_no;


		return view('Outlet_Transaction.outlet_expenses',compact('get_data','warehouse','expense_type','last_code'));
	}
	
   public function save(Request $request)
	{
		$data=new OutletExpenseModel;
		 
		$user_id=Session::get('user_id');        
		
		$login_user = DB::table('tbl_user')
		->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		->where('tbl_user.id', '=', $user_id)
		->get()->first();		 

		if($request->updated_id)
		  {
            
			$data = OutletExpenseModel::find($request->updated_id);
			$data->currency = $login_user->currency_id;
			$data->expense_no=$request->expense_no;
			$data->warehouse_id=$request->warehouse_id;
			$data->expense_type=$request->expense_type;
			$data->expense_date=$request->expense_date;
			$data->expense_amount=$request->expense_amt;
			$data->comment=$request->comment;
			
			$data->save();
			return redirect(route('outlet_expenses_list'))->with('successMessage','Expenses Updated Successfully');
	
		  } else 
			
			{
            
				$data->currency = $login_user->currency_id;
				$data->expense_no=$request->expense_no;
				$data->warehouse_id=$request->warehouse_id;
				$data->expense_type=$request->expense_type;
				$data->expense_date=$request->expense_date;
				$data->expense_amount=$request->expense_amt;
				$data->comment=$request->comment;
				$data->save();
				return redirect(route('outlet_expenses_list'))->with('successMessage','Expenses Added Successfully');
				
			 }   
	 }
	 
	 public function view($id)
      { 
			$user_id=Session::get('user_id');
			$get_data =DB::table('tbl_outlet_expenses')				
			->leftJoin('tbl_expense_type', 'tbl_outlet_expenses.expense_type', '=', 'tbl_expense_type.id')
			->leftJoin('tbl_warehouse', 'tbl_outlet_expenses.warehouse_id', '=', 'tbl_warehouse.id')
			
			->select('tbl_outlet_expenses.*','tbl_outlet_expenses.expense_no','tbl_outlet_expenses.expense_date','tbl_expense_type.expense_code','tbl_expense_type.expense_name',
			'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_outlet_expenses.expense_amount')->where('tbl_outlet_expenses.id', '=',$id)->get()->first();
				 
		/*	$get_data_details =DB::table('tbl_company_delivery_detail')
  
			   ->leftJoin('tbl_material_master', 'tbl_company_delivery_detail.material_code', '=', 'tbl_material_master.id')
			   ->leftJoin('tbl_unit_of_measurement', 'tbl_company_delivery_detail.uom', '=', 'tbl_unit_of_measurement.id')
			   ->leftJoin('tbl_reason_type', 'tbl_company_delivery_detail.resion', '=', 'tbl_reason_type.id')
	  
			  ->select('tbl_company_delivery_detail.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type')->where('tbl_company_delivery_detail.header_id', '=', $id)->get()->all();
		  
         
			$login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency','tbl_currency_type.currency_notation')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();		*/	  
	
		 
			/* $reason =OutletExpenseModel::all()->sortByDesc('id'); */
	
			return view('Outlet_Transaction.outlet_expenses_view',compact('get_data'));
	
	  }
	 
	 
	 
	 
	 
 }
