<?php

namespace App\Http\Controllers;
use App\Models\OutletModel;  
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\TradingCenterModel; 
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel; 
use Carbon\Carbon;
use App\Models\ReasonTypeModel;
use Session;
use PDF;
use App\Exports\OutletReturnExport; 
use Maatwebsite\Excel\Facades\Excel;
use Illuminate\Http\Request;

class OutletReturnsSales extends Controller
{

	public function add()
	{ 
         $distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);  	
		 $user_id=Session::get('user_id');	  
		$result = DB::table('tbl_outlet_counter_sales_header')
		->select('tbl_outlet_counter_sales_header.*')->get()->sortByDesc('id')->first();
	 
	   if($result=='')
		 {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->counter_sales_no;
		 }
	   else
	     {
		    $getcode = $result->counter_sales_no; 
		    $last_code = ++$getcode;
	     }  
		  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active'); 
		  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $outlet=OutletModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
		  $login_user = DB::table('tbl_user')
		 ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		 ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		 ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		 ->where('tbl_user.id', '=', $user_id)
		 ->get()->first(); 
		 //dd($login_user);
	 
		 return view('Outlet_Transaction.outlet_return_sales' ,compact('last_code', 'route','material','login_user','outlet', 'distibutor') );
	 }   
	 public function get_warehouse($distributor_id)
	  
	  {
	     /*  echo $distributor.', '.$warehouse_id;
		 exit; */ 
		 
	   
	   $data =WarehouseModel::all()->where('distributor','=',$distributor_id)->where('warehouse_type','=',1)->sortByDesc('id');	
	    
      $html = ''; 
      if(count($data) > 0) {
        foreach($data as $warehouse_name) {
			$html .='<option value=""></option>';
            $html .= '<option class="opt_v1" value="' . $warehouse_name->id . '">'. $warehouse_name->warehouse_name;
            $html .= "</option>";
        }
      return response()->json($html);//then sent this data to ajax success 
	}
   }
   public function get_outlet_return_warehouse_of_warehouse($warehouse)
	{
		
		$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',3)->where('status', '=', 'active')->where('outlet_warehouse','=',$warehouse)->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($outlet_warehouse as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		
	}
	
  public function get_outlet_warehouse($warehouse_id)
	  
	  { 
	 
	   $data =WarehouseModel::all()->where('warehouse_type','=',3)->where('status','=','active')->where('warehouse_name','=',$warehouse_id)->sortByDesc('id');	   
	    
      $html = ''; 
      if(count($data) > 0) {
        foreach($data as $outlet_name) {
			$html .='<option value=""></option>';
            $html .= '<option class="opt_v1" value="' . $outlet_name->id . '">'. $outlet_name->warehouse_name;
            $html .= "</option>";
        }
      return response()->json($html);//then sent this data to ajax success 
	}
   }
     
   
	 public function get_outlet_warehouse_of_warehouse($warehouse,$outlet_id)
	 
	 {
		$outlet_warehouse=OutletModel::get()->where('customer_name','=',3)->where('status', '=', 'active')->where('outlet_warehouse','=',$warehouse)->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($outlet_warehouse as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php	
			
		  }
		
	} 
	
   public function save(Request $request)
    {
		// dd($request);
     $warehouse=OutletModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('id', '=', $request->outlet);
	     // dd($warehouse[0]->warehouse_name);  
	   
	  $current = Carbon::now();
	  $user_id=Session::get('user_id');			
	  $login_user = DB::table('tbl_user')
	  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
	  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
	  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
	  ->where('tbl_user.id', '=', $user_id)
	  ->get()->first();
		  
	  $date = str_replace('/', '-', $request->invoice_date);
	  $newDate = date("d-m-Y", strtotime($date));
	  $salesman_id=2;
	 
	  $data3=array(
	  'counter_sales_no'      =>  $request->counter_sales_number,
	  'currency'            =>  $login_user->currency_id,
	  'distibutor_id'            =>  $request->distibutor,
	  'warehouse_id'            =>  $request->warehouse,
	  'outlet_id'            =>  $request->outlet,
	  'remark'              =>  $request->comment,
	  'total_gross'         =>  $request->gross_amount_totali,
	  'total_invoice_value' =>  $request->invoice_amount_totali,
	  'created_at'         => $current,
	  );
				 
	 $header_id =DB::table('tbl_outlet_counter_sales_header')->insertGetId($data3);
		 
	 if(count($request->material_name)>0)
		{
	   
		   foreach($request['material_name'] as $key => $n)
		    {
			  if($request->quantity[$key ]!='')
				{
				  $data2=array
					(
					 'material_id' => $request->material_name[$key ],
					 'header_id'           =>$header_id,
					 'uom'           => $request->uom[$key ],
					 'unite_price'   => $request->price[$key ],
					 'return_type'   => $request->return_type[$key ],
					 'resion_type'        => $request->resion[$key ],
					 'gross_total'   => $request->gross[$key ],
					 //  'vat'           => $request->vat[$key ],
					 'total'         => $request->total[$key ],
					 'base_qty'    => $request->packing_size[$key ],
					 // 'net_amount'    => $request->net_amount[$key ],
					 'quantity'      => $request->quantity[$key ],
					 'created_at'    => $current,
					);
				 DB::table('tbl_outlet_counter_sales_details')->insert($data2);
									 
				 /* stock movement functionality start from here   */
				 $stock = DB::table('tbl_warehouse_stock')
				 ->where('tbl_warehouse_stock.warehouse_id','=',$request->warehaouse_id)
				 ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
				 ->get()->all();
				 $count=count($stock);
				 if($count>0)
					{
				  
					   if($request->return_type[$key]=='1')
					    {										
						  // reducing stock from warehouse
							$query = DB::table('tbl_warehouse_stock')
						  ->where('warehouse_id',$request->warehaouse_id)
						  ->where('material_id','=',$request->material_name[$key]);
						  
						   $query->increment('qty',$request->packing_size[$key]);
					    }
					   else
					    {
						   $query = DB::table('tbl_warehouse_stock')
						  ->where('warehouse_id',$request->warehaouse_id)
						  ->where('material_id','=',$request->material_name[$key]);
						   $query->increment('return_stock',$request->packing_size[$key]);
					    }
					}
			    } 
		    }		 
		}
		return redirect(route('outlet_return_sales_list'))->with('successMessage','Item Uploaded Successfully');
    }
   public function list(Request $request)
    { 
     
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
	 
	  if($request->fromdate!='')
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
	 
	  if($request->warehouse!='')
		{
		  $where .= "AND warehouse.id = '".$request->warehouse."'";
		}
		 
	  if($request->outlet!='')
		{
		  $where .= "AND outlet.id = '".$request->outlet."'";
		}

			 //$outlet =OutletModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=',1)->where('status', '=', 'active');
			//$get_data = CurrencyTypeModel::all()->sortByDesc('id'); 
			$get_data = DB::select("SELECT riheader.*,riheader.id,(outlet.warehouse_name) as outlet_name,(outlet.warehouse_code) as outlet_code,
			warehouse.warehouse_code,warehouse.warehouse_name,customer.customer_code,customer.customer_name,
			currency.currency_notation
			
			FROM tbl_outlet_counter_sales_header as riheader
			LEFT JOIN tbl_warehouse as outlet on riheader.outlet_id=outlet.id
			LEFT JOIN tbl_customer as customer on riheader.distibutor_id=customer.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
			WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC");
	 
			
	 	return view('Outlet_Transaction.outlet_return_sales_list',compact('get_data','warehouse'));
    
	}
	 public function get_material()
	  {		
		   $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		   ?>
		   <option  value="">     </option>
		   <?php
		  foreach($material as $material_name)
			{
			  ?>
			  <option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code .' - '. $material_name->material_name ?></option>	
			  <?php		
			}
		
	        //return response()->json($get_data);
		
      }
	  
     public function get_material_price($id,$val)
	  {
	 
		   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	     
		   $alt_uom = explode(",",$material->alt_uom);				   
		   $key = array_search($id, $alt_uom);				   
		   $alt_unit_price = explode(",",$material->alt_unit_price);
			echo $alt_unit_price[$key];			
	  }    
	 
	 public function get_material_detailsUom($id,$row)
      {
			$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
			t1.alt_uom) WHERE t1.`id`='.$id.'');			
			$get_material_price=MaterialMasterModel::find($id);			
			$alt_unit_price = explode(",",$get_material_price->alt_unit_price);			
		   //dd($material_master);
			$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
		    foreach($material_master as $key=>$data)
			  {					
				 ?>
				 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				 <?php
				 
				}
	  }
	   
     public function get_resion($id)
      {		 
		$reason =ReasonTypeModel::all()->sortByDesc('id')->where('return_type', '=', $id);		 
		foreach($reason as $key=>$data)
		  {				
			  ?>
			  <option   value ="<?php echo $data->id; ?>" ><?php echo $data->reasion_type; ?></option>
			  <?php				 
		  }	   
	  }  
		
     public function get_material_return_alt_packing_size($id,$val)
	  {
	 
		 $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		 $alt_uom = explode(",",$material->alt_uom);
	   
		 $key = array_search($id, $alt_uom);
	   
		 $alt_alt_packing_size = explode(",",$material->alt_packing_size);

		 echo $alt_alt_packing_size[$key];
			
	   }
     public function get_return_filter($id,$url_return)
       {
			 //dd($url_return);
		 $outlet_warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type','=',3)->where('outlet_warehouse', '=', $id);
		  ?>
			<option  value="">  </option>
			<?php  
			  foreach($outlet_warehouse as $outletname)   
				{ 
					?>
					<option <?php if($outletname->id==$url_return) { echo "selected";} ?> value="<?php echo $outletname->id ?>"  ><?php echo $outletname->warehouse_code.' - '.$outletname->warehouse_name ?></option>	
					<?php		
				}				 
	    }	   
	 public function view($id)
	  {   
	
		 $user_id=Session::get('user_id');
		 $get_data =DB::table('tbl_outlet_counter_sales_header')
		
		->leftJoin('tbl_warehouse as outlet', 'tbl_outlet_counter_sales_header.outlet_id', '=', 'outlet.id')
		->leftJoin('tbl_customer', 'tbl_outlet_counter_sales_header.distibutor_id', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_outlet_counter_sales_header.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_currency_type', 'tbl_outlet_counter_sales_header.currency', '=', 'tbl_currency_type.id')           
		->select('tbl_outlet_counter_sales_header.*','outlet.warehouse_name as outlet_name','outlet.warehouse_name as outlet_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_currency_type.currency_notation')->where('tbl_outlet_counter_sales_header.id', '=',$id)->get()->first();		
		 $get_data_details =DB::table('tbl_outlet_counter_sales_details')

		  ->leftJoin('tbl_material_master', 'tbl_outlet_counter_sales_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_counter_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_outlet_counter_sales_details.resion_type', '=', 'tbl_reason_type.id')
  
		  ->select('tbl_outlet_counter_sales_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_counter_sales_details.header_id', '=', $id)->get()->all();

			$login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();			          
		  $reason =ReasonTypeModel::all()->sortByDesc('id');		
		return view('Outlet_Transaction.outlet_return_sales_view',compact('get_data','get_data_details','login_user','reason'));
		
      }	
	  
	   public function outlet_return_sales_export($id)
	      {   
		      
             return Excel::download(new OutletReturnExport($id), 'return_export.xlsx');
        
	       }  
	   public function  outlet_return_sales_pdf($id)
	      {   
		       $get_data =DB::table('tbl_outlet_counter_sales_header')
		        ->leftJoin('tbl_warehouse as outlet', 'tbl_outlet_counter_sales_header.outlet_id', '=', 'outlet.id')
		        ->leftJoin('tbl_customer', 'tbl_outlet_counter_sales_header.distibutor_id', '=', 'tbl_customer.id')
		        ->leftJoin('tbl_warehouse', 'tbl_outlet_counter_sales_header.warehouse_id', '=', 'tbl_warehouse.id')
		        ->leftJoin('tbl_currency_type', 'tbl_outlet_counter_sales_header.currency', '=', 'tbl_currency_type.id')           
		        ->select('tbl_outlet_counter_sales_header.*','outlet.warehouse_name as outlet_name','tbl_customer.address','tbl_customer.tin_no','tbl_customer.contact_no','tbl_customer.email','outlet.warehouse_name as outlet_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_currency_type.currency_notation')->where('tbl_outlet_counter_sales_header.id', '=',$id)->get()->first();
				
		       $get_data_details =DB::table('tbl_outlet_counter_sales_details')
                 ->leftJoin('tbl_material_master', 'tbl_outlet_counter_sales_details.material_id', '=', 'tbl_material_master.id')
		         ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_counter_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		         ->leftJoin('tbl_reason_type', 'tbl_outlet_counter_sales_details.resion_type', '=', 'tbl_reason_type.id')
                 ->select('tbl_outlet_counter_sales_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_counter_sales_details.header_id', '=', $id)->get()->all();
				 
				 $pdf=PDF::loadView('export.pdf.outlet_return_sales_pdf', compact('get_data','get_data_details'));
                return $pdf->download('return_export.pdf');
        
	       }  
 }
