<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel;
use App\Models\CustomerModel;
use App\Models\ClientModel;
use App\Exports\OutletReportExport;
use App\Models\MaterialCategoryModel;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Maatwebsite\Excel\Facades\Excel;
class OutletStockReportController extends Controller
 {
   public function add()
    { 		  
	   $get_data1 = DB::table('tbl_outlet')
		->leftJoin('tbl_country', 'tbl_outlet.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_city', 'tbl_outlet.city_id', '=', 'tbl_city.id')
		->select('tbl_outlet.*', 'tbl_country.country_name','tbl_city.city_name')
		->get();
		 //dd($get_data1); 
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();

		return view('Outlet_Transaction.outlet_stock_report',compact('material_category','get_data1'));
	}
	  
   public function get_category_details($id)
    { 	
				
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
		
		$get_transfer_warehouse=DB::table('tbl_outlet')
			->leftJoin('tbl_country', 'tbl_outlet.country_id', '=', 'tbl_country.id')
			->leftJoin('tbl_city', 'tbl_outlet.city_id', '=', 'tbl_city.id')
			->select('tbl_outlet.*', 'tbl_country.country_name','tbl_city.city_name')
			->get();
			
		return view('Outlet_Transaction.outlet_stock_report',compact('material_category','get_transfer_warehouse'));
		
		
      }
	
     public function get_wareouse($cat_id,$warehouse_id)
      { 		
		 $material_master1 = DB::table('tbl_outlet_warehouse')
		  ->leftJoin('tbl_material_master', 'tbl_outlet_warehouse.material_id', '=', 'tbl_material_master.id')
		  ->select('tbl_material_master.alt_uom','tbl_material_master.material_name','tbl_material_master.id as material_id')
			 ->where('tbl_outlet_warehouse.outlet_warehouse_id', '=', $warehouse_id)
			 ->where('tbl_outlet_warehouse.material_category_id', '=', $cat_id)
			 ->groupBy('material_name','material_id')
		  ->get()->all();
		//dd($material_master1);					  
		if(count($material_master1)>0)
        {
		  ?>
		
           <table class="mb-0 table table-bordered table-responsive border-dark" >
           <thead class="border-dark">
			   <tr>
				 <th style="width:10%;" class="text-center">Material Name</th>
				 <th style="width:100%;" class="text-center">Outlet Warehouse Stock</th>
			  </tr>
           </thead>
           <tbody>
				  <?php 
				   $get_data = ClientModel::get()->first();
				   $max_uoms=$get_data->max_uom;
				   $uom_count=''; 
				  ?>										 
	     	   <?php
			 foreach($material_master1 as $key1=> $data) 
		       {
		   ?>
		  <tr>									  
			<td><h5 class="font-weight-bold ml-2"> <?php echo $material_master1[$key1]->material_name; ?>
			  </h5>
			   <input type="hidden" name="material_id[]" class="form-control"  value="<?php echo $material_master1[$key1]->material_id; ?>"/>														
			 </td>
		   <td>
	<table style="width:100%;" class="table-light table">  
	  <thead>
			  <?php 

				$material_master = DB::table('tbl_outlet_warehouse')
				   ->leftJoin('tbl_material_master', 'tbl_outlet_warehouse.material_id', '=', 'tbl_material_master.id')
				   ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_warehouse.uom_id', '=', 'tbl_unit_of_measurement.id')
				   ->select('tbl_outlet_warehouse.id','tbl_outlet_warehouse.new_stock','tbl_material_master.material_name','tbl_material_master.id as material_id','tbl_material_master.alt_uom', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.id as uom_id'
					 )
				  ->where('tbl_outlet_warehouse.outlet_warehouse_id', '=', $warehouse_id)
				  ->where('tbl_outlet_warehouse.material_category_id', '=', $cat_id)
				   ->where('tbl_outlet_warehouse.material_id', '=', $material_master1[$key1]->material_id)
				  ->get()->all();
					  
					
			   foreach($material_master as $key=> $data2)
				 {										
					  $alt_uom = explode(",",$material_master1[$key1]->alt_uom);
					  $uom_count=count($alt_uom);
					  $s=$key;
					 
					?>
					<th class="text-justify text-center font-weight-bold">
						  <label class="font-weight-bold" ><?php echo $data2->uom_name; ?></data>
						 </label> 
						  <br>
						  <label class="font-weight-bold" ><?php echo $data2->new_stock; ?></label>			 
					</th>
						   
					 <?php 
				 
				  }
	   
			   ?>
							 
			  </thead>
			 </table>
		  </td>
		 </tr>
		 <?php
	  }
		 ?>

			 </tbody>
			 </table> 

		   
			<?php  
  }     
			   else  
				{ 
				  ?>
				 <div class="container-fluid "><h1 class="text-center"></h1>
				  <br><h4 class="text-center font-weight-bold"><strong class="text-primary">"Sorry"</strong> Materials are not available in this category</h4>
				  </div>
				<?php
				 }
      
	}
	
   public function outlet_transfer_report_export($id)
	{ 	
  
	  return Excel::download(new OutletReportExport($id), 'outlet_report.xlsx');
	  
	}
 }
