<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\WarehouseModel; 
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel;
use App\Models\CustomerModel;
use App\Models\ClientModel;
use App\Models\ReasonModel;
use App\Models\MaterialCategoryModel;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Session;
use PDF;
use App\Exports\OutletStockTransferExport; 
use App\Exports\OutletStockTransferExportPdf; 
use Maatwebsite\Excel\Facades\Excel;
 
class OutletStockTransferController extends Controller
 {
   public function list(Request $request)
	{
		$current_date=date("Y-m-d");
	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }

		if($request->fromdate!='')
	      {
		   $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
	      }
		 $distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
						$get_data = DB::select("SELECT riheader.*, 
						warehouse.warehouse_code,warehouse.warehouse_name,
						warehouse1.warehouse_code as w_code ,warehouse1.warehouse_name as w_name,tbl_reason.reason_name,reason_code
						
						FROM tbl_outlet_stock_transfer_header as riheader
						LEFT JOIN tbl_warehouse as warehouse on riheader.from_warehouse=warehouse.id
						LEFT JOIN tbl_warehouse as warehouse1 on riheader.outlet_id=warehouse1.id
						LEFT JOIN tbl_reason on riheader.reason_name=tbl_reason.id
						WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC ");
						
						//dd($get_data);

					return view('Outlet_Transaction.outlet_stock_transfer_list',compact('get_data','distibutor'));
	 }
	public function add()
	 { 	
		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);
		
		$reason =ReasonModel::all()->sortByDesc('id')->where('status', '=', 'active'); 
		
		$get_data=WarehouseModel::get()->where('status', '=', 'active')->whereIn('warehouse_type', [0,1])->where('status', '=', 'active')->all();		
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
		return view('Outlet_Transaction.outlet_stock_transfer',compact('get_data','material_category','material','distibutor','reason'));
	 }
		
	public function get_outlet_transfer_warehouse_list($id)
	 { 		   
		$get_data=WarehouseModel::get()->where('outlet_warehouse','=',$id)->where('warehouse_type','=',3)->where('status', '=', 'active')->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($get_data as $warehouse_name)
		  {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		
      }
	   
	 public function get_outlet_distibutor_warehouse_list($id)
      { 	
		$get_data=WarehouseModel::get()->where('distributor', $id)->where('status', '=', 'active')->where('warehouse_type', '=', 1)->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($get_data as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
	      }
		
      }
	   
	 public function get_category_details($id)
	  { 	
		$get_data=WarehouseModel::get()->where('status', '=', 'active')->all();
		
		$material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
		
		$get_transfer_warehouse=DB::table('tbl_outlet')
			->leftJoin('tbl_country', 'tbl_outlet.country', '=', 'tbl_country.id')
			->leftJoin('tbl_city', 'tbl_outlet.city', '=', 'tbl_city.id')
			->select('tbl_outlet.*', 'tbl_country.country_name','tbl_city.city_name')
			->get();
		
		return view('Outlet_Transaction.outlet_stock_transfer',compact('get_data','material_category','get_transfer_warehouse'));
		
		
	  }
	
	 public function view($view)
	  { 	
		  //$get_data=WarehouseModel::get()->where('status', '=', 'active')->all();
		  
		 	$get_data_details =DB::table('tbl_outlet_stock_transfer_details')

	    ->leftJoin('tbl_material_master', 'tbl_outlet_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
	    ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
	  

	    ->select('tbl_outlet_stock_transfer_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_stock_transfer_details.header_id', '=', $view)->get()->all();
	  
		   //dd($get_data_details); 
			
			$distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$header_details = DB::select("SELECT riheader.*, 
			warehouse.warehouse_code,warehouse.warehouse_name,
			warehouse1.warehouse_code as w_code ,warehouse1.warehouse_name as w_name,
			warehouse2.customer_code,warehouse2.customer_name, 
			tbl_reason.reason_code,tbl_reason.reason_name,tbl_reason.reason_type 
		 
			
			FROM tbl_outlet_stock_transfer_header as riheader
			LEFT JOIN tbl_warehouse as warehouse on riheader.from_warehouse=warehouse.id
			LEFT JOIN tbl_warehouse as warehouse1 on riheader.outlet_id=warehouse1.id
			LEFT JOIN tbl_customer as warehouse2 on riheader.distibutor=warehouse2.id
			LEFT JOIN tbl_reason on riheader.reason_name=tbl_reason.id
			WHERE riheader.id =".$view." ");
			
			 //dd($header_details[0]->id);
  
			return view('Outlet_Transaction.outlet_stock_transfer_view',compact('get_data_details','header_details','distibutor'));
			

	  }
	
	
	 public function save(Request $request)
	  {
		
           $get_outlet_transfer_details=DB::table('tbl_warehouse')
			->select('tbl_warehouse.outlet')
			->where('warehouse_type','=',3)
			->where('id','=',$request->transfer_warehouse)
			->get();	
		
	     $current = Carbon::now();
		 $date = str_replace('/', '-', $request->adjust_date);
		 $newDate = date("d-m-Y", strtotime($date));
		
		  $data3=array(
				   
				     'distibutor'           =>     $request->distibutor,
					 'from_warehouse'       =>     $request->warehouse_stock,
					 'outlet_id'            =>     $request->transfer_warehouse,
					 'date'                 =>     $request->transfer_date,
					 'reason_type'          =>     $request->reason_type,
			         'reason_name'          =>	   $request->reason_is,
					 'remark'               =>     $request->remark,
					 'status'               =>     'transferred',
					 'created_at'           =>     $current,
			         );
				 $header_id =DB::table('tbl_outlet_stock_transfer_header')->insertGetId($data3); 
				 
				 if(count($request->material_name)>0)
				   {
					  foreach($request['material_name'] as $key => $n)
						{
						 if($request->quantity[$key ]!='')
						   {
							  $material_details= DB::table('tbl_material_master')
									->select('tbl_material_master.uom_id', 'tbl_material_master.material_category_id',  'tbl_material_master.material_types_id')
									->where('tbl_material_master.id','=',$request->material_name[$key ])
								  ->get()->first();
							   
							   
							  $data2=array(
								 'material_id'           => $request->material_name[$key ],
								 'header_id'             => $header_id,
								 'uom_id'                => $request->uomh[$key ],
								 'material_category_id'  => $material_details->material_category_id,
								 'stock_qty'             => $request->quantity[$key ],
								 'available_stock'       => $request->availble_qty[$key ],
								 'balance_qty'           => $request->balance_qty[$key ],
								 'created_at'            => $current,
								 ); 
							 
							 DB::table('tbl_outlet_stock_transfer_details')->insert($data2); 
							
							 //storing data in warehouse_stock
								 $material_master = DB::table('tbl_outlet_stock_warehouse')
								  ->where('tbl_outlet_stock_warehouse.warehouse_id','=',$request->warehouse_stock)
								  ->where('tbl_outlet_stock_warehouse.outlet_warehouse_id','=',$request->transfer_warehouse)
								  ->where('tbl_outlet_stock_warehouse.material_id','=',$request->material_name[$key])
								  ->get()->all();
								  
								  $count=count($material_master);
								  
								  if($count>0)
								    {
									  // reducing from 1st warehouse
									  $query = DB::table('tbl_warehouse_stock')
									  ->where('warehouse_id', $request->warehouse_stock)
									  ->where('material_id','=',$request->material_name[$key]);
									  
									   $query->decrement('qty',$request->quantity[$key]);
									   
									    // increamenting from 2nd warehouse
									   $query = DB::table('tbl_outlet_stock_warehouse')
										  ->where('tbl_outlet_stock_warehouse.warehouse_id','=',$request->warehouse_stock)
										  ->where('tbl_outlet_stock_warehouse.outlet_warehouse_id','=',$request->transfer_warehouse)
										  ->where('tbl_outlet_stock_warehouse.material_id','=',$request->material_name[$key]);
									   $query->increment('qty',$request->quantity[$key]);
									
								     }
								  else
								    {
									  // reducing from 1st warehouse
									  $query = DB::table('tbl_warehouse_stock')
									  ->where('warehouse_id', $request->warehouse_stock)
									  ->where('material_id','=',$request->material_name[$key]);
									  
									   $query->decrement('qty',$request->quantity[$key]);
									  //when stock does not exist
									  
									    $warehouse_details = DB::table('tbl_warehouse')
											->select('tbl_warehouse.region',  'tbl_warehouse.sub_region')
											->where('tbl_warehouse.id','=',$request->transfer_warehouse)
											->get()->first();
										
										$data4=array(
										 'warehouse_id'  => $request->warehouse_stock,
										 'outlet_warehouse_id' => $request->transfer_warehouse,
										 'material_id'  => $request->material_name[$key],
										 'uom'   => $material_details->uom_id,
										 'qty'   => $request->quantity[$key ],
										 'outlet_id'  => $get_outlet_transfer_details[0]->outlet,
										'created_at'  => $current,
										 );	
    								    DB::table('tbl_outlet_stock_warehouse')->insert($data4);
								     }
								 
						   } 
					  }
		  
					}
				
		   return redirect(route('outlet_stock_transfer_list'))->with('successMessage','Stock Transfered Successfully');
		
      }
		
     public function get_material_price($id,$val,$uom)
	  {
	      
			$alt_unit_price = DB::select('SELECT qty as stock FROM `tbl_warehouse_stock` as ws WHERE ws.warehouse_id='.$id.' AND  `material_id` ='.$val.'');
			
			$s=0;
		  $count=count($alt_unit_price);
		  dd($count);
				if($count > 0)
				echo $alt_unit_price[0]->stock;
				else
				echo $s;
		 	
	  }
		
     public function get_material_detailsUom($id,$row)
	  {
		
		   $material_master = DB::table('tbl_material_master')
				->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
				
				->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.uom_code')
				->where('tbl_material_master.id','=',$id)
				->get()->all();
				
				echo $material_master[0]->uom_name.'-'.$material_master[0]->uom;		
	  }
	  
	  public function get_reason($route)
	{ 
        
		  $data =ReasonModel::select('reason_name','id')->where('reason_type','=',$route)->get();
		$html = '';
      if(count($data) > 0) {
        foreach($data as $reason_name) {
			$html .='<option value=""></option>';
            $html .= '<option class="opt_v1" value="' . $reason_name->id . '">'. $reason_name->reason_name;
            $html .= "</option>";
        }
      return response()->json($html);//then sent this data to ajax success 
	}
		
	}
	
		   public function outlet_stock_transfer_export($id)
	      {   
		      
             return Excel::download(new OutletStockTransferExport($id), 'outlet_stock_transfer.xlsx');
        
	       }  
	    public function stock_transfer_export_pdf($id)
	      {   
		       $get_data =DB::table('tbl_outlet_stock_transfer_header')
		
			->leftJoin('tbl_warehouse as outlet', 'tbl_outlet_stock_transfer_header.outlet_id', '=', 'outlet.id')
			->leftJoin('tbl_customer', 'tbl_outlet_stock_transfer_header.distibutor', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_outlet_stock_transfer_header.from_warehouse', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_reason', 'tbl_outlet_stock_transfer_header.reason_name', '=', 'tbl_reason.id')
			->leftJoin('tbl_reason_type', 'tbl_outlet_stock_transfer_header.reason_type', '=', 'tbl_reason_type.id')
			
			->select('tbl_outlet_stock_transfer_header.*','outlet.warehouse_name as outlet_name','outlet.warehouse_name as outlet_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_reason.reason_code','tbl_reason.reason_name as r_name','tbl_reason_type.reasion_type','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_customer.address','tbl_customer.tin_no','tbl_customer.contact_no','tbl_customer.email')
		    ->where('tbl_outlet_stock_transfer_header.id', '=',$id)->get()->first();
				
			 $get_data_details =DB::table('tbl_outlet_stock_transfer_details')

		    ->leftJoin('tbl_material_master', 'tbl_outlet_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
		    ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id') 
		  
		    ->select('tbl_outlet_stock_transfer_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation') 
		    ->where('tbl_outlet_stock_transfer_details.header_id', '=', $id)->get()->all(); 
		  
	  	    $pdf=PDF::loadView('export.pdf.outlet_stock_transfer_export_pdf', compact('get_data','get_data_details'));
		    return $pdf->download('outlet_stock_transfer.pdf');
        dd($get_data_details);
	       }   
	
 }
