<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\SalesmanTypeModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\OutstandingDetailsModels;
use App\Models\ReasonTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanUnloadModel;
use App\Models\ManageCodeModel;
use Illuminate\Support\Facades\DB;    

class ParametersApiController extends Controller
 {
   public function materialcategory_details()
	{
	   $get_data=DB::table('tbl_material_category') 
		->select(
		'tbl_material_category.category_code',
		'tbl_material_category.id as category_id',
		'tbl_material_category.category_name')

		->where('tbl_material_category.status','active')
		->get()->all();  
	 
		if($get_data !='')
		  {   
		   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Material Category Details"); 
		  } 
		  else
		  {
		   return array('Result'=>[], 'API_Status' => 0, 'Message' => "Material Category Details Are Not Found"); 
		  }
    }
   public function expence_type_details() 
	{
	      $get_data=DB::table('tbl_expense_type')
		  ->leftJoin('tbl_expense_category', 'tbl_expense_type.id', '=', 'tbl_expense_category.id')
		  ->select('tbl_expense_type.id','tbl_expense_type.expense_code','tbl_expense_type.expense_name','tbl_expense_category.expense_category_code','tbl_expense_category.expense_category')
		  ->where('tbl_expense_type.status','=',"active")
		  ->where('tbl_expense_category.id','=','2') 
		  ->get();
		 
		  if($get_data !='')
		   {  
             return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Expense Details");
		   }
		  else 
	       {
    		 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Details Not Found");
           } 
     }
	public function reason_type_good_and_bad()
	 {  
		  $returntype = ReasonTypeModel::all(); 
		  $r= array();
		  $i=0;
		  foreach($returntype as $value)
		  {
			   
			  $r[$i]['id'] = $value->id; 
			  $r[$i]['reasion_type'] = $value->reasion_type;
			  $r[$i]['return_type'] = $value->return_type;
			 
			 if($value->return_type =='1')
			 {
				$r[$i]['return_type_name'] = "Good Return";
			 }
			 else 
			 {
				 $r[$i]['return_type_name'] = "Bad Return";
			 }			 
			 
			  $i++; 
		  }
			
			if(!empty($r)) 
			 { 
			  return array('Data'=>$r, 'Status' => '1', 'Message' => 'Records');
			 } 
			else
			 { 
			  return $r  =  array('Data'=>[], 'Status' => '0', 'Message' => 'No Records Found');
			 } 
    }
   public function country_details() 
    {
		 $get_data=DB::table('tbl_country')
		 ->select('tbl_country.id','tbl_country.country_name')
		 ->where('tbl_country.status','=',"active")
		 ->get();
	
		 if($get_data !='') 
			{  
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Country Details");
			}
		  else 
			{
		 	 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Country Details Not Found");
			} 
	} 
   public function city_details() 
    {
		 $get_data=DB::table('tbl_city')
		 ->leftJoin('tbl_country', 'tbl_city.country_id', '=', 'tbl_country.id')
		 ->select('tbl_city.id','tbl_city.city_name','tbl_city.country_id','tbl_country.country_name')
		 ->where('tbl_city.status','=',"active")
		 ->get();
	
		 if($get_data !='')
			{  
			   return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "City Details");
			}
		  else 
		    {
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "City Details Not Found");
		    } 
	}	
   public function customer_category_detail() 
	{ 
		 $get_data=DB::table('tbl_customer_category') 
		 ->select('tbl_customer_category.id','tbl_customer_category.customer_category_name')
		 ->where('tbl_customer_category.status','=',"active")
		 ->get();
	
		 if($get_data !='')
			{  
			  return array('Result'=>$get_data, 'API_Status' => 1, 'Message' => "Customer Category Details");
			}
		  else 
		    {
			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Customer Category Details Not Found");
		   } 
	}
   public function uom_details()
	 {
		$details= DB::table('tbl_unit_of_measurement') 
		->select('tbl_unit_of_measurement.id as alt_uom_id','tbl_unit_of_measurement.unit_notation as alt_uom_name')
		->get()->all();
		if($details !='')
		{
		  return array('result'=>$details, 'Status'=>1, 'Message'=>'Uom Details');
		}
	   else
		{
		  return array('Result'=>[],'Status'=>0, 'Message'=>'Uom Details Not');
			
		} 
	} 
 }