<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\PricingPlanModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\CustomerCategoryModel;
use App\Models\MaterialCategoryModel;
use App\Models\MaterialMasterModel; 
use App\Models\CustomerModel;
use App\Models\RouteModel;
use App\Models\ClientModel;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class PricingPlanController extends Controller
 {
  
   public function list()
	{
		$get_data = DB::table('tbl_pricing_plan')->orderBy('id', 'DESC')->get()->all();;
		return view('Master_Configuration.pricing_plan_list',compact('get_data'));
	}

   public function view($id)
	{    
	  $user_id=Session::get('user_id'); 
	  $material_master_view = DB::table('tbl_new_price')
	 ->leftJoin('tbl_material_master', 'tbl_new_price.material_id', '=', 'tbl_material_master.id')
	  ->leftJoin('tbl_unit_of_measurement', 'tbl_new_price.uom_id', '=', 'tbl_unit_of_measurement.id')
	 ->where('tbl_new_price.header_id',$id)
	 ->select('tbl_new_price.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')
	 ->get()->all();

	  $login_user = DB::table('tbl_user')
	  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
	  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
	  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
	  ->where('tbl_user.id', '=', $user_id)
	  ->get()->first();	 
	    $get_material =DB::table('tbl_pricing_plan')
	 ->leftJoin('tbl_material_category as mat_cat', 'tbl_pricing_plan.material_category_id', '=', 'mat_cat.id') 
	  ->select('mat_cat.category_code as codes','mat_cat.category_name as names')
	   ->where('tbl_pricing_plan.id', '=',$id)
	  ->get();
	  
	   //  dd($get_material);  
		$get_data_view =DB::table('tbl_pricing_plan') 
		->leftJoin('tbl_route', 'tbl_pricing_plan.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_customer_category', 'tbl_pricing_plan.customer_category_id', '=', 'tbl_customer_category.id')
		->leftJoin('tbl_material_category', 'tbl_pricing_plan.material_category_id', '=', 'tbl_material_category.id') 
		
		->select('tbl_pricing_plan.*','tbl_route.route_code','tbl_route.route_name',
		'tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_material_category.category_code','tbl_material_category.category_name')->where('tbl_pricing_plan.id', '=',$id)->get()->first();
		$customer_category_id=explode(",",$get_data_view->customer_category_id);
		
		$customer_category_id =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active')->whereIn('id' ,$customer_category_id);
		
		$material_category_id=explode(",",$get_data_view->material_category_id);
		
		$material_category_id =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active')->whereIn('id' ,$material_category_id);
		
		$route_id=explode(",",$get_data_view->route_id); 
		
		 $route_id =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active')->whereIn('id' ,$route_id);
		return view('Master_Configuration.pricing_plan_view',compact('get_data_view','material_master_view','login_user','route_id','customer_category_id','material_category_id','get_material'));
	}
    
   public function add()
	 {
		 $user_id=Session::get('user_id');
		$customer_category_id =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$route_id =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		$material_category_id =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $material_master =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		   $login_user = DB::table('tbl_user')
				->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
				->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
				->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
				->where('tbl_user.id', '=', $user_id)
				->get()->first();
				//dd($login_user);
		return view('Master_Configuration.pricing_plan',compact('customer_category_id','material_category_id','material_master','customer','route_id','login_user'));
   }

  public function edit($id)
   {   
    
			$user_id=Session::get('user_id');	
			 $get_data=PricingPlanModel::find($id);
			 
			$customer_category_id =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
			//$customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_category_id =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$route_id =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
			//dd($route);
			//$material =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_master =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
			//dd($get_data); 
			$get_data_details =DB::table('tbl_new_price')	  
		     ->leftJoin('tbl_material_master', 'tbl_new_price.material_id', '=', 'tbl_material_master.id')
		    ->leftJoin('tbl_unit_of_measurement', 'tbl_new_price.uom_id', '=', 'tbl_unit_of_measurement.id')
  
		    ->select('tbl_new_price.*','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->  where('tbl_new_price.header_id', '=', $id)->get()->all();	
			//dd($get_data_details);
			 $login_user = DB::table('tbl_user')
				->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
				->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
				->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
				->where('tbl_user.id', '=', $user_id)
				->get()->first();
				//dd($login_user);

			return view('Master_Configuration.pricing_plan_edit',compact('get_data_details','get_data','customer_category_id','material_category_id','route_id','material_master','login_user'));
    }
   
  public function save(Request $request)
	{
		 /*  dd($request); */
		  $user_id=Session::get('user_id');
		  $company_id=Session::get('company_id');
		  
		$newDate = date("Y-m-d g:i a");
	   // dd($newDate);  
	    $current = Carbon::now();
	   $data=new PricingPlanModel; 
	       
		if($request->updated_id)

		  {   
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
			 
			   /* $detail1= DB::table('tbl_pricing_plan')
					->where('route_id', $request->updated_id)
					->get()->first(); 
			   
					 if($detail1!='')   
					{
						$detail1= DB::table('tbl_pricing_plan')
						->where('route_id', $request->updated_id)
						->delete();
						 //dd($detail1);
					}
					
					$detail2= DB::table('tbl_pricing_plan')
					->where('customer_category_id', $request->updated_id)
					->get()->first(); 
			   
					 if($detail2!='')   
					{
						$detail2= DB::table('tbl_pricing_plan')
						->where('customer_category_id', $request->updated_id)
						->delete();
						 //dd($detail1);
					}  
					$detail3= DB::table('tbl_pricing_plan')
					->where('material_category_id', $request->updated_id)
					->get()->first(); 
			   
					 if($detail3!='')   
					{
						$detail3= DB::table('tbl_pricing_plan')
						->where('material_category_id', $request->updated_id)
						->delete();
						 //dd($detail1);
					}  
					 */ 
				    $route_id=0;
				   $customer_category_id=0;
				   $material_category_id=0;
  
					  if($request->route_id!=null)
					    {
							$route_id = implode(",", $request->route_id);
						 
					    }
					  if($request->customer_category_id!=null)
					   {
						 $customer_category_id = implode(",", $request->customer_category_id);
					   }
					 
					  if($request->material_category_id!=null)
					    {
						  $material_category_id = implode(",", $request->material_category_id);
					    
					     }    
						  
					$data3=array   
				       (   
						 'id' => $request->updated_id,
						 'plan_name' =>  $request->plan_name,
						 'company_id' => $company_id, 
						 'price_applied_on' => $request->price_applied_on,
						 'customer_category_id' => $customer_category_id,
						 'route_id' => $route_id,
						 'material_category_id' => $material_category_id,
						 'valid_from' =>  $request->valid_from,
						 'valid_to' =>  $request->valid_to,
						 'status' =>  $request->status,
						 // 'created_at' => $current,
					     'updated_user' => $user_id,
						
			            );
						//dd($data3);
				    //$header_id =DB::table('tbl_pricing_plan')->insertGetId($data3);	  
				 
				  DB::table('tbl_pricing_plan')
				->where('id', $request->updated_id)
				->update($data3); 
				
		        $detail= DB::table('tbl_new_price')
					->where('header_id', $request->updated_id)
					->get()->first();
			   if($detail!='')   
				 {
				   $detail= DB::table('tbl_new_price')
					->where('header_id', $request->updated_id)
					->delete();
				 }          
	   
	   if(count($request->material_name)>0)
		{
		  foreach($request['material_name'] as $key => $n)
		    {     
		     
				$data2=array
				 (				 
				   'header_id'     => $request->updated_id,
				   'material_id'   => $request->material_name[$key ],
			        'uom_id'           => $request->uom[$key ], 
				   'current_price'         => $request->price[$key ],
				   'new_price'   =>$request->new_price[$key ], 
				   'updated_at'    => $current,
				 );
				 DB::table('tbl_new_price')->insert($data2);
				 
				 
			  }
			}
		
			  return redirect(route('pricing_plan_list'))->with('successMessage','Pricing Plan Updated Successfully');
			 }
	 
			  else
				{
	
				$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
			
				$route_id=0;
				$customer_category_id=0;
				$material_category_id=0;
 
					  if($request->route_id!=null)
					    {
							$route_id = implode(",", $request->route_id);
						 
					    }
					  if($request->customer_category_id!=null)
					   {
						 $customer_category_id = implode(",", $request->customer_category_id);
					   }
					 
					  if($request->material_category_id!=null)
					    {
						  $material_category_id = implode(",", $request->material_category_id);
					    
					     }
					$data3=array   
				       ( 
						 'plan_name'      =>  $request->plan_name,
						 'company_id'      => $company_id, 
						 'price_applied_on'           => $request->price_applied_on,
						 'customer_category_id'           => $customer_category_id,
						 'route_id'           => $route_id,
						 'material_category_id'           => $material_category_id,
						 'valid_from'       =>  $request->valid_from,
						 'valid_to'              =>  $request->valid_to,
						 'status'            =>  $request->status,
						// 'created_at'         => $current,
						 'created_user'         => $user_id,
						
			            );
				// dd($data3);
				$header_id =DB::table('tbl_pricing_plan')->insertGetId($data3);	  
				          
	  
	  
	   if(count($request->material_name)>0)
		{
		  foreach($request['material_name'] as $key => $n)
		    {     
		     
				$data2=array
				 (				 
				   'header_id'     => $header_id,
				   'material_id'   => $request->material_name[$key ],
			        'uom_id'           => $request->uom[$key ], 
				   'current_price'         => $request->price[$key ],
				   'new_price'   =>$request->new_price[$key ], 
				   'created_at'    => $current,
				 );
				 DB::table('tbl_new_price')->insert($data2);
				 
				 
			  }
			}
		}
			  return redirect(route('pricing_plan_list'))->with('successMessage','Pricing Plan Added Successfully');
			 
	 }
	

//testing in json_decode
   public function get_material_price2($id,$val)
	{
	  $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
	  $alt_uom = explode(",",$material->alt_uom);				   
	  $key = array_search($id, $alt_uom);				   
	  $alt_unit_price = explode(",",$material->alt_unit_price);
	  echo $alt_unit_price[$key];
		
	}  
	 
   public function pricing_plan_material_detailsUom2($id,$row)
    {
		//dd($id);
	  $uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $material_master = DB::select('SELECT t2.id, t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
	  t1.alt_uom) WHERE t1.`id`='.$id.'');				
	  $get_material_price=MaterialMasterModel::find($id);				
	  $alt_unit_price = explode(",",$get_material_price->alt_uom);
	 // dd($material_master);
	  
	  $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);

	  foreach($material_master as $key=>$data)
		{
	
		 ?>
		 <option  <?php if($data->id == $material->uom_id)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
			  <?php
	 
		}
    }

   public function get_material2()
    {		
	  $material_id =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
      	  
	  ?>
	  <option  value="">     </option>
	  <?php
	  foreach($material_id as $material_name)
	    {
		  ?>
		  <option value="<?php echo $material_name->id ?>"  ><?php echo $material_name-> material_code.' - '.$material_name->material_name ?></option>	
		  <?php		
	    }		
	}
	
  /*  public function get_approved1($id)
	{	
           	
	  DB::table('tbl_pricing_plan')
	   ->where('id', $id)
	   ->update(['status' => 'active']);

	} */
	
   public function get_cancel_load1($material_category_id,$id)
	{	
	dd($material_category_id);
	  DB::table('tbl_pricing_plan')
	   ->where('id', $id)
	   ->update([
				 
				'material_category_id'  => $material_category_id
		       ]);
			   
			     return view(route('pricing_plan_view'));   
    }
   public function get_material_alt_packing_size1($id,$val)
	{
		// dd($id);
	 
	  $material_id=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

	  $alt_uom = explode(",",$material_id->alt_packing_size);
   
	  $key = array_search($id, $alt_uom);
   
	  $alt_alt_packing_size = explode(",",$material_id->alt_packing_size);
	 
	  echo $alt_alt_packing_size[$key];

    }
 }
  