<?php

namespace App\Http\Controllers;
use App\Models\MaterialMasterModel;
use App\Models\PromotionModel;
use Illuminate\Support\Facades\DB;
use Session;

use Illuminate\Http\Request;

class PromotionController extends Controller
 {
   public function add()
    {
	   
	   $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   
	   return view('Merchandising.promotion',compact('material'));
	} 
	
   public function list()
	{
		$get_data = DB::table('tbl_promotion')
		
		->leftJoin('tbl_material_master', 'tbl_promotion.material', '=', 'tbl_material_master.id')
		->select('tbl_promotion.*', 'tbl_material_master.material_name','tbl_material_master.material_code')->orderBy('id', 'DESC')->get();
		
		return view('Merchandising.promotion_list',compact('get_data'));
     }
	 
	public function save(Request $request)
	 { 
	   $data=new PromotionModel;	
	   if($request->updated_id)
	     {
	      $data = PromotionModel::find($request->updated_id);         
		  $data->material=$request->material;
		  $data->from_date=$request->from_date;
		  $data->to_date=$request->to_date;
		  $data->amount=$request->amount;
		  $data->status=$request->status;
		  $data->save();

		  return redirect(route('promotion_list'))->with('successMessage','Promotion Updated Successfully');
		 }
	   else
		 {
		 
		  $data->material=$request->material;
		  $data->from_date=$request->from_date;
		  $data->to_date=$request->to_date;
		  $data->amount=$request->amount;
		  $data->status=$request->status;
		  $data->save();
			 
		  return redirect(route('promotion_list'))->with('successMessage','Promotion Added Successfully');
		 } 
	 }
	
	public function edit($id)
     {
		$get_data=PromotionModel::find($id);
		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');

		return view('Merchandising.promotion',compact('get_data','material'));
     }
	
	public function view($id)
	 {    
		$get_data = DB::table('tbl_promotion')
		->leftJoin('tbl_material_master', 'tbl_promotion.material', '=', 'tbl_material_master.id')
		->select('tbl_promotion.*', 'tbl_material_master.material_name','tbl_material_master.material_code')
		->where('tbl_promotion.id', '=', $id)
        ->first();
		
		return view('Merchandising.promotion_view',compact('get_data'));
	 }
 }
