<?php

namespace App\Http\Controllers; 
use Illuminate\Http\Request;
use App\Models\SupplierModel;
use App\Models\ManageCodeModel;
use App\Models\PurchaseOutstandingModel;
use App\Exports\PurchaseInvoiceVerificationExport;
use App\Exports\PurchaseInvoiceVerificationExportPdf;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use Illuminate\Support\Facades\DB;
use Session;
  


class PurchaseInvoiceVerificationController extends Controller
{
    //
    public function list(Request $request){
		
		
		
	 $delivery_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$delivery_date."' and '".$delivery_date."'"; 
		}
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
  
	  if($request->supplier!='')
		{
		  $where .= "AND supplier.id = '".$request->supplier."'";  
		}
		 
		 
	   $distibutor=SupplierModel::all()->sortByDesc('id')
	   //->where('supplier_id', '!=', 1)
	   ->where('status', '=', 'active');
	   
	   	$get_data = DB::select("SELECT riheader.*, 
			supplier.supplier_code,supplier.supplier_name,
			currency.currency_notation,header.purchase_order_number
			
			FROM tbl_invoice_verification_header as riheader		
			LEFT JOIN tbl_supplier as supplier on riheader.supplier_id=supplier.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
			LEFT JOIN tbl_purchase_order_header as header on riheader.purchase_order_id=header.id 
			 
			
			WHERE riheader.id IS NOT NULL ".$where." ");
	   
	 
		  //dd($get_data);

	    
        return view('Purchase_Transaction.invoice_verification_list',compact('get_data','distibutor'));
		 
    }
	
	public function view($id){
		
		//dd($id);
		
	 $get_data= DB::table('tbl_invoice_verification_header')
	 ->leftjoin('tbl_supplier','tbl_invoice_verification_header.supplier_id','=','tbl_supplier.id')
	 ->leftjoin('tbl_purchase_order_header','tbl_invoice_verification_header.purchase_order_id','=','tbl_purchase_order_header.id')
	 ->leftjoin('tbl_good_receipt_note_header','tbl_invoice_verification_header.grn_id','=','tbl_good_receipt_note_header.id')
	 ->leftJoin('tbl_currency_type', 'tbl_good_receipt_note_header.currency_id', '=', 'tbl_currency_type.id')
	 ->select('tbl_invoice_verification_header.*','tbl_supplier.supplier_code','tbl_supplier.supplier_name','tbl_purchase_order_header.purchase_order_number','tbl_good_receipt_note_header.grn_code','tbl_invoice_verification_header.invoice_code','tbl_currency_type.currency_notation')  
	 ->where('tbl_invoice_verification_header.id', '=',$id)
	 ->get()->first();
	 
	  $grn_datas=explode(",",$get_data->grn_id);
        // dd($grn_datas);

        $grn=DB::table('tbl_good_receipt_note_header as header')
        ->select('header.grn_code')
        ->whereIn('header.id',$grn_datas)  
        ->get();

		$i = 0;
        $code = array();
        foreach($grn as $key[$i] => $g_code){
            
            $code[$i] = $g_code->grn_code;
            $i++;
        }

        $grn_code = implode(",",$code);
        

		$get_data_details= DB::table('tbl_invoice_verification_details')
		->leftJoin('tbl_material_master', 'tbl_invoice_verification_details.material_id', '=', 'tbl_material_master.id')
		->leftJoin('tbl_unit_of_measurement', 'tbl_invoice_verification_details.uom', '=', 'tbl_unit_of_measurement.id')
		->select('tbl_invoice_verification_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_invoice_verification_details.quantity','tbl_invoice_verification_details.unit_price','tbl_invoice_verification_details.discount','tbl_invoice_verification_details.vat','tbl_invoice_verification_details.net_amount','tbl_invoice_verification_details.total')
		->where('tbl_invoice_verification_details.header_id', '=', $id)->get()->all();
		
		 //dd($get_data_details);  
		
		return view('Purchase_Transaction.invoice_verification_view',compact('get_data','get_data_details','grn_datas','grn_code'));
		
		
		
	}




    public function add(Request $request){
        $detail = array();
        $material = array();
        $grn_id =array();
        $footerdetail = array();
        
        $user_id=Session::get('user_id');	
        $result = DB::table('tbl_invoice_verification_header as header')
        ->select('header.*')->get()->sortByDesc('id')->first();
        
        if($result=='')
        {
        $getcode = ManageCodeModel::where('id', 1)->first();
        $last_code = $getcode->invoice_verification_code;
        }
        
        else
        {
        $getcode = $result->invoice_code; 
        $last_code = ++$getcode;
            
        }
      
        $multipl_grn=0;

        if($request->grn_id){
            $multipl_grn=implode(",",$request->grn_id);

  
        $detail = DB::table('tbl_good_receipt_note_header as header')
                        ->leftJoin('tbl_good_receipt_note_details as details','header.id','=','details.header_id')
                        ->leftJoin('tbl_material_master','details.material_id','=','tbl_material_master.id')
                        ->leftJoin('tbl_unit_of_measurement as uom','details.uom','=','uom.id')
                        ->select(DB::raw('SUM(details.quantity) as quantity'),'tbl_material_master.*','uom.unit_notation',
                                'details.header_id','details.material_id','details.uom','details.unite_price',
                                DB::raw('SUM(details.order_qty) as order_qty'),
                                DB::raw('SUM(details.pending_qty) as pending_qty'),
                                
                                DB::raw('SUM(details.gross_total) as gross_total'),
                                DB::raw('SUM(details.vat) as vat'),
                                DB::raw('SUM(details.base_qty) as base_qty'),
                                DB::raw('SUM(details.net_amount) as net_amount'),
                                DB::raw('SUM(details.discount) as discount'),
                                DB::raw('SUM(details.total) as total'))
                        ->groupBy('details.material_id')
                        ->whereIn('header.id', $request->grn_id)
                        ->get();
        
                        $footerdetail = DB::table('tbl_good_receipt_note_header as header')
                       
                        ->select(DB::raw('SUM(header.total_gross) as total_gross'),
                                 DB::raw('SUM(header.total_vat) as total_vat'),
                                DB::raw('SUM(header.net_total_amount) as net_total_amount'),
                                
                                DB::raw('SUM(header.total_grn_value) as total_grn_value'),
                                )
                        ->groupBy('header.purchase_order_id')
                        ->whereIn('header.id', $request->grn_id)
                        ->get();
        
        $material = DB::table('tbl_good_receipt_note_header as header')
                        ->leftJoin('tbl_good_receipt_note_details','header.id','=','tbl_good_receipt_note_details.header_id')
                        ->leftJoin('tbl_material_master','tbl_good_receipt_note_details.material_id','=','tbl_material_master.id')
                        ->select('tbl_material_master.*')
                        ->where('header.id','=',$request->grn_id)
                        ->get();
        
       
        }
       
        $login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();

        $suppliers=SupplierModel::all()->sortByDesc('id')->where('status', '=', 'active');

        return view('Purchase_Transaction.invoice_verification',compact('suppliers','detail','material','last_code','multipl_grn','login_user','footerdetail'));
    }


    public function get_purchase_order($supplier_id,$purchase_id){
        
        $data = DB::table('tbl_supplier')
            ->leftJoin('tbl_purchase_order_header as p_header','tbl_supplier.id','=','p_header.supplier_id')
            ->leftJoin('tbl_good_receipt_note_header as g_header','p_header.id','=','g_header.purchase_order_id')
            ->select('p_header.*','tbl_supplier.supplier_code','tbl_supplier.supplier_name')
            
            ->where('tbl_supplier.id',$supplier_id)
            ->where('g_header.is_invoice',0)
            ->groupBy('p_header.id')
            ->get();
        

                    ?>
                    <option  value="">     </option>
                    <?php
                      foreach($data as $datas)
                        {
                            ?>
                            <option <?php if($datas->id==$purchase_id){ echo "selected";} ?> value="<?php echo $datas->id ?>"  ><?php echo $datas->purchase_order_number .'('. $datas->supplier_code .' - '. $datas->supplier_name ?>)</option>	
                            <?php		
                        }	
    }

    public function get_purchase_grn($purchase_order_id,$grn_id){

        $grn = explode(",",$grn_id);

        $data = DB::table('tbl_purchase_order_header')
                    ->leftJoin('tbl_good_receipt_note_header','tbl_purchase_order_header.id','=','tbl_good_receipt_note_header.purchase_order_id')
                    ->select('tbl_good_receipt_note_header.id','tbl_good_receipt_note_header.grn_code')
                    ->where('is_invoice','=', '0')
                    ->where('tbl_good_receipt_note_header.purchase_order_id','=',$purchase_order_id)
                    ->get();

                    
                        foreach($data as $datas)
                        {
                            ?>
                            <option <?php if($datas->id==in_array($datas->id,$grn)){ echo "selected";} ?> value="<?php echo $datas->id ?>"  ><?php echo $datas->grn_code ?></option>	
                            
                            <?php		
                        }
                       
    }

    public function save(Request $request){
        
        $grn_id =array();
        
        $get_cust =DB::table('tbl_purchase_order_header')
        ->leftJoin('tbl_purchase_order_header as purchase', 'tbl_purchase_order_header.id', '=', 'purchase.id')		
        ->leftJoin('tbl_supplier', 'tbl_purchase_order_header.supplier_id', '=', 'tbl_supplier.id')		
		->select('purchase.supplier_id','purchase.delivery_date','purchase.currency_id','purchase.purchase_order_number','purchase.supplier_id','tbl_supplier.tin_no as tin_number','purchase.remark') 
		
		->where('tbl_purchase_order_header.id', '=', $request->purchase_order_id)
		->get()->first();	
        
        
        $user_id=Session::get('user_id');

        $login_user = DB::table('tbl_user')
        ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
        ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
        ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
        ->where('tbl_user.id', '=', $user_id)
        ->get()->first();

        $data3=array
        (
            'supplier_id'               => $request->supplier_id,
            'grn_id'                    => $request->multipl_grn,
            'invoice_code'              => $request->invoice_code,
            'purchase_order_id'         => $request->purchase_order_id,
            'tin_no'                    => $get_cust->tin_number,
            'delivery_date'             => $get_cust->delivery_date,
            'remark'                    => $get_cust->remark,
            'currency_id'               => $login_user->currency_id,
            'total_gross'               => $request->gross_amount_total,
        //  'total_excise'              => $request->total_excise,
            'total_vat'                 => $request->vat_amount_total,
            'net_total_amount'          => $request->net_amount_total,
            'total_discount'            =>  0,
            'total_invoice_value'       => $request->total_invoice_value,
        

        );
    
        $header_id=DB::table('tbl_invoice_verification_header')->insertGetID($data3);
        
        $pending=0;
                $is_pending=0;				
			     foreach($request['material_name1'] as $key => $n)
				   {
				    
					 
						 $data2=array(
						 'material_id'   => $request->material_name1[$key ],
						 'header_id'     => $header_id,
						 'uom'           => $request->uom[$key ],
                         'quantity'      => $request->hquantity1[$key ],
                         'unit_price'    => $request->price1[$key ],
						 'gross_total'   => $request->gross1[$key ],
                         'vat'           => $request->vat[$key ],
						 'net_amount'    => $request->net_amount[$key ],
						 'discount'      => 0,
                         'total'         => $request->total1[$key ],

						 'order_qty'     => $request->hquantity1[$key ],
						 'pending_qty'   => $pending,

						 'base_qty'      => $request->opacking_size[$key ],

						 );
                        

                         DB::table('tbl_invoice_verification_details')->insert($data2);
                    }

                    $grn_id = explode(',',$request->multipl_grn);

                    //getting credit days of supplier
                    $supplier_creditdays = DB::table('tbl_supplier')
                    ->select('tbl_supplier.credit_days')->where('tbl_supplier.id', '=', $request->supplier_id)->get()->first();

                    //adding credit days with current date
                    $current_date=date("Y-m-d");  
                    $date=date_create($current_date);
                    date_add($date,date_interval_create_from_date_string(" ".$supplier_creditdays->credit_days." days")); 
                    $due_date= date_format($date,"Y-m-d");
                    
                    foreach($grn_id as $grn){
                    $affected  =  DB::table('tbl_good_receipt_note_header')
                                    ->where('id',$grn)
                                    ->update(['is_invoice' => 1]);
                    }

                    $data=new PurchaseOutstandingModel;
					$data->invoice_number=$request->invoice_code;
                    $data->supplier_id= $request->supplier_id;
                    $data->amount_paid=0;
                    $data->amount_outstanding=$request->total_invoice_value;
                    $data->invoice_id=$header_id;
                    $data->invoice_amount= $request->total_invoice_value;
					$data->due_date=$due_date;
					$data->save();
                    
                    return redirect(route('invoice_verification_list'))->with('successMessage',$request->invoice_code.' '.'Invoice save successfully');
    }
	
	public function invoice_verification_export($id)
	 {
		return Excel::download(new PurchaseInvoiceVerificationExport($id),'invoice_verification.xlsx');
		
        //return response()->json($get_data);
	 } 
	  public function invoice_verification_export_pdf($id)
	 {
		  
		 $user_id=Session::get('user_id');
		   $get_data =DB::table('tbl_invoice_verification_header')
		  ->leftJoin('tbl_supplier as supplier', 'tbl_invoice_verification_header.supplier_id', '=', 'supplier.id')
		  ->leftJoin('tbl_currency_type', 'tbl_invoice_verification_header.currency_id', '=', 'tbl_currency_type.id')
		   ->leftJoin('tbl_purchase_order_header', 'tbl_invoice_verification_header.purchase_order_id', '=', 'tbl_purchase_order_header.id')
		   ->leftJoin('tbl_good_receipt_note_header', 'tbl_invoice_verification_header.grn_id', '=', 'tbl_good_receipt_note_header.id')
		 
		  ->select('tbl_invoice_verification_header.*', 'supplier.supplier_name','supplier.address','supplier.email_id','supplier.contact_number','supplier.supplier_code','tbl_purchase_order_header.purchase_order_number','tbl_good_receipt_note_header.grn_code','tbl_currency_type.currency_notation')->where('tbl_invoice_verification_header.id', '=',$id)->get()->first();    
		 
		$get_data_details =DB::table('tbl_invoice_verification_details')
		  ->leftJoin('tbl_material_master', 'tbl_invoice_verification_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_invoice_verification_details.uom', '=', 'tbl_unit_of_measurement.id')
          ->select('tbl_invoice_verification_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation','tbl_invoice_verification_details.quantity','tbl_invoice_verification_details.unit_price','tbl_invoice_verification_details.vat','tbl_invoice_verification_details.net_amount','tbl_invoice_verification_details.total','tbl_invoice_verification_details.discount')
		  ->where('tbl_invoice_verification_details.header_id', '=', $id)->get()->all();
		// dd($get_data_details);
		  $pdf=PDF::loadView('export.pdf.purchase_invoice_verification_export_pdf',compact('get_data','get_data_details'));
		 
		  return $pdf->download('invoice_verification.pdf');
		
		
	 }
	 
	 
	/* public function invoice_verification_export_pdf($id)
	 {
		
		return Excel::download(new PurchaseInvoiceVerificationExport($id),'invoice_verification.pdf');
	
        
	    //return response()->json($get_data);
	 } */

}
