<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\MenuModel;
use App\Models\SubMenuModel;
use App\Exports\SalesOrderExport;
use Maatwebsite\Excel\Facades\Excel;
use App\Models\ManageCodeModel;
use App\Models\CustomerTypeModel;
use App\Models\CustomerModel;
use App\Models\WarehouseModel;
use App\Models\ReasonTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\UnitOfMeasurementModel;

use PDF;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Session;

class ReturnOrderController extends Controller
{
    //

    public function list(Request $request){

      		 //dd($request);
		$current_date=date("Y-m-d");

		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }
		   
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
				 
		if($request->customer!='')
		  {
			$where .= "AND customer.id = '".$request->customer."'";
		  }
					
		if($request->warehouse!='')
		  {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		  }

		  $distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active');
	   
			//$get_data = CurrencyTypeModel::all()->sortByDesc('id');

			$get_data = DB::select("SELECT riheader.*, 
			customer.customer_code,customer.customer_name,
			warehouse.warehouse_code,warehouse.warehouse_name,
			
			currency.currency_notation
			
			FROM tbl_return_order_header as riheader
			
			LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
		
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
			WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC ");
			
			//dd($get_data);


        return view('Company_Transaction.return_order_list',compact('get_data','distibutor'));
    }



    public function add(){
        $user_id=Session::get('user_id');	  
		$result = DB::table('tbl_return_order_header')
		->select('tbl_return_order_header.*')->get()->sortByDesc('id')->first();
			 
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->company_return_order_code;
		  }
		else
		  {
			 $getcode = $result->return_order_number; 
			 $last_code = ++$getcode;
		  }
			 
			  $distribution_type =CustomerTypeModel ::all()->sortByDesc('id')->where('status', '=', 'active');
			
			  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
								  
			  $login_user = DB::table('tbl_user')
				->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
				->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
				->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
				->where('tbl_user.id', '=', $user_id)
				->get()->first();
				//dd($login_user);

        
        return view('Company_Transaction.return_order',compact('last_code','distribution_type','material','login_user'));
    }



    public function save(Request $request){
      // dd($request);

      if($request->updated_id){

      }else{

        $get_region_subregion = DB::table('tbl_customer')
        ->select('tbl_customer.id', 'tbl_customer.region','tbl_customer.sub_region')
        ->where('tbl_customer.id', '=', $request->customer_type)
        ->get()->first();

        $current = Carbon::now();
				$user_id=Session::get('user_id');			
				$login_user = DB::table('tbl_user')
                ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			          ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
                ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
			          ->where('tbl_user.id', '=', $user_id)
		            ->get()->first();

        $date = str_replace('/', '-', $request->delevery_date);
        $newDate = date("d-m-Y", strtotime($date));


        $data3=array
        ( 
          'return_order_number'       =>  $request->return_order_number,
          'currency_id'               =>  $login_user->currency_id,
          'region_id'                 =>  $get_region_subregion->region,
          'subregion_id'              =>  $get_region_subregion->sub_region,
          'distribution_type_id'      =>  $request->distribution_type,
          'delevary_date'             =>  $newDate,
          'customer_id'               =>  $request->customer_type,
          'remark'                    =>  $request->comment,
          'warehouse_id'              =>  $request->warehouse,
          'total_gross'               =>  $request->gross_amount_totali,
          'tin_no'                    =>  $request->tin_no,
          'total_order_value'         =>  $request->invoice_amount_totali,
          'created_at'                => $current,
          'created_user'              => $user_id,
        );
  
        $header_id =DB::table('tbl_return_order_header')->insertGetId($data3);

          foreach($request['material_name1'] as $key => $n)
          {
             if($request->quantity1[$key ]!='')
             {
             $data2=array
                (
               'material_id'    => $request->material_name1[$key ],
               'header_id'      => $header_id,
               'uom_id'         => $request->uom1[$key ],
               'unite_price'    => $request->price1[$key ],
               'gross_total'    => $request->gross1[$key ],
               'total'          => $request->total1[$key ],
               'quantity'       => $request->quantity1[$key ],
               'return_type_id' => $request->return_type[$key ],
               'resion_id'      => $request->resion[$key ],
               'base_qty'       => $request->opacking_size[$key ],
               'created_at'     => $current,
                );
                
                DB::table('tbl_return_order_detail')->insert($data2);
              } 
           }

      }

				return redirect(route('return_order_list'))->with('successMessage',$request->return_order_number.' '.'Order Save Successfully');

        // return view('Company_Transaction.return_order_list');

    }



    public function edit($id){

      $user_id=Session::get('user_id');
		  $order_data = DB::table('tbl_return_order_header')
			 ->leftJoin('tbl_customer_type', 'tbl_return_order_header.distribution_type_id', '=', 'tbl_customer_type.id')
			 ->leftJoin('tbl_customer', 'tbl_return_order_header.customer_id', '=', 'tbl_customer.id') 
			 ->where('tbl_return_order_header.id','=',$id)
			 ->select('tbl_return_order_header.*','tbl_customer_type.customer_type_code', 'tbl_customer_type.customer_type_name','tbl_customer.customer_code','tbl_customer.customer_name as cust_name')
			 ->get()->first();	
			
           $warehouse =WarehouseModel::all()->sortByDesc('id')->where('distributor', '=', $order_data->customer_id)->where('status', '=', 'active')->where('warehouse_type', '=', 1); 
           $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
           $login_user = DB::table('tbl_user')
						->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
						->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
						->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
						->where('tbl_user.id', '=', $user_id)
						->get()->first();		   
                   						
		   $get_data_details =DB::table('tbl_return_order_detail')	  
		     ->leftJoin('tbl_material_master', 'tbl_return_order_detail.material_id', '=', 'tbl_material_master.id')
		    ->leftJoin('tbl_unit_of_measurement', 'tbl_return_order_detail.uom_id', '=', 'tbl_unit_of_measurement.id')
  
		    ->select('tbl_return_order_detail.*','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation','tbl_material_master.vat as material_vat','tbl_material_master.excise as material_excise')->  where('tbl_return_order_detail.header_id', '=', $id)->get()->all();	
		    $reason =ReasonTypeModel::all()->sortByDesc('id');
		    $get_data =DB::table('tbl_return_order_header')		
		    ->select('tbl_return_order_header.*')->where('tbl_return_order_header.id', '=',$id)->get()->first();

        return view('Company_Transaction.return_order_edit',compact('order_data','warehouse','material','login_user','get_data_details','reason','get_data'));
    }



    public function view($id){


      $user_id=Session::get('user_id');
      $get_data =DB::table('tbl_return_order_header')
  
      ->leftJoin('tbl_customer', 'tbl_return_order_header.customer_id', '=', 'tbl_customer.id')
      ->leftJoin('tbl_warehouse', 'tbl_return_order_header.warehouse_id', '=', 'tbl_warehouse.id')
      ->leftJoin('tbl_customer_type', 'tbl_return_order_header.distribution_type_id', '=', 'tbl_customer_type.id')
      //->join('tbl_warehouse', 'tbl_return_order_header.warehouse', '=', 'tbl_warehouse.id')
      ->leftJoin('tbl_currency_type', 'tbl_return_order_header.currency_id', '=', 'tbl_currency_type.id')
      ->select('tbl_return_order_header.*','tbl_customer.customer_name','tbl_customer.customer_code',
      'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_customer_type.customer_type_name','tbl_customer_type.customer_type_code','tbl_currency_type.currency_notation')->where('tbl_return_order_header.id', '=',$id)->get()->first();
       
      //dd($get_data);
      $get_data_details =DB::table('tbl_return_order_detail')
  
       ->leftJoin('tbl_material_master', 'tbl_return_order_detail.material_id', '=', 'tbl_material_master.id')
       ->leftJoin('tbl_unit_of_measurement', 'tbl_return_order_detail.uom_id', '=', 'tbl_unit_of_measurement.id')
       ->leftJoin('tbl_reason_type', 'tbl_return_order_detail.resion_id', '=', 'tbl_reason_type.id')
  
       ->select('tbl_return_order_detail.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name', 'tbl_unit_of_measurement.unit_notation',)->where('tbl_return_order_detail.header_id', '=', $id)->get()->all();
      
      //dd($get_data_details); 
  
      $login_user = DB::table('tbl_user')
      ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
      ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
      ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
      ->where('tbl_user.id', '=', $user_id)
        ->get()->first();			  
  
      //dd($get_data);
      $reason =ReasonTypeModel::all()->sortByDesc('id');

        return view('Company_Transaction.return_order_view',compact('get_data','get_data_details','login_user','reason'));
    }



    public function get_customer($id)
    {
       
       $customer_type =CustomerModel::all()->sortByDesc('id')->where('customer_type', '=',$id)->where('status', '=', 'active');
  
       ?>
       <option  value="">     </option>
       <?php
       foreach($customer_type as $customer_name)
         {
           ?>
             <option value="<?php echo $customer_name->id ?>"  ><?php echo $customer_name->customer_code.' - '.$customer_name->customer_name  ?></option>	
          <?php		
         }
       
        //return response()->json($get_data);
       
    }


    public function get_warehouse($id)
    {
                
       $warehouse_name =WarehouseModel::all()->sortByDesc('id')->where('distributor', '=', $id)->where('warehouse_type', '=', 1)->where('status', '=', 'active');

       ?>
       <option  value="">     </option>
       <?php
       foreach($warehouse_name as $warehouse)
         {
           ?>
           <option value="<?php echo $warehouse->id ?>"  ><?php echo $warehouse->warehouse_code.' - '.$warehouse->warehouse_name  ?></option>	
            <?php		
         } 
       
         //return response()->json($get_data);
       
    }


    public function get_customer_tin($id)
    {
       $customer_tin =CustomerModel::get()->sortByDesc('id')->where('id', '=', $id)->where('status', '=', 'active')->first();
       echo $customer_tin->tin_no;
       
    } 



   public function get_resions($id)
    {
        
       $reason =ReasonTypeModel::all()->sortByDesc('id')->where('return_type', '=', $id);
    
       foreach($reason as $key=>$data)
         {
               
           ?>
           <option   value ="<?php echo $data->id; ?>" ><?php echo $data->reasion_type; ?></option>
           <?php
    
         }
      
    }
    
    

    public function get_materials()
    {
       $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
           
       ?>
       <option  value="">     </option>
       <?php
       foreach($material as $material_name)
         {
           ?>
           <option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code.' - '.$material_name->material_name ?></option>	
           <?php		
         }
               
        //return response()->json($get_data);
       
    }



    public function get_material_detailsUom1($id,$row)
    {
           $uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
           $material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
           t1.alt_uom) WHERE t1.`id`='.$id.'');
           
           $get_material_price=MaterialMasterModel::find($id);
           $alt_unit_price = explode(",",$get_material_price->alt_unit_price);
           
           //dd($alt_unit_price);
           //dd($material_master);
           $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
   
           foreach($material_master as $key=>$data)
             {
   
                ?>
                   <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
                <?php
    
             }
    }


    public function get_material_price($id,$val)
    {
       
       $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
     
       $alt_uom = explode(",",$material->alt_uom);
      
       $key = array_search($id, $alt_uom);
       
       $alt_unit_price = explode(",",$material->alt_unit_price);

       echo $alt_unit_price[$key];
           
    
           
    }


    public function material_alt_packing_size($id,$val)
    {
   
      $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

      $alt_uom = explode(",",$material->alt_uom);
     
      $key = array_search($id, $alt_uom);
     
      $alt_alt_packing_size = explode(",",$material->alt_packing_size);

      echo $alt_alt_packing_size[$key];
  
    }



    public function get_list_warehouse($id,$warehouse_url)
    {
      $material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=', 1);
      
      ?>
      <option  value="">     </option>
      <?php
      foreach($material as $material_name)
      {
      ?>
      <option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
      <?php		
     }
       
    //return response()->json($get_data);
   
  }


}
