<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\RouteModel;
use App\Models\ManageCodeModel;
use App\Models\CustomerModel;
use App\Models\WarehouseModel;
use App\Models\VehicleModel;
use App\Models\SalesAreaModel;
use Illuminate\Support\Facades\DB;
use Session;

class RouteController extends Controller
 {
   public function list()
    {
		//$get_data = RouteModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_route')
		->leftJoin('tbl_sales_area', 'tbl_route.sales_area_id', '=', 'tbl_sales_area.id')
		->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_vehicle', 'tbl_route.vehicle_id', '=', 'tbl_vehicle.id')
		
		->select('tbl_route.*', 'tbl_sales_area.sales_area_code','tbl_sales_area.sales_area_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_vehicle.vehicle_code','tbl_vehicle.vehicle_number')
		->orderBy('id', 'DESC')->get();

    	  return view('Master_Configuration.route_list',compact('get_data'));
    }
	
   public function view($id)
	{
			
		 $get_data = DB::table('tbl_route')
		->leftJoin('tbl_sales_area', 'tbl_route.sales_area_id', '=', 'tbl_sales_area.id')
		->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_vehicle', 'tbl_route.vehicle_id', '=', 'tbl_vehicle.id')
		
		->select('tbl_route.*', 'tbl_sales_area.sales_area_code','tbl_sales_area.sales_area_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_vehicle.vehicle_code','tbl_vehicle.vehicle_number')
		->where('tbl_route.id', '=', $id)
		->first();
		
		return view('Master_Configuration.route_view',compact('get_data'));	
	}
			
   public function add()
    { 
        $distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);	
		$result =RouteModel::get()->sortByDesc('id')->first();
	  if($result=='')
	    {
		    $getcode = ManageCodeModel::where('id', 1)->first();
		    $last_code = $getcode->route_code;
	    }
	else
		{
			 $getcode = $result->route_code	; 
			 $last_code = ++$getcode;
		}
		
			$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
			//$vehicle =VehicleModel::all()->sortByDesc('id')->where('status', '=', 'active');
			/*$vehicle=DB::table("tbl_vehicle")->select('*')
						->whereNOTIn('id',function($query){
							$query->select('id')->from('tbl_route');
							})
						
						->where('status', '=', 'active')
						->get()->all();*/
			
			//$salesarea =SalesAreaModel::all()->sortByDesc('id')->where('status', '=', 'active');
			
		return view('Master_Configuration.route',compact('warehouse','last_code','distibutor'));
	}
	
  public function edit($id)
    {
		 
		$distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);
		$get_data=RouteModel::find($id);		
		$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
		$vehicle =VehicleModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$salesarea =SalesAreaModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->route_code;
		
		return view('Master_Configuration.route',compact('get_data','warehouse','vehicle','salesarea','last_code','distibutor'));
		
    }
	
   public function save(Request $request)
    { 	  
	  $data=new RouteModel;			
	  if($request->updated_id)
	    {			
			$data = RouteModel::find($request->updated_id);
			$data->route_code=$request->route_code;
			$data->route_name=$request->route_name;
			$data->route_description=$request->route_description;
			$data->sales_area_id=$request->sales_area_name;
			$data->distibutor_id=$request->distibutor;
			$data->warehouse_id=$request->warehouse_name;
			$data->vehicle_id=$request->vehicle_number;			
			$data->company_id= Session::get('company_id');
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
		    return redirect(route('route_list'))->with('successMessage','Route Updated Successfully');
	    }
	
	 else
    	{
			
			$data->route_code=$request->route_code;
			$data->route_name=$request->route_name;
			$data->route_description=$request->route_description;
			$data->sales_area_id=$request->sales_area_name;
			$data->distibutor_id=$request->distibutor;
			$data->warehouse_id=$request->warehouse_name;
			$data->vehicle_id=$request->vehicle_number;			
			$data->created_user= Session::get('user_id');
			$data->company_id= Session::get('company_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('route_list'))->with('successMessage','Route Added Successfully');
		}
		
    } 
   public function get_warehouse_details($id,$edit_id)
    {		
		//dd($id);	
		$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',1)->where('status', '=', 'active')->where('distributor','=',$id)->all();
		
		?>
		<option  value="">     </option>
		<?php
		foreach($outlet_warehouse as $warehousename)
		  {
			?>
			<option value="<?php echo $warehousename->id ?>" <?php if($warehousename->id == $edit_id) { echo "selected"; } ?> ><?php echo $warehousename->warehouse_code." - ".$warehousename->warehouse_name; ?></option>	
			<?php		
		  }
	  }
   public function get_salesarea_details($id,$edit_id)
	{	
        //dd($id);	  
		$salesarea =SalesAreaModel::get()->where('status', '=', 'active')->where('warehouse_id','=',$id)->all();
		//dd($salesarea);
		?>
		<option  value="">     </option>
		<?php
		foreach($salesarea as $sales)
		  {
			?>
			<option value="<?php echo $sales->id ?>" <?php if($sales->id == $edit_id) { echo "selected"; } ?> ><?php echo $sales->sales_area_code." - ".$sales->sales_area_name; ?></option>	
			<?php		
		  }
	}
   public function get_vehicle_details($id,$edit_id)
	{
		   if($edit_id!=0) 
			{			
				$get_data=DB::table('tbl_route')
				->select('tbl_route.vehicle_id')
				->where('tbl_route.status','=','active')
				->where('tbl_route.vehicle_id','!=',$edit_id)
				->get()->toArray();
			}
		else{
				
				$get_data=DB::table('tbl_route')
				->select('tbl_route.vehicle_id')
				->where('tbl_route.status','=','active')
				->get()->toArray();
				
			}
			
		foreach($get_data as $key=> $data)
			{
			 $get_data1[$key]= $data->vehicle_id;
			}
		   
		$vehicle =VehicleModel::get()->whereNotIn('id',$get_data1)->where('status', '=', 'active')->where('warehouse_id','=',$id)->all();	   
				
		?>
		<option  value="" > </option>
		<?php
		foreach($vehicle as $vehicle)
		    {
			 
			 ?>
			 <option value="<?php echo $vehicle->id ?>" <?php if($vehicle->id == $edit_id) { echo "selected"; } ?>> 
			 <?php echo $vehicle->vehicle_code." - ".$vehicle->vehicle_number; ?></option>	
			 <?php		
			}    	
		   
				
	}
   public function get_warehouse_edit($id)
    {
		$get_data=DB::table('tbl_route')
			->select('tbl_route.warehouse_id')
			->where('tbl_route.status', '=', 'active')
			->where('tbl_route.id', '=', $id)
			->get()->first();
					
		$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
		
			?>
			<option  value="">     </option>
			<?php
		  foreach($warehouse as $warehousename)
		    {
				?>
				<option value="<?php echo $warehousename->id ?>" <?php if($warehousename->id == $get_data->warehouse_name) { echo "selected"; } ?> ><?php echo $warehousename->warehouse_code." - ".$warehousename->warehouse_name; ?></option>	
				<?php		
		    }
	}
	  
 }
