<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\ExpenseTypeModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\RouteExpensesReportExport;

class RouteExpensesReportController extends Controller
 {
  public function list()
   {		
		//$get_data = SupplierTypeModel::all()->sortByDesc('id');
		 $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id; 
		 
	   }
     
        $regId=implode(",",$all_region); 
	  
		  $expense_type =ExpenseTypeModel::all()->sortByDesc('id')
			->where('status', '=', 'active')
			->where('expense_category', '=', 1);;
		return view('Report.route_expenses_report',compact('regId','region','expense_type'));  
	}
		
   public function get_route_expenses_subregion($id)
	{
	    $data = explode(',',$id);
		
        $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		 
		if(count($sub_region)>0){
			foreach($sub_region as $subreg){
				
				$all_subregion[] = $subreg->id;
			}
			$subregId=implode(",",$all_subregion);
		}else{

			$subregId = 0;
		}

		?>
		<option  value="">     </option>
		<?php if(count($sub_region) > 0){ ?>
			<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php } 
		foreach($sub_region as $sub_region_name)
		  {
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		    <?php  	   	
		  }
	}
	
   public function get_route_expenses_warehouse($id)
	{
	       $data = explode(',',$id);
	   
		   $warehouse =WarehouseModel::all()->sortByDesc('id')->whereIn('sub_region',$data)->where('status', '=', 'active');
		  
		   if(count($warehouse)>0){
			foreach($warehouse as $warehou){
				
				$all_warehouse[] = $warehou->id;
			}
			$warehouId=implode(",",$all_warehouse);
		   }else{

			$warehouId = 0;
		}
		?>
		  <option  value="">     </option>
         <?php if(count($warehouse) > 0){ ?>
			<option  value="0" data-value="<?php echo $warehouId ?>">Select All</option>
		 <?php } 
		 foreach($warehouse as $warehouse_name)
		   {
				?>
				  <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
			   <?php  	   	
		   }
	 }
   
     public function get_route_expenses_route($id)
	 {
	      $data = explode(',',$id);
		 
		  $route =RouteModel::all()->sortByDesc('id')->whereIn('warehouse_id',$data)->where('status', '=', 'active');
		  
		  if(count($route)>0){
			foreach($route as $routeId){
				
				$all_route[] = $routeId->id;
			}
			    $all_routeId=implode(",",$all_route);
		   }else{

			    $all_routeId = 0;
		    }?>
				<option  value="">     </option>
				<?php if(count($route) > 0){ ?>
			 <option  value="0" data-value="<?php echo $all_routeId ?>">Select All</option>
		    <?php } 
			foreach($route as $route_name)
			  {
				 ?>
				   <option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code.' - '.$route_name->route_name  ?></option>	
			     <?php  	   	
			  }
	 }
			
	public function get_route_expenses_salesman($id)
	 {
	       $data = explode(',',$id);
		  
			$salesman =SalesmanModel::all()->sortByDesc('id')->whereIn('route_id',$data)->where('status', '=', 'active');
		 
            if(count($salesman)>0){
			 foreach($salesman as $salesm){
				
				$all_salesman[] = $salesm->id;
			}
			   $salesmanId=implode(",",$all_salesman);
		    }else{

			  $salesmanId = 0;
		   }
				?>
		    <option  value="">     </option>
		    <?php if(count($salesman) > 0){ ?>
			<option  value="0" data-value="<?php echo $salesmanId ?>">Select All</option>
		    <?php } 
			foreach($salesman as $salesman_name)
		      {
				?>
				  <option value="<?php echo $salesman_name->id ?>"  ><?php echo $salesman_name->salesman_code.' - '.$salesman_name->salesman_name  ?></option>	
			    <?php  	   	
			   }
	 }
			
	public function get_route_expenses_report($region,$subregion,$warehouse,$route,$salesman,$expenses,$fromdate,$todate)
	 {
	   if($expenses!='s')
		 {
			$get_data = DB::select("SELECT riheader.created_at,
						warehouse.warehouse_code,
						warehouse.warehouse_name,
						route.route_name,
						route.route_code,
						salesman.salesman_name,
						salesman.salesman_code,
						expense.expense_code,
						riheader.expense_no,
						expense.expense_name,
						currency.currency_notation,
						riheader.expense_amount
						
						FROM tbl_route_expenses as riheader
						LEFT JOIN tbl_route as route on riheader.route_id=route.id
						LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
						LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
						LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
						LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
		         WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.expense_type=".$expenses."  ");	
		        ?>
		  
			    <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
				  <thead>
					 <tr>
						<th class="text-justify text-left">Date</th>
						<th class="text-justify text-left">Warehouse</th>
						<th class="text-justify text-left">Route</th>
						<th class="text-justify text-left">Salesman</th>
						<th class="text-justify text-left">Expense Code</th>
						<th class="text-justify text-left">Expense Type</th>
						<th class="text-justify text-left">Expense Amount</th>
												  
					</tr>
				</thead>
				 <tbody>
				 <?php
						foreach($get_data as $key=>$data)
						 {
							?>
						   <tr>
							 <?php
								$row1 = date("d M Y g:i a", strtotime($data->created_at));
										
										  
								?>
								<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
								
							 </tr>
							 <?php
						   }
								?>
						</tbody>
					  </table> 

               <?php				  
		  }
		else
		  {
			 /* start */
			 if($salesman!='s')
			    {
			       $final_data  = array();
				   //if single subregion
				   if($salesman!=0)
					 {
							
					   $agent_id[]=$salesman;
														
					  }
										//multiple sub region
				    else  
					  {
						  
						$agent_name     = array(); 
						$agent_id     = array(); 
						$get_data1 = DB::table('tbl_salesman')
											 
						->select('tbl_salesman.id')
						->get();
												
						foreach($get_data1 as $key=> $warehous)
						  {
						
						    $agent_id[]=$warehous->id;
												 
						   }
										
					   }
                         $get_data = DB::select("SELECT riheader.created_at,
					            warehouse.warehouse_code,
								warehouse.warehouse_name,
					            route.route_name,
								route.route_code,
								salesman.salesman_name,
								salesman.salesman_code,
								expense.expense_code,
								riheader.expense_no,
								expense.expense_name,
								currency.currency_notation,
								riheader.expense_amount
								
								FROM tbl_route_expenses as riheader
								LEFT JOIN tbl_route as route on riheader.route_id=route.id
								LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
								LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
								LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
								LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
							WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.salesman_name  in (".implode(',',$agent_id).") ");
                     
						 ?>
				   <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
					  <thead>
						 <tr>
							<th class="text-justify text-left">Date</th>
							<th class="text-justify text-left">Warehouse</th>
							<th class="text-justify text-left">Route</th>
                            <th class="text-justify text-left">Salesman</th>
							<th class="text-justify text-left">Expense Code</th>
							<th class="text-justify text-left">Expense Type</th>
                            <th class="text-justify text-left">Expense Amount</th>
									                  
						</tr>
					  </thead>
                      <tbody>
					   <?php
						foreach($get_data as $key=>$data)
						  {
							?>
						   <tr>
							 <?php
								$row1 = date("d M Y g:i a", strtotime($data->created_at));
										
										  
								?>
								<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
								
							</tr>
							 <?php
							}
								?>
						</tbody>
					  </table> 
					 
					<?php
		 				
		       }
		     else
		       {
			     if($route!='s')
			       {
					if($route!=0)
					  {
						$agent_name     = array(); 
						$agent_id[]=$route;
						
					  }
				    else
				      {
						$agent_name     = array(); 
						$agent_id     = array(); 
						$get_data1 = DB::table('tbl_route')
											 
						->select('tbl_route.id')
						->get();
											
						foreach($get_data1 as $key=> $warehous)
						  {
							
							$agent_id[]=$warehous->id;
													 
						   }
					
				       }
				 $get_data = DB::select("SELECT riheader.created_at,
					            warehouse.warehouse_code,
								warehouse.warehouse_name,
					            route.route_name,
								route.route_code,
								salesman.salesman_name,
								salesman.salesman_code,
								expense.expense_code,
								riheader.expense_no,
								expense.expense_name,
								currency.currency_notation,
								riheader.expense_amount
								
								FROM tbl_route_expenses as riheader
								LEFT JOIN tbl_route as route on riheader.route_id=route.id
								LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
								LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
								LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
								LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
							WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.route_id  in (".implode(',',$agent_id).") ");
                     
						 ?>
				    <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
					 <thead>
						<tr>
							<th class="text-justify text-left">Date</th>
							<th class="text-justify text-left">Warehouse</th>
							<th class="text-justify text-left">Route</th>
                            <th class="text-justify text-left">Salesman</th>
							<th class="text-justify text-left">Expense Code</th>
							<th class="text-justify text-left">Expense Type</th>
                            <th class="text-justify text-left">Expense Amount</th>
									                  
						</tr>
					 </thead>
                     <tbody>
					 <?php
							foreach($get_data as $key=>$data)
							  {
								?>
                               <tr>
								 <?php
									$row1 = date("d M Y g:i a", strtotime($data->created_at));
											
											  
									?>
									<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
                                     <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
									 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
									
                                </tr>
								 <?php
							  }
									?>
							</tbody>
						  </table> 
						 
						<?php
				
				
			   }
             else{
                   //
				   
				   if($warehouse!='s')
			         {
				       $final_data  = array();
					   //if single subregion
                       if($warehouse!=0)
						 {
							  $agent_name     = array(); 
							  $agent_id     = array(); 
							  $agent_id[]=$warehouse;
														
						 }
										//multiple sub region
					   else  
						 {
							  
							$agent_name     = array(); 
							$agent_id     = array(); 
							$get_data1 = DB::table('tbl_warehouse')
							->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
							->where('tbl_warehouse.warehouse_type','=',1)
							->where('tbl_warehouse.status','=','active')
							->get();
							
						  foreach($get_data1 as $key=> $warehouse1)
							{
						  
							 $agent_id[]=$warehouse1->id;
												 
							}
							
												
						}
                       $get_data = DB::select("SELECT riheader.created_at,
					            warehouse.warehouse_code,
								warehouse.warehouse_name,
					            route.route_name,
								route.route_code,
								salesman.salesman_name,
								salesman.salesman_code,
								expense.expense_code,
								riheader.expense_no,
								expense.expense_name,
								currency.currency_notation,
								riheader.expense_amount
								
								FROM tbl_route_expenses as riheader
								LEFT JOIN tbl_route as route on riheader.route_id=route.id
								LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
								LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
								LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
								LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
							WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.warehouse_id  in (".implode(',',$agent_id).") ");
                     
						 ?>
						 <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
					 <thead>
						<tr>
							<th class="text-justify text-left">Date</th>
							<th class="text-justify text-left">Warehouse</th>
							<th class="text-justify text-left">Route</th>
                            <th class="text-justify text-left">Salesman</th>
							<th class="text-justify text-left">Expense Code</th>
							<th class="text-justify text-left">Expense Type</th>
                            <th class="text-justify text-left">Expense Amount</th>
									                  
						</tr>
					   </thead>
                       <tbody>
					   <?php
							foreach($get_data as $key=>$data)
							{
								?>
                               <tr>
								 <?php
									$row1 = date("d M Y g:i a", strtotime($data->created_at));
											
											  
									?>
									<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
								    <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
                                     <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
									 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
									
                                </tr>
								 <?php
							 }
									?>
							</tbody>
						  </table> 
						 
						<?php
		          }
                else
			      {
					if($subregion!='s')
					  {
						   
					   if($subregion!=0)
						 {
							$agent_id     = array(); 
							$agent_id[]=$subregion;
						 }
										//multiple sub region
					   else  
					     {
						   $agent_name     = array(); 
						   $agent_id     = array(); 
						   $get_data1 = DB::table('tbl_sub_region')
						  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
				          ->where('tbl_sub_region.status','=','active')
						   ->get();
						   foreach($get_data1 as $key=> $sub_region)
								{
							  
								 $agent_id[]=$sub_region->id;
													 
								}
											
					      }
                             $get_data = DB::select("SELECT riheader.created_at,
					            warehouse.warehouse_code,
								warehouse.warehouse_name,
								warehouse.sub_region,
							    route.route_name,
								route.route_code,
								salesman.salesman_name,
								salesman.salesman_code,
								expense.expense_code,
								riheader.expense_no,
								expense.expense_name,
								currency.currency_notation,
								riheader.expense_amount
								
								FROM tbl_route_expenses as riheader
								LEFT JOIN tbl_route as route on riheader.route_id=route.id
								LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
								LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
								LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
								LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
							    LEFT JOIN tbl_sub_region as sub_region_name on warehouse .sub_region=sub_region_name.id
							    WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND  sub_region_name.id in (".implode(',',$agent_id).") ");
                      
						  ?>
				         <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
					     <thead>
						 <tr>
							<th class="text-justify text-left">Date</th>
							<th class="text-justify text-left">Warehouse</th>
							<th class="text-justify text-left">Route</th>
                            <th class="text-justify text-left">Salesman</th>
							<th class="text-justify text-left">Expense Code</th>
							<th class="text-justify text-left">Expense Type</th>
                            <th class="text-justify text-left">Expense Amount</th>
									                  
						 </tr>
					     </thead>
                         <tbody>
					    <?php
						  foreach($get_data as $key=>$data)
							{
							 ?>
						     <tr>
							  <?php
								$row1 = date("d M Y g:i a", strtotime($data->created_at));
										
										  
								?>
								<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
								 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
								
							 </tr>
							 <?php
							 }
						     ?>
						    </tbody>
					       </table> 
					      <?php
		 
							
					  }
					else
					  {
						if($region!='s')
						  {
							if($region!=0)
							  {
							 
								$agent_id     = array(); 
								$agent_id[]=$region;
							   }
							 else  
							   {
										
								 $agent_name     = array(); 
								 $agent_id     = array(); 
								 $get_data1 = DB::table('tbl_region')
								 ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			                     ->where('tbl_region.status','=','active')
								 ->get()->all();
								
								 foreach($get_data1 as $key=> $region)
								   {
									
									 $agent_id[]=$region->id;
											 
									}
								}
							   $get_data = DB::select("SELECT riheader.created_at,
									warehouse.warehouse_code,
									warehouse.warehouse_name,
									warehouse.region,
									route.route_name,
									route.route_code,
									salesman.salesman_name,
									salesman.salesman_code,
									expense.expense_code,
									riheader.expense_no,
									expense.expense_name,
									currency.currency_notation,
									riheader.expense_amount
									
									FROM tbl_route_expenses as riheader
									LEFT JOIN tbl_route as route on riheader.route_id=route.id
									LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
									LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
									LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
									LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
									LEFT JOIN tbl_region as region_name on warehouse .region=region_name.id
								WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND region  in (".implode(',',$agent_id).") ");
						  
							 ?>
							 <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
							 <thead>
							 <tr>
								<th class="text-justify text-left">Date</th>
								<th class="text-justify text-left">Warehouse</th>
								<th class="text-justify text-left">Route</th>
								<th class="text-justify text-left">Salesman</th>
								<th class="text-justify text-left">Expense Code</th>
								<th class="text-justify text-left">Expense Type</th>
								<th class="text-justify text-left">Expense Amount</th>
														  
							 </tr>
							 </thead>
							 <tbody>
							 <?php
								foreach($get_data as $key=>$data)
								{
									?>
								   <tr>
									 <?php
										$row1 = date("d M Y g:i a", strtotime($data->created_at));
												
												  
										?>
										<td class="font-weight-bold text-justify text-left"><?php echo $row1; ?></td>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->route_code.' - '.ucfirst($data->route_code); ?></td>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->salesman_code.' - '.ucfirst($data->salesman_name); ?></td>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->expense_no; ?> </td>
										 <td class="font-weight-bold text-justify text-left"><?php echo $data->expense_code.' - '.$data->expense_name; ?></td>
										 <td class="font-weight-bold text-justify text-left"><?php echo $data->currency_notation .'  '.$data->expense_amount; ?></td>
										
									</tr>
									 <?php
								  }
										?>
								</tbody>
							  </table> 

									 <?php
			 
							
					 } 
				   }
			     }				   
				   //
               }				 
			
		    }
				
				/* end */

		}				

	 }
    public function get_route_expenses_reportxls(Request $request)
	 {
		
		$region=$request->region1;
		$subregion=$request->subregion1;
		$warehouse=$request->warehouse1;
		$route=$request->route1;
		$salesman=$request->salesman1;
		$expenses=$request->expenses1;
		$fromdate=$request->fromdate1;
		$todate=$request->todate1;
		 return Excel::download(new RouteExpensesReportExport($region,$subregion,$warehouse,$route,$salesman,$expenses,$fromdate,$todate), 'route_expenses_report.xlsx');

      }
 }
