<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\RouteOutstandingReportExport;

class RouteOutstandingController extends Controller
 {
   public function list()
	{		
		//$get_data = SupplierTypeModel::all()->sortByDesc('id');
		 $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
	
		return view('Report.route_outstanding_report',compact('region'));  
	}
		
   public function get_route_report_outstanding_subregion($id)
	{
	  if($id!=0)
		{
		  $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->where('region', '=', $id)->where('status', '=', 'active');
		}
	  else 	
		{
		 $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		}	
   
			?>
			<option  value="">     </option>
			<option  value="0">Select All</option>
			<?php
	  foreach($sub_region as $sub_region_name)
		{
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		   <?php  	   	
		}
	 }
	
    public function get_route_report_outstanding_warehouse($id)
	 {
	   if($id!=0)
		 {		
			$warehouse =WarehouseModel::all()->sortByDesc('id')->where('sub_region', '=', $id)->where('status', '=', 'active');
		  }
		else{
		     $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
	        }
   
			?>
			<option  value="">     </option>
			<option  value="0">Select All</option>
			<?php
		      foreach($warehouse as $warehouse_name)
				{
				  ?>
				    <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
			      <?php  	   	
				}
	 }
  
    public function get_route_report_outstanding_route($id)
	 {
	   if($id!=0)
	     {		
			$route =RouteModel::all()->sortByDesc('id')->where('warehouse_name', '=', $id)->where('status', '=', 'active');
		 }
	   else{
			 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		   }
   
			?>
			<option  value="">     </option>
			<option  value="0">Select All</option>
			<?php
			   foreach($route as $route_name)
				{
				  ?>
				    <option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code.' - '.$route_name->route_name  ?></option>	
			      <?php  	   	
				}
	 }
			
	public function get_route_report_outstanding_salesman($id)
	 {
		if($id!=0)
		  {		
			 $salesman =SalesmanModel::all()->sortByDesc('id')->where('sub_region', '=', $id)->where('status', '=', 'active');
		  }
		else{
		      $salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
	        }
   
			?>
			<option  value="">     </option>
			<option  value="0">Select All</option>
			<?php
				foreach($salesman as $salesman_name)
			      {
					?>
					  <option value="<?php echo $salesman_name->id ?>"  ><?php echo $salesman_name->salesman_code.' - '.$salesman_name->salesman_name  ?></option>	
				    <?php  	   	
				  }
	 }
			
	public function get_route_outstanding_report($region,$subregion,$warehouse,$route,$salesman,$fromdate,$todate)	
	 {

	    /* echo $region.','.$subregion.','.$warehouse.','.$route.','.$salesman.','.$fromdate.','.$todate; */
	    if($salesman!='s')
	      {
			$final_data  = array();
			 //if single subregion
			 if($salesman!=0)
			   {
							
			    $agent_id[]=$salesman;
											
			   }
				//multiple sub region
			 else  
			   {
				  
				 $agent_name     = array(); 
				 $agent_id     = array(); 
				 $get_data1 = DB::table('tbl_salesman')
									 
				 ->select('tbl_salesman.id')
				 ->get();
													
				  foreach($get_data1 as $key=> $warehous)
					{
					
					  $agent_id[]=$warehous->id;
											 
					 }
				}
					 $get_data = DB::select("SELECT 
							customer.customer_code,
							customer.customer_name,
							warehouse.warehouse_code,
							warehouse.warehouse_name,
							riheader.total_invoice_amount,
							riheader.amount_paid,
							riheader.amount_outsatnding,
							riheader.due_date,
							header.invoice_number
							
							FROM tbl_outstanding_details as riheader
							
							LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
							LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
							LEFT JOIN tbl_route_invoice_header as header on riheader.invoice_id=header.id 
						WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.salesman_id  in (".implode(',',$agent_id).") ");
				 
					 ?>
						 <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
						  <thead>
							  <tr>
									 <th class="text-justify text-left">Customer Name </th>
									 <th class="text-justify text-left">Warehouse Name </th>
								   
									 <th class="text-justify text-left">Invoice Amount</th>
									 <th class="text-justify text-left">Invoice Paid Amount</th>
									 <th class="text-justify text-left">Due Amount</th>
									 <th class="text-justify text-left">Due Date</th>
									 
									 <th class="text-justify text-left">Invoice No.</th>
								 
							  </tr>
						  </thead>
	  
						  <tbody>
						  <?php
						  foreach($get_data as $data)
						  {
							  $due_amount=$data->total_invoice_amount - $data->amount_paid;
							 ?>
								  
							 <tr>
								<td class="font-weight-bold text-justify text-left"><?php echo $data->customer_code.' - '.ucfirst($data->customer_name); ?></td>
									  <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
									 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->total_invoice_amount,2); ?></td>
									 
									 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->amount_paid,2); ?></td>
									 
									 <td class="font-weight-bold text-justify text-left"><?php echo number_format($due_amount,2); ?></td>
									
									 <td class="font-weight-bold text-justify text-left"><?php echo $data->due_date; ?></td>
									  <td class="font-weight-bold text-justify text-left"><?php echo $data->invoice_number; ?></td>
									
									
								  </tr>
							   <?php 
							}
						  ?>
													
							</tbody>
	  
							<tfoot>
							<!--<tr>
							  <th>Currency code </th>
							  <th>Currency Name</th>
							  <th>Currency Notation</th>
							  <th>Status</th>
							  <th>Action</th>
							</tr>-->
							</tfoot>
						 </table>
						 
						<?php
		 
							
							
			}
		  else
		    {
			  if($route!='s')
			    {
				  if($route!=0)
				    {
					  $agent_name     = array(); 
					  $agent_id[]=$route;
					
				    }
					else
					{
						$agent_name     = array(); 
								$agent_id     = array(); 
								$get_data1 = DB::table('tbl_route')
													 
								->select('tbl_route.id')
								->get();
													
								foreach($get_data1 as $key=> $warehous)
									{
									
									 $agent_id[]=$warehous->id;
															 
									}
						
					  }
					  $get_data = DB::select("SELECT 
									customer.customer_code,
									customer.customer_name,
									warehouse.warehouse_code,
									warehouse.warehouse_name,
									riheader.total_invoice_amount,
									riheader.amount_paid,
									riheader.amount_outsatnding,
									riheader.due_date,
									header.invoice_number
									
									FROM tbl_outstanding_details as riheader
									
									LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
									LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
									LEFT JOIN tbl_route_invoice_header as header on riheader.invoice_id=header.id 
								WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.route_id  in (".implode(',',$agent_id).") ");
						 
							 ?>
							 <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
							  <thead>
								  <tr>
										 <th class="text-justify text-left">Customer Name </th>
										 <th class="text-justify text-left">Warehouse Name </th>
									   
										 <th class="text-justify text-left">Invoice Amount</th>
										 <th class="text-justify text-left">Invoice Paid Amount</th>
										 <th class="text-justify text-left">Due Amount</th>
										 <th class="text-justify text-left">Due Date</th>
										 
										 <th class="text-justify text-left">Invoice No.</th>
									 
								  </tr>
							  </thead>
		  
							  <tbody>
							  <?php
							  foreach($get_data as $data)
							  {
								  $due_amount=$data->total_invoice_amount - $data->amount_paid;
							    ?>
								  
								 <tr>
									<td class="font-weight-bold text-justify text-left"><?php echo $data->customer_code.' - '.ucfirst($data->customer_name); ?></td>
										  <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
										 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->total_invoice_amount,2); ?></td>
										 
										 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->amount_paid,2); ?></td>
										 
										 <td class="font-weight-bold text-justify text-left"><?php echo number_format($due_amount,2); ?></td>
										
										 <td class="font-weight-bold text-justify text-left"><?php echo $data->due_date; ?></td>
										  <td class="font-weight-bold text-justify text-left"><?php echo $data->invoice_number; ?></td>
										
										
									  </tr>
							      <?php 
							    }
							  ?>
														
							  </tbody>
		  
								<tfoot>
								<!--<tr>
								  <th>Currency code </th>
								  <th>Currency Name</th>
								  <th>Currency Notation</th>
								  <th>Status</th>
								  <th>Action</th>
								</tr>-->
								</tfoot>
						   </table>
							 
							<?php
					
					
				 }
				   else{
						 //
					   
					   if($warehouse!='s')
					     {
						  $final_data  = array();
							 //if single subregion
							  if($warehouse!=0)
								 {
									
									  $agent_name     = array(); 
									  $agent_id     = array(); 
									  
										 
										  $agent_id[]=$warehouse;
																
								  }
											//multiple sub region
								else  
								  {
									  
									$agent_name     = array(); 
									$agent_id     = array(); 
									$get_data1 = DB::table('tbl_warehouse')
														 
									->select('tbl_warehouse.id')
									->get();
									
									 foreach($get_data1 as $key=> $warehouse1)
										{
									  
										  $agent_id[]=$warehouse1->id;
															 
										 }
									
														
								     }
								$get_data = DB::select("SELECT 
										customer.customer_code,
										customer.customer_name,
										warehouse.warehouse_code,
										warehouse.warehouse_name,
										riheader.total_invoice_amount,
										riheader.amount_paid,
										riheader.amount_outsatnding,
										riheader.due_date,
										header.invoice_number
										
										FROM tbl_outstanding_details as riheader
										
										LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
										LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
										LEFT JOIN tbl_route_invoice_header as header on riheader.invoice_id=header.id 
									WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.warehouse_id  in (".implode(',',$agent_id).") ");
							 
								 ?>
								 <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
								  <thead>
									  <tr>
											 <th class="text-justify text-left">Customer Name </th>
											 <th class="text-justify text-left">Warehouse Name </th>
										   
											 <th class="text-justify text-left">Invoice Amount</th>
											 <th class="text-justify text-left">Invoice Paid Amount</th>
											 <th class="text-justify text-left">Due Amount</th>
											 <th class="text-justify text-left">Due Date</th>
											 
											 <th class="text-justify text-left">Invoice No.</th>
										 
									  </tr>
								  </thead>
			  
								  <tbody>
								  <?php
								  foreach($get_data as $data)
								  {
									  $due_amount=$data->total_invoice_amount - $data->amount_paid;
								    ?>
									  
									 <tr>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->customer_code.' - '.ucfirst($data->customer_name); ?></td>
											  <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->total_invoice_amount,2); ?></td>
											 
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->amount_paid,2); ?></td>
											 
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($due_amount,2); ?></td>
											
											 <td class="font-weight-bold text-justify text-left"><?php echo $data->due_date; ?></td>
											  <td class="font-weight-bold text-justify text-left"><?php echo $data->invoice_number; ?></td>
											
											
										    </tr>
							               <?php 
							          }  
									  ?>
																
									  </tbody>
				  
										<tfoot>
										<!--<tr>
										  <th>Currency code </th>
										  <th>Currency Name</th>
										  <th>Currency Notation</th>
										  <th>Status</th>
										  <th>Action</th>
										</tr>-->
										</tfoot>
								   </table>
									 
									<?php
			 
								
								
							
					      }
				        else
						  {
							if($subregion!='s')
							  {
								if($subregion!=0)
									 {
										$agent_id     = array(); 
										$agent_id[]=$subregion;
									  }
												//multiple sub region
								 else  
								   {
									  $agent_name     = array(); 
									  $agent_id     = array(); 
									  $get_data1 = DB::table('tbl_sub_region')
									  ->select('tbl_sub_region.id')
									  ->get();
									   foreach($get_data1 as $key=> $sub_region)
										 {
									  
										  $agent_id[]=$sub_region->id;
															 
										 }
													
								     }
									 $get_data = DB::select("SELECT 
										customer.customer_code,
										customer.customer_name,
										warehouse.warehouse_code,
										warehouse.warehouse_name,
										riheader.total_invoice_amount,
										riheader.amount_paid,
										riheader.amount_outsatnding,
										riheader.due_date,
										header.invoice_number
										
										FROM tbl_outstanding_details as riheader
										
										LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
										LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
										LEFT JOIN tbl_route_invoice_header as header on riheader.invoice_id=header.id 
									WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.subregion  in (".implode(',',$agent_id).") ");
							 
								   ?>
								   <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
								    <thead>
									  <tr>
											 <th class="text-justify text-left">Customer Name </th>
											 <th class="text-justify text-left">Warehouse Name </th>
										   
											 <th class="text-justify text-left">Invoice Amount</th>
											 <th class="text-justify text-left">Invoice Paid Amount</th>
											 <th class="text-justify text-left">Due Amount</th>
											 <th class="text-justify text-left">Due Date</th>
											 
											 <th class="text-justify text-left">Invoice No.</th>
										 
									  </tr>
								   </thead>
			  
								   <tbody>
								   <?php
								   foreach($get_data as $data)
								     {
									  $due_amount=$data->total_invoice_amount - $data->amount_paid;
								       ?>
									  
										 <tr>
											<td class="font-weight-bold text-justify text-left"><?php echo $data->customer_code.' - '.ucfirst($data->customer_name); ?></td>
												  <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
												 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->total_invoice_amount,2); ?></td>
												 
												 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->amount_paid,2); ?></td>
												 
												 <td class="font-weight-bold text-justify text-left"><?php echo number_format($due_amount,2); ?></td>
												
												 <td class="font-weight-bold text-justify text-left"><?php echo $data->due_date; ?></td>
												  <td class="font-weight-bold text-justify text-left"><?php echo $data->invoice_number; ?></td>
												
												
											  </tr>
									    <?php 
								       }
								         ?>
															
									  </tbody>
				  
										<tfoot>
										<!--<tr>
										  <th>Currency code </th>
										  <th>Currency Name</th>
										  <th>Currency Notation</th>
										  <th>Status</th>
										  <th>Action</th>
										</tr>-->
										</tfoot>
								   </table>		
								<?php
				 
									
							  }
							else
							  {
								if($region!='s')
								  {
									 
								    if($region!=0)
									  {
											$agent_id     = array(); 
											$agent_id[]=$region;
									   }
									 else  
									   {
											
										 $agent_name     = array(); 
										 $agent_id     = array(); 
										 $get_data1 = DB::table('tbl_region')
										 ->select('tbl_region.id')
										  ->get()->all();
										 foreach($get_data1 as $key=> $region)
											{
												
											  $agent_id[]=$region->id;
														 
											 }
										}
									$get_data = DB::select("SELECT 
										customer.customer_code,
										customer.customer_name,
										warehouse.warehouse_code,
										warehouse.warehouse_name,
										riheader.total_invoice_amount,
										riheader.amount_paid,
										riheader.amount_outsatnding,
										riheader.due_date,
										header.invoice_number
										
										FROM tbl_outstanding_details as riheader
										
										LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
										LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
										LEFT JOIN tbl_route_invoice_header as header on riheader.invoice_id=header.id 
									WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.region  in (".implode(',',$agent_id).") ");
							 
								   ?>
								   <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
								   <thead>
									  <tr>
											 <th class="text-justify text-left">Customer Name </th>
											 <th class="text-justify text-left">Warehouse Name </th>
										   
											 <th class="text-justify text-left">Invoice Amount</th>
											 <th class="text-justify text-left">Invoice Paid Amount</th>
											 <th class="text-justify text-left">Due Amount</th>
											 <th class="text-justify text-left">Due Date</th>
											 
											 <th class="text-justify text-left">Invoice No.</th>
										 
									  </tr>
								  </thead>
			  
								  <tbody>
								  <?php
								  foreach($get_data as $data)
								    {
									  $due_amount=$data->total_invoice_amount - $data->amount_paid;
								      ?>
									  
									 <tr>
										<td class="font-weight-bold text-justify text-left"><?php echo $data->customer_code.' - '.ucfirst($data->customer_name); ?></td>
											  <td class="font-weight-bold text-justify text-left"><?php echo $data->warehouse_code.' - '.ucfirst($data->warehouse_name); ?></td>
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->total_invoice_amount,2); ?></td>
											 
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($data->amount_paid,2); ?></td>
											 
											 <td class="font-weight-bold text-justify text-left"><?php echo number_format($due_amount,2); ?></td>
											
											 <td class="font-weight-bold text-justify text-left"><?php echo $data->due_date; ?></td>
											  <td class="font-weight-bold text-justify text-left"><?php echo $data->invoice_number; ?></td>
											
											
										  </tr>
										<?php 
								    }
									  ?>
																
									  </tbody>
				  
										<tfoot>
										<!--<tr>
										  <th>Currency code </th>
										  <th>Currency Name</th>
										  <th>Currency Notation</th>
										  <th>Status</th>
										  <th>Action</th>
										</tr>-->
										</tfoot>
								   </table>

										 <?php
				 
									
								  } 
							  }
						 }				   
					   
					   //
			     }				 
			}
	 }
    public function get_route_outstanding_reportxls(Request $request)
	 {
		
		$region=$request->region1;
		$subregion=$request->subregion1;
		$warehouse=$request->warehouse1;
		$route=$request->route1;
		$salesman=$request->salesman1;
		$fromdate=$request->fromdate1;
		$todate=$request->todate1;
		 return Excel::download(new RouteOutstandingReportExport($region,$subregion,$warehouse,$route,$salesman,$fromdate,$todate), 'route_outstanding_report.xlsx');

     }	
 }
