<?php

namespace App\Http\Controllers;
use App\Models\WarehouseModel;
use Illuminate\Http\Request;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\OutstandingModel;
use App\Models\TradingCenterModel;
use Carbon\Carbon;
use Session;
use PDF;
use App\Exports\RouteInvoiceExport; 
use Maatwebsite\Excel\Facades\Excel;
use Illuminate\Support\Facades\DB;

class SalesmanInvoiceController extends Controller
 {
    public function list(Request $request)
	 {
		 
		$current_date=date("Y-m-d");	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }	  
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
			 
		if($request->warehouse!='')
		  {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		  }
		 
	    if($request->route!='')
		  {
			$where .= "AND route.id = '".$request->route."'";
		  }
		
		  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
		  //$get_data = CurrencyTypeModel::all()->sortByDesc('id');
		
			$get_data = DB::select("SELECT riheader.*, route.route_name,route.route_code,
			customer.customer_code,customer.customer_name,
			warehouse.warehouse_code,warehouse.warehouse_name,
			salesman.salesman_name,salesman.salesman_code,currency.currency_notation
			
			FROM tbl_route_invoice_header as riheader
			LEFT JOIN tbl_route as route on riheader.route_id=route.id
			LEFT JOIN tbl_customer as customer on riheader.customer_name=customer.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
			
			//dd($get_data);
		 
		  return view('Route_Transaction.salesman_invoice_list',compact('get_data','route','warehouse'));
	  }
	
	 public function view($id)
	  {   
	
		$user_id=Session::get('user_id');
		$get_data =DB::table('tbl_route_invoice_header')
		->leftJoin('tbl_trading_center', 'tbl_route_invoice_header.trading_center_id', '=', 'tbl_trading_center.id')
		->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_currency_type', 'tbl_route_invoice_header.currency_id', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
	
		 ->select('tbl_route_invoice_header.*', 'tbl_trading_center.trading_name', 'tbl_trading_center.trading_center_code', 'tbl_route.route_name','tbl_route.route_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_route_invoice_header.id', '=',$id)->get()->first();
		 

		 $get_data_details =DB::table('tbl_route_invoice_details')
		 

		  ->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_route_invoice_details.uom_id', '=', 'tbl_unit_of_measurement.id')
  
		  ->select('tbl_route_invoice_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation')->where('tbl_route_invoice_details.header_id', '=', $id)->get()->all();
  
				  $login_user = DB::table('tbl_user')
				  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
				  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
				  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
				  ->where('tbl_user.id', '=', $user_id)
				  ->get()->first();			  
			

			
		  return view('Route_Transaction.salesman_invoice_view',compact('get_data','get_data_details','login_user'));
		
	 }
	
	public function add()
	 {   	
		$user_id=Session::get('user_id');	  
		$result = DB::table('tbl_route_invoice_header')
		 ->select('tbl_route_invoice_header.*')->get()->sortByDesc('id')->first();
	  
	    if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->invoice_number_code;
		  }
		else
		  {
			$getcode = $result->invoice_number; 
		    $last_code = ++$getcode;
		  }

			$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name')
		
			->get()->all();
			
			$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
			  $customer_type =CustomerModel ::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 1);		
            // $salesman = SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');	 	
               	  	   
			  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');		
			  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
			  $login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();
			     
 
    	  return view('Route_Transaction.salesman_invoice',compact('last_code','customer_type','material_master','material_category','route','material','login_user'));
	 }
	
    public function save(Request $request)
     {
	
		$current = Carbon::now();
		$user_id=Session::get('user_id');

		$salesman = DB::table('tbl_salesman')
		->select('tbl_salesman.id as salesman_id')
		->where('tbl_salesman.route_id', '=', $request->route_id1)
		->get()->first();
	 
		$get_region_subregion = DB::table('tbl_customer')
		->select('tbl_customer.id', 'tbl_customer.region','tbl_customer.sub_region')
	   ->where('tbl_customer.id', '=', $request->customer_type)
	   ->get()->first();
		//dd($get_region_subregion);
		
		
		$login_user = DB::table('tbl_user')
	   ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
	   ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
	   ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
	   ->where('tbl_user.id', '=', $user_id)
	   ->get()->first();
        
		 $date = str_replace('/', '-', $request->invoice_date);
		 $newDate = date("d-m-Y", strtotime($date));
         
		 //getting credit days of customer
		  $customer_creditdays = DB::table('tbl_customer')
		 ->select('tbl_customer.credit_days')->where('tbl_customer.id', '=', $request->customer_type)->get()->first();
		 
		 //adding credit days with current date
		  $current_date=date("Y-m-d");  
		  $date=date_create($current_date);
		  date_add($date,date_interval_create_from_date_string(" ".$customer_creditdays->credit_days." days"));
		  $due_date= date_format($date,"Y-m-d");
		 
		 $data3=array
				   (
					 'invoice_number'      =>  $request->invoice_number,
					 'currency_id'         =>  $login_user->currency_id,
					 'warehouse_id'           =>  $request->warehaouse_id,
					 'salesman_id'            =>  $request->salesman_id,
					 'invoice_date'        =>  $newDate,
					 'customer_name'       =>  $request->customer_type,
					 'remark'              =>  $request->comment,
					 
					 'region_id'              =>  $get_region_subregion->region,
					 'subregion_id'           =>  $get_region_subregion->sub_region,
					 
					 'route_id'            =>  $request->route_id1,
					 'trading_center_id'   =>  $request->trading_center,
					 'total_gross'         =>  $request->gross_amount_totali,
					 'net_total_amount'    =>  $request->net_amount_totali,
					 'total_vat'           =>  $request->vat_amount_totali,
					 //'total_unite_price'   =>  $request->price_amount_totali,
					 'total_invoice_value' =>  $request->invoice_amount_totali,
					  'created_at'         => $current,
			      );
				 
			 $header_id =DB::table('tbl_route_invoice_header')->insertGetId($data3);
				 
				    //add data in Route outstanding
					$data=new OutstandingModel;
					$data->customer_id=$request->customer_type;
					$data->warehouse_id= $request->warehaouse_id;
					$data->salesman_id= $request->salesman_id;
					$data->route_id= $request->route_id1;
					$data->region= $get_region_subregion->region;
					$data->subregion= $get_region_subregion->sub_region;
					$data->invoice_id=$header_id;
					//$data->invoice_number=$request->invoice_number;
					$data->total_invoice_amount=$request->invoice_amount_totali;
					$data->amount_outsatnding=$request->invoice_amount_totali;
					$data->due_date=$due_date;
					$data->amount_paid=0;
					$data->save();
		   
		  if(count($request->material_name)>0)
			{
				
			  foreach($request['material_name'] as $key => $n)
			    {
			      if($request->quantity[$key]!='')
			         {
					  $data2=array
					    (
						 'material_code' => $request->material_name[$key ],
						 'header_id'           =>$header_id,
						 'uom_id'           => $request->uom[$key ],
						 'unite_price'   => $request->price[$key ],
						 'gross_total'   => $request->gross[$key ],
						 'vat'           => $request->vat[$key ],
						 'total'         => $request->total[$key ],
						 'net_amount'    => $request->net_amount[$key ],
						 'quantity'    => $request->quantity[$key ],
						 'base_qty'    => $request->packing_size[$key ],
						 'created_at'    => $current,
						);
						
					    DB::table('tbl_route_invoice_details')->insert($data2);
					 
					    /* stock movement functionality start from here */
					    $stock = DB::table('tbl_warehouse_stock')
							  ->where('tbl_warehouse_stock.warehouse_id','=',$request->warehaouse_id)
							  ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
							  ->get()->all();
							  $count=count($stock);
							  if($count>0)
								{
								  // reducing stock from warehouse
								  $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id',$request->warehaouse_id)
								  ->where('material_id','=',$request->material_name[$key]);
								  
								   $query->decrement('qty',$request->packing_size[$key]);
								}	   
			        } 
               }
		 
	       }
		   
	 return redirect(route('salesman_invoice_list'))->with('successMessage','Route Invoice Uploaded Successfully');
      }
	  
	 public function get_trading($id1)
      {
		
		 $get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');
        
		  ?>
		 <option  value="">     </option>
		 <?php
		 foreach($get_data as $trading)
		   {
			  ?>
			 <option value="<?php echo $trading->id ?>"  ><?php echo $trading->trading_center_code." - ".$trading->trading_name ?></option>	
			 <?php		
		   }
		 
      }
	  
	  
	   public function salesman($id)
      {
		
		 $get_data=SalesmanModel::all()->where('id', '=', $id)->where('status', '=', 'active');
         
		  ?>
		 <option  value="">     </option>
		 <?php
		 foreach($get_data as $salesman)
		   {
			  ?>
			 <option value="<?php echo $salesman->id ?>"  ><?php echo $salesman->salesman_code." - ".$salesman->salesman_name ?></option>	
			 <?php	
             		 
		   }
		
      }
	
	 public function get_customer($id1)
      {
			 
		
		$get_data=CustomerModel::all()->sortByDesc('id')->where('trading_center_id', '=', $id1)->where('customer_type', '=', 1)->where('status', '=', 'active');
		
		?>
		<option  value="">     </option>
		<?php
	   foreach($get_data as $customer)
		 {
			?>
			<option value="<?php echo $customer->id ?>"  ><?php echo $customer->customer_code." - ".$customer->customer_name ?></option>	
			<?php		
		 }
		 
      }
	  
	 public function get_material()
      {
		
		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
	
		?>
		<option  value="">     </option>
		<?php
		foreach($material as $material_name)
		  {
			?>
			<option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code.' - '.$material_name->material_name ?></option>	
			<?php		
		  }
		 
	  }
		 
     public function get_material_price($warehouse,$id,$val)
	  {
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
		$alt_uom = explode(",",$material->alt_uom);
		$key = array_search($id, $alt_uom);
		$alt_unit_price = explode(",",$material->alt_unit_price);
		echo $alt_unit_price[$key];
			
	  }

	 public function get_material_vat($id)
	  {
	 
		$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	

		echo $material_vat->vat;
				
	  }
		
	 public function check_availbl_stock($warehouse,$id,$val)
	  {
	 
		 $get_data = DB::table('tbl_warehouse_stock')
			
			->select(DB::raw('sum(tbl_warehouse_stock.qty) as stock_total'))
			->where('warehouse_id','=',$warehouse)
			->where('material_id','=',$val)
			->groupBy('tbl_warehouse_stock.warehouse_id','tbl_warehouse_stock.material_id')
			->get()->all();
	     $total=count($get_data);
	     if($total>0)
		   echo $get_data[0]->stock_total;
		 else
		   echo $total;
         	
	  }
		
	 public function get_material_alt_packing_size($id,$val)
	  {
	 
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		$alt_uom = explode(",",$material->alt_uom);
	   
		$key = array_search($id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material->alt_packing_size);

		echo $alt_alt_packing_size[$key];
	
	  }
	   
     public function get_material_detailsUom($id,$row)
	  {
		$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
		t1.alt_uom) WHERE t1.`id`='.$id.'');
		
		$get_material_price=MaterialMasterModel::find($id);
		
		$alt_unit_price = explode(",",$get_material_price->alt_unit_price);
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);

	    foreach($material_master as $key=>$data)
		  {
				
			?>
			<option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option> 
			<?php
 
		  }
	  }
	  
	  public function route_invoice_export($id)
	  {
		  
		  return Excel::download(new RouteInvoiceExport($id), 'route_invoice.xlsx');
	  }
	  
	   public function route_invoice_pdf($id)
	  {
		  
		  $get_data =DB::table('tbl_route_invoice_header')
		->leftJoin('tbl_trading_center', 'tbl_route_invoice_header.trading_center_id', '=', 'tbl_trading_center.id')
		->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_currency_type', 'tbl_route_invoice_header.currency_id', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
	
		 ->select('tbl_route_invoice_header.*', 'tbl_trading_center.trading_name', 'tbl_trading_center.trading_center_code', 'tbl_route.route_name','tbl_route.route_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_customer.tin_no','tbl_customer.address','tbl_customer.email','tbl_customer.contact_no','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_route_invoice_header.id', '=',$id)->get()->first();
		  
		 $get_data_details =DB::table('tbl_route_invoice_details') 
		 

		  ->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_route_invoice_details.uom_id', '=', 'tbl_unit_of_measurement.id')
  
		  ->select('tbl_route_invoice_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation')->where('tbl_route_invoice_details.header_id', '=', $id)->get()->all();
		  
		  $pdf=PDF::loadView('export.pdf.route_invoice_pdf', compact('get_data','get_data_details'));
		  return $pdf->download('route_invoice.pdf');
	  }

     public function get_routename_filter($id,$url_route)
      {

		$route =RouteModel::all()->sortByDesc('id')->where('warehouse_id', '=', $id)->where('status', '=', 'active');	
		?>

		<option  value="">     </option>
		<?php
		foreach($route as $route_name)
          {
			?>
			<option value="<?php if ($route_name->id==$url_route) { echo "selected";}  ?>"  > <?php echo $route_name->route_code ?> - <?php echo $route_name->route_name ?> </option>	
			<?php		
		  }		
      }	    
 }
?>