<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\SalesmanTypeModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\ReasonTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanUnloadModel;
use App\Models\ManageCodeModel;
use Illuminate\Support\Facades\DB;

class TransactionApiController extends Controller
 {   

 //ROUTE POST API
 
   public function save_invoice(Request $request)	 
    { 
	    $trading = DB::table('tbl_customer')
			 ->leftJoin('tbl_route_invoice_header','tbl_customer.id', '=', 'tbl_route_invoice_header.customer_name')
			 ->select('tbl_customer.trading_center_id','tbl_customer.customer_name')
			 ->where('tbl_customer.id', $request->customer_name) 
			 ->get()->all(); 
 
		$newDate = date('Y-m-d');
		$save_data=array(
						 'invoice_number'                   =>  $request->invoice_number,
						 'salesman_id'                      =>  $request->salesman,
						 'region_id'                        =>  $request->region,
						 'subregion_id'                     =>  $request->subregion,
						 'warehouse_id'                     =>  $request->warehouse,
						 'invoice_date'                     =>  $newDate,
						 'customer_name'                    =>  $request->customer_name,
						 'route_id'                         =>  $request->route_id, 
						 'trading_center_id'                =>  $request->trading_center_id,
						 'remark'                           =>  $request->remark,
						 'total_gross'                      =>  $request->total_gross,
						 'total_invoice_value'              =>  $request->total_invoice_value,
						 'currency_id'                      =>  $request->currency,
						 'total_vat'                        =>  $request->total_vat,
						 'total_discount'                   =>  $request->total_discount,
						 'net_total_amount'                 =>  $request->net_total_amount,
						);
         
	    $header=DB::table('tbl_route_invoice_header')->insertGetId($save_data); 
	   
	    foreach($request['items'] as $key)
	        {  
		   
		      $material=MaterialMasterModel::get()->sortByDesc('id')->first()
			          ->find($key['material_code']);	
              $alt_uom = explode(",",$material->alt_uom);
	          $key1 = array_search($key['uom_id'], $alt_uom);
	          $alt_alt_packing_size = explode(",",$material->alt_packing_size);
              $total= $alt_alt_packing_size[$key1]*$key['quantity'];
		   
		   
			    $data2=array(
							 'header_id'         => $header,
							 'material_code'                   =>   $key['material_code'],
							 'uom_id'                          =>   $key['uom_id'],
							 'quantity'                        =>   $key['quantity'],
							 'unite_price'                     =>   $key['unite_price'],
							 'vat'                             =>   $key['vat'],
							 'gross_total'                     =>   $key['gross_total'],
							 'discount'                        =>   $key['discount'],
							 'discount_id'                     =>   $key['discount_id'],
							 'base_qty'                        =>   $total,
							 'total'                           =>   $key['total'],
							 'net_amount'                      =>   $key['net_amount'],
							);
		   
			  $details= DB::table('tbl_route_invoice_details')->insert($data2); 
			}
		    
		  if($details)
		    { 
		       return array( 'API_Status' => 1, 'Message' => "Data Inserted"); 
			} 
			else
			{ 
		       return array('API_Status' => 0, 'Message' => "Data Not Inserted"); 
		    } 
    }
    
   public function save_saleman_load(Request $request)
    { 
		$save_data=array(
						 'route_id'            =>  $request->route_id,
						 'salesman_id'         =>  $request->salesman_id,
						 'load_date'           =>  $request->load_date,
						 'load_number'         =>  $request->load_number,
						 'warehouse_id'        =>  $request->warehouse_id,
						 'currency'            =>  $request->currency,
						 'status'              =>  $request->status,
						 'total_load_value'    =>  $request->total_load_value,
			            );

		$header_id =DB::table('tbl_route_salesmanload_header')->insertGetId($save_data);
		 
	    foreach($request['Details'] as $key)
		    {
			 $data2=array(
						 'header_id'     => $header_id,
						 'material_id'   => $key['material_id'],
						 'uom_id'        => $key['uom'],
						 'quantity'      => $key['quantity'],
						 'price'         => $key['price'],
						 'total'         => $key['total'],
						 'base_qty'      => $key['base_qty'],
				        );
					
		     $details= DB::table('tbl_route_salesmanload_details')->insert($data2);
			}	
			 
		if($details)
		    {
 
			  return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");
            } 
		else 			   
			{

			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
            }
    }
   public function update_load_status(Request $request)
    { 
        $current = Carbon::now()->format('Y-m-d'); 
		if(!strcmp($request->status,"confirm"))
		    {
			 $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
				 
		     foreach($stock_reserve as $key => $n)
		        {
			       //storing data in warehouse_stock
					$material_master = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					->where('item_id','=',$stock_reserve[$key]->item_id)
					->get()->all();
					
					$count = count($material_master);
				
				  if($count>0)
				    {
					 // reducing from 1st warehouse
					 $query = DB::table('tbl_route_warehouse_stock')
					 ->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					 ->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					 ->where('item_id','=',$stock_reserve[$key]->item_id);
						
					 $query->increment('qty',$stock_reserve[$key]->qty);
										   
				    }
				 else
				    {
					 $data4=array(
								 'warehouse_id'  => $stock_reserve[$key]->warehouse_id,
								 'route_warehouse_id' => $stock_reserve[$key]->route_warehouse_id,
								 'item_id'  => $stock_reserve[$key]->item_id,
								 'uom_id'   => $stock_reserve[$key]->uom,
								 'qty'   => $stock_reserve[$key]->qty,
								 'route_id'  => $stock_reserve[$key]->route_id,
								 'created_at'  => $current,
					            );	
					
				     DB::table('tbl_route_warehouse_stock')->insert($data4); 
				    }
		        }
             
		    }
		else
		    {
		     $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
					 
		     foreach($stock_reserve as $key => $n)
		        {	
			     $query = DB::table('tbl_warehouse_stock')
				 ->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				 ->where('material_id','=',$stock_reserve[$key]->item_id)
				 ->get()->all();
				
				 $count=count($query);
			
			     if($count>0)
			        {
				     // reducing from 1st warehouse
			         $query = DB::table('tbl_warehouse_stock')
				     ->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				     ->where('material_id','=',$stock_reserve[$key]->item_id); 
				     $query->increment('qty',$stock_reserve[$key]->qty);
		            } 
		        } 
		    }	 
	   
	    DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->delete();
					 
		$mediaFiles = $request->sign;
		$extension = $mediaFiles->getClientOriginalExtension(); 
		$media_ext = $mediaFiles->getClientOriginalName();
		$media_no_ext = pathinfo($media_ext, PATHINFO_FILENAME);
		$mFiles = 'singnature-' . time() . '.' . $extension;
		$mediaFiles->move(public_path().'/images/salesmanload_sign/', $mFiles); 
			//dd($mediaFiles); 
		 $data= DB::table('tbl_route_salesmanload_header')
		 ->where('id', $request->load_id)
		 ->update([
				 'status' => $request->status,
				 'sign' =>   $mFiles
			 ]);
					  
	    if($data) 
		    { 
		     return array('Result'=>[], 'API_Status' => 1, 'Message' => "status updated "); 
		    } 
	    else 
		   {
		     return array('Result'=>[], 'API_Status' => 0, 'Message' => "Status Not updated"); 
		    } 
    }
   public function save_pending_customer(Request $request) 
	{
	    $cmp= DB::table('tbl_warehouse')
			->select('tbl_warehouse.company_id')
			->where('id', $request->warehouse) 
			->get()->all(); 

		$cmp_id=$cmp[0]->company_id;
		$newDate = date("d-m-Y");

		$save_data=array(
						 "company_id"            =>$cmp_id,
						 "customer_type"         =>$request->customer_type,
						 "customer_category"     =>$request->customer_category,
						 "customer_code"         =>$request->customer_code,
						 "customer_name"         =>$request->customer_name,
						 "tin_no"                =>$request->tin_no,
						 "address" 			    =>$request->address,
						 "city"  				=>$request->city,
						 "country"  				=>$request->country,
						 "email"  				=>$request->email,
						 "contact_no"  			=>$request->contact_no,
						 "payment_term"  		=>$request->payment_term,
						 "credit_limit"  		=>$request->credit_limit,
						 "credit_days"  			=>$request->credit_days,
						 "region"  				=>$request->region,
						 "sub_region"  			=>$request->sub_region,
						 "warehouse"  			=>$request->warehouse,
						 "route_id"  			=>$request->route_id,
						 "trading_center_id" 	=>$request->trading_center_id,
						 "thresold_frequency"  	=>$request->thresold_frequency,
					    );
		$header=DB::table('tbl_pending_customer')
		    ->where('tbl_pending_customer.approval_status','=',"pending")
		    ->insertGetId($save_data);
				
	    if($header)
		    {
			 return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");
		    }
		else 
		    { 
		     return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
            } 
	}
   public function sales_return_save(Request $request) 
	{
		//dd($request);
		$trading = DB::table('tbl_customer') 
		    ->leftJoin('tbl_return_sales_header','tbl_customer.id','=', 'tbl_return_sales_header.customer_name') 
		    ->select('tbl_customer.trading_center_id','tbl_customer.customer_name') 
		    ->where('tbl_customer.id', $request->customer_name) 
		    ->get()->all();  
		   
	    $newDate = date("d-m-Y");
	    $save_data=array(
						 'return_number'                 =>  $request->return_number,
						 'salesman'                      =>  $request->salesman,
						 'region'                        =>  $request->region,
						 'subregion'                     =>  $request->subregion,
						 'warehouse'                     =>  $request->warehouse,
						 'invoice_date'                  =>  $newDate,
						 'customer_name'                 =>  $request->customer_name,
						 'route_id'                      =>  $request->route_id, 
						 'trading_center_id'             =>  $request->trading_center_id,
						 'remark'                        =>  $request->remark,
						 'total_gross'                   =>  $request->total_gross,
						 'total_invoice_value'           =>  $request->total_invoice_value,
						 'currency'                      =>  $request->currency,
						);

	    $header_id =DB::table('tbl_return_sales_header')->insertGetId($save_data);
		 
		foreach($request['Item'] as $key)
		    {  
			 $data2=array(
			 'header_id'                       =>  $header_id,
			 'material_id'                     =>  $key['material_id'],
			 'uom'                             =>  $key['uom'],
			 'quantity'                        =>  $key['quantity'],
			 'return_type'                     =>  $key['return_type'],
			 'resion'                          =>  $key['resion'],
			 'unite_price'                     =>  $key['unite_price'],
			 'gross_total'                     =>  $key['gross_total'],
			 'total'                           =>  $key['total'],
			 'base_qty'                        =>  $key['base_qty'],
			  );
			 $details= DB::table('tbl_return_sales_details')->insert($data2);
		    }	
	    if($details)
		    {
		     return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted"); 
		    }
		else
		    { 
		     return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
		    }  
	}
	
  public function save_route_unload(Request $request)	 
    { 
	  
	   $route_warehouse=DB::table('tbl_warehouse')
	   ->where('warehouse_type','=',2)
	   ->where('status', '=', 'active')
	   ->where('route_warehouse','=', $request->warehouse_id)
       ->get()->all();
	   
	 
	  
		   $newDate = date("H:i:s"); 
		   $save_data=array(
			 'salesman_id'                      =>  $request->salesman_id,
			 'warehouse_id'                      =>  $request->warehouse_id,
			 'route_id'                         =>  $request->route_id,
			 'unload_time'                      =>  $newDate,
			 'unload_code'                      =>  $request->unload_code,
			 
			  );
         
		   $header=DB::table('tbl_route_unload_header')->insertGetId($save_data); 
		   
		   
		 
//dd($alt_alt_packing_size);
		 foreach($request['items'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             $total1= $alt_alt_packing_size[$key1]*$key['availble_quantity'];
		    
			 $data2=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'available_qty'                    =>   $key['availble_quantity'],
			 'base_qty'                         =>   $total,
			 'available_base_qty'               =>   $total1,
		     );
			
		     $material_master = DB::table('tbl_route_warehouse_stock')
			->where('warehouse_id',  $request->warehouse_id)
			->where('route_warehouse_id', $route_warehouse[0]->id)
			->where('item_id','=',$key['material_id'])
			->get()->all();
			
			 $count = count($material_master);
			 if($count>0)
              {
			  // reducing from 1st warehouse
				 $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $request->warehouse_id)
				->where('material_id','=',$key['material_id']);
				 $query->increment('qty',$key['quantity']);
					
				 DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id',  $request->warehouse_id)
					->where('route_warehouse_id', $route_warehouse[0]->id)
					->where('item_id','=',$key['material_id'])
					->delete();
									   
		      }	
					
			     $details= DB::table('tbl_route_unload_details')->insert($data2); 
		  }
		  
		foreach($request['stock_variance'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             
		    
			 $data3=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'base_qty'                         =>   $total,
			 );
			
		     DB::table('tbl_stock_variance')->insert($data3); 
		  }
		foreach($request['return_stock'] as $key)
		 {  
		 
		    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
             
		    
			 $data4=array( 
			 'header_id'                        =>   $header,
			 'material_id'                      =>   $key['material_id'],
			 'uom_id'                           =>   $key['uom_id'],
			 'quantity'                         =>   $key['quantity'],
			 'return_type'                      =>   $key['return_type'],
			 'return_reason'                    =>   $key['return_reason'],
			 'base_qty'                         =>   $total,
			 );
			
		     DB::table('tbl_unload_return_stock')->insert($data4); 
		  }
		    
		    if($details)
		     { 
		       return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			 } 
			 else
			 { 
		       return array( 'API_Status' => 0, 'Message' => "Data Not Inserted"); 
		     } 
    } 
   public function save_route_order(Request $request)
    {
	    $trading = DB::table('tbl_customer') 
		   ->leftJoin('tbl_return_sales_header','tbl_customer.id','=', 'tbl_return_sales_header.customer_name') 
		   ->select('tbl_customer.trading_center_id','tbl_customer.customer_name') 
		   ->where('tbl_customer.id', $request->customer_name) 
		   ->get()->all(); 
	    $ldate = date('Y-m-d H:i:s');
	    $save_data= array(
						  'order_number'       =>$request->order_number,
						  'salesman_id'        =>$request->salesman_id,
						  'warehouse_id'       =>$request->warehouse_id,
						  'order_date'         =>$request->order_date,
						  'customer_id'        =>$request->customer_id,
						  'route_id'           =>$request->route_id,
						  'region_id'          =>$request->region_id,
						  'subregion_id'       =>$request->subregion_id,
						  'trading_center_id'  =>$request->trading_center_id,
						  'remark'             =>$request->remark,
						  'currency_id'        =>$request->currency_id,
						  'total_gross'        =>$request->total_gross,
						  'total_vat'          =>$request->total_vat,
						  'net_total_amount'   =>$request->net_total_amount,
						  'total_discount'     =>$request->total_discount,
						  'total_invoice_value'=>$request->total_invioce_value,
						  'created_at'         =>$ldate,
						  'is_deliver'         =>$request->is_deliver,
						);
 
	    $header_id =DB::table('tbl_route_order_header')->insertGetId($save_data);
		   
		foreach($request['Item'] as $key)
		    {
			   
			 $material=MaterialMasterModel::get()->sortByDesc('id')
			          ->first()->find($key['material_id']);	
             $alt_uom = explode(",",$material->alt_uom);
	         $key1 = array_search($key['uom_id'], $alt_uom);
	         $alt_alt_packing_size = explode(",",$material->alt_packing_size);
             $total= $alt_alt_packing_size[$key1]*$key['quantity'];
			   
			 $save_data2=array(
							   'material_id'          =>$key['material_id'],
							   'uom_id'               =>$key['uom_id'],
							   'quantity'             =>$key['quantity'],
							   'base_qty'             =>$total,
							   'header_id'            =>$header_id,
							   'unite_price'          =>$key['unite_price'],
							   'gross_total'          =>$key['gross_total'],
							   'vat'                  =>$key['vat'],
							   'net_amount'           =>$key['net_amount'],
							   'discount'             =>$key['discount'],
							   'discount_id'          =>$key['discount_id'],
							   'total'                =>$key['total'],
							   'created_at'           =>$ldate,
							);
			 $details= DB::table('tbl_route_order_details')->insert($save_data2);
		    }	
	    if($details)
		    {
			 return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			}
		else
			{ 
			 return array('API_Status' => 0, 'Message' => "Data Not Inserted");
			}  
	}
   public function save_route_exchange(Request $request)
    {
	   
	    $ldate = date('Y-m-d H:i:s');
	    $save_data= array(
						   'exchange_number'        =>$request->exchange_number,
						   'exchange_date'          =>$request->exchange_date,
						   'exchange_amount'        =>$request->exchange_amount,
						   'customer_id'            =>$request->customer_id,
						   'salesman_id'            =>$request->salesman_id,
						   'warehouse_id'           =>$request->warehouse_id,
						   'route_id'               =>$request->route_id,
						   'invoice_code'           =>$request->invoice_code,
						   'return_code'            =>$request->return_code,
						   'amount'                 =>$request->amount,
						   'created_at'             =>$ldate,
					    );
 
		$header_id =DB::table('tbl_route_exchange_header')->insertGetId($save_data);
		   
		foreach($request['Invoice'] as $key)
		    {
			   
			 $save_data2=array(
							   'material_id'          =>$key['material_id'],
							   'uom_id'               =>$key['uom_id'],
							   'quantity'             =>$key['quantity'],
							   'amount'               =>$key['amount'],
							   'header_id'            =>$header_id,
							   'total_amount'         =>$key['total_amount'],
							   'created_at'           =>$ldate,
							);
			 $details1= DB::table('tbl_route_exchange_invoice_details')->insert($save_data2);
		    }	
		  
		foreach($request['Return'] as $key)
		    {
			   
			 $save_data3=array(
							   'material_id'              =>$key['material_id'],
							   'uom_id'                   =>$key['uom_id'],
							   'quantity'                 =>$key['quantity'],
							   'amount'                   =>$key['amount'],
							   'header_id'                =>$header_id,
							   'total_amount'             =>$key['total_amount'],
							   'return_type_id'           =>$key['return_type_id'],
							   'return_reason_id'         =>$key['return_reason_id'],
							   'created_at'               =>$ldate,
							);
			 $details2= DB::table('tbl_route_exchange_return_details')->insert($save_data3);
		    }	
			
	    if($details2)
			{
			 return array('API_Status' => 1, 'Message' => "Data Inserted"); 
			}
		else
			{ 
			 return array('API_Status' => 0, 'Message' => "Data Not Inserted");
			} 
    }
   public function save_outstanding(Request $request)
    {
	    $ldate=date('Y-m-d H:i:s');
		$save_data=array(
						  'salesman_id'           =>$request->salesman_id,
						  'customer_id'           =>$request->customer_id,
						  'region'                =>$request->region,
						  'subregion'             =>$request->subregion,
						  'warehouse_id'          =>$request->warehouse_id,
						  'route_id'              =>$request->route_id,
						  'amount_paid'           =>$request->amount_paid,
						  'amount_outsatnding'    =>$request->amount_outsatnding,
						  'total_invoice_amount'  =>$request->total_invoice_amount,
						  'due_date'              =>$request->due_date,
						  'created_at'            =>$ldate
						);
	    $details=DB::table('tbl_outstanding_details')->insertGetId($save_data);
		if($details !='')
		{
		  return array('API_status'=>1, 'Message'=>'Data Inserted');
		}
		else
		{
		  return array('Result'=>[],'API_status'=>0, 'Message'=>'Data Not Inserted');
		}
    } 
   public function route_collection_save(Request $request)
    {    
		$current = Carbon::now(); 
		$newDate = date("d-m-Y");
		$save_data=array(
						 
						 'route_id'                         =>  $request->route_id,
						 'customer_id'                      =>  $request->customer_id,
						 'trading_center_id'                =>  $request->trading_center_id,
						 'warehouse_id'                     =>  $request->warehouse_id,
						 'collection_type'                  =>  $request->collection_type,
						 'collection_number'                =>  $request->collection_number, 
						 'cheque_number'                    =>  $request->cheque_no, 
						 'cheque_date'                      =>  $request->cheque_date,
						 'bank_name'                        =>  $request->bank_name,
						 'account_number'                   =>  $request->account_no,
						 'branch_name'                      =>  $request->branch_name,
						 'created_at'                       => $current,
						);

		$header_id =DB::table('tbl_route_collection_header')->insertGetId($save_data);
		   
		foreach($request['Item'] as $key => $n)
		    {
		     if($request['Item'][$key]['paid_amount']!=0)
			    {
				 $total_outstanding_amount =DB::table('tbl_outstanding_details')
					   ->where('tbl_outstanding_details.id','=',$request['Item'][$key]['out_id'])
					   ->get();
					
				 $total_outstanding= $total_outstanding_amount[0]->total_invoice_amount;	
				
				 $data=OutstandingDetailsModels::find($request['Item'][$key]['out_id']);
				 
				 $data->increment('amount_paid',$request['Item'][$key]['paid_amount']);
				 $data->decrement('amount_outsatnding',$request['Item'][$key]['paid_amount']);
				 $data->save();
				
				 $s= $data->amount_outsatnding;
		               
		            
		   
				 $data2=array
							(
							 'header_id'             =>   $header_id,
							 'invoice_id'            =>   $request['Item'][$key]['invoice_id'],
							 'invoice_no'            =>   $request['Item'][$key]['invoice_number'],
							 'outstanding_amt'       =>   $s,
							 'total_outstanding'     =>   $total_outstanding,
							 'paid_amt'              =>   $request['Item'][$key]['paid_amount'],
							 'created_at'            =>   $current,
							);
				 if($s < 1)
					{
					  OutstandingDetailsModels::find($request->out_id[$key])->delete();
					   
					}
				}
			 $details= DB::table('tbl_route_collection_details')->insert($data2);
			}	
	    if($details)
		    {
		     return array('Result'=>[], 'API_Status' => 1, 'Message' => "Data Inserted");
		    } 
	    else
		    {
			 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Data Not Inserted");
			} 
    }


//ROUTE GET API
   public function load_request_list($route_id,$salesman_id)
    {  
		$fields = array();
		$return_data1 = array();
        $today = Carbon::now()->format('Y-m-d'); 
        $get_data=DB::table('tbl_route_salesmanload_header') 
	        ->select('tbl_route_salesmanload_header.id',
					 'tbl_route_salesmanload_header.route_id',
					 'tbl_route_salesmanload_header.salesman_id',
					 'tbl_route_salesmanload_header.load_date',
					 'tbl_route_salesmanload_header.load_number',
					 'tbl_route_salesmanload_header.warehouse_id',
					 'tbl_route_salesmanload_header.currency',
					 'tbl_route_salesmanload_header.status',
					 'tbl_route_salesmanload_header.total_load_value',
				    )
			->where('tbl_route_salesmanload_header.route_id','=',$route_id)
			->where('tbl_route_salesmanload_header.salesman_id','=',$salesman_id)
			->whereBetween(DB::raw("(STR_TO_DATE(tbl_route_salesmanload_header.load_date,'%Y-%m-%d'))"),[$today,$today])
			->get(); 
		
	    if($get_data!='')
	        {		
	         foreach($get_data as $key => $details)	
		        {
				  if($get_data[$key]->status!='pending')
					{
					 $return_data1[$key]['id']               = $get_data[$key]->id;
					 $return_data1[$key]['route_id']         = $get_data[$key]->route_id;
					 $return_data1[$key]['salesman_id']      = $get_data[$key]->salesman_id;
					 $return_data1[$key]['load_date']        = $get_data[$key]->load_date;
					 $return_data1[$key]['load_number']      = $get_data[$key]->load_number;
					 $return_data1[$key]['warehouse_id']     = $get_data[$key]->warehouse_id;
					 $return_data1[$key]['currency']         = $get_data[$key]->currency;
					 $return_data1[$key]['status']           = $get_data[$key]->status;
					 $return_data1[$key]['total_load_value'] = $get_data[$key]->total_load_value;
			
					 $get_material_data=DB::table('tbl_route_salesmanload_details')
					    ->leftJoin('tbl_material_master','tbl_route_salesmanload_details.material_id', '=', 'tbl_material_master.id')
					    ->leftJoin('tbl_unit_of_measurement','tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
					    ->select('tbl_route_salesmanload_details.id',
								 'tbl_route_salesmanload_details.header_id',
								 'tbl_route_salesmanload_details.material_id',
								 'tbl_route_salesmanload_details.uom_id',
								 'tbl_route_salesmanload_details.quantity',
								 'tbl_route_salesmanload_details.price',
								 'tbl_route_salesmanload_details.total',
								 'tbl_material_master.material_code',
								 'tbl_material_master.material_name',
								 'tbl_unit_of_measurement.unit_notation' 
								)
						->where('tbl_route_salesmanload_details.header_id','=',$get_data[$key]->id)
						->get(); 
			
					 if($get_material_data!='')	
					    {
						 foreach($get_material_data as $key1 => $load_details1)	
						    {
							
							 $fields[$key1] = 
							   array(  //this array must be created dynamic 
								     'material_id' => $get_material_data[$key1]->material_id,
								     'material_name' => $get_material_data[$key1]->material_name,
								     'material_code' => $get_material_data[$key1]->material_code,
								     'uom_id' => $get_material_data[$key1]->uom_id,
								     'uom_name' => $get_material_data[$key1]->unit_notation,
								     'quantity' => $get_material_data[$key1]->quantity,
								     'price' => $get_material_data[$key1]->price,
								     'total' => $get_material_data[$key1]->total,
                                    );
							} 
						}
			
					 $return_data1[$key]['material'] = $fields;
					 $fields=array(); 
					} 
	            }
	        }	
	    if($get_data !='')
		{  
		  return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Load Details");
		}
	   else
		{
		 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Something went wrong");
		}
    }
   public function delivery_details()
    {
	    $fields = array();
		$return_data1 = array();
        $get_data=DB::table('tbl_route_delivery_header as rd')
	        ->select(
					  'rd.id',
					  'rd.route_delivery_number',
					  'rd.salesman_id',
					  'rd.warehouse_id',
					  'rd.order_date',
					  'rd.customer_id',
					  'rd.route_id',
					  'rd.region_id',
					  'rd.subregion_id',
					  'rd.trading_center_id',
					  'rd.currency_id',
					  'rd.total_gross',
					  'rd.total_vat',
					  'rd.net_total_amount',
					  'rd.total_discount',
					  'rd.total_order_value',
					  'rd.order_type',
					  'rd.order_number',
			        )
		    ->get(); 
		 if($get_data!='')
	        {	
	   
	         foreach($get_data as $key => $details)	
		        {
			
			      if($get_data[$key]->status='active')
				    {
							
						$return_data1[$key]['id']                     = $get_data[$key]->id;
						$return_data1[$key]['route_delivery_number']  = $get_data[$key]->route_delivery_number;
						$return_data1[$key]['salesman_id']            = $get_data[$key]->salesman_id;
						$return_data1[$key]['warehouse_id']           = $get_data[$key]->warehouse_id;
						$return_data1[$key]['order_date']             = $get_data[$key]->order_date;
						$return_data1[$key]['customer_id']            = $get_data[$key]->customer_id;
						$return_data1[$key]['route_id']               = $get_data[$key]->route_id;
						$return_data1[$key]['region_id']              = $get_data[$key]->region_id;
						$return_data1[$key]['subregion_id']           = $get_data[$key]->subregion_id;
						$return_data1[$key]['trading_center_id ']     = $get_data[$key]->trading_center_id;
						$return_data1[$key]['currency_id']            = $get_data[$key]->currency_id;
						$return_data1[$key]['total_gross']            = $get_data[$key]->total_gross;
						$return_data1[$key]['total_vat']              = $get_data[$key]->total_vat;
						$return_data1[$key]['net_total_amount']       = $get_data[$key]->net_total_amount;
						$return_data1[$key]['total_discount']         = $get_data[$key]->total_discount;
						$return_data1[$key]['total_order_value']      = $get_data[$key]->total_order_value;
						$return_data1[$key]['order_type']             = $get_data[$key]->order_type;
						$return_data1[$key]['order_number']           = $get_data[$key]->order_number;
						
						$get_material_data=DB::table('tbl_route_delivery_details')
						 
						->get(); 
			
					 if($get_material_data!='')
					    {
						  
						 foreach($get_material_data as $key1 => $load_details1)	
						    {
							
							 $fields[$key1] = 
							 array( //this array must be created dynamic 
								  'material_id'     => $get_material_data[$key1]->material_id,
								  'uom_id'          => $get_material_data[$key1]->uom_id,
								  'quantity'        => $get_material_data[$key1]->quantity,
								  'header_id'       => $get_material_data[$key1]->header_id,
								  'unite_price'     => $get_material_data[$key1]->unite_price,
								  'gross_total'     => $get_material_data[$key1]->gross_total,
								  'vat'             => $get_material_data[$key1]->vat,
								  'net_amount'      => $get_material_data[$key1]->net_amount,
								  'discount'        => $get_material_data[$key1]->discount,
								  'discount_id'     => $get_material_data[$key1]->discount_id,
								  'total'           => $get_material_data[$key1]->total,
								  'base_qty'        => $get_material_data[$key1]->base_qty,
								  
								);
							} 
						}
			
					 $return_data1[$key]['material'] = $fields;
					 $fields=array();
		            } 
	            }
	        }	
	    if($get_data !='')
	    {  
		  return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Delivery Details");
	    }
	    else
	    {
		 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Delivery Details NOt Found");
	    }
    }
   public function route_exchange_details()
    {
	    $fields = array();
		$return_data1 = array();
        $get_data=DB::table('tbl_route_exchange_header as rd')
	            ->leftJoin('tbl_customer','rd.customer_id','=','tbl_customer.id') 
	            ->leftJoin('tbl_salesman','rd.salesman_id','=','tbl_salesman.id') 
	            ->leftJoin('tbl_warehouse','rd.warehouse_id','=','tbl_warehouse.id') 
	            ->leftJoin('tbl_route','rd.route_id','=','tbl_route.id') 
	            ->select(
				          'rd.id',
						  'rd.exchange_number',
						  'rd.exchange_date',
						  'rd.exchange_amount',
						  'rd.customer_id',
						  'tbl_customer.customer_name',
						  'rd.salesman_id',
						  'tbl_salesman.salesman_name',
						  'rd.warehouse_id',
						  'tbl_warehouse.warehouse_name',
						  'rd.route_id',
						  'rd.invoice_code',
						  'rd.return_code',
						  'rd.amount',
						)
				->get(); 
				
		if($get_data!='')
	    {	
	   
	       foreach($get_data as $key => $details)	
		    {
				
				$return_data1[$key]['id']                               = $get_data[$key]->id;
				$return_data1[$key]['exchange_number']                  = $get_data[$key]->exchange_number;
				$return_data1[$key]['exchange_date']                    = $get_data[$key]->exchange_date;
				$return_data1[$key]['exchange_amount']                  = $get_data[$key]->exchange_amount;
				$return_data1[$key]['customer']                         = $get_data[$key]->customer_name;
				$return_data1[$key]['customer_id']                      = $get_data[$key]->customer_id;
				$return_data1[$key]['salesman']                         = $get_data[$key]->salesman_name;
				$return_data1[$key]['salesman_id']                      = $get_data[$key]->salesman_id;
				$return_data1[$key]['warehouse']                        = $get_data[$key]->warehouse_name;
				$return_data1[$key]['warehouse_id']                     = $get_data[$key]->warehouse_id;
				$return_data1[$key]['route_id']                         = $get_data[$key]->route_id;
				$return_data1[$key]['invoice_code']                     = $get_data[$key]->invoice_code;
				$return_data1[$key]['return_code']                      = $get_data[$key]->return_code;
				$return_data1[$key]['amount']                           = $get_data[$key]->amount;
				
				
			 $get_material_data=DB::table('tbl_route_exchange_invoice_details as exchange_invoice')
							   ->leftJoin('tbl_material_master','exchange_invoice.material_id','=','tbl_material_master.id') 
							   ->leftJoin('tbl_unit_of_measurement','exchange_invoice.uom_id','=','tbl_unit_of_measurement.id') 
							   ->get(); 
				
			 if($get_material_data!='')
				{
				 foreach($get_material_data as $key1 => $load_details1)	
					{
					
					 $fields[$key1] = 
					  array( //this array must be created dynamic 
						  'material_id'       => $get_material_data[$key1]->material_id,
						  'material'          => $get_material_data[$key1]->material_name,
						  'uom_id'            => $get_material_data[$key1]->uom_id,
						  'uom'               => $get_material_data[$key1]->unit_notation,
						  'quantity'          => $get_material_data[$key1]->quantity,
						  'header_id'         => $get_material_data[$key1]->header_id,
						  'amount'            => $get_material_data[$key1]->amount,
						  'total_amount'      => $get_material_data[$key1]->total_amount,
						  );
						
					}
				}
				
			 $material_data=DB::table('tbl_route_exchange_return_details as exchange_return')
					   ->leftJoin('tbl_material_master','exchange_return.material_id','=','tbl_material_master.id') 
					   ->leftJoin('tbl_unit_of_measurement','exchange_return.uom_id','=','tbl_unit_of_measurement.id') 
					   ->leftJoin('tbl_reason_type','exchange_return.return_reason_id','=','tbl_reason_type.id') 
					   ->get(); 
				
			   if($material_data!='')
				{
				 foreach($material_data as $key2 => $load_details1)	
					{
					 $fields2[$key2] = 
					 array( //this array must be created dynamic 
						  'material_id'       => $material_data[$key2]->material_id,
						  'material'          => $material_data[$key2]->material_name,
						  'uom_id'            => $material_data[$key2]->uom_id,
						  'uom'               => $material_data[$key2]->unit_notation,
						  'quantity'          => $material_data[$key2]->quantity,
						  'header_id'         => $material_data[$key2]->header_id,
						  'amount'            => $material_data[$key2]->amount,
						  'total_amount'      => $material_data[$key2]->total_amount,
						  'return_type_id'    => $material_data[$key2]->return_type_id,
						  'return_reason_id'  => $material_data[$key2]->return_reason_id,
						  'reasion_type'      => $material_data[$key2]->reasion_type,
						);
					} 
				}
				
			 $return_data1[$key]['return'] = $fields2;
			 $return_data1[$key]['invoice'] = $fields;
				
			 $fields=array();
			   
				
			}
	    }	
	         if($get_data !='')
	           {  
                return array('Result'=>$return_data1, 'API_Status' => 1, 'Message' => "Route Exchange Details");
               }
			   else
			   {
                return array('Result'=>[], 'API_Status' => 0, 'Message' => " Details NOt Found");
               }
    }
   public function route_outstanding_details($route_id)
	{
		$fields = array();
		$return_data1 = array();
	
	    $get_data=DB::table('tbl_outstanding_details as rd')
	            ->select(DB::raw("SUM(rd.amount_outsatnding) as total_amount_outsatnding"),
						  'rd.customer_id',
						  'rd.route_id',
						 )
				->where('rd.route_id',$route_id)
				->groupBy('rd.customer_id')
				->get();
					
		if($get_data!='')
	    {	
	      foreach($get_data as $key => $details)	
		    {
			 $return_data1[$key]['customer_id']                      = $details->customer_id;
			 $return_data1[$key]['route_id']                         = $details->route_id;
			 $return_data1[$key]['total_amount_outsatnding']                         = $details->total_amount_outsatnding;
				
	         $customer_outstanding=DB::table('tbl_outstanding_details')
			 ->where('customer_id','=',$details->customer_id)
			 ->get();
		     if($customer_outstanding!='')
		        {
			  
		  	     foreach($customer_outstanding as $key1 => $load_details1)	
		            {
				
				     $fields[$key1] = 
                     array( //this array must be created dynamic 
						  'outstanding_id'           => $customer_outstanding[$key1]->id,
						  'salesman_id'              => $customer_outstanding[$key1]->salesman_id,
						  'customer_id'              => $customer_outstanding[$key1]->customer_id,
						  'warehouse_id'             => $customer_outstanding[$key1]->warehouse_id,
						  'route_id'                 => $customer_outstanding[$key1]->route_id,
						  'invoice_id'               => $customer_outstanding[$key1]->invoice_id,
						  'remaining_outstanding'    => $customer_outstanding[$key1]->amount_outsatnding,
						  'total_paid_amount'        => $customer_outstanding[$key1]->amount_paid,
						  'total_outstanding'        => $customer_outstanding[$key1]->total_invoice_amount,
						  
						);
			        } 
			     $return_data1[$key]['get_outstanding_customer_wise'] = $fields;
		         $fields=array();
			    }
		    } 
	         if($get_data !='')
	            {  
                 return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Collection Details");
                }
			   else
			   {
                 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Collection Details NOt Found");
                }
        } 
	 
   
	}
   public function route_collection_list()
	{
	    $fields = array();
		$return_data1 = array();
	    $get_data=DB::table('tbl_route_collection_header as rd')
	            ->select(
				          'rd.id',
						  'rd.collection_number',
						  'rd.warehouse_id',
						  'rd.customer_id',
						  'rd.route_id',
						  'rd.trading_center_id',
						  'rd.collection_type',
						  'rd.cheque_number',
						  'rd.bank_name',
						  'rd.account_number',
						  'rd.branch_name',
	                    )
				->get(); 
		if($get_data!='')
	    {	
	       foreach($get_data as $key => $details)	
		    {
			
				
			 $return_data1[$key]['id']                               = $details->id;
			 $return_data1[$key]['collection_number']            = $details->collection_number;
			 $return_data1[$key]['warehouse_id']                     = $details->warehouse_id;
			 $return_data1[$key]['customer_id']                      = $details->customer_id;
			 $return_data1[$key]['route_id']                         = $details->route_id;
			 $return_data1[$key]['trading_center_id ']               = $details->trading_center_id;
			 $return_data1[$key]['collection_type']                      = $details->collection_type;
			 $return_data1[$key]['cheque_number']                      = $details->cheque_number;
			 $return_data1[$key]['bank_name']                        = $details->bank_name;
			 $return_data1[$key]['account_number']                 = $details->account_number;
			 $return_data1[$key]['branch_name']                   = $details->branch_name;
			
			
	
			 $get_material_data=DB::table('tbl_route_collection_details')
			 ->where('header_id','=',$details->id)
			 ->get(); 
			
		     if($get_material_data!='')
		        {
			  
				 foreach($get_material_data as $key1 => $load_details1)	
				    {
				
				     $fields[$key1] = 
                     array( //this array must be created dynamic 
						  'header_id'                => $get_material_data[$key1]->header_id,
						  'invoice_no'               => $get_material_data[$key1]->invoice_no,
						  'invoice_id'               => $get_material_data[$key1]->invoice_id,
						  'outstanding_amt'          => $get_material_data[$key1]->outstanding_amt,
						  'paid_amt'                 => $get_material_data[$key1]->paid_amt,
						  'total_outstanding'        => $get_material_data[$key1]->total_outstanding,
						  
				        );
			        } 
				 $return_data1[$key]['details'] = $fields;
		         $fields=array();
		        }
			} 
	    }
	  	
	    if($get_data !='')
	    {  
		 return array('Result'=>$return_data1 , 'API_Status' => 1, 'Message' => "Route Collection Details");
	    }
	    else
	    {
		 return array('Result'=>[], 'API_Status' => 0, 'Message' => "Route Collection Details NOt Found");
	    }
    } 
}
