<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\UserModel;
use App\Models\UserRoleModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\CompanyModel;
use Illuminate\Support\Facades\DB;
use Session;
use App\Models\ManageCodeModel;

class UserController extends Controller
 {
   public function list()
    {
		$get_data = UserModel::all()->sortByDesc('id');		
		$get_data = DB::table('tbl_user')
		->leftJoin('tbl_user_role', 'tbl_user.user_role', '=', 'tbl_user_role.id')
		->leftJoin('tbl_company', 'tbl_user.company_name', '=', 'tbl_company.id')
		->select('tbl_user.*', 'tbl_user_role.role_name','tbl_company.company_name')
		->orderBy('id', 'DESC')->get();

	    return view('User & Role Configuration.user_list',compact('get_data'));
    }
	
	
   public function view($id) 
	{    
	    // $get_data=UserModel::find($id);
		$get_data = DB::table('tbl_user')
		->leftJoin('tbl_user_role', 'tbl_user.user_role', '=', 'tbl_user_role.id')
		->leftJoin('tbl_company', 'tbl_user.company_name', '=', 'tbl_company.id')
		->leftJoin('tbl_region', 'tbl_user.region', '=', 'tbl_region.id')
		
		->select('tbl_user.*', 'tbl_user_role.role_name','tbl_company.company_name as comp','tbl_region.region_code','tbl_region.region_name')
		->where('tbl_user.id', '=', $id)
		->get()->first();
		//dd($get_data->sub_region);
		
		$subregion = DB::select('SELECT t2.id, t2.sub_region_code,t2.sub_region_name FROM tbl_user as t1 LEFT JOIN  tbl_sub_region as t2 ON find_in_set(t2.id, 
			t1.sub_region) WHERE t1.`id`='.$id.'');
			
		$warehouse = DB::select('SELECT t2.id, t2.warehouse_code,t2.warehouse_name FROM tbl_user as t1 LEFT JOIN  tbl_warehouse as t2 ON find_in_set(t2.id, 
			t1.warehouse) WHERE t1.`id`='.$id.'');		
		
	   return view('Master_Configuration.user_view',compact('get_data','subregion','warehouse'));
     }
	
	public function add()
     { 
		$result =UserModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->user_code;
		  }
		else
		  {
			 $getcode = $result->user_code; 
			 $last_code = ++$getcode;
		  } 
			 $user_role = UserRoleModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 $company_name = CompanyModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			
			 //dd($company_name);
			 return view('Master_Configuration.user',compact('last_code','user_role','company_name','region'));
      }  
	
	 public function edit($id)
      {
		  $get_data=UserModel::find($id);	
	 
		  $last_code = $get_data->user_code;
		  $user_role = UserRoleModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $company_name = CompanyModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		  $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
				
		  $subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');

		

	      return view('Master_Configuration.user',compact('get_data','last_code','user_role','company_name','region','subregion','warehouse'));
     }
	
    public function save(Request $request)
     {	
		 
          $subregion_ides = implode(',', $request->sub_region);
          $warehouse_ides = implode(',', $request->warehouse_name);
		
		  $user_image=$request->file('user_profile_pic');
		  if($user_image)
			{
				$data=new UserModel;

				$filenameWithExt = $request->file('user_profile_pic')->getClientOriginalName();
				// Get just filename
				$filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);            
				// Get just ext
				$extension = $request->file('user_profile_pic')->getClientOriginalExtension();
				//Filename to store
				$fileNameToStore = $filename.'_'.time().'.'.$extension;                       
				// Upload Image
				$path = $request->file('user_profile_pic')->    storeAs('public/user', $fileNameToStore);
			}
		  else
			{
			  $old_path = UserModel::find($request->updated_id);
			  $path= $old_path->user_profile_pic;
			}		   
					
		  if($request->updated_id) 
		    {					
				$data = UserModel::find($request->updated_id);
				$data->user_role=$request->user_role;
				$data->user_code=$request->user_code;
				$data->user_name=$request->user_name;
				$data->user_password=md5($request->user_password);
				
				$data->first_name=$request->first_name;
				$data->last_name=$request->last_name;
				$data->city=$request->city;
				
				$data->zip=$request->zip;
				$data->region=$request->region;
				$data->sub_region=$subregion_ides;
				$data->warehouse=$warehouse_ides;
				$data->address=$request->address;
					
					
				$data->email=$request->email;
				
				$data->contact_no=$request->contact_no;
				$data->user_profile_pic=$path;
				 $data->company_name=$request->company_name;
				//$data->block_check=$request->block_check;
				$data->block_to=$request->block_to;
				$data->block_from=$request->block_from;
				$data->updated_user= Session::get('user_id');
				$data->company_id= Session::get('company_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('user_list'))->with('successMessage','User Updated Successfully');
			
			} else 
				{   
					$data->user_role=$request->user_role;
					$data->user_code=$request->user_code;
					$data->user_name=$request->user_name;
					$data->user_password=md5($request->user_password);
					$data->email=$request->email;
					
					$data->first_name=$request->first_name;
					$data->last_name=$request->last_name;
					$data->city=$request->city;
					
					$data->zip=$request->zip;
					$data->region=$request->region;
					$data->sub_region=$subregion_ides;
					$data->warehouse=$warehouse_ides; 
					$data->address=$request->address;
					
					$data->contact_no=$request->contact_no;
					$data->user_profile_pic=$path;
					 $data->company_name=$request->company_name;
					//$data->block_check=$request->block_check;
					$data->block_to=$request->block_to;
					$data->block_from=$request->block_from;
					$data->created_user= Session::get('user_id');
					$data->company_id= Session::get('company_id');
					$data->status=$request->status;
					$data->save();
					return redirect(route('user_list'))->with('successMessage','User Added Successfully');				
			    }	    	
       }
		 
	  public function get_subregion($id, $subregion_id)
	   {
		
			$get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $id)->where('status', '=', 'active');
			//dd($get_data);
			
			$sub = explode(",",$subregion_id);
				
		  foreach($get_data as $subregionname)
		    {
			   ?>
			   <option value="<?php echo $subregionname->id ?>" <?php if($subregionname->id ==in_array($subregionname->id,$sub)) { echo "selected"; } ?> ><?php echo $subregionname->sub_region_code." - ".$subregionname->sub_region_name; ?></option>	
			   <?php		
		     }
	
		 //return response()->json($get_data);
		
	   }
    
	  public function get_distibutors($id, $distibutors_id)
	   {
		
		 $get_data= DB::select("SELECT * FROM tbl_warehouse where sub_region in(".$id.") AND status='active'");
				
		 $warehouse1 = explode(",",$distibutors_id);	
		 foreach($get_data as $subregionname)
		   {
				?>
				<option value="<?php echo $subregionname->id ?>" <?php if($subregionname->id == in_array($subregionname->id,$warehouse1)) { echo "selected"; } ?> ><?php echo $subregionname->warehouse_code." - ".$subregionname->warehouse_name; ?></option>	
				<?php		
		   }
		
		 //return response()->json($get_data);
		
	   }
    
 }



