<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\VehicleModel;
use App\Models\VehicleTypeModel;
use App\Models\ManageCodeModel;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;

class VehicleController extends Controller
 { 
   public function list()
    {

		//$get_data = VehicleModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_vehicle')
		->leftJoin('tbl_warehouse', 'tbl_vehicle.warehouse_id', '=', 'tbl_warehouse.id')
		 ->leftJoin('tbl_vehicle_type', 'tbl_vehicle.type', '=', 'tbl_vehicle_type.id')
		
		->select('tbl_vehicle.*', 'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_vehicle_type.vehicle_type_name','tbl_vehicle_type.vehicle_type_code')
		->orderBy('id', 'DESC')->get();
		
		//dd($get_data);
	    return view('Master_Configuration.vehicle_list',compact('get_data'));
    }
	
   public function add()
    { 	
	    $result =VehicleModel::get()->sortByDesc('id')->first();
	    if($result=='')
	      {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->vehicle_code;				
			$get_erp_asset_code = ManageCodeModel::where('id', 1)->first();
			$last_code_erp_asset = $get_erp_asset_code->erp_asset_code;
		  }
		else
		  {
			 $getcode = $result->vehicle_code; 
			 $last_code = ++$getcode;			 
			 $get_erp_asset_code = $result->erp_asset_code; 
			 $last_code_erp_asset = ++$get_erp_asset_code;			 
		  }
	
			 $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
			 $vehicletype =VehicleTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 return view('Master_Configuration.vehicle',compact('warehouse','vehicletype','last_code','last_code_erp_asset'));
     }
	
	public function vehicle_view($id)
     {
		   //$get_data=VehicleModel::find($id);		
		   $get_data = DB::table('tbl_vehicle')
		   ->leftJoin('tbl_warehouse', 'tbl_vehicle.warehouse_id', '=', 'tbl_warehouse.id')
		   ->leftJoin('tbl_vehicle_type', 'tbl_vehicle.type', '=', 'tbl_vehicle_type.id')
		 
		   ->select('tbl_vehicle.*', 'tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_vehicle_type.vehicle_type_code','tbl_vehicle_type.vehicle_type_name')
		   ->where('tbl_vehicle.id', '=', $id)
		   ->first();
	
           return view('Master_Configuration.vehicle_view',compact('get_data'));
     }
	
    public function edit($id)
     {
		  $get_data=VehicleModel::find($id);
		  $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
		  $vehicletype =VehicleTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $last_code = $get_data->vehicle_code;
		  $last_code_erp_asset=$get_data->erp_asset_code;
		
		  return view('Master_Configuration.vehicle',compact('get_data','warehouse','vehicletype','last_code','last_code_erp_asset'));
     }
	
    public function save(Request $request)
     {	
		 $data=new VehicleModel;			
		 if($request->updated_id)
		   {			
				$data = VehicleModel::find($request->updated_id);		
				$data->vehicle_code=$request->vehicle;
				$data->vehicle_number=$request->vehicle_number;
				$data->brand=$request->brand;
				$data->type=$request->type;
				$data->capacity=$request->capacity;
				$data->vehicle_owner=$request->vehicle_owner;
				$data->vehicle_chechis_number=$request->vehicle_chechis_number;
				$data->tank_capacity=$request->tank_capacity;
				$data->vehicle_mileage=$request->vehicle_mileage;
				$data->warehouse_id=$request->warehouse_id;
				$data->erp_asset_code=$request->erp_asset_code;
				$data->company_id= Session::get('company_id');
				$data->updated_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('vehicle_list'))->with('successMessage','Vehicle Updated Successfully');			
		   }
		 else 
		   {
				$data->vehicle_code=$request->vehicle;
				$data->vehicle_number=$request->vehicle_number;
				$data->brand=$request->brand;
				$data->type=$request->type;
				$data->capacity=$request->capacity;
				$data->vehicle_owner=$request->vehicle_owner;
				$data->vehicle_chechis_number=$request->vehicle_chechis_number;
				$data->tank_capacity=$request->tank_capacity;
				$data->vehicle_mileage=$request->vehicle_mileage;
				$data->warehouse_id=$request->warehouse_id;
				$data->erp_asset_code=$request->erp_asset_code;
				$data->company_id= Session::get('company_id');
				$data->created_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('vehicle_list'))->with('successMessage','Vehicle Added Successfully');			
		   }	
    	
     }
 }

