<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\SupplierModel;
use App\Models\PurchaseOutstandingModel;
use App\Models\ManageCodeModel;
use App\Exports\PurchaseVendorPaymentExport;
use App\Exports\PurchaseVendorPaymentExportPdf;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Session;


class VendorPaymentController extends Controller
{
    //
    public function list(Request $request){

		$suppliers = SupplierModel::all()->sortByDesc('id')->where('status', '=', 'active');
	    $current_date=date("Y-m-d");	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		   }
  
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
	 
		if($request->supplier!='')
		  {
			$where .= "AND supplier.id = '".$request->supplier."'";
		  }
		  
		  
		
		$result = DB::select("SELECT riheader.id, 
		riheader.vendor_payment_code,
		riheader.collection_type,
		supplier.supplier_name,
		riheader.created_at
		
			
		FROM vendor_payment_header as riheader					
		
		LEFT JOIN tbl_supplier as supplier on riheader.supplier_id = supplier.id				
		
		WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");


        // $result = DB::table('vendor_payment_header')
        //         ->leftJoin('vendor_payment_details', 'vendor_payment_header.id', '=', 'vendor_payment_details.header_id')
        //         ->leftJoin('tbl_supplier', 'vendor_payment_header.supplier_id', '=', 'tbl_supplier.id')
        //         ->select('tbl_supplier.supplier_name',
        //                 'vendor_payment_header.collection_type',
        //                 'vendor_payment_details.due_date',
        //                 'vendor_payment_header.vendor_payment_code',
        //                 'vendor_payment_header.id'

        //         )
        //         ->get()->all();

		  
		  
        return view('Purchase_Transaction.vendor_payment_list',compact('suppliers','result'));

    }

    public function add(){

        $result = DB::table('vendor_payment_header')
		 ->select('vendor_payment_header.*')->get()->sortByDesc('id')->first();
	 
		if($result=='')
	      {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->purchase_collection_code;
		  }
	    else
		  {
			 $getcode = $result->vendor_payment_code; 
			 $last_code = ++$getcode;
		   }
        
        $suppliers = SupplierModel::all()->sortByDesc('id')->where('status', '=', 'active');

        
        $outstanding = DB::table('tbl_purchase_outstanding')
        ->select(DB::raw('sum(tbl_purchase_outstanding.amount_outstanding)'))
        ->select('tbl_purchase_outstanding.invoice_id')
        ->select('tbl_purchase_outstanding.due_date')
        ->select('tbl_purchase_outstanding.due_date')

        ->select('tbl_purchase_outstanding.created_at')
        
        ->get();
       
        
        return view('Purchase_Transaction.vendor_payment',compact('suppliers','last_code'));
    }

    public function save(Request $request)
    { 	
        $total_outstanding= array();
		$total_credit1= array();
		$count=0;
		$count1=0;
		$flag='';
		
		  $current = Carbon::now();
		  $flag='';		 
		  $user_id=Session::get('user_id');			
		
			  
				 $data3=array
				(
				 'supplier_id'      =>  $request->supplier,
                 'vendor_payment_code'        =>  $request->collection_number,
				 'collection_type'        =>  $request->collection_type,
				 'cheque_no'              =>  $request->cheque_number,
				 'cheque_date'            =>  $request->cheque_date,
				 'bank_name'              =>  $request->bank_name,
				 'account_no'             =>  $request->account_number,
				 'branch_name'              =>  $request->branch_name,
				 'created_at'             =>  $current,
				 'created_user'             =>  $user_id,
				);
			
			   $header_id =DB::table('vendor_payment_header')->insertGetId($data3);
               
         foreach($request['outstanding'] as $key => $n)
		     {
				  if($request->paid_now[$key]!=0)
			       {
				     $data=PurchaseOutstandingModel::find($request->out_id[$key]);
				     $data->increment('amount_paid',$request->paid_now[$key]);
				     $data->decrement('amount_outstanding',$request->paid_now[$key]);
				     $data->save();
				     $s= $data->amount_outstanding;
					                $data2=array
									(
										 'due_date'      => $request->due_date[$key ],
										 'header_id'       => $header_id,
										 'invoice_number'      => $request->invoice_number[$key ],
										 'outstanding_amt'  =>  $data->amount_outstanding,
										 'total_outstanding'  => $request->total_outstanding[$key ],
										 'paid_amount'        => $request->paid_now[$key ],
										 'created_at'      => $current,
									 );
								   DB::table('vendor_payment_details')->insert($data2); 
				           if($s < 1)
				           {
                            PurchaseOutstandingModel::find($request->out_id[$key])->delete();
					           
				          }
				    }
			 
			 }
             return redirect(route('vendor_payment_list'))->with('successMessage',$request->collection_number.' '.'Collection Save Successfully');
    }

    public function outstanding_details($supplier_id){
            $suppliers = SupplierModel::all()->sortByDesc('id')->where('status', '=', 'active');

            $total_outstanding =  PurchaseOutstandingModel::where('supplier_id',$supplier_id)->sum('amount_outstanding');

            // $total_outstanding_details = PurchaseOutstandingModel::all()->sortByDesc('id')->where('supplier_id', '=', $supplier_id);
            

            $total_outstanding_details = DB::table('tbl_purchase_outstanding')
                                        ->leftJoin('tbl_supplier','tbl_purchase_outstanding.supplier_id','=','tbl_supplier.id')
                                        ->select('tbl_purchase_outstanding.*','tbl_supplier.supplier_name')
                                        ->where('tbl_purchase_outstanding.supplier_id','=',$supplier_id)
                                        ->get();

              $result = DB::table('vendor_payment_header')
		 ->select('vendor_payment_header.*')->get()->sortByDesc('id')->first();
	 
		if($result=='')
	      {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->purchase_collection_code;
		  }
	    else
		  {
			 $getcode = $result->vendor_payment_code; 
			 $last_code = ++$getcode;
		   }

            return view('Purchase_Transaction.vendor_payment',compact('total_outstanding','total_outstanding_details','suppliers','last_code'));
    }

    public function view($id){

		$get_data =DB::table('vendor_payment_header')
					->leftJoin('tbl_supplier','vendor_payment_header.supplier_id','=','tbl_supplier.id')
					->leftJoin('tbl_purchase_outstanding','vendor_payment_header.supplier_id','=','tbl_purchase_outstanding.supplier_id')
					->select('vendor_payment_header.*','tbl_supplier.supplier_name','tbl_purchase_outstanding.invoice_number')
					->where('vendor_payment_header.id','=',$id)->get()->first();

		$get_data_details = DB::table('vendor_payment_details')
					->select('vendor_payment_details.*')
					->where('vendor_payment_details.header_id','=',$id)->get()->all();
		
		
        return view('Purchase_Transaction.vendor_payment_view',compact('get_data','get_data_details'));
    }
	
	public function vendor_payment_export($id)
	 {
		return Excel::download(new PurchaseVendorPaymentExport($id),'vendor_payment.xlsx');
		
        //return response()->json($get_data);
	 } 
	 
	  public function vendor_payment_export_pdf($id)
	 {
		 
		 $user_id=Session::get('user_id'); 
		/*  $get_data =DB::table('vendor_payment_header')
		  ->leftJoin('tbl_supplier as supplier', 'tbl_invoice_verification_header.supplier_id', '=', 'supplier.id')
		   
		   
		   ->select('vendor_payment_header.*','supplier.supplier_code','supplier.supplier_name','vendor_payment_header.collection_type')
		  ->where('vendor_payment_header.id', '=',$id)->get()->first();     
			//dd($get_data);
         $get_data_details =DB::table('vendor_payment_details')
          ->select('vendor_payment_details.invoice_number','vendor_payment_details.total_outstanding','vendor_payment_details.outstanding_amt','vendor_payment_details.paid_amount','tbl_currency_type.currency_notation')
		  ->where('vendor_payment_details.header_id', '=', $id)->get()->all(); */
		 
		    $get_data =DB::table('vendor_payment_header')
		  ->leftJoin('tbl_supplier as supplier', 'vendor_payment_header.supplier_id', '=', 'supplier.id') 
		 
		  ->select('vendor_payment_header.*','supplier.supplier_name','supplier.address','supplier.email_id','supplier.contact_number','supplier.supplier_code','vendor_payment_header.collection_type','vendor_payment_header.vendor_payment_code','supplier.tin_no')->where('vendor_payment_header.id', '=',$id)->get()->first();    
		 $get_data_details =DB::table('vendor_payment_details')
          ->select('vendor_payment_details.invoice_number','vendor_payment_details.total_outstanding','vendor_payment_details.outstanding_amt','vendor_payment_details.paid_amount')
		  ->where('vendor_payment_details.header_id', '=', $id)->get()->all();
		// dd($get_data_details);
		  $pdf=PDF::loadView('export.pdf.purchase_vendor_payment_export_pdf',compact('get_data','get_data_details'));
		 
		  return $pdf->download('vendor_payment.pdf');
		 
	 }
	 
	/* public function vendor_payment_export_pdf($id)
	 {
		
		return Excel::download(new PurchaseVendorPaymentExport($id),'vendor_payment.pdf');
	
        
	    //return response()->json($get_data);
	 } */
}
