<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateCompanyModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_company', function (Blueprint $table) {
            $table->integer('id');
			$table->string('company_logo',250)->nullable();
			$table->string('company_code',120);
			$table->string('company_name',120);
			$table->integer('company_type');
			$table->integer('currency_id');
			$table->string('address',100);
			$table->integer('city_id');
			$table->integer('country_id');
			$table->integer('vat');
			$table->string('email_id',125);
			$table->bigInteger('contact_no');
			$table->string('pincode',10);
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
			$table->enum('status', ['active', 'inactive']);
            $table->timestamps();
			 
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_company');
    }
}
