<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSalesAreaModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_sales_area', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('sales_area_code',25);
			$table->string('sales_area_name',125);
			$table->integer('warehouse_id');
			$table->integer('region_id');
			$table->integer('sub_region_id');
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_sales_area');
    }
}
