<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateRouteModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_route', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('route_code',20);
			$table->string('route_name',120);
			$table->string('route_description',120);
			$table->integer('sales_area_name_id');
			$table->integer('warehouse_id');
			$table->integer('vehicle_id');
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();  
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_route');
    }
}
