<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateDiscountModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_discount', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('discount_code',25);
			$table->string('discount_name',25);
			$table->string('discount_percentage',25);
			$table->decimal('discount_amount',20,2);
			$table->string('discount_on',25);
			$table->string('distributor',25);
			$table->integer('customer_type_id');
			$table->integer('customer_category_id');
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });



    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_discount');
    }
}
