<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSupplierModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_supplier', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->integer('supplier_type_id');
			$table->string('supplier_code',20);
			$table->string('supplier_name',120);
			$table->string('tin_number',50);
			$table->integer('supplier_currency_id');
			$table->integer('payment_term');
			$table->integer('country_id');
			$table->integer('city_id');
			$table->string('address',120);
			$table->string('email_id',40);
			$table->bigInteger('contact_number');
			$table->string('bank_account_number1',20);
			$table->string('bank_account_number2',20);
			$table->string('bank_branch',20);
			$table->string('bank_name',20);
			$table->string('bank_address',20);
			$table->string('bank_code',20);
			$table->string('erp_material_code',20)->nullable();
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_supplier');
    }
}
