<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSalesmanTargetModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_salesman_target', function (Blueprint $table) {
            $table->integer('id');
            $table->string('warehouse_id',20);
            $table->string('salesman_id',25);
            $table->string('target_based_on',25)->nullable();
            $table->string('month',25);
            $table->string('year',25);
            $table->string('material_category_id',25)->nullable();
            $table->string('salesman_target',25);
            $table->string('total_sales',25)->nullable(); 
            $table->string('set_category',25)->nullable();
            $table->integer('created_user')->length(11)->nullable();
            $table->integer('updated_user')->length(11)->nullable();
            $table->timestamps();
        });
		
		Schema::create('tbl_total_sales_qty', function (Blueprint $table) {
            $table->integer('id');
			$table->string('salesman_id',20);
			$table->string('warehouse_id',20);
			$table->string('route_id',20);
			$table->string('date',20);
			$table->timestamps();
        });
		
		Schema::create('tbl_total_sales_amt', function (Blueprint $table) {
            $table->integer('id');
			$table->string('salesman_id',20);
			$table->string('warehouse_id',20);
			$table->string('route_id',20);
			$table->string('date',20);
			$table->timestamps();
        });
		
		Schema::create('tbl_total_count_qty', function (Blueprint $table) {
             $table->integer('id');
			$table->string('sales_qty_header',20);
			$table->string('category_id',20);
			$table->string('sales_qty',20);
			$table->timestamps();
        });
		
		Schema::create('tbl_total_count_amt', function (Blueprint $table) {
             $table->integer('id');
			$table->string('sales_qty_header',20);
			$table->string('category_id',20);
			$table->string('sales_amt',20);
			$table->timestamps();
        });
		
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_salesman_target','tbl_total_sales_qty','tbl_total_sales_amt','tbl_total_count_qty','tbl_total_count_amt');
    }
}