<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateCompanyStockTransferModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
   public function up()
    {
        Schema::create('tbl_company_stock_transfer_header', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('from_warehouse');
			$table->integer('transfer_warehouse');
			$table->date('transfer_date');
			$table->string('transfer_reason',100);
			$table->string('remark',100);
			$table->string('status',20);
		    $table->timestamps();
        });
		
		Schema::create('tbl_company_stock_transfer_details', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('header_id');
			$table->integer('material_id');
			$table->integer('uom_id');
			$table->integer('material_category_id');
			$table->integer('balance_qty');
			$table->string('stock_qty',20);
		    $table->timestamps();
        });
    } 

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_company_stock_transfer_header','tbl_company_stock_transfer_details');
    }
}
