<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateDeviceConfigurationModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_device_configuration', function (Blueprint $table) {
            $table->id();
			$table->string('synchronize',20);
			$table->string('google_api_key',120);
			$table->enum('gcm_notification', ['yes', 'no']); 
			$table->enum('pre_sale', ['yes', 'no']);
			$table->string('disclaimer',1000);
			$table->enum('printer_type', ['zebra printer', 'A4 printer']);
			$table->string('geofence_radius',20);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_device_configuration');
    }
}
