<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateStockAdjustModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_stock_adjust_header', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('warehouse');
			$table->string('adjustment_type',50);
			$table->string('remark',150);
			$table->string('invoice_date',20);
            $table->timestamps();
        });
		
		Schema::create('tbl_stock_adjust_details', function (Blueprint $table) {
             $table->integer('id');
			 $table->integer('header_id');
			 $table->string('material_code',20);
			 $table->string('uom',20);
			 $table->string('adjustment_type',20);
			 $table->decimal('available_qty',10,2);
			 $table->decimal('adjust_qty',10,2);
			 $table->decimal('balance_qty',10,2);
			 $table->timestamps();
			 
		});
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_stock_adjust_header','tbl_stock_adjust_details');
    }
}
