<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAssetTrackingModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_asset_tracking', function (Blueprint $table) {
            $table->integer('id');
			 $table->string('asset_code',25);
			 $table->string('asset_name',125);
			 $table->string('asset_type',125);
			 $table->string('asset_barcode',125);
			 $table->string('serial_no',125);
			 $table->string('image',250)->nullable();
			 $table->string('longitude',125);
			 $table->string('latitude',125);
			 $table->string('valid_from',25);
			 $table->string('valid_to',25);
			 
			 $table->string('region',125);
			 $table->string('sub_region',125);
			 $table->string('route',125);
			 $table->string('customer_category',125);
			 $table->string('customer',125);
			 
			 $table->enum('status', ['active', 'inactive']);  
			 $table->timestamps();   
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_asset_tracking');
    }
}
