<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateRouteOrderModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_route_order_header', function (Blueprint $table) {
            $table->integer('id');
			$table->string('order_number',20);
			$table->string('salesman',20);
			$table->integer('warehouse');
			$table->string('order_date',20);
			$table->integer('customer_id');
			$table->integer('route_id');
			$table->integer('region')->length(11)->nullable();
			$table->integer('subregion')->length(11)->nullable();
			$table->integer('trading_center_id');
			$table->string('remark',200);
			$table->string('currency',20);
			$table->decimal('total_gross',10,2); 
			$table->decimal('total_vat',10,2);
			$table->decimal('net_total_amount',10,2);
			$table->decimal('total_discount',10,2)->nullable();
			//$table->string('total_unite_price',20);
			$table->decimal('total_order_value',10,2);
            $table->timestamps();
        });
		Schema::create('tbl_route_order_details', function (Blueprint $table) {
            $table->integer('id');
			$table->string('material_code',20);
			$table->string('uom',20);
			$table->integer('quantity');
			$table->integer('header_id');
			$table->decimal('unite_price',10,2);
			$table->decimal('gross_total',10,2);
			$table->decimal('vat',10,2);
			$table->decimal('net_amount',10,2);
			$table->decimal('discount',10,2)->nullable();
			$table->string('discount_id',20)->nullable();
			$table->decimal('total',10,2);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_route_order_header','tbl_route_order_details');
    }
}
