<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateRouteExchangeModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
   public function up()
    {
		
        Schema::create('tbl_route_exchange_header', function (Blueprint $table) {
            $table->integer('id');
			$table->string('exchange_number',20);
			$table->string('exchange_date',50);
			$table->integer('exchange_amount');
			$table->integer('customer_id');
			$table->integer('salesman_id');
			$table->integer('warehouse_id',20);
            $table->timestamps();
        });
		
		Schema::create('tbl_route_exchange_return_details', function (Blueprint $table) {
             $table->integer('id');
			$table->integer('material_id');
			$table->integer('uom_id');
			$table->integer('quantity');
			$table->integer('header_id');
			
			$table->decimal('total_amount',10)->nullable();
			$table->integer('return_type_id',20)->nullable();
			$table->integer('return_reason_id');
            $table->timestamps();
        });
		
		Schema::create('tbl_route_exchange_invoice_details', function (Blueprint $table) {
             $table->integer('id');
			 $table->decimal('amount',10);
			$table->integer('material_id');
			$table->integer('uom_id');
			$table->integer('quantity');
			$table->integer('header_id');
			
			$table->decimal('total_amount',10)->nullable();
            $table->timestamps();
        });
    }


    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_route_exchange_header','tbl_route_exchange_return_details','tbl_route_exchange_invoice_details');
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
   
}
