<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePurchaseOrderModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_purchase_order_header', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('supplier_id');
			$table->integer('tin_no_id');
			$table->string('delivery_date',20);
			$table->string('remark',100)->nullable();
		    $table->enum('is_grn', ['0', '1'])->default(0);
			$table->integer('currency_id',20); 
			$table->decimal('total_gross',10,2);
			$table->decimal('total_Excise',10,2);
			$table->decimal('total_vat',10,2);
			$table->decimal('net_total_amount',10,2);
			$table->decimal('total_discount',10,2)->nullable();
            $table->timestamps();
        });
	    Schema::create('tbl_purchase_order_details', function (Blueprint $table) {
            $table->integer('id');
			$table->string('material_code',20);
			$table->string('uom',20);
			$table->string('quantity',20);
			$table->string('header_id',20);
			$table->decimal('unite_price',10,2);
			$table->decimal('gross_total',10,2);
			$table->decimal('vat',10,2);
			$table->decimal('excise',10,2);
			$table->decimal('net_amount',10,2);
			$table->decimal('discount',10,2)->nullable();
			$table->string('discount_id',20)->nullable();
			$table->decimal('total',10,2);
			$table->integer('base_qty');
			$table->timestamps();
        });
		
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_purchase_order_header','tbl_purchase_order_details');
    }
}
