<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateVendorPaymentModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('vendor_payment_header', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('supplier_id');
			$table->integer('vendor_payment_code');
			$table->integer('collection_type',20);
			$table->string('cheque_no',20)->nullable();
			$table->string('cheque_date',20)->nullable();
			$table->string('bank_name',70)->nullable();
			$table->string('account_no',30)->nullable();
			$table->string('branch_name',20)->nullable();
			$table->integer('created_user');
			$table->integer('updated_user');
			$table->timestamps();
        });
        Schema::create('vendor_payment_details', function (Blueprint $table) {
            $table->integer('id');
            $table->string('due_date',20);
			$table->string('outstanding_amt',20);
			$table->string('total_outstanding',20);
			$table->string('paid_amount',20);
			$table->integer('created_user');
			$table->integer('updated_user');
			$table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('vendor_payment_header','vendor_payment_details');
    }
}
