<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAssetMasterModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_asset_master', function (Blueprint $table) {
            $table->id();

            $table->integer('asset_code');
            $table->integer('asset_category_id');
            $table->integer('asset_number');
            $table->integer('serial_number');
            $table->integer('model_number');
            $table->string('aquisition_date');
            $table->integer('sap_code');
            $table->integer('supplier_id');
            $table->string('manufacturer');
            $table->string('country');
            $table->integer('customer_id');
            $table->enum('status', ['active', 'inactive']);

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_asset_master');
    }
}
