<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route; 
use App\Http\Controllers\MasterApiController;
use App\Http\Controllers\DiscountController;
use App\Http\Controllers\TransactionApiController;
use App\Http\Controllers\MerchandisingApiController;
use App\Http\Controllers\AdvancePaymentController;
use App\Http\Controllers\CustomerCategoryController;
use App\Http\Controllers\BankController;

  
/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

        //GET API //
		
		
		//logout_Api
 Route::get('/salesman_logout/{id}', [MasterApiController::class, 'checkin_checkout'])->name('salesman_logout');
 
 
 
 
//login_Api
Route::get('/salesman_login/{user_id}/{password}', [MasterApiController::class, 'salesman_login'])->name('salesman_login');

//login_Api
Route::get('/salesman_login_demo/{user_id}/{password}', [AdvancePaymentController::class, 'salesman_login'])->name('salesman_login');

//Customer_api
Route::get('/customer_details/{type_id}/{route_id}', [MasterApiController::class, 'customer_details'])->name('customer_details');

Route::get('/customer/{customer_type_id}/{route_id}', [MasterApiController::class, 'customer_plan_details'])->name('customer_plan_details');
  
//Material_Api    
Route::get('/material_details/', [MasterApiController::class, 'material_details'])->name('material_details');

//route_visit_plan_details
Route::get('/route_visit_plan_details/', [MasterApiController::class, 'route_visit_plan_details'])->name('route_visit_plan_details');

//reason_type_good_and_bad
Route::get('/reason_type_good_and_bad/', [MasterApiController::class, 'reason_type_good_and_bad'])->name('reason_type_good_and_bad');

//material_category_api
Route::get('materialcategory_details', [MasterApiController::class, 'materialcategory_details'])->name('materialcategory_details');

//pricing_api
Route::get('pricing_plan', [MasterApiController::class, 'pricing_plan'])->name('pricing_plan');

// load_request_list
Route::get('load_request_list/{route_id}/{salesman_id}', [MasterApiController::class, 'load_request_list'])->name('load_request_list');

//device_configuration_details
Route::get('device_configuration_details/', [MasterApiController::class, 'device_configuration_details'])->name('device_configuration_details');

//trading_center_details
Route::get('trading_center_details/{id}/', [MasterApiController::class, 'trading_center_details'])->name('trading_center_details');

//route_invoice_request
//Route::get('route_invoice_request/{route_id}/{salesman}', [MasterApiController::class, 'route_invoice_request'])->name('route_invoice_request');
 
//customer plan
Route::get('customer_plan_detail',[MasterApiController::class,'customer_plan_detail'])->name('customer_plan_detail');

//customer category api
Route::get('customer_category_detail',[MasterApiController::class,'customer_category_detail'])->name('customer_category_detail');

//Expense type api
Route::get('expence_type_details',[MasterApiController::class,'expence_type_details'])->name('expence_type_details');
Route::post('expense_request',[MasterApiController::class,'expense_request'])->name('expense_request');

//country_details
Route::get('country_details',[MasterApiController::class,'country_details'])->name('country_details');

//city_details
Route::get('city_details',[MasterApiController::class,'city_details'])->name('city_details');

//uom_details
Route::get('uom_details',[MasterApiController::class,'uom_details'])->name('uom_details');



     //POST API

//invoice api
Route::post('/save_invoice/', [MasterApiController::class, 'save_invoice'])->name('save_invoice');

//order save api
Route::post('/save_company_order/', [MasterApiController::class, 'save_company_order'])->name('save_company_order');
//save_pending_customer
Route::post('/save_pending_customer/', [MasterApiController::class, 'save_pending_customer'])->name('save_pending_customer');

//sales_return_save
Route::post('/sales_return_save/', [MasterApiController::class, 'sales_return_save'])->name('sales_return_save');

//invoice api
Route::post('/save_saleman_load/', [MasterApiController::class, 'save_saleman_load'])->name('save_saleman_load');

//update_load_status
Route::post('/update_load_status/', [MasterApiController::class, 'update_load_status'])->name('update_load_status');

//testing update_load_status
Route::post('/update_load_status1/', [BankController::class, 'update_load_status'])->name('update_load_status1');

//Shelf Display
Route::get('shelf_display_details/{route_id}/',[MasterApiController::class,'shelf_display_details'])->name('shelf_display_details');

//Planogram Details
Route::get('planogram_details/{route_id}/',[MasterApiController::class,'planogram_details'])->name('planogram_details');

//save_route_unload
Route::post('/save_route_unload/',[MasterApiController::class,'save_route_unload'])->name('save_route_unload');

//Asset tracking
Route::get('asset_tracking_details/{rouet_id}/',[MasterApiController::class,'asset_tracking_details'])->name('asset_tracking_details');

//comaplaint
Route::post('/complaint_save/',[MasterApiController::class,'complaint_save'])->name('complaint_save');
Route::post('/survey_save/',[MasterApiController::class,'survey_save'])->name('survey_save');

//update_unload_status
Route::post('/update_unload_status/', [MasterApiController::class, 'update_unload_status'])->name('update_unload_status');


//Save route order
Route::post('/save_route_order/',[MasterApiController::class,'save_route_order'])->name('save_route_order');

//Route Delivery details
Route::get('delivery_details',[MasterApiController::class,'delivery_details'])->name('delivery_details');

//Route exchange header
Route::post('/save_route_exchange/',[MasterApiController::class,'save_route_exchange'])->name('save_route_exchange');


//Route exxhange details
Route::get('/route_exchange_details/',[MasterApiController::class,'route_exchange_details'])->name('route_exchange_details');

//outstanding details
Route::post('/save_outstanding/',[MasterApiController::class,'save_outstanding'])->name('save_outstanding');

Route::get('route_outstanding_details/{route_id}',[MasterApiController::class,'route_outstanding_details'])->name('route_outstanding_details');

 //Route Collection
Route::post('/route_collection_save/',[MasterApiController::class,'route_collection_save'])->name('route_collection_save');

Route::get('route_collection_list',[MasterApiController::class,'route_collection_list'])->name('route_collection_list');

Route::Post('/customer_outstanding/',[MasterApiController::class,'customer_outstanding_save'])->name('customer_outstanding');

Route::Post('/asset_save/',[MasterApiController::class,'asset_save'])->name('asset_save');

Route::Post('/planogram_save/',[MasterApiController::class,'planogram_save'])->name('planogram_save');

//marchendising competitor
Route::Post('/save_competitor/',[MasterApiController::class,'save_competitor'])->name('save_competitor');

//marchendising Promotion Post
Route::Post('/save_promotion_post/',[MasterApiController::class,'save_promotion_post'])->name('save_promotion_post');

//marchendising
Route::Post('/survey_answer_save/',[MasterApiController::class,'survey_answer_save'])->name('survey_answer_save');
Route::get('survey_details',[MasterApiController::class,'survey_details'])->name('survey_details');