<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route; 
use App\Http\Controllers\TransactionApiController;
use App\Http\Controllers\MasterApisController;
use App\Http\Controllers\ParametersApiController;
use App\Http\Controllers\MerchandisingApiController;


/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

//RouteTransactionApi -:

//POST API 
 
//Route invoice save
Route::post('/save_invoice/', [TransactionApiController::class, 'save_invoice'])->name('save_invoice');

//Salesman load save
Route::post('/save_saleman_load/', [TransactionApiController::class, 'save_saleman_load'])->name('save_saleman_load');

//Update load status
Route::post('/update_load_status/', [TransactionApiController::class, 'update_load_status'])->name('update_load_status');

//Save pending customer
Route::post('/save_pending_customer/', [TransactionApiController::class, 'save_pending_customer'])->name('save_pending_customer');

//Sales return save
Route::post('/sales_return_save/', [TransactionApiController::class, 'sales_return_save'])->name('sales_return_save');

//Save route unload
Route::post('/save_route_unload/',[TransactionApiController::class,'save_route_unload'])->name('save_route_unload');

//Save route order
Route::post('/save_route_order/',[TransactionApiController::class,'save_route_order'])->name('save_route_order');

//Route exchange header save
Route::post('/save_route_exchange/',[TransactionApiController::class,'save_route_exchange'])->name('save_route_exchange');

//outstanding save
Route::post('/save_outstanding/',[TransactionApiController::class,'save_outstanding'])->name('save_outstanding');

//Route Collection
Route::post('/route_collection_save/',[TransactionApiController::class,'route_collection_save'])->name('route_collection_save');

//GET API

//Load request list
Route::get('load_request_list/{route_id}/{salesman_id}', [TransactionApiController::class, 'load_request_list'])->name('load_request_list');

//Route Delivery details
Route::get('delivery_details',[TransactionApiController::class,'delivery_details'])->name('delivery_details');

//Route exchange details
Route::get('/route_exchange_details/',[TransactionApiController::class,'route_exchange_details'])->name('route_exchange_details');

//Route outstanding details
Route::get('route_outstanding_details/{route_id}',[TransactionApiController::class,'route_outstanding_details'])->name('route_outstanding_details');

Route::get('route_collection_list',[TransactionApiController::class,'route_collection_list'])->name('route_collection_list');

//MasterApis -:
//GET API

//Login Api
Route::get('/salesman_login/{user_id}/{password}', [MasterApiController::class, 'salesman_login'])->name('salesman_login');

//Customer details
Route::get('/customer_details/{type_id}/{route_id}', [MasterApisController::class, 'customer_details'])->name('customer_details');

//Material details    
Route::get('/material_details/', [MasterApisController::class, 'material_details'])->name('material_details');

//pricing details
Route::get('pricing_plan', [MasterApisController::class, 'pricing_plan'])->name('pricing_plan');

//trading_center_details
Route::get('trading_center_details/{id}/', [MasterApisController::class, 'trading_center_details'])->name('trading_center_details');

//customer plan details

Route::get('/customer/{customer_type_id}/{route_id}', [MasterApisController::class, 'customer_plan_details'])->name('customer_plan_details');

Route::get('customer_plan_detail',[MasterApisController::class,'customer_plan_detail'])->name('customer_plan_detail');

//route_visit_plan_details
Route::get('/route_visit_plan_details/', [MasterApisController::class, 'route_visit_plan_details'])->name('route_visit_plan_details');

//device_configuration_details
Route::get('device_configuration_details/', [MasterApisController::class, 'device_configuration_details'])->name('device_configuration_details');

//POST API -:
//Company order save 
Route::post('/save_company_order/', [MasterApiController::class, 'save_company_order'])->name('save_company_order');

//Parameters Apis -:
//GET API

//material category details
Route::get('materialcategory_details', [ParametersApiController::class, 'materialcategory_details'])->name('materialcategory_details');

//Expense type details
Route::get('expence_type_details',[ParametersApiController::class,'expence_type_details'])->name('expence_type_details');

//reason_type_good_and_bad details
Route::get('/reason_type_good_and_bad/', [ParametersApiController::class, 'reason_type_good_and_bad'])->name('reason_type_good_and_bad');

//country_details
Route::get('country_details',[ParametersApiController::class,'country_details'])->name('country_details');

//city_details
Route::get('city_details',[ParametersApiController::class,'city_details'])->name('city_details');

//customer category details
Route::get('customer_category_detail',[ParametersApiController::class,'customer_category_detail'])->name('customer_category_detail');

//uom_details
Route::get('uom_details',[ParametersApiController::class,'uom_details'])->name('uom_details');

//Merchandising Apis -:
//GET API

//Shelf Display details
Route::get('shelf_display_details',[MerchandisingApiController::class,'shelf_display_details'])->name('shelf_display_details');

//Planogram Details 
Route::get('planogram_details',[MerchandisingApiController::class,'planogram_details'])->name('planogram_details');

//Asset tracking
Route::get('asset_tracking_details',[MerchandisingApiController::class,'asset_tracking_details'])->name('asset_tracking_details');

